	/************************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	*************************************************************************************************
	*  	TP n 2: Acqurir l'tat du commodo de commande feux et afficher les tats des entres  		
	*------------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite qu'un changement d'etat sur le module 8 entres provoque automatiquement 
	*	l'envoie de trames:
	*   -> Les trames reues sont affiches					
	*   -> Les tats des entres sont affichs									
 	*----------------------------------------------------------------------------------------------	
	*  NOM du FICHIER :  CAN_VMD_TP2.C			       						
	* ***************** 													
	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "Can_vmd.h"

//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{// Dfinition de variables locales
Trame T_IM_CFG; 
Trame Trame_Recue; 

unsigned char Cptr_TimeOut,I_Message_Pb_Affiche;
// Initialisations
//*****************
clsscr();
/* Initialisation DU SJA1000 de la carte PC104 */
Init_Aton_CAN();

// Pour initialiser les liaison en entres
T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_CFG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_Feux;
T_IM_CFG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne 
						//(GPDDR donne la direction des I/O) adresse = 1Fh  page 16
T_IM_CFG.data[1]=0x7F; // deuxime donne -> "Masque" 
					  //-> Tous les bits concerns sauf GP0 (voir doc page 16)
T_IM_CFG.data[2]=0x7F; // troisime donne -> "Valeur" -> Tous les bits en entre
// Envoi trame pour dfinir de la direction des entres sorties
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM_CFG);  // Envoyer trame sur rseau CAN
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}}
    }while(Cptr_TimeOut==200);
clsscr();

//Configuration du composant pour un envoie automatique des trames ...
T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; 
T_IM_CFG.trame_info.champ.dlc=0x03; 
//Commodo Feux
T_IM_CFG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_Feux;
T_IM_CFG.data[0]=0x1C;	//Adresse du registre IOTEN=0x00 + Offset=0x1C==>0x1C (cf datasheet)
T_IM_CFG.data[1]=0xFF; //Tous les bits sont concerns 
T_IM_CFG.data[2]=0xFF; //GP7TXC  GP0TXC sont valids pour un envoie sur changement d'tat
Ecrire_Trame(T_IM_CFG);
while(Lire_Trame(&Trame_Recue)!=1);

// Pour afficher titre
gotoxy(1,2);
printf("    TP  n: 2    ACQUERIR ET AFFICHER ETAT COMMODO FEUX   \n");
printf("    **************************************************** \n");
// Boucle principale
//*******************
while(1)
	{  // On teste si une trame a t reue
	   if (1==Lire_Trame(&Trame_Recue))  // La fonction renvoie 1 dans ce cas
		{gotoxy(4,10);
		printf("Trame recue\n");
		Affiche_Trame(Trame_Recue);
		if (Trame_Recue.ident.extend.identificateur.ident==0x5400000)
			{ // On a reu l'tat du commodo donc on affiche les nouveaux tats
			Etat_Commodo_Feux.valeur=~Trame_Recue.data[1];
			gotoxy(4,16);
			printf("Etat des differentes entrees imposees par le commodo:\n");
			printf("    Octet recupere et complemente (en Hexa) =%2.2x\n",Etat_Commodo_Feux.valeur);
			printf("    Veilleuse= %d ,   Code= %d ,   Phare= %d\n",Cde_Veilleuse,Cde_Code,Cde_Phare);
			printf("    clignotant gauche= %d  ,   clignotant droit= %d\n",Cde_Clign_Gauche,Cde_Clign_Droit); 
			printf("    Klaxon= %d\n",Cde_Klaxon);
			printf("    Feux de stop= %d\n",Cde_Stop);
 			printf("    Commande Warning= %d\n",Cde_Warning);
			}	
		}
	}// FIN de la boucle principale
}// FIN fonction principale