/* declaration pour la carte clavier afficheur */


union reg_bit
{
struct
	{
	unsigned char b7:1;
	unsigned char b6:1;
	unsigned char b5:1;
	unsigned char b4:1;
	unsigned char b3:1;
	unsigned char b2:1;
	unsigned char b1:1;
	unsigned char b0:1;
	} r_bit;
unsigned char valeur;
};



#define eid005	(char *)	0xb30000

#define as_rtc	*(unsigned char *)	(eid005)
#define ds_rtc	*(unsigned char *)	(eid005+1)
#define ctrl_rtc	*(unsigned char *) 	(eid005+8)


#define version 	*(unsigned char *)	(eid005+15)

//#define clavier	*(unsigned char *)	(eid005+5)
#define status	(*(union reg_bit *) 	(eid005+6))
#define ctrl	(*(union reg_bit *)	(eid005+7))

/* registre RTC 14285 */

#define	REGA		0x0a
#define	REGB		0x0b
#define	REGC		0x0c
#define	REGD		0x0d

/* afficheur */

union reg_ctrl_aff
{
struct
 {
	unsigned char tmp:3;
	unsigned char fs:1;
	unsigned char cd:1;
	unsigned char ce:1;
	unsigned char wr:1;
	unsigned char rd:1;
 } bit_ctrl;
unsigned char octet;
};

#define ctrl_aff	(*(union reg_ctrl_aff *)	(eid005+3))
#define db_aff	*(unsigned char *)	(eid005+4)

#define LCD_STATUS_BUSY1	0x01
#define LCD_STATUS_BUSY2	0x02

#define LCD_CG_ROM_MODE_OR 0x80
#define LCD_CG_ROM_MODE_XOR	0x81;
#define LCD_MODE_OFF		0x90
#define LCD_MODE_TXT		0x94
#define LCD_MODE_GRAPH		0x98

#define LCD_GRAPHICS_HOME	0x0400
#define LCD_GRAPHICS_AREA	0x10
#define LCD_GRAPHICS_SIZE	0x400

#define LCD_ADDRESS_POINTER_SET 0x24
#define LCD_WRITE_AUTO_INCREMENT	0xC0
#define LCD_WRITE_NO_INCREMENT	0xc4

struct image{
short t_image;
char largeur;
char hauteur;
char *point;
};

/* clavier */

union reg_clavier
{
struct
	{
	unsigned char ligne:4;
	unsigned char colonne:4;
	} matrice;
unsigned char valeur;
};

#define touche	status.r_bit.b0 

#define clavier (*(union reg_clavier *) (eid005+5))

/* buzzer */

#define buzzer ctrl.r_bit.b7
