


//*****************************************************
//  Structures de donnes pour application  CAN VMD
//  Nom de fichier: CAN_VMD.h
//*****************************************************

#ifndef _VMD_H
#define _VMD_H


// Format de message 
typedef struct {
    /* nombre d'octets  envoyer, -1 si c'est une Remote Frame */
    int dlc;   
    unsigned char id1;  /* 8 bits de poids forts de l'ID. */
    unsigned char id2;  /* 3 bits de poids faible de l'ID. */
    unsigned char data[8];
} Message;


//  Pour l'identificateur en mode standard
typedef union 
{
struct 
	{
	unsigned short ident:11;
	unsigned short rtr:1;
	unsigned short nul:4;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	} registre;
unsigned short valeur;
} ident_standard;

//  Pour l'identificateur en mode tendu
typedef union
{
struct
	{
	unsigned long ident:29;
	unsigned long rtr:1;
	unsigned long x:2;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	unsigned char ident3;
	unsigned char ident4;
	} registre;
unsigned long valeur;
} ident_extend;

// Pour registre d'information Trame SJA1000
typedef union
	{
	struct
		{
		unsigned char extend:1;
		unsigned char rtr:1;
		unsigned char nul:2;
		unsigned char dlc:4;
		} champ;
	unsigned char registre;
	} tr_info;

// Pour Trame circulant sur rseau CAN
typedef struct
{
tr_info trame_info;
union
	{
	ident_standard standard;
	ident_extend   extend;
	} ident;	
unsigned char data[8];
} Trame;

typedef union
{
struct
	{
	unsigned char GP7:1;
	unsigned char GP6:1;
	unsigned char GP5:1;
	unsigned char GP4:1;
	unsigned char GP3:1;	
	unsigned char GP2:1;
	unsigned char GP1:1;
	unsigned char GP0:1;
	}bit;
unsigned char valeur;
}Port_8ES;
Port_8ES Etat_Commodo_Feux;
//  Dclaration des identificateurs, pour les diffrents modules sur le bus 
//--------------------------------------------------------------------------------
// Pour Essuie Glace
#define Ident_T_IM_Commodo_EG 0x05880000 // Commodo EG en commande (Information  Message)
#define Ident_T_AIM_Commodo_EG 0x05A00000 // Commodo EG en commande (Information  Message)
#define Ident_T_IRM1_Commodo_EG 0x05841E07 // Commodo EG en interrogation:  1 octet demand
#define Ident_T_IRM8_Commodo_EG 0x05840000 // Commodo EG en interrogation:  8 octets demands
#define Ident_T_OB_Commodo_EG 0x05900000 // Commodo EG "On Bus" (Par scduleur)
// Pour module Asservissement
#define Ident_T_IM_Asservissement 0x00880000	// "Asservissement" en commande (Input Message)
#define Ident_T_IRM1_Asservissement 0x00841E07	// "Asservissement" en interrogation: 1 octet en rponse
#define Ident_T_IRM8_Asservissement 0x00840000	// "Asservissement" en interrogation: 8 octets en rponse 
#define Ident_T_AIM_Asservissement 0x00A00000	// "Asservissement" en Acquittement commande
#define Ident_T_OB_Asservissement 0x00900000	// "Asservissement" en On Bus (par scduleur)

// Pour le "Commodo Essuie Glace"
Port_8ES Commodo_EG;
#define Etat_Commodo_EG Commodo_EG.valeur
#define Valeur_Commodo_EG Commodo_EG.valeur
#define Cde_EG_Av_Int Commodo_EG.bit.GP0	// Commande Essuie Glace Avant en Intermittant
#define Entree1 Commodo_EG.bit.GP1
#define Entree2 Commodo_EG.bit.GP2
#define Cde_EG_Av_Pos1 Commodo_EG.bit.GP3 // Commande Essuie Glace Avant en Position1
#define Cde_EG_Av_Pos2 Commodo_EG.bit.GP4 // Commande Essuie Glace Avant en Position2
#define Cde_EG_Ar Commodo_EG.bit.GP5	// Commande Essuie Glace Arrire
#define Cde_Lave_Glace_Ar Commodo_EG.bit.GP6
#define Cde_Lave_Glace_Av Commodo_EG.bit.GP7

#endif