	/************************************************************************************************
	*       TPs sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)  					
	*************************************************************************************************
	*       APPLICATION: Commande Essuie-glace
	*************************************************************************************************
	*  	TP n 1:  Acqurir l'tat des entres binaires ainsi que la valeur de l'entre analogique
	*              du commodo Essuie-Glace  
	*              Afficher sparment les tats de ces entres binaires
	* 		   Afficher la valeur de l'entre analogique 		
	*------------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite qu' intervalles de temps rguliers on interroge le module 8 entres sur lequel 
	*   est reli le commodo de commande Essuie-Glace 								
	*   -> Les tats des entres binaires et de l'entre analogique sont affichs							
	*   -> La priode d'chantillonnage est de type "logiciel" 									
	*	(comptage du nombre de passages dans la boucle principale)						
 	*----------------------------------------------------------------------------------------------	
	*  NOM du FICHIER :  TP_1_CANVMD_EG.C			       						
	* ***************** 													
	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_01B.h"
//#include "Aton_can.h"
//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{// Dfinition de variables locales
int Compteur_Passage;
unsigned short S_Temp,Valeur_ANA,Valeur_ANA_Mem,Commodo_EG_Mem;
unsigned int Cptr_TimeOut;
unsigned char AN0H,AN10L,Flag_Affiche;  // Pour rcuprer le rsultat de la conversion A->N
Trame Trame_Recue; 
Trame T_IRM_Commodo_EG;	// Trame pour interroger Module 8E sur Commodo Essuie Glace  
					// IRM -> Information Request Message -> Trame interrogative
Trame T_IM_Commodo_EG;	// Trame d'ordre Module 8E sur Commodo Essuie Glace  
					// IM -> Information Message -> Trame de commande

// Initialisations
//*****************
clsscr();
/* Initialisation DU SJA1000 de la carte PC104 */
Init_Aton_CAN();
// Pour initialiser les liaison en entres du noeud "Commodo Essuie-Glace"
T_IM_Commodo_EG.trame_info.registre=0x00;
T_IM_Commodo_EG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Commodo_EG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_EG;
T_IM_Commodo_EG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne 
						//(GPDDR donne la direction des I/O) adresse = 1Fh  page 16
T_IM_Commodo_EG.data[1]=0x7F; // deuxime donne -> "Masque" 
					  //-> Tous les bits concerns sauf GP7 (voir doc page 16)
T_IM_Commodo_EG.data[2]=0x7F; // troisime donne -> "Valeur" -> Tous les bits en entre
// Envoi trame pour dfinir de la direction des entres sorties
Ecrire_Trame(T_IM_Commodo_EG);  // Envoyer trame sur rseau CAN
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 if(Cptr_TimeOut==2000)
		{ gotoxy(2,12);
		  printf(" Pas de reponse a la trame de commande en initialisation \n");
		  printf(" Couper et/ou  remettre    alimentation 12 V  \n");
		  do{}while(Lire_Trame(&Trame_Recue)==0); // On attend les trames  "On Bus"
              for(Cptr_TimeOut=0;Cptr_TimeOut<100000;Cptr_TimeOut++);
              Ecrire_Trame(T_IM_Commodo_EG);  // Renvoyer trame IM sur rseau CAN
	 	  Cptr_TimeOut=0;
	 	  do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 	  if(Cptr_TimeOut==2000)
			{ gotoxy(2,12);
		   	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		  	 printf("  Modifier le programme et recommencer  \n");
	        	 do{}while(1); // On reste bloqu, on ne continue pas
			} 
		}
clsscr();
// Pour afficher le titre du TP
printf("********************************************************************* \n");
printf("     TPs sur Reseau CAN    Application: Commande Essui-Glace          \n");
printf("     ---------------------------------------------------------------  \n");
printf("     TP n 1                                                          \n"); 
printf("     ACQUERIR les entrees binaires du COMMODO EG                      \n");
printf("     ACQUERIR la valeur de l'entree analogique du COMMODO EG          \n");
printf("     AFFICHER les valeurs acquises                				\n");
printf("     (nota: Le micro switch GP0 doit etre sur ON)    			\n");
printf("********************************************************************* \n");
// Pour activer les conversions Ana -> Num
T_IM_Commodo_EG.data[0]=0x2A; 	// Adresse du registre ADCON0  
T_IM_Commodo_EG.data[1]=0xF0; 	// Masque -> bits 7..4 concerns
T_IM_Commodo_EG.data[2]=0x80;	// Valeur ->  ADON=1 et "prescaler rate"=1:32
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir le mode de conversion
T_IM_Commodo_EG.data[0]=0x2B; 	// Adresse du registre ADCON1  
T_IM_Commodo_EG.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM_Commodo_EG.data[2]=0x0C;	// Valeur ->  voir doc MCP25050 page 36
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour trame interrogative envoye au commodo EG -> 'IRM'   (Information Request Message)
// Dfinir donnes d'identification
T_IRM_Commodo_EG.trame_info.registre=0x00;
T_IRM_Commodo_EG.trame_info.champ.extend=1;
T_IRM_Commodo_EG.trame_info.champ.dlc=0x08;  // On demande la valeur de 8 registre
T_IRM_Commodo_EG.trame_info.champ.rtr=1;
T_IRM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IRM8_Commodo_EG;
							// Voir dfinitions dans fichier CAN_VMD.h
Ecrire_Trame(T_IRM_Commodo_EG); // On envoi une premire trame
// Initialiser les variables diverses
Compteur_Passage=0;
// Boucle principale
//*******************
   do
	{  // On teste si une trame a t reue, en rpons  l'interrogation
	   if (1==Lire_Trame(&Trame_Recue))  // La fonction renvoie 1 dans ce cas
		{
		 //printf("Trame recue en reponse a la demande: c'est une 'OM' (Output Messsage) \n");
		 //Affiche_Trame(Trame_Recue);
		 if (Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM8_Commodo_EG)
			{ // On a reu l'tat du commodo donc on affiche les nouveaux tats
			 Commodo_EG.valeur=~(Trame_Recue.data[1]&0xFF);  // Les entres binaires
			 AN0H =Trame_Recue.data[2]; 	// On rcupre les MSB de la conversion A->N  voie AN0 
			 AN10L =Trame_Recue.data[4]; // On rcupre les LSB AN1 et AN0
	 	 	 // Traiter les donnes et reconstituer le rsultat de conversion sur 10 bits
			 Valeur_ANA=(unsigned short)(AN0H);	//Transfert avec transtypage
			 Valeur_ANA=Valeur_ANA<<2;	// Dcaler de 2 bits vers poids forts
			 S_Temp=(unsigned short)(AN10L&0x0C); // Pour ne rcuprer que les 2 bits AD1 et AD0
			 Valeur_ANA=Valeur_ANA|(S_Temp>>2);  // On reconstitue les 10 du resultat de conversion
			 //Valeur_ANA=Valeur_ANA&0x2FC;
			 // On affiche les rsultats s'il y a eu un changement dans les valeurs
			 if(Commodo_EG.valeur!=Commodo_EG_Mem)
			 	{printf("Bh=%x\n",Commodo_EG.valeur);
				 printf(" NOUVEAUX etats des entrees commodo:\n");
				 printf("Valeur analogique %4d   Binaires %2.2x \n",Valeur_ANA,Commodo_EG.valeur);
				}
			if(Valeur_ANA!=Valeur_ANA_Mem)
				{//printf(" Nouvelle valeur de l'entre analogique:\n");
				 printf("Ad=%d\n",Valeur_ANA);
				}
			 // Mmorisation des valeurs acquises
			 Commodo_EG_Mem=Commodo_EG.valeur;
			 Valeur_ANA_Mem=Valeur_ANA;
			 }	
		}
	Compteur_Passage++;
	if (Compteur_Passage==5000)
	     {Compteur_Passage=0;// C'est la fin de temporisation "soft"
		Ecrire_Trame(T_IRM_Commodo_EG);  // On interroge le module Commodo EG
	     }
	}while(1);     // FIN de la boucle principale
}
// FIN fonction principale