	/************************************************************************************************
	*       TPs sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)  					
	*************************************************************************************************
	*       APPLICATION: Commande Essuie-glace  distance
	*************************************************************************************************
	*  	TP n2:  Marche Arrt du moteur + vitesse rglable par commodo Essuie-Glace 		
	*------------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite que l'etat du moteur (marche ou arret) suive l'etat de BP1 (GP4)
	*    La vitesse du moteur sera fonction de l'entre analogique 0 du commodo EG
 	*----------------------------------------------------------------------------------------------	
	*  NOM du FICHIER :  TP_2_CAN_VMD_EG.C			       						
	* ***************** 													
	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_01B.h"
//#include "Aton_can.h"
//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{// Dfinition de variables locales
int Compteur_Passage;
unsigned char Commodo_EG_Mem;
unsigned int Cptr_TimeOut;
unsigned char AN0H; // Pour mmoriser les 8 biits de poids forts du rsultat de conversion A->N
unsigned char Val_Vitesse,Val_Vitesse_Mem;
Trame Trame_Recue; 
Trame T_IRM_Commodo_EG;		// Trame pour interroger Module 8E sur Commodo Essuie Glace  
					// IRM -> Information Request Message -> Trame interrogative
Trame T_IM_Commodo_EG;		// Trame pour commander le Module 8E sur Commodo Essuie Glace  
					// IM -> Information Message -> Trame de commande
Trame T_IM_Asservissement;	// Trame pour commander le module "Asservissement" 
					// IM -> Information Message -> Trame de commande
// Initialisations
//*****************

/* Initialisation DU SJA1000 de la carte PC104 */
Init_Aton_CAN();
// Pour initialiser les liaisons en entres  noeud "Commodo_EG"
T_IM_Commodo_EG.trame_info.registre=0x00;
T_IM_Commodo_EG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Commodo_EG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_EG;
T_IM_Commodo_EG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne 
						//(GPDDR donne la direction des I/O) adresse = 1Fh  page 16
T_IM_Commodo_EG.data[1]=0x7F; // deuxime donne -> "Masque" 
					  //-> Tous les bits concerns sauf GP0 (voir doc page 16)
T_IM_Commodo_EG.data[2]=0x7F; // troisime donne -> "Valeur" -> Tous les bits en entre
// Envoi trame pour dfinir de la direction des entres sorties
Ecrire_Trame(T_IM_Commodo_EG);  // Envoyer trame sur rseau CAN
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 if(Cptr_TimeOut==2000)
		{ clsscr();
		  gotoxy(2,12);
		  printf(" Pas de reponse a la trame de commande en initialisation \n");
		  printf(" Couper et/ou  remettre    alimentation 12 V  \n");
		  do{}while(Lire_Trame(&Trame_Recue)==0); // On attend les trames  "On Bus"
              for(Cptr_TimeOut=0;Cptr_TimeOut<200000;Cptr_TimeOut++);
              Ecrire_Trame(T_IM_Commodo_EG);  // Renvoyer trame IM sur rseau CAN
	 	  Cptr_TimeOut=0;
	 	  do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 	  if(Cptr_TimeOut==2000)
			{ gotoxy(2,12);
		   	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		  	 printf("  Modifier le programme et recommencer  \n");
	        	 do{}while(1); // On reste bloqu, on ne continue pas
			} 
		}
// Pour activer les conversions Ana -> Num
T_IM_Commodo_EG.data[0]=0x2A; 	// Adresse du registre ADCON0  
T_IM_Commodo_EG.data[1]=0xF0; 	// Masque -> bits 7..4 concerns
T_IM_Commodo_EG.data[2]=0x80;	// Valeur ->  ADON=1 et "prescaler rate"=1:32
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir le mode de conversion
T_IM_Commodo_EG.data[0]=0x2B; 	// Adresse du registre ADCON1  
T_IM_Commodo_EG.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM_Commodo_EG.data[2]=0x0C;	// Valeur ->  voir doc MCP25050 page 36
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser le module "Asservissement"
// Trame de type "IM" (trame de commande): Donnes d'identification pour le noeud "Asservissement"
T_IM_Asservissement.trame_info.registre=0x00;
T_IM_Asservissement.trame_info.champ.extend=1;
T_IM_Asservissement.trame_info.champ.dlc=0x03;
T_IM_Asservissement.trame_info.champ.rtr=0;
T_IM_Asservissement.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
// Pour dfinir des Entres/Sorties
T_IM_Asservissement.data[0]=0x1F; 	// Adresse du registre GPDDR  (direction de E/S)
T_IM_Asservissement.data[1]=0xEF; 	// Masque -> Bit 7 non concern 
T_IM_Asservissement.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre trame rponse (acquitement)
// Pour mettre  0 les sorties 
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x1C; 	// Masque -> sorties GP4,3,2 sont consernes
T_IM_Asservissement.data[2]=0x00;	// Valeur ->  les 3 sorties sont force  0  (ValidIP=0)
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)
// Pour dfinir sortie GP2 en PWM1  
T_IM_Asservissement.data[0]=0x21; 	// Adresse du registre T1CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)
// Pour dfinir frquence signal sortie PWM1  
T_IM_Asservissement.data[0]=0x23; 	// Adresse du registre PR1
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)

// Pour trame interrogative envoye au commodo Essuie-Glace  -> 'IRM'   (Information Request Message)
// Dfinir donnes d'identification
T_IRM_Commodo_EG.trame_info.registre=0x00;
T_IRM_Commodo_EG.trame_info.champ.extend=1;
T_IRM_Commodo_EG.trame_info.champ.dlc=0x08;   // On attend 8 octets en rponse
T_IRM_Commodo_EG.trame_info.champ.rtr=1;
T_IRM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IRM8_Commodo_EG;
							// Voir dfinitions dans fichier CAN_VMD.h
Ecrire_Trame(T_IRM_Commodo_EG); // On envoi une premire trame interrogative pour initialiser la mmoire
do{}while(Lire_Trame(&Trame_Recue)==0);
Commodo_EG.valeur=Trame_Recue.data[1]&0x10;
Commodo_EG_Mem=Commodo_EG.valeur;  // On met en mmoire l'tat actuel pour comparaison ultrieure

Val_Vitesse=Trame_Recue.data[2]; // On rcupre les MSB de la conversion A->N  voie AN0 
// Pour initialiser rapport cyclique PWM1 -> c'est le module de la commande    
T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=Val_Vitesse;	// Valeur ->PWM1DC   commande gale  50% (car valeur maxi=255)
Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
Val_Vitesse_Mem=Val_Vitesse;  // On met en mmoire la valeur pour comparaison ultrieure

// Les initialisations se sont bien passe
// On peut afficher le titre du TP
clsscr();
gotoxy(1,2);
printf("    ************************************************************************ \n");
printf("      TPs sur Reseau CAN    Application: Commande Essui-glace  distance     \n");
printf("      ---------------------------------------------------------------------  \n");
printf("      TP n 2         Marche/Arret du moteur                                 \n");
printf("      Le moteur est en etat MARCHE si on appuie sur BP1 (GP4)                \n");
printf("      Modifier l'entre analogique pour modifier la vitesse                  \n");
printf("    ************************************************************************ \n");

// Pour afficher l'tat initial
 	gotoxy(2,10);
	printf("  Etat entree GP4 (BP1) = %d \n",Commodo_EG.bit.GP4);  
	if(Commodo_EG.bit.GP4)printf("   Moteur a l'arret     \n");  
	else {printf("   Moteur en marche     \n"); 
		T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
		T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
		T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
		Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
		do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
	      }	
	gotoxy(2,14);
	printf("  Valeur entree analogique = %d \n",Val_Vitesse);  // On affiche sa valeur

// Boucle principale
//*******************
   do
	{  Ecrire_Trame(T_IRM_Commodo_EG); // On envoi trame interrogative au noeud commodo Essuie-Glace
         // On attend la rponse
	   do{}while(Lire_Trame(&Trame_Recue)==0);  // La fonction renvoie 1 dans ce cas
		if (Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM8_Commodo_EG)
			{ // On a reu l'tat du commodo donc on affiche les nouveaux tats
			// Pour l'entre Marche/Arret
			Commodo_EG.valeur=~(Trame_Recue.data[1]&0xF0);
			if(Commodo_EG.valeur!=Commodo_EG_Mem)
				{// S'il y a eu changement, on commande le moteur
			        printf("Bh=%2.2x\n",Commodo_EG.valeur); 
				  //gotoxy(2,10);
			        //printf("  Etat entree GP4 (BP1) = %d \n",Commodo_EG.bit.GP4);  // On affiche sa valeur
				 if(Commodo_EG.bit.GP4==0) // On test GP4 (BP1) du commodo EG
				 {// BP1 est relach car l'entre vaut 1
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x00; 	// ValidIP =0 donc moteur  l'arret
				  //printf("   Moteur a l'arret     \n"); 
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				 }
				 else
				 {// dans la cas contraire BP1 est appuy 
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
				  //printf("   Moteur en marche     \n"); 
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				 }
			      }// Fin si changement 
			 Commodo_EG_Mem=Commodo_EG.valeur;  // On met en mmoire l'tat actuel
			// Pour l'entre analogique
			Val_Vitesse=Trame_Recue.data[2]; // On rcupre les MSB de la conversion A->N  voie AN0 
			if(Val_Vitesse!=Val_Vitesse_Mem)
			  {	  printf("Ad=%d\n",Val_Vitesse); 
 				  //gotoxy(2,14);
			        //printf("  Valeur entree analogique = %d \n",Val_Vitesse);  // On affiche sa valeur
   			   // Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   T_IM_Asservissement.data[2]=Val_Vitesse;	// Valeur ->PWM1DC   
			   Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
			  }
			Val_Vitesse_Mem=Val_Vitesse;
			} // Fin si identificateur correct	
	}while(1);// FIN de la boucle principale
}// FIN fonction principale