	/************************************************************************************
	*       TPs sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)			
	*************************************************************************************
	*   TP n3:   Battement essuie glace avant
	*-------------------------------------------------------------------------------------  		
	*   CAHIER DES CHARGES :					      				
	*  *********************						      			
	*  On souhaite que l'essuie glace ralise le cycle suivant:
	*	- rotation droite jusqu' atteindre le fin de course droit  
	*	- arrt sur fin de course droit et dmarrage en rotation gauche
	*	- rotation gauche jusqu' atteindre le fin de course gauche  
 	*	- arrt sur fin de course gauche et dmarrage en rotation droite
	* 	etc ...
	*  La structure de programme sera de type "boucle de scrutation". 
	*  On affichera  l'cran, dans quel tat on est.
	*---------------------------------------------------------------------------------------
	*  NOM du FICHIER :  TP_3_CAN_VMD_EG.C			       				
	* ***************** 									
	*****************************************************************************************/

// Dclaration des fichiers d'inclusion
#include <stdio.h>
#include"Structures_Donnees.h"
#include"cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_01B.h"
//#include "Aton_can.h"

// Dclaration des variables 
// Pour les Indicateurs divers (variables binaires)
union byte_bits Indicateurs,FC,FC_Mem; // Structures de bits
#define I_Sens_Rotation Indicateurs.bit.b0 
#define I_Attente_Reponse_IRM Indicateurs.bit.b1 
#define I_Message_Pb_Affiche Indicateurs.bit.b2 
// Pour les fins de course
#define Etat_FC FC.valeur // Pour l'ensemble des fins de course
#define fs FC.bit.b7	// Pour fin de surcourse
#define fcg FC.bit.b6	// Pour fin de course gauche
#define fcd FC.bit.b5	// Pour fin de course droit
#define Etat_FC_Mem FC_Mem.valeur // Pour la mmorisation des fins de courses
// Dclarations des diverses trames de communication
Trame Trame_Recue;	// Pour la trame qui vient d'etre reue par le controleur
#define Ident_Trame_Recue Trame_Recue.ident.extend.identificateur.ident
// Trmes de type "IM" (Input Message -> trame de commande)
Trame T_IM_Asservissement; 	// Pour la commande du moteur
Trame T_IRM_Acquisition_FC;	// Pour l'acquisition de l'tat des fins de courses EG	
// Dclaration constantes
#define Module_Vitesse 50

//======================
// FONCTION PRINCIPALE
//======================
main()
{
//  INITIALISATIONS
//------------------
// Dclaration de variables locales  la fonction principale
int Cptr_Affichage=0,Cptr_TimeOut;

Init_Aton_CAN();
clsscr();
// Trame de type "IM" (trame de commande): Donnes d'identification
T_IM_Asservissement.trame_info.registre=0x00;
T_IM_Asservissement.trame_info.champ.extend=1;
T_IM_Asservissement.trame_info.champ.dlc=0x03;
T_IM_Asservissement.trame_info.champ.rtr=0;
T_IM_Asservissement.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
// Pour dfinir des Entres/Sorties
T_IM_Asservissement.data[0]=0x1F; 	// Adresse du registre GPDDR  (direction de E/S)
						// doc MCP25050 Page 16 
T_IM_Asservissement.data[1]=0xEF; 	// Masque -> Bit 7 non concern 
T_IM_Asservissement.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM_Asservissement); 	// C'est la premire trame envoye
	 Cptr_TimeOut=0;				// On teste si le module rpond bien			
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
		 	{I_Message_Pb_Affiche=1;
		  	 gotoxy(2,12);
	 	  	 printf(" Pas de reponse a la trame de commande en initialisation \n");
	 	 	 printf("  Verifier si alimentation 12 V  est OK \n");}}
    }while((Cptr_TimeOut==100)||(Ident_Trame_Recue!=Ident_T_AIM_Asservissement)); //On vrifie identificateur
		  	 gotoxy(2,12);
	 	  	 printf("                                                          \n");
	 	 	 printf("                                         \n");
// Pour mettre  0 les sorties 
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x1C; 	// Masque -> sorties GP4,3,2 sont consernes
T_IM_Asservissement.data[2]=0x00;	// Valeur ->  les 3 sorties  0
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP2 en PWM1  
T_IM_Asservissement.data[0]=0x21; 	// Adresse du registre T1CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM1  
T_IM_Asservissement.data[0]=0x23; 	// Adresse du registre PR1
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP3 en PWM2  
T_IM_Asservissement.data[0]=0x22; 	// Adresse du registre T2CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR2ON=1; Prescaler2=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM2  
T_IM_Asservissement.data[0]=0x24; 	// Adresse du registre PR2
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR2=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser rapport cyclique PWM1 
T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=Module_Vitesse;	// Valeur ->  PWM1DC 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser rapport cyclique PWM2  0
T_IM_Asservissement.data[0]=0x26; 	// Adresse du registre PWM2DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0;	// Valeur ->  PWM2DC=0 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour Valider le circuit de puissance
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x10; 	// Masque -> sortie GP4 (ValidIP) est consern
T_IM_Asservissement.data[2]=0x10;	// Valeur ->  ValidIP=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Masque pour les commandes IM futures
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
// Pour acqurir l'tat des fin de course
// Trame de type "IRM" (trame interrogative): Donnes d'identification
T_IRM_Acquisition_FC.trame_info.registre=0x00;
T_IRM_Acquisition_FC.trame_info.champ.extend=1;
T_IRM_Acquisition_FC.trame_info.champ.dlc=1;
T_IRM_Acquisition_FC.trame_info.champ.rtr=1;
T_IRM_Acquisition_FC.ident.extend.identificateur.ident=Ident_T_IRM1_Asservissement;
 Ecrire_Trame(T_IRM_Acquisition_FC); 	// Envoi trame pour acqurir tats fins de course
do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
	Etat_FC=~(Trame_Recue.data[0]&0xE0); 	// On rcupre l'tat des fin de course
	Etat_FC=Etat_FC&0xE0;
	Etat_FC_Mem=Etat_FC;			// On le mmorise
// Initialisation des variables diverses
	I_Sens_Rotation=0;

// Pour afficher titre
gotoxy(1,6);
printf("    ********************************************************* \n");
printf("     TPs sur Reseau CAN    Application: Commande Essui-glace  \n");
printf("     -------------------------------------------------------  \n");
printf("       TP n3    Battement du BALAI D'ESSUI GLACE             \n");
printf("    ********************************************************* \n");

// BOUCLE PRINCIPALE
//*******************
while(1)
	{
	// Pour "Acqurir l'tat des fins de course"
	Ecrire_Trame(T_IRM_Acquisition_FC); // Envoi trame pour acqurir tats fins de course
	Cptr_TimeOut=0;
	do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<10000));
	 if(Cptr_TimeOut==10000)
		{clsscr(),gotoxy(2,10);
		 printf(" Pas de reponse a la trame interrogative pour fins de courses \n");
		 printf("  Il faut recharger et relancer le programme \n");
		 do{}while(1);} // Stop
	 else { if(Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM1_Asservissement)
			// Si identificateur attendu
			 {Etat_FC=~(Trame_Recue.data[0]&0xE0); 	// On rcupre l'tat des fins de course uniquement
			  Etat_FC=Etat_FC&0xE0;
	 		 if(Etat_FC!=Etat_FC_Mem) 		// S'il y a eu une modification 
							// de l'tat des fin de courses -> on traite
	 		 {printf("FCh=%2.2x => FinCourseDroite=%x ,  FinCourseGauche=%x ,  FinSurCourse=%x \n Sens de rotation=%x \n",Etat_FC,fcd,fcg,fs,I_Sens_Rotation);

	      // Traiter le changement de l'tat
		if(I_Sens_Rotation) 	// Si on tourne en ngatif
			{if(fcg) 		// Si on est arriv en fin de course gauche
				{T_IM_Asservissement.data[2]=0; 	// On arrte la rotation ngative
				 T_IM_Asservissement.data[0]=0x26; 	// Adresse du registre PWM2DC
			 	 Ecrire_Trame(T_IM_Asservissement);
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				 T_IM_Asservissement.data[2]=Module_Vitesse; // On commande la rotation positive
				 T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			  	 Ecrire_Trame(T_IM_Asservissement);
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				 I_Sens_Rotation=!I_Sens_Rotation;		// On change d'tat  
				}}
		else	{// On tourne en positif
			 if(fcd) 		// Si on est arriv en fin de course droit
				{T_IM_Asservissement.data[2]=0; 	// On arrte la rotation positive
				 T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			 	 Ecrire_Trame(T_IM_Asservissement);
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				 T_IM_Asservissement.data[2]=Module_Vitesse; // On commande la rotation ngative
				 T_IM_Asservissement.data[0]=0x26; 	// Adresse du registre PWM2DC
			  	 Ecrire_Trame(T_IM_Asservissement);
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				 I_Sens_Rotation=!I_Sens_Rotation;		// On change d'tat  
				}}
		}// Fin si modif fin de course
            Etat_FC_Mem=Etat_FC; // Mmorisation du nouvel tat
             
		}} // Fin "Traiter changement d'tat"
	} //  Fin boucle principale
} // Fin fonction principale