/*    *************************************************************************************************
	*       TPs sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)  					
	*************************************************************************************************
	*       APPLICATION: Commande Essuie-glace
	*************************************************************************************************
	*  	TP n4:  Squence commande moteur E.G.		
	*------------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite que l'tat du moteur dpende de la position du commodo
	*  	- Si Position 1	Moteur en marche  faible vitesse 
	* 	- Si Position 2	Moteur en marche  grande vitesse 
	* 	- Si Position 3	Moteur en marche  vitesse ajustable par l'entre analogique
	*	- Si Position 4	Moteur en marche priodique avec dans l'tat marche une vitesse ajustable
 	*----------------------------------------------------------------------------------------------	
	*  NOM du FICHIER :  TP_4_CAN_VMD_EG.C			       						
	* ***************** 													
	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_01B.h"
//#include "Aton_can.h"

// Variables globales
//---------------------
union byte_bits Indicateurs;
#define I_Affiche Indicateurs.bit.b0
#define I_Fin_Tempo Indicateurs.bit.b1
#define I_Active_Tempo Indicateurs.bit.b2
#define I_Etat_Moteur Indicateurs.bit.b3
unsigned int Compteur_Passage_Irq;

//  Fonction d'interruption "Base de Temps"
//========================================
void irq_bt()
// Fonction excute toute les 10 mS
{if(I_Active_Tempo) // Si mode intermittent actif
	{Compteur_Passage_Irq++;
	 if(Compteur_Passage_Irq==400)  // 4  Secondes se sont coules
		{Compteur_Passage_Irq=0;
		 I_Fin_Tempo=1;
		}
	}
} // Fin de la fonction d'interruption

//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{// Dfinition de variables locales
int Compteur_Passage;
unsigned char Commodo_EG_Mem;
unsigned int Cptr_TimeOut;
unsigned char AN0H; // Pour mmoriser les 8 biits de poids forts du rsultat de conversion A->N
unsigned char Val_Vitesse,Val_Vitesse_Mem;

Trame Trame_Recue; 
Trame T_IRM_Commodo_EG;		// Trame pour interroger Module 8E sur Commodo Essuie Glace  
					// IRM -> Information Request Message -> Trame interrogative
Trame T_IM_Commodo_EG;		// Trame pour commander le Module 8E sur Commodo Essuie Glace  
					// IM -> Information Message -> Trame de commande
Trame T_IM_Asservissement;	// Trame pour commander le module "Asservissement" 
					// IM -> Information Message -> Trame de commande
// Initialisations
//*****************

/* Initialisation DU SJA1000 de la carte PC104 */
Init_Aton_CAN();
// Pour initialiser les liaisons en entres  noeud "Commodo_EG"
T_IM_Commodo_EG.trame_info.registre=0x00;
T_IM_Commodo_EG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Commodo_EG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_EG;
T_IM_Commodo_EG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne 
						//(GPDDR donne la direction des I/O) adresse = 1Fh  page 16
T_IM_Commodo_EG.data[1]=0x7F; // deuxime donne -> "Masque" 
					  //-> Tous les bits concerns sauf GP0 (voir doc page 16)
T_IM_Commodo_EG.data[2]=0x7F; // troisime donne -> "Valeur" -> Tous les bits en entre
// Envoi trame pour dfinir de la direction des entres sorties
Ecrire_Trame(T_IM_Commodo_EG);  // Envoyer trame sur rseau CAN
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 if(Cptr_TimeOut==2000)
		{ clsscr();
		  gotoxy(2,12);
		  printf(" Pas de reponse a la trame de commande en initialisation \n");
		  printf(" Couper et/ou  remettre    alimentation 12 V  \n");
		  do{}while(Lire_Trame(&Trame_Recue)==0); // On attend les trames  "On Bus"
              for(Cptr_TimeOut=0;Cptr_TimeOut<200000;Cptr_TimeOut++);
              Ecrire_Trame(T_IM_Commodo_EG);  // Renvoyer trame IM sur rseau CAN
	 	  Cptr_TimeOut=0;
	 	  do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<2000));
	 	  if(Cptr_TimeOut==2000)
			{ gotoxy(2,12);
		   	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		  	 printf("  Modifier le programme et recommencer  \n");
	        	 do{}while(1); // On reste bloqu, on ne continue pas
			} 
		}
// Pour activer les conversions Ana -> Num
T_IM_Commodo_EG.data[0]=0x2A; 	// Adresse du registre ADCON0  
T_IM_Commodo_EG.data[1]=0xF0; 	// Masque -> bits 7..4 concerns
T_IM_Commodo_EG.data[2]=0x80;	// Valeur ->  ADON=1 et "prescaler rate"=1:32
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir le mode de conversion
T_IM_Commodo_EG.data[0]=0x2B; 	// Adresse du registre ADCON1  
T_IM_Commodo_EG.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM_Commodo_EG.data[2]=0x0C;	// Valeur ->  voir doc MCP25050 page 36
Ecrire_Trame(T_IM_Commodo_EG);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser le module "Asservissement"
// Trame de type "IM" (trame de commande): Donnes d'identification pour le noeud "Asservissement"
T_IM_Asservissement.trame_info.registre=0x00;
T_IM_Asservissement.trame_info.champ.extend=1;
T_IM_Asservissement.trame_info.champ.dlc=0x03;
T_IM_Asservissement.trame_info.champ.rtr=0;
T_IM_Asservissement.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
// Pour dfinir des Entres/Sorties
T_IM_Asservissement.data[0]=0x1F; 	// Adresse du registre GPDDR  (direction de E/S)
T_IM_Asservissement.data[1]=0xEF; 	// Masque -> Bit 7 non concern 
T_IM_Asservissement.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre trame rponse (acquitement)
// Pour mettre  0 les sorties 
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x1C; 	// Masque -> sorties GP4,3,2 sont consernes
T_IM_Asservissement.data[2]=0x00;	// Valeur ->  les 3 sorties sont force  0  (ValidIP=0)
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)
// Pour dfinir sortie GP2 en PWM1  
T_IM_Asservissement.data[0]=0x21; 	// Adresse du registre T1CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)
// Pour dfinir frquence signal sortie PWM1  
T_IM_Asservissement.data[0]=0x23; 	// Adresse du registre PR1
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse (acquitement)

// Pour trame interrogative envoye au commodo Essuie-Glace  -> 'IRM'   (Information Request Message)
// Dfinir donnes d'identification
T_IRM_Commodo_EG.trame_info.registre=0x00;
T_IRM_Commodo_EG.trame_info.champ.extend=1;
T_IRM_Commodo_EG.trame_info.champ.dlc=0x08;   // On attend 8 octets en rponse
T_IRM_Commodo_EG.trame_info.champ.rtr=1;
T_IRM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IRM8_Commodo_EG;
							// Voir dfinitions dans fichier CAN_VMD.h
// Une premire acquisition pour initialiser les grandeurs mise en mmoire
Ecrire_Trame(T_IRM_Commodo_EG); // On envoi une premire trame interrogative pour initialiser la mmoire
do{}while(Lire_Trame(&Trame_Recue)==0);
Commodo_EG.valeur=~(Trame_Recue.data[1]&0xF0);
Commodo_EG_Mem=Commodo_EG.valeur;  // On met en mmoire l'tat actuel pour comparaison ultrieure
Val_Vitesse=Trame_Recue.data[2]; // On rcupre les MSB de la conversion A->N  voie AN0 
Val_Vitesse_Mem=Val_Vitesse;  // On met en mmoire la valeur pour comparaison ultrieure
// Pour les indicateurs binaires
Indicateurs.valeur=0; //Tous les indicateurs sont positionns  0

// Les initialisations se sont bien passe
// On peut afficher le titre du TP
//clsscr();
//gotoxy(1,2);
printf("    *************************************************************** \n");
printf("      TPs sur Reseau CAN    Application: Commande Essui-glace       \n");
printf("      ------------------------------------------------------------  \n");
printf("      TP n4        Sequence de commande  moteur E.G.               \n");
printf("      La vitesse moteur depend de la position commodo               \n");
printf("           Pos1 (BP1): Petite vitesse                               \n");
printf("           Pos2 (BP2): Grande Vitesse                    		    \n");
printf("           Pos3 (BP3): Vitesse Ajustable     				    \n");
printf("           Pos4 (BP4): Fonctionnement priodique  		          \n");
printf("    *************************************************************** \n");

// Pour initialiser la base de temps et temporisations
SetVect(96,&irq_bt);	// mise en place de l'autovecteur 
PITR = 0x0048;		// Une interruption toutes les 10 millisecondes 
PICR = 0x0760; 		//  96 = 60H

// Boucle principale
//*******************
   do
	{  Ecrire_Trame(T_IRM_Commodo_EG); // On envoi trame interrogative au noeud commodo Essuie-Glace
         // On attend la rponse
	   do{}while(Lire_Trame(&Trame_Recue)==0);  // La fonction renvoie 1 dans ce cas
		if (Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM8_Commodo_EG)
			{ 
			Commodo_EG.valeur=~(Trame_Recue.data[1]&0xF0); // On rcupre les tats des entres binaires
			if(Commodo_EG.valeur!=Commodo_EG_Mem)
			   {// S'il y a eu changement d'une des entres binaires, on commande le moteur
				if(Commodo_EG.bit.GP4==1) // On test GP4 (BP1) du commodo EG
			      { // BP1 est actionn  (GP4=0)
				  I_Active_Tempo=0;
   				  //gotoxy(2,12);
			        //printf("   Action sur BP1 (GP4)  \n" );  
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
   			   	 // Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   	  T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   	  T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   	  T_IM_Asservissement.data[2]=40;	// Valeur ->PWM1DC   Vitesse lente
			   	  Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   	  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				}
			     //else {
				if(Commodo_EG.bit.GP5==1) // On test GP5 (BP2) du commodo EG
			       { // BP2 est actionn  (GP5=0)
				  I_Active_Tempo=0;
   				  //gotoxy(2,12);
			        //printf("   Action sur BP2 (GP5) \n" );  
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
   			   	 // Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   	  T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   	  T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   	  T_IM_Asservissement.data[2]=70;	// Valeur ->PWM1DC   Vitesse rapide
			   	  Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   	  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				}
				//else {
				if(Commodo_EG.bit.GP6==1) // On test GP6 (BP3) du commodo EG
			       { // BP3 est actionn  (GP6=0)
				  I_Active_Tempo=0;
   				  //gotoxy(2,12);
			        //printf("   Action sur BP3 (GP6)\n" );  
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
   			   	 // Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   	  T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   	  T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   	  T_IM_Asservissement.data[2]=Val_Vitesse; // Valeur ->PWM1DC   Vitesse rglable
			   	  Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   	  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				}
			      //else {
				if(Commodo_EG.bit.GP7==1) // On test GP6 (BP3) du commodo EG
			       { // BP3 est actionn  (GP6=0)
				  I_Active_Tempo=1;
   				  //gotoxy(2,12);
			        //printf("   action sur BP4 (GP7)\n" );  
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; // ValidIP =1 donc moteur en marche
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
   			   	 // Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   	  T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   	  T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   	  T_IM_Asservissement.data[2]=Val_Vitesse; // Valeur ->PWM1DC   Vitesse rglable
			   	  Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   	  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				}
 				//else  {
				// ni BP1 ni BP2 ni BP3 ni BP4 actionn  ->  On arrete donc le moteur
				if(Commodo_EG.valeur==0x0F)
				 {I_Active_Tempo=0;
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x00; 	// ValidIP =0 donc moteur  l'arret
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				  //gotoxy(2,12);
				  //printf("   Moteur a l'arret          \n");
				 }
				//gotoxy(2,14);
			      printf("Bh=%2.2x\n",Commodo_EG.valeur);  // On affiche sa valeur
		      }// Fin si changement d'une des entres binaires
		// Pour l'entre analogique
			Val_Vitesse=Trame_Recue.data[2]; // On rcupre les MSB de la conversion A->N  voie AN0 
			if(Val_Vitesse!=Val_Vitesse_Mem) 
			  {	  //gotoxy(2,16);
			        printf("Ad=%3d\n",Val_Vitesse);  // On affiche sa valeur
				if((Commodo_EG.bit.GP6==1)||(Commodo_EG.bit.GP7==1))
   			   	{// Pour modifier le rapport cyclique PWM1 -> c'est le module de la commande    
			   	 T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
			   	 T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
			   	 T_IM_Asservissement.data[2]=Val_Vitesse;	// Valeur ->PWM1DC   
			   	 Ecrire_Trame(T_IM_Asservissement);  // Le moteur ne peut tourner car ValidIP=0
			   	 do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
				}
			  }
		// Mise en mmoire des valeurs acquises
			Commodo_EG_Mem = Commodo_EG.valeur;  // On met en mmoire l'tat des entres binaires
			Val_Vitesse_Mem=Val_Vitesse;		// On met en mmoire le rsultat de conversion A->N
			} // Fin si identificateur correct
		// Pour mode priodique
		if(I_Active_Tempo==1)
			{if(I_Fin_Tempo==1)
		 		{I_Fin_Tempo=0;
				 if(I_Etat_Moteur==1)
					{I_Etat_Moteur=0;
				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x00; 	// ValidIP =0 donc moteur  l'arret
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
					}
				 else
					{I_Etat_Moteur=1;
 				  T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
				  T_IM_Asservissement.data[1]=0x10; 	// Masque -> seule la sortie ValidIP sera conserne
				  T_IM_Asservissement.data[2]=0x10; 	// ValidIP =1 donc moteur en marche
				  Ecrire_Trame(T_IM_Asservissement);  
				  do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
					}
				}
			}
	}while(1);// FIN de la boucle principale
}// FIN fonction principale