	/************************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	*************************************************************************************************
	*  	TP n 1: Faire commuter les feux d'un bloc optique							
	*----------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite qu' intervalles de temps rguliers on dactive la sortie prcdemment active  
	*   pour activer la suivante (fonction chenillard)   								
	*   -> Les trames reues et envoyes sur le bus CAN sont affiches					
	*   -> La temporisation est de type "logiciel" 									
	*	(comptage du nombre de passages dans la boucle principale)						
 	*----------------------------------------------------------------------------------------------	
	*  NOM du FICHIER :  CAN_VMD_TP1.C			       							
	* ***************** 													
	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "Can_vmd.h"

//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{
// Dclaration des variables locales
Trame Trame_Recue;
Trame T_IM_Feux;  // Trame de type "Input Message" pour commande module 4 Sorties de puissance
int Compteur_Passage,Cptr_TimeOut;
char I_Message_Pb_Affiche;
// Initialisations
//*****************
clsscr();
/* Initialisation DU SJA1000 de la carte ATON-Systemes" sur  */
Init_Aton_CAN();
//  Dfinition trame pour activer bloc optique arrire droit
// D'aprs doc SJA1000 et  doc MCP25050 pages 22 (fonction "Write Register") et 15 (Adresse GPLAT)
T_IM_Feux.trame_info.registre=0x00;
T_IM_Feux.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Feux.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Feux.ident.extend.identificateur.ident=0x0F880000;// C'est l'identificateur du bloc optique arrire droit
T_IM_Feux.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne (GPDDR donne la direction des I/O) adresse = 1Fh  page 16
T_IM_Feux.data[1]=0x7F;	// deuxime donne -> "Masque" -> les sorties sont sur les 4 bits de poids faibles
T_IM_Feux.data[2]=0xF0;	// troisime donne -> "Valeur" -> Les sorties sont sur les 4 bits lsb
// Envoi trame pour dfinir de la direction des entres sorties
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM_Feux);// Envoyer trame sur rseau CAN
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}}
    }while(Cptr_TimeOut==200);
clsscr();
// Initialiser les sorties  0
T_IM_Feux.data[0]=0x1E;	// premire donne -> "Adresse" du registre concerne (GPLAT dfinit l'tat des sorties) 02h+1Ch = 1Eh
T_IM_Feux.data[1]=0x0F;	// deuxime donne -> "Masque" -> les sorties sont sur les 4 bits de poids faibles
T_IM_Feux.data[2]=0x00;	// troisime donne -> "Valeur" -> au dpart toutes les sorties sont  0 (lampes teintes)
// Envoi trame pour dfinir les sorties  0
Ecrire_Trame(T_IM_Feux);  // Envoyer trame sur rseau CAN
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse "Acquittement"
// Initialisations des variables diverses
Compteur_Passage=0;
// Pour afficher titre
gotoxy(1,2);
printf("    TP  n: 1    COMMANDER FEUX D'UN BLOC OPTIQUE         \n");
printf("    **************************************************** \n");
// Boucle principale
//*******************
while(1)
	{Compteur_Passage++;
	if (Compteur_Passage==400000)
		{// C'est la fin temporisation
		// On passe  la lampe suivante en modifiant le paramtre "Valeur" du message
		switch(T_IM_Feux.data[2])
			{case 0 : T_IM_Feux.data[2]=0x01;
				 break;
			 case 1 : T_IM_Feux.data[2]=0x02;
				break;
			 case 2 : T_IM_Feux.data[2]=0x04;
				break;
			 case 4 : T_IM_Feux.data[2]=0x08;
				break;
			 case 8 : T_IM_Feux.data[2]=0;
				break;
			 default : T_IM_Feux.data[2]=0;}
		gotoxy(1,5),printf("Ecrire sur feux arrieres droit:\n");
		Affiche_Trame(T_IM_Feux); 	// Afficher trame envoye  l'cran
		Ecrire_Trame(T_IM_Feux);  	// Envoyer trame sur rseau CAN
		do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre la rponse "Acquittement
		gotoxy(1,10);
		printf("Trame recue en reponse\n");
		Affiche_Trame(Trame_Recue);	// Afficher trame envoye  l'cran
		Compteur_Passage=0;}
	}// FIN de la boucle principale
}// FIN de la fonction principale
