	/***********************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	************************************************************************************************
	*  	TP n 4:   Commander les feux  partir du commodo feux 
	*			Representation d'un tableau de bord sur la carte clavier/afficheur
	*-----------------------------------------------------------------------------------------------		
	*  NOM du FICHIER :  CAN_VMD_TP4_Aff.C			       							
	* ***************** 													
	*************************************************************************************************/

// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "Can_vmd.h"
#include "eid005.h"		//dfinition du module Clavier Afficheur adresse de base 0xb30000
#include "EID005_image.c"	//images  afficher sur le module EID005

#define CRTL			REG_ETAT.bits_octet.b8 //touche CRTL de la carte EID210

void Passer_a_Etat_Modif_Feux(void);
void Passer_a_Etat_Control_Stat(void);
void Gerer_Afficheur(void);

//Variables pour le Clavier Afficheur
int hr = 11, mn = 24, sc = 0 , sc_Mem; //Pour mettre  jour l'heure
int jj = 31, mm = 1, aa = 6; //Pour mettre  jour la date
char heure[20];
//Clavier Matric 4 par 4
short    Touche[4][4] = { 0x0A, 0x00, 0x0B, 0x0F,
				  0x07, 0x08, 0x09, 0x0E,
				  0x04, 0x05, 0x06, 0x0D,
				  0x01, 0x02, 0x03, 0x0C } ;
short TOUCHE; //Touche appuye

// Dclarations des constantes
//-----------------------------

// Pour les temporisations
#define Tempo_Commodo 2		// En dizime de seconde -> 0,2 S
#define Tempo_Clignot 8	   	// En dizime de seconde -> 0,8 S
#define Tempo_Att_Rep 20	// Attente rponse en dizime de seconde -> 2 S
#define Tempo_Affichage 10	// Attente rponse en dizime de seconde -> 0,1 S

// Pour le codage des tats
#define Etat_Lect_Commodo_Feux 0
#define Etat_Modif_Feux 1
#define Etat_Control_Stat 2

// Dclaration des variables
//---------------------------

// Pour les indicateurs divers (variables binaires)
union word_bits Indicateurs;
#define I_Attente_Reponse Indicateurs.bit.b0
#define I_Fin_Tempo_Commodo Indicateurs.bit.b1
#define I_Fin_Tempo_Clignot Indicateurs.bit.b2
#define I_Fin_Tempo_Affichage Indicateurs.bit.b3
#define I_Fin_Tempo_Att_Rep Indicateurs.bit.b4
#define I_En_Att_Rep Indicateurs.bit.b5
#define I_Clignot_Gauche Indicateurs.bit.b6
#define I_Clignot_Droit Indicateurs.bit.b7
#define I_Message_Pb_Affiche Indicateurs.bit.b8
#define I_Warning Indicateurs.bit.b9

// Dclaration des trames
Trame Trame_Recue;
Trame Trame_Envoyee;
Trame T_IM; 	// Trame de type "Input Message" pour commande module 4 Sorties de puissance
Trame T_IRM;  	// Trame de type "Information Request Message" pour interroger "Status" lampes 
			// Ou commodo

// Pour la comparaison des identificateurs Trame envoye <-> Trame reue 
#define Ident_Trame_Envoyee Trame_Envoyee.ident.extend.identificateur.ident
#define Ident_Trame_Recue Trame_Recue.ident.extend.identificateur.ident
#define Ident_T_IRM  T_IRM.ident.extend.identificateur.ident
#define Ident_T_IM  T_IM.ident.extend.identificateur.ident
#define Valeur_T_IM T_IM.data[2]

// Pour les temporisations
WORD Compteur_Passage,Compteur_dS; // dS -> dizime de Seconde
WORD Valeur_Fin_Tempo_Commodo,Valeur_Fin_Tempo_Clignot,Valeur_Fin_Tempo_Affichage,Valeur_Fin_Tempo_Att_Rep;
// Pour le diagramme des tats
unsigned char Etat,Rang_Control_Stat,Rang_Modif_Feux;
// Pour la mmoire
unsigned char Valeur_Commodo_Feux_Mem;
//  Fonction d'interruption "Base de Temps"
void irq_bt()
// Fonction excute toute les 10 mS
{Compteur_Passage++;
if(Compteur_Passage==10) // Une 1/2 Seconde s'est coule
	{Compteur_Passage=0;
	 Compteur_dS++;
	 if(Compteur_dS==Valeur_Fin_Tempo_Commodo)
		{I_Fin_Tempo_Commodo = 1;
		 Valeur_Fin_Tempo_Commodo = Compteur_dS + Tempo_Commodo;}
	 if(Compteur_dS==Valeur_Fin_Tempo_Affichage)
		{I_Fin_Tempo_Affichage = 1;
		 Valeur_Fin_Tempo_Affichage = Compteur_dS + Tempo_Affichage;}
	 if(Compteur_dS==Valeur_Fin_Tempo_Clignot)
		{ if(I_Clignot_Gauche||I_Clignot_Droit||I_Warning)
			{I_Fin_Tempo_Clignot = 1;
		       Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;}
		}
 	 if(Compteur_dS==Valeur_Fin_Tempo_Att_Rep)
		{I_Fin_Tempo_Att_Rep = 1;}
	}
} // Fin de la fonction d'interruption

//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{
int Cptr_TimeOut,Temp;
// Initialisations
//*****************
clsscr();

/* Initialisation du module Clavier Afficheur */
printf("init_aff...\n");
init_aff();
printf("cls aff...\n");
lcd_cls();
printf("clr_graphics...\n");
clr_graphics();
printf("load image...\n");
printf("Charge heure...\n");
cfg_RTC(hr,mn,sc,jj,mm,aa);

/* Initialisation DU SJA1000 de la carte ATON-Systemes" sur  */
Init_Aton_CAN();
//  Dfinition des trames pour activer ou lire un bloc optique 
// D'aprs doc SJA1000 et  doc MCP25050 pages 22 (fonction "Write Register") et 37 (Adresse GPPIN)
// Pour les trames de commande  -> IM  
T_IM.trame_info.registre=0x00;
T_IM.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
Ident_T_IM=Ident_T_IM_FRD;// C'est l'identificateur du bloc optique arrire droit
T_IM.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne -> GPDDR
T_IM.data[1]=0x7F;	// deuxime donne -> "Masque" -> Voir Doc MCP25050 page 16
T_IM.data[2]=0xF0;	// troisime donne -> "Valeur" -> Les sorties sont les 4 bits de poids faibles 

//Configuration du registre de dirrection et
//Verification de la presence des modules
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer une premire trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM_FRD)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse du Feux aRriere Droit a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);

Ident_T_IM=Ident_T_IM_FRG;// C'est l'identificateur du bloc optique arrire gauche
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer une premire trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM_FRG)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse Feux aRriere Gauche a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);

Ident_T_IM=Ident_T_IM_FVG;// C'est l'identificateur du bloc optique aVant gauche
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer une premire trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM_FVG)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse Feux aVant Gauche a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);

Ident_T_IM=Ident_T_IM_FVD;// C'est l'identificateur du bloc optique aVant Droit
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer une premire trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM_FVD)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse Feux aVant Droit a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);

Ident_T_IM=Ident_T_IM_Commodo_Feux;// C'est l'identificateur du bloc Commdo Lumiere
T_IM.data[2]=0xFF;	// troisime donne -> "Valeur" ->8 bits sont des entres 
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer une premire trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM_Commodo_Feux)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse du Commodo Lumire a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);
clsscr();

// Initialiser les sorties  0 (registre GPlat)
T_IM.data[0]=0x1E;	// premire donne -> "Adresse" du registre concerne (GPLAT dfinit l'tat des sorties) 03h+1Ch = 1Eh
T_IM.data[1]=0x0F;	// deuxime donne -> "Masque" -> les sorties sont sur les 4 bits de poids faibles
T_IM.data[2]=0x00;	// troisime donne -> "Valeur" -> au dpart toutes les sorties sont  0 (lampes teintes)

// Pour les trames interrogative ->  IRM  (Information Request Trame)
T_IRM.trame_info.registre=0x00;
T_IRM.trame_info.champ.extend=1;
T_IRM.trame_info.champ.dlc=0x01;
T_IRM.trame_info.champ.rtr=1;
Ident_T_IRM=Ident_T_IRM_Commodo_Feux; // On commence par lire le commodo
Etat = Etat_Lect_Commodo_Feux;
Valeur_Commodo_Feux_Mem=0;
// Et on envoie sur le bus la premire trame 
//Ecrire_Trame(T_IRM);
//Trame_Envoyee = T_IRM;
//I_Attente_Reponse=1;
// Pour l'tat "Control Status"
Rang_Control_Stat=0;
// Pour l'tat "Modif Feux"
Rang_Modif_Feux=0;
// Pour l'ensemble des indicateurs
Indicateurs.valeur=0;
// On envoie sur le bus la premire trame 
Ecrire_Trame(T_IRM);
Trame_Envoyee = T_IRM;
I_Attente_Reponse=1;


// Pour base de temps et temporisations
//***************************************
SetVect(96,&irq_bt);	// mise en place de l'autovecteur 
PITR = 0x0048;		// Une interruption toutes les 10 millisecondes 
PICR = 0x0760; 		//  96 = 60H
// Pour les temporisations
Compteur_Passage = 0,Compteur_dS = 0;
Valeur_Fin_Tempo_Clignot = Tempo_Clignot;
Valeur_Fin_Tempo_Affichage = Tempo_Affichage;
Valeur_Fin_Tempo_Commodo = Tempo_Commodo;
Valeur_Fin_Tempo_Att_Rep = Tempo_Att_Rep;
//   Afficher titre
gotoxy(1,2);
printf("    TP  n: 4    ACTIVER FEUX AVEC COMMODO ET CONTROLER ETAT AMPOULES   \n");
printf("    		Integration d'un tableau de bord				 \n");
printf("    ****************************************************************** \n");

//preparation de l'afficheur
lcd_cls();	//efface l'cran texte
clr_graphics(); //efface l'cran graphique
Load_image(t_bord,0x400); //Affiche le tableau de bord

// Boucle principale
//*******************
while(CRTL==1)
	{
	if(I_Attente_Reponse) // Une trame est attendue
		{
		 if (1==Lire_Trame(&Trame_Recue)) //Si trame reue, la fonction retourne 1
			// Une Trame a t reue
			{I_Attente_Reponse=0;
			 I_Fin_Tempo_Att_Rep=0; // On rarme la tempo attente rponse
			 Valeur_Fin_Tempo_Att_Rep = Compteur_dS + Tempo_Att_Rep;
			 I_En_Att_Rep=0;
			 if(Etat==Etat_Lect_Commodo_Feux)
				// On est dans l'tat "Lecture Commodo"
					{
					if(Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM_Commodo_Feux)
						{ //On verifie que la trame provient bien du commodo Feux
						Valeur_Commodo_Feux=~(Trame_Recue.data[0]); //On rcupre l'tat du commodo
				 	 if(Valeur_Commodo_Feux!= Valeur_Commodo_Feux_Mem)
					 // On a dtect une modification de l'tat commodo
						{Valeur_Commodo_Feux_Mem = Etat_Commodo_Feux.valeur; // On met en mmoire
						 // On prdfinit l'tat des diffrentes ampoules
						 // Combinaisons dfinies dans CAN_VMD.h
						Valeur_FVG=Cde_Nulle,Valeur_FVD=Cde_Nulle; 
 						Valeur_FRG=Cde_Nulle,Valeur_FRD=Cde_Nulle; 
						I_Warning=0;
						I_Clignot_Droit=0;
						I_Clignot_Gauche=0;
						 if(Cde_Phare) // Si Commande Phare
							{Valeur_FVG=Cde_FV_P,Valeur_FVD=Cde_FV_P;  // Les feux aVant
 							 Valeur_FRG=Cde_FR_P,Valeur_FRD=Cde_FR_P;} // Les feux aRire
						 else if(Cde_Code) // Si Commande Code
							{Valeur_FVG=Cde_FV_C,Valeur_FVD=Cde_FV_C;  // Les feux aVant
 							 Valeur_FRG=Cde_FR_C,Valeur_FRD=Cde_FR_C;} // Les feux aRire
						 else if(Cde_Veilleuse) // Si commande Veilleuse
							{Valeur_FVG=Cde_FV_V,Valeur_FVD=Cde_FV_V;  // Les feux aVant
 							 Valeur_FRG=Cde_FR_V,Valeur_FRD=Cde_FR_V;} // Les feux aRire
						 if(Cde_Warning)
							{Valeur_FVG|=Masque_Clign_AV;
							 Valeur_FRG|=Masque_Clign_AR;
							 Valeur_FVD|=Masque_Clign_AV;
							 Valeur_FRD|=Masque_Clign_AR;
							 I_Warning=1;
							 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
							 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
						  else
						    {
						    if(Cde_Clign_Droit)
							{Valeur_FVD|=Masque_Clign_AV;
							 Valeur_FRD|=Masque_Clign_AR;
							 I_Clignot_Droit=1;
							 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
							 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
 						    if(Cde_Clign_Gauche)
							{Valeur_FVG|=Masque_Clign_AV;
							 Valeur_FRG|=Masque_Clign_AR;
							 I_Clignot_Gauche=1;
						 	 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
							 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
						    }
 						 if(Cde_Klaxon)
							{Valeur_FRG|=Masque_Klaxon;
							 Valeur_FRD|=Masque_Klaxon;}
						 if(Cde_Stop)
							{Valeur_FRG|=Masque_Stop;
							 Valeur_FRD|=Masque_Stop;}
						  Gerer_Afficheur(); //on actualise le tableau de bord
						 }
						 Passer_a_Etat_Modif_Feux();} // Fin si action commodo dtect
					else 	Passer_a_Etat_Control_Stat();	} // FIN bloc si "Etat lecture commodo"
			else	if(Etat==Etat_Modif_Feux)
					{// On est dans Etat "Modif feux"
 					//On prpare la trame pour commande feux suivant
 					switch(Rang_Modif_Feux) // Module suivant dans la liste
					{// Le Feux aVant gauche a dj t command
					 case 1 : {Ident_T_IM=Ident_T_IM_FVD; //Feux aVant Droit
							Valeur_T_IM=Valeur_FVD;
							Rang_Modif_Feux++;
							Ecrire_Trame(T_IM); // Envoyer trame
							Trame_Envoyee =T_IM;
							I_Attente_Reponse=1;}
				 	 break;	
					 case 2 : {Ident_T_IM=Ident_T_IM_FRD; //Feux aRrire Droit
							Valeur_T_IM=Valeur_FRD;
							Rang_Modif_Feux++;
							Ecrire_Trame(T_IM); // Envoyer trame
							Trame_Envoyee =T_IM;
							I_Attente_Reponse=1;}
				 	 break;	
					 case 3 : {Ident_T_IM=Ident_T_IM_FRG; //Feux aRrire Gauche
							Valeur_T_IM=Valeur_FRG;
							Rang_Modif_Feux++;
							Ecrire_Trame(T_IM); // Envoyer trame
							Trame_Envoyee =T_IM;
							I_Attente_Reponse=1;
						    }
				 	 break;
					 default : 	// On est arriv  la fin de la modif feux
							// On retourne au controle status
							{Passer_a_Etat_Control_Stat();}
				 	 break;	
					}
					} // FIN bloc "Etat modif feux"
			else	if(Etat==Etat_Control_Stat)
					{//while(I_Fin_Tempo_Affichage==0){};
					 //I_Fin_Tempo_Affichage=0;
 					 switch(Rang_Control_Stat) // Module suivant dans la liste
						{case 0 : 	{// C'est le controle du Feux aVant Gauche 
	 							Valeur_Status_FVG=Trame_Recue.data[0];
								// On passe (peut tre) au feu suivant
								Ident_T_IRM=Ident_T_IRM_FVD;} //Feux aVant Droit	
			 			 break;	
			 			 case 1 : 	{// C'est le controle du Feux aVant Droit
	 							Valeur_Status_FVD=Trame_Recue.data[0];
								// On passe (peut tre) au feu suivant
								Ident_T_IRM=Ident_T_IRM_FRD;} //Feux aRrire Droit
						 break;	
						 case 2 : 	{// C'est le controle du Feux aRrire Droit
	 							Valeur_Status_FRD=Trame_Recue.data[0];
					 			// On passe (peut tre) au feu suivant
								Ident_T_IRM=Ident_T_IRM_FRG;} //Feux aRrire Gauche
			 			 break;	
			 			 case 3 : 	{// C'est le controle du Feux aRrire Gauche
	 							Valeur_Status_FRG=Trame_Recue.data[0];
								// On passe (peut tre) au feu suivant
								Ident_T_IRM=Ident_T_IRM_FVG;} //Feux aVant Gauche
						 break;
						}
					 // On teste s'il est temps  d'aller lire le commodo
					 if(I_Fin_Tempo_Commodo)
						{// Passer  l'tat "Lecture Commodo"
						 I_Fin_Tempo_Commodo=0;
						 Etat = Etat_Lect_Commodo_Feux; 
						 Ident_T_IRM=Ident_T_IRM_Commodo_Feux; 
						 // On envoie sur le bus la premire trame 
						Ecrire_Trame(T_IRM);
						Trame_Envoyee = T_IRM;
						I_Attente_Reponse=1;}
 					// On teste si clignotants activs ET si fin tempo clignotant  
				      else if((I_Clignot_Gauche||I_Clignot_Droit || I_Warning)&&I_Fin_Tempo_Clignot)
						{I_Fin_Tempo_Clignot=0;
						 if(I_Warning)
							{// Commuter ampoules clgnotants droits et gauches
							 Valeur_FVD^=Masque_Clign_AV;
							 Valeur_FRD^=Masque_Clign_AR;
						 	 Valeur_FVG^=Masque_Clign_AV;
						 	 Valeur_FRG^=Masque_Clign_AR;
							 Passer_a_Etat_Modif_Feux();}
						 else
						   {
						   if(I_Clignot_Gauche)
							{// Commuter ampoules clignotants gauche
						 	 Valeur_FVG^=Masque_Clign_AV;
						 	 Valeur_FRG^=Masque_Clign_AR;
							 Passer_a_Etat_Modif_Feux();}
						   if(I_Clignot_Droit)
							{// Commuter ampoules clignotants gauche
							 Valeur_FVD^=Masque_Clign_AV;
							 Valeur_FRD^=Masque_Clign_AR;
							 Passer_a_Etat_Modif_Feux();}
						   }
						 }// Fin prise compte clignotant  
						// On continue le controle des Feux
					else	{if(Rang_Control_Stat==3)Rang_Control_Stat=0;
						 else Rang_Control_Stat++;// Passage au feux suivant
						// On envoie la trame interrogative sur le bus
						 Ecrire_Trame(T_IRM);
						 Trame_Envoyee =T_IRM;
						 I_Attente_Reponse=1;}  
					} // FIN bloc "Etat Control Status"
		} // Fin Si trame reue
		else if (I_Fin_Tempo_Att_Rep) // On attend depuis trop longtemps une rponse !
			{clsscr();
			gotoxy(1,2); // On raffiche le titre
printf("    TP  n: 4    ACTIVER FEUX AVEC COMMODO FEUX ET CONTROLER ETAT AMPOULES   \n");
printf("    *********************************************************************** \n");
			 I_Fin_Tempo_Att_Rep=0; // On rarme la tempo attente rponse
			 Valeur_Fin_Tempo_Att_Rep = Compteur_dS + Tempo_Att_Rep;
			 gotoxy(1,4),printf(" !! Attente reponse modules  !!  \n");
			 gotoxy(1,9),printf("                                \n");
		  	 gotoxy(1,20),printf("                               \n");
		 	 gotoxy(1,16),printf("                               \n");
			 I_En_Att_Rep=1;
			 // On refait une tentative d'interrogation commodo
			 Etat = Etat_Lect_Commodo_Feux; 
			 Ident_T_IRM=Ident_T_IRM_Commodo_Feux; 
			 // On envoie sur le bus la premire trame 
			 Ecrire_Trame(T_IRM);
			 Trame_Envoyee = T_IRM;
			I_Attente_Reponse=1;
			}

			 //On refait une tentative d'interrogation du commodo
	if(I_Fin_Tempo_Affichage)
		{I_Fin_Tempo_Affichage=0;
			if(I_En_Att_Rep==0) // Alors on peut afficher
				{		// Rsultat diagnostic Feux aVant Gauche
						gotoxy(1,4),printf("Bloc optique avant gauche:     \n");
						if(Veilleuse_FVG==1 && S_Veilleuse_FVG==0)
						{gotoxy(1,5),printf("!! Probleme sur Veilleuse avant gauche   \n");}
					 	if(Veilleuse_FVG==0 && S_Veilleuse_FVG==1)
					 	{gotoxy(1,5),printf("                                         \n");}
					 	if(Code_FVG==1 && S_Code_FVG==0)
						{gotoxy(1,6),printf("!! Probleme sur Code avant gauche        \n");}
					 	if(Code_FVG==0 && S_Code_FVG==1)
						{gotoxy(1,6),printf("                                         \n");}
					 	if(Phare_FVG==1 && S_Phare_FVG==0)
						{gotoxy(1,7),printf("!! Probleme sur Phare avant gauche        \n");}
					 	if(Phare_FVG==0 && S_Phare_FVG==1)
						{gotoxy(1,7),printf("                                          \n");}
					 	if(Clignot_FVG==1 && S_Clignot_FVG==0)
						{gotoxy(1,8),printf("!! Probleme sur Clignotant avant gauche   \n");}
					 	if(Clignot_FVG==0 && S_Clignot_FVG==1)
						{gotoxy(1,8),printf("                                          \n");}
						// Rsultat diagnostic Feux aVant Droit
						gotoxy(1,9),printf("Bloc optique avant Droit:\n");
						if(Veilleuse_FVD==1 && S_Veilleuse_FVD==0)
						{gotoxy(1,10),printf("!! Probleme sur Veilleuse avant droit \n");}
					 	if(Veilleuse_FVD==0 && S_Veilleuse_FVD==1)
						{gotoxy(1,10),printf("                                      \n");}
					 	if(Code_FVD==1 && S_Code_FVD==0)
						{gotoxy(1,11),printf("!! Probleme sur Code avant droit       \n");}
					 	if(Code_FVD==0 && S_Code_FVD==1)
						{gotoxy(1,11),printf("                                       \n");}
					 	if(Phare_FVD==1 && S_Phare_FVD==0)
						{gotoxy(1,12),printf("!! Probleme sur Phare avant droit     \n");}
					 	if(Phare_FVD==0 && S_Phare_FVD==1)
						{gotoxy(1,12),printf("                                       \n");}
					 	if(Clignot_FVD==1 && S_Clignot_FVD==0)
						{gotoxy(1,13),printf("!! Probleme sur Clignotant avant droit  \n");}
					 	if(Clignot_FVD==0 && S_Clignot_FVD==1)
						{gotoxy(1,13),printf("                                        \n");} 
						// Rsultat diagnostic Feux aRierre Droit
						gotoxy(1,20),printf("Feux arriere droit:\n");
						if(Veilleuse_FRD==1 && S_Veilleuse_FRD==0)
						{gotoxy(1,21),printf("!! Probleme sur Lampe Arriere droit     \n");}
					 	if(Veilleuse_FRD==0 && S_Veilleuse_FRD==1)
						{gotoxy(1,21),printf("                                        \n");}
					 	if(Clignot_FRD==1 && S_Clignot_FRD==0)
						{gotoxy(1,22),printf("!! Probleme sur Clignotant Arriere droit \n");}
					 	if(Clignot_FRD==0 && S_Clignot_FRD==1)
						{gotoxy(1,22),printf("                                         \n");}
					 	if(Stop_FRD==1 && S_Stop_FRD==0)
						{gotoxy(1,23),printf("!! Probleme sur Stop Arriere droit       \n");}
					 	if(Stop_FRD==0 && S_Stop_FRD==1)
						{gotoxy(1,23),printf("                                         \n");}
						// Rsultat diagnostic Feux aVant Gauche
						gotoxy(1,16),printf("Feux arriere gauche:\n");
						if(Veilleuse_FRG==1 && S_Veilleuse_FRG==0)
						{gotoxy(1,17),printf("!! Probleme sur Lampe Arriere Gauche      \n");}
					 	if(Veilleuse_FRG==0 && S_Veilleuse_FRG==1)
						{gotoxy(1,17),printf("                                          \n");}
					 	if(Clignot_FRG==1 && S_Clignot_FRG==0)
						{gotoxy(1,18),printf("!! Probleme sur Clignotant Arriere Gauche \n");}
					 	if(Clignot_FRG==0 && S_Clignot_FRG==1)
						{gotoxy(1,18),printf("                                          \n");}
					 	if(Stop_FRG==1 && S_Stop_FRG==0)
						{gotoxy(1,19),printf("!! Probleme sur Stop Arriere Gauche        \n");}
					 	if(Stop_FRG==0 && S_Stop_FRG==1)
						{gotoxy(1,19),printf("                                          \n");}
					 	if(Klaxon_FRG==1 && S_Klaxon_FRG==0)
						{gotoxy(1,19),printf("!! Probleme sur Klaxon Arriere Gauche      \n");}
					 	if(Klaxon_FRG==0 && S_Klaxon_FRG==1)
						{gotoxy(1,19),printf("                                          \n");}
						// Pour l'ta commodo
			gotoxy(4,24);
			printf("Etat des differentes entrees imposees par le commodo:\n");
printf(" Veilleuse=%d , Code=%d , Phare=%d , clign. G.=%d  \n",Cde_Veilleuse,Cde_Code,Cde_Phare,Cde_Clign_Gauche);
printf(" Klaxon=%d ,    Feux de stop=%d ,    clign. D= %d\n",Cde_Klaxon,Cde_Stop,Cde_Clign_Droit);

				//Actualiser l'heure du module EID005
				//Mise a jour de l'heure
				sc = readbyte(0);
				mn = readbyte(2); 
				hr = readbyte(4);
				//Afficher l'heure
				lcd_gotoxy(0x66,0);
				sprintf(heure,"%2d:%2d:%2d",hr,mn,sc);
				lcd_out_str(heure);
				sc_Mem=sc;
				} // Fin si on n'est pas en attente de rponse aprs message d'alerte
			} // Fin if fin tempo affichage	
	}// FIN de la boucle principale
}// FIN de la fonction principale
}

// Fonction "Passer  l'tat CONTROL STATUS"
void Passer_a_Etat_Control_Stat(void)
{Etat=Etat_Control_Stat; // On retourne  l'tat "Control des status"
		// Pour prparer la trame interrogative pour module suivant dans la liste
		  switch(Rang_Control_Stat) // Module suivant dans la liste
			{case 0 : Ident_T_IRM=Ident_T_IRM_FVG; //Feux aVant Gauche
			 break;	
			 case 1 : Ident_T_IRM=Ident_T_IRM_FVD; //Feux aVant Droit
			 break;	
			 case 2 : Ident_T_IRM=Ident_T_IRM_FRD; //Feux aRrire Droit
			 break;	
			 case 3 : Ident_T_IRM=Ident_T_IRM_FRG; //Feux aRrire Gauche
			 break;
			 default : {Rang_Control_Stat=0;
					Ident_T_IRM=Ident_T_IRM_FVG;} //Feux aVant Gauche
			 break;
			}
	// On envoie la trame interrogative sur le bus
	Ecrire_Trame(T_IRM);
	Trame_Envoyee =T_IRM;
	I_Attente_Reponse=1;
} // FIN fonction "Paaser  Etat control Status"

// Fonction "Passer  l'Etat Modification Feux"
void Passer_a_Etat_Modif_Feux(void)
{WORD I_TEMP;
 Etat=Etat_Modif_Feux; // Passer  l'tat "Modif feux"
 //On prpare la trame pour commander premier feux  
 Ident_T_IM=Ident_T_IM_FVG; // Feux aVant Gauche: Premier dans la liste
 Valeur_T_IM=Valeur_FVG;
 Rang_Modif_Feux=1;
 // On envoie la trame de commande sur le bus
 Ecrire_Trame(T_IM);
 I_Attente_Reponse=1;
} //  FIN Fonction "Passer  l'Etat Modification Feux"						 

//Affichage des symboles sur l'afficheur128*64
//Gestion de l'affichage des images
void Gerer_Afficheur(void)
{
//Affichage des images lumires
if(Cde_Veilleuse) AfficheImage(8,8,i_veil,1);
	else AfficheImage(8,8,i_veil,0);
if(Cde_Code) AfficheImage(8,28,i_code,1);
	else AfficheImage(8,28,i_code,0);
if(Cde_Phare) AfficheImage(8,40,i_phare,1);
	else AfficheImage(8,40,i_phare,0);
if(Cde_Warning)
	{
	AfficheImage(64,8,i_c_droit,1);
	AfficheImage(40,8,i_c_gauche,1);
	}
	else 
	{
	if(Cde_Clign_Droit) AfficheImage(64,8,i_c_droit,1);
			else AfficheImage(64,8,i_c_droit,0);
	if(Cde_Clign_Gauche) AfficheImage(40,8,i_c_gauche,1);
			else AfficheImage(40,8,i_c_gauche,0);
	}
}
