	/************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)		*	
	*************************************************************************************
	*   TP n5:  Commander le moteur de l'essuie glace avant
	*--------------------------------------------------------  		
	*   CAHIER DES CHARGES :					      				
	*  *********************						      			
	*  On souhaite que l'essuie ralise le cycle suivant:
	*	- rotation droite avec une vitesse croissante de 0  Vmax  
	*	- rotation droite avec une vitesse dcroissante de Vmax  0  
	*	- rotation gauche avec une vitesse croissante de 0  Vmax 
 	*	- rotation gauche avec une vitesse dcroissante de Vmax  0  
	* 	etc ...
	*  On affichera  l'cran, dans quelle partie du cycle on se situe, avec quel niveau de vitesse
	*----------------------------------------------------------------------------------------------
	*  NOM du FICHIER :  CAN_VMD_TP5.C			       				
	* ***************** 									
	**********************************************************************************************/

// Dclaration des fichiers d'inclusion
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_vmd.h"

// Dclaration des variables 
int Cptr_TimeOut;
// Pour les indicateurs divers (variables binaires)
union byte_bits Indicateurs;
#define I_Sens_Rotation Indicateurs.bit.b0
#define I_Sens_Variation Indicateurs.bit.b1
#define I_Autorise_Rot	Indicateurs.bit.b2
#define I_Attente_Trame_Acquittement Indicateurs.bit.b3
#define I_Message_Pb_Affiche Indicateurs.bit.b4
// Dclarations des diverses trammes de communication sur Bus CAN
Trame Trame_Recue;	// Pour trame qui vient d'tre reue par controleur CAN
// Les trames de type "IM" (trame de commande)
Trame T_IM_Asservissement; 	// Pour les trame de type "IM"  destination de la carte "Asservissement"
					//  IM -> Input Message -> trame de commande

//===========================					
// DEFINITION DES FONCTIONS
//===========================

// De la fonction principale
//============================
main()
{
//  INITIALISATIONS
//------------------

int Cptr_Incrementation_Vitesse=0,Cptr_Affichage=0;
BYTE Module_Vitesse=0;
/* Initialisation DU SJA1000 de la carte PC104 */
Init_Aton_CAN();
clsscr();
I_Message_Pb_Affiche=0;
// Trame de type "IM" (trame de commande): Donnes d'identification
T_IM_Asservissement.trame_info.registre=0x00;
T_IM_Asservissement.trame_info.champ.extend=1;
T_IM_Asservissement.trame_info.champ.dlc=0x03;
T_IM_Asservissement.trame_info.champ.rtr=0;
T_IM_Asservissement.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
// Pour dfinir des Entres/Sorties
T_IM_Asservissement.data[0]=0x1F; 	// Adresse du registre GPDDR  (direction de E/S)
T_IM_Asservissement.data[1]=0xEF; 	// Masque -> Bit 7 non concern 
T_IM_Asservissement.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
do {Ecrire_Trame(T_IM_Asservissement);
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<100));
	 if(Cptr_TimeOut==100)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse a la trame de commande en initialisation \n");
		 	 printf("  Verifier si alimentation 12 V  est OK \n");}}
    }while(Cptr_TimeOut==100);
// Pour mettre  0 les sorties 
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x1C; 	// Masque -> sorties GP4,3,2 sont consernes
T_IM_Asservissement.data[2]=0x00;	// Valeur ->  les 3 sorties  0
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP2 en PWM1  
T_IM_Asservissement.data[0]=0x21; 	// Adresse du registre T1CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM1  
T_IM_Asservissement.data[0]=0x23; 	// Adresse du registre PR1
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP3 en PWM2  
T_IM_Asservissement.data[0]=0x22; 	// Adresse du registre T2CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR2ON=1; Prescaler2=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM2  
T_IM_Asservissement.data[0]=0x24; 	// Adresse du registre PR2
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR2=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser rapport cyclique PWM1  0
T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0;	// Valeur ->  PWM1DC=0 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser rapport cyclique PWM2  0
T_IM_Asservissement.data[0]=0x26; 	// Adresse du registre PWM2DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0;	// Valeur ->  PWM2DC=0 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour Valider le circuit de puissance
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x10; 	// Masque -> sortie GP4 (ValidIP) est consern
T_IM_Asservissement.data[2]=0x10;	// Valeur ->  ValidIP=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Masque pour les commandes IM futures
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns

// Initialisation des variables application
Module_Vitesse=0;
Indicateurs.valeur=0; // Sens positif, vitesse croissante
I_Attente_Trame_Acquittement=0;
Cptr_TimeOut=0;
clsscr();
// Pour afficher titre
gotoxy(1,2);
printf("    TP  n: 5    COMMANDER LE BALAI D'ESSUI GLACE    \n");
printf("    ********************************************** \n");


// BOUCLE PRINCIPALE
//*******************
while(1)
	{if(I_Attente_Trame_Acquittement)
		{Cptr_TimeOut++;
		 if(Lire_Trame(&Trame_Recue)==1)
		  {if(Trame_Recue.ident.extend.identificateur.ident==Ident_T_AIM_Asservissement)
			{// C'est bien l'"Acq IM" du module "Asservissement"
			  I_Attente_Trame_Acquittement=0;}}
		 else {if(Cptr_TimeOut==65000)
			  {clsscr();
		 	   gotoxy(1,10);
		 	   printf(" Pas de reponse a une trame de commande en cours de cycle \n");
			   printf(" Recharger le programme puis relancer\n");
			   do{}while(1);}}
		}
	// Bloc pour faire voluer l'tat
	Cptr_Incrementation_Vitesse++;
	if (Cptr_Incrementation_Vitesse==2000)
		{// Il est temps de faire voluer la vitesse moteur
		Cptr_Incrementation_Vitesse=0;
		if(I_Sens_Variation) // Si on doit diminuer la vitesse
			{Module_Vitesse--;
			 if(Module_Vitesse==255)Module_Vitesse=0,I_Sens_Variation=0,I_Sens_Rotation=!I_Sens_Rotation;}
		else {Module_Vitesse++; // Sinon, on augmente la vitesse
			if(Module_Vitesse==0)Module_Vitesse=255,I_Sens_Variation=1;}
		if(I_Sens_Rotation) // Si on tourne en ngatif
			{if(I_Attente_Trame_Acquittement==0)
				{T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
				 T_IM_Asservissement.data[2]=Module_Vitesse; 
					// En thorie : 0--> 0 tr/min et 255 ->5000 tr/min 
				 Ecrire_Trame(T_IM_Asservissement);
				 I_Attente_Trame_Acquittement=1,Cptr_TimeOut=0;}}
		else	{if(I_Attente_Trame_Acquittement==0)
				{T_IM_Asservissement.data[0]=0x26; 	// Adresse du registre PWM2DC
				 T_IM_Asservissement.data[2]=Module_Vitesse;
				 Ecrire_Trame(T_IM_Asservissement);
				 I_Attente_Trame_Acquittement=1,Cptr_TimeOut=0;}}
		} // Fin modification vitesse moteur
	// Bloc pour afficher l'tat
	Cptr_Affichage++;
	if(Cptr_Affichage==20000)
		{Cptr_Affichage=0;
		gotoxy(1,10);
		if(I_Sens_Rotation==0)
			{printf("Trame pour commander le moteur en negatif                Valeur\n");
			 Affiche_Trame(T_IM_Asservissement);}
	 	else  {printf("Trame pour commander le moteur en positif                Valeur\n");
			 Affiche_Trame(T_IM_Asservissement);}}
	} //  Fin boucle principale
} // Fin fonction principale


