	/************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)		*	
	*************************************************************************************
	*   TP n7 :  Rguler la vitesse du balai d'essuie-glace 
	*-------------------------------------------------------------------------------------  		
	*   CAHIER DES CHARGES :					      				
	*  *********************						      			
	*  Etape 1: Faire varier la vitesse du moteur avec le potentiomtre implant sur le 
	*		module "Asservissement"
	* 		Afficher le rsultat de conversion de l'entre potentiomtre ainsi que de 
	*		l'ente image vitesse
	*---------------------------------------------------------------------------------------
	*  NOM du FICHIER :  CAN_VMD_TP7_1.C			       				
	* ***************** 									
	*****************************************************************************************/

// Dclaration des fichiers d'inclusion
#include <stdio.h>
#include"Structures_Donnees.h"
#include"cpu_reg.h"
#include "eid210_reg.h"
#include "CAN_vmd.h"

// Dclarations des diverses trames de communication
Trame Trame_Recue;	// Pour la trame qui vient d'etre reue par le controleur
// Trmes de type "IM" (Input Message -> trame de commande)
Trame T_IM_Asservissement; 	// Pour la commande du moteur
Trame T_IRM_Acquisition_FC_AN;	// Pour l'acquisition des entres Ana et fins de courses
// Dclaration des variables 
// Pour les Indicateurs divers (variables binaires)
union byte_bits Indicateurs; // Structures de bits
#define I_Sens_Rotation Indicateurs.bit.b0 
#define I_Attente_Reponse_IRM Indicateurs.bit.b1 
#define I_Message_Pb_Affiche Indicateurs.bit.b2 
// Pour les rsultats de conversion
unsigned short S_Mesure_Vitesse,S_Val_Pot,S_Temp;
unsigned char AN0H,AN1H,AN10L;

//======================
// FONCTION PRINCIPALE
//======================
main()
{
//  INITIALISATIONS
//------------------
// Dclaration de variables locales  la fonction principale
// Les diffrents compteurs
unsigned int Cptr_Affichage,Cptr_TimeOut,Ctpr_Acquisition;
// Initilisation carte controleur rseau CAN
Init_Aton_CAN();
// Effacer l'cran
clsscr();
// Initialisation des diffrentes trames et envoi aux modules CAN
// Trame de type "IM" (trame de commande): Donnes d'identification
T_IM_Asservissement.trame_info.registre=0x00;
T_IM_Asservissement.trame_info.champ.extend=1;
T_IM_Asservissement.trame_info.champ.dlc=0x03;
T_IM_Asservissement.trame_info.champ.rtr=0;
T_IM_Asservissement.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
// Pour dfinir des Entres/Sorties
T_IM_Asservissement.data[0]=0x1F; 	// Adresse du registre GPDDR  (direction de E/S)
						// doc MCP25050 Page 16 
T_IM_Asservissement.data[1]=0xEF; 	// Masque -> Bit 7 non concern 
T_IM_Asservissement.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM_Asservissement); 	// C'est la premire trame envoye
	 Cptr_TimeOut=0;				// On teste si le module rpond bien			
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<100));
	 if(Cptr_TimeOut==100)
		{if(I_Message_Pb_Affiche==0)
		 	{I_Message_Pb_Affiche=1;
		  	 gotoxy(2,10);
	 	  	 printf(" Pas de reponse a la trame de commande en initialisation \n");
	 	 	 printf("  Verifier si alimentation 12 V  est OK \n");}}
    }while(Cptr_TimeOut==100);
clsscr();
// Pour mettre  0 les sorties 
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x1C; 	// Masque -> sorties GP4,3,2 sont consernes
T_IM_Asservissement.data[2]=0x00;	// Valeur ->  les 3 sorties  0
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP2 en PWM1  
T_IM_Asservissement.data[0]=0x21; 	// Adresse du registre T1CON
T_IM_Asservissement.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 conserns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM1  
T_IM_Asservissement.data[0]=0x23; 	// Adresse du registre PR1
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser rapport cyclique PWM1 
T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
T_IM_Asservissement.data[2]=100;	// Valeur ->  PWM1DC=0 
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour Valider le circuit de puissance
T_IM_Asservissement.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM_Asservissement.data[1]=0x10; 	// Masque -> sortie GP4 (ValidIP) est consern
T_IM_Asservissement.data[2]=0x10;	// Valeur ->  
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour activer les conversions Ana -> Num
T_IM_Asservissement.data[0]=0x2A; 	// Adresse du registre ADCON0  
T_IM_Asservissement.data[1]=0xF0; 	// Masque -> bits 7..4 concerns
T_IM_Asservissement.data[2]=0x80;	// Valeur ->  ADON=1 et "prescaler rate"=1:32
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir le mode de conversion
T_IM_Asservissement.data[0]=0x2B; 	// Adresse du registre ADCON1  
T_IM_Asservissement.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM_Asservissement.data[2]=0x0C;	// Valeur ->  voir doc MCP25050 page 36
Ecrire_Trame(T_IM_Asservissement);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour acqurir les rsultats de conversion A->N et fins de courses
// Trame de type "IRM" (trame interrogative): Donnes d'identification
T_IRM_Acquisition_FC_AN.trame_info.registre=0x00;
T_IRM_Acquisition_FC_AN.trame_info.champ.extend=1;
T_IRM_Acquisition_FC_AN.trame_info.champ.dlc=0x08; // On demande les valeurs de 8 rgistres
T_IRM_Acquisition_FC_AN.trame_info.champ.rtr=1;
T_IRM_Acquisition_FC_AN.ident.extend.identificateur.ident=Ident_T_IRM8_Asservissement; // 
Cptr_Affichage=0;
Ctpr_Acquisition=0;
// Pour afficher titre
gotoxy(1,2);
printf(" TP  n: 7_1    FAIRE VARIER LA VITESSE DU BALAI D'ESSUIE GLACE   \n");
printf(" ********************************************************************* \n");
printf("     - en agissant sur le potentiometre sur carte Asservissement \n");
printf("     - en boucle ouverte (On ne tient pas compte de la mesure vitesse) \n");
printf(" ********************************************************************* \n");


// BOUCLE PRINCIPALE
//*******************
while(1)
	{Ctpr_Acquisition++;
	if(Ctpr_Acquisition==10)
	{Ctpr_Acquisition=0;
	// Acqurir les rsultats de conversion
	Ecrire_Trame(T_IRM_Acquisition_FC_AN); // Demande trame de lecture fin de course et AN
	Cptr_TimeOut=0;
	do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<20000));
	 if(Cptr_TimeOut==20000)
		{clsscr(),gotoxy(2,10);
		 printf(" Pas de reponse a la trame interrogative acquerir resultats de conversion \n");
		 printf("  Il faut recharger et relancer le programme \n");
		 do{}while(1);} // Stop 
	 else {if(Trame_Recue.ident.extend.identificateur.ident==Ident_T_IRM8_Asservissement)
			// Si identificateur correct
			 {AN0H =Trame_Recue.data[2]; 	// On rcupre les MSB de Tension potentiometre
	 		 AN1H =Trame_Recue.data[3]; 	// On rcupre les MSB de la mesure vitesse
			 AN10L =Trame_Recue.data[4];} // On rcupre les LSB AN1 et AN0
	 	 	 // Traiter les donnes et reconstituer les rsultats
			 S_Val_Pot=(unsigned short)(AN0H);	//Transfert avec transtypage
			 S_Val_Pot=S_Val_Pot<<2;	// Dcaler de 2 bits vers poids forts
			 S_Temp=(unsigned short)(AN10L&0x0C); // Pour ne rcuprer que les 2 bits AD1 et AD0
			 S_Val_Pot=S_Val_Pot|(S_Temp>>2);
			 S_Mesure_Vitesse=(unsigned short)(AN1H);	//Transfert avec transtypage
			 S_Mesure_Vitesse=S_Mesure_Vitesse<<2;	// Dcaler de 2 bits vers poids forts
			 S_Temp=(unsigned short)(AN10L&0xC0); // Pour ne rcuprer que les 2 bits AD1 et AD0
			 S_Mesure_Vitesse=S_Mesure_Vitesse|(S_Temp>>6);
			 T_IM_Asservissement.data[0]=0x25; 	// Adresse du registre PWM1DC (Charger cde vitesse)
			 T_IM_Asservissement.data[2]=(AN0H) ;	// Valeur ->  Commande vitesse
			 Ecrire_Trame(T_IM_Asservissement);
			 do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
			}} // Fin acquisition et traitement
	Cptr_Affichage++;
	if(Cptr_Affichage==1000)
		{Cptr_Affichage=0;
		 Cptr_Affichage=0;
		 gotoxy(1,10);
 		 printf("  Valeur de l'entree Potentiomtre:             \n");
 		 printf("  Valeur de la Commande moteur:                 \n");
		 printf("  Valeur de l'entree Mesure vitesse:            \n");
		// Afficher grandeurs
		gotoxy(1,10);
		 printf("  Valeur de l'entree Potentiometre: %d\n",S_Val_Pot);
 		 printf("  Valeur de la Commande moteur: %d \n",AN0H);
		 printf("  Valeur de l'entree Mesure vitesse: %d\n",S_Mesure_Vitesse);}
	} //  Fin boucle principale
} // Fin fonction principale