/******************************************************************/
/*	Gestion du VMD sous Interruption (IRQ3)				*/
/*		Coupl  la carte web sous Interruption (IRQ2)		*/
/*			et au simulateur d'E/S					*/
/*	Fichier objet a inclure:						*/
/*			aton_can.o	ou aton_can2.0 (pour le VMD)		*/
/*			eid001.o	(pour le sim E/S)				*/
/*			eid003.o	(pour la carte WEB)			*/
/******************************************************************/

//Biliotheque standar
#include <stdio.h>
#include <string.h>
#include "eid210.h"

//Biliotheque EID001
#include "eid001.h"

//Biliotheque VMD
#include "aton_can.h"   //Adresse de base 0xB30280 ou 0xB30100 (cfg d'usine)
#include "vmd.h"

//Biliotheque EID003
#include "eid003.h"	//Adresse de base 0xB30000 (acun switch actif)

main()
{
//Variables VMD
int compteur;

COMMODO commodo;
Trame message;
Trame feux_ag;
Trame feux_ad;
Trame feux_avd;
Trame feux_avg;
Trame etat_feux_ag;
Trame com_lum;
Trame e_gpddr;

clsscr();
/*InitSimES*/
printf("init sim E/S...\n");
InitLED();
InitSwitch();
Init7Seg();

// trame pou interroger le commodo lumiere
com_lum.trame_info.registre=0x00;
com_lum.trame_info.champ.extend=1;
com_lum.trame_info.champ.dlc=0x01;
com_lum.trame_info.champ.rtr=1;
com_lum.ident.extend.identificateur.ident=0x5041e07;

e_gpddr.trame_info.registre=0x00;
e_gpddr.trame_info.champ.extend=1;
e_gpddr.trame_info.champ.dlc=0x03;
e_gpddr.ident.extend.identificateur.ident=0x5080000;
e_gpddr.data[0]=0x1F;
e_gpddr.data[1]=0x7F;
e_gpddr.data[2]=0x7F;

// trame pour le feux arrire gauche
feux_ag.trame_info.registre=0x00;
feux_ag.trame_info.champ.extend=1;
feux_ag.trame_info.champ.dlc=0x03;
feux_ag.ident.extend.identificateur.ident=0xF080000;
feux_ag.data[0]=0x1e;	
feux_ag.data[1]=0x0f;
feux_ag.data[2]=0x00;

// trame pour le feux arriere droit
feux_ad.trame_info.registre=0x00;
feux_ad.trame_info.champ.extend=1;
feux_ad.trame_info.champ.dlc=0x03;
feux_ad.ident.extend.identificateur.ident=0xF880000;
feux_ad.data[0]=0x1e;	
feux_ad.data[1]=0x0f;
feux_ad.data[2]=0x00;

// trame pour le feux avant gauche
feux_avg.trame_info.registre=0x00;
feux_avg.trame_info.champ.extend=1;
feux_avg.trame_info.champ.dlc=0x03;
feux_avg.ident.extend.identificateur.ident=0xE080000;
feux_avg.data[0]=0x1e;	
feux_avg.data[1]=0x0f;
feux_avg.data[2]=0x00;

// trame pour le feux avant droit
feux_avd.trame_info.registre=0x00;
feux_avd.trame_info.champ.extend=1;
feux_avd.trame_info.champ.dlc=0x03;
feux_avd.ident.extend.identificateur.ident=0xE880000;
feux_avd.data[0]=0x1e;	
feux_avd.data[1]=0x0f;
feux_avd.data[2]=0x00;

// trame interrogation etat feux arriere gauche
etat_feux_ag.trame_info.registre=0x00;
etat_feux_ag.trame_info.champ.extend=1;
etat_feux_ag.trame_info.champ.dlc=0x01;
etat_feux_ag.trame_info.champ.rtr=1;
etat_feux_ag.ident.extend.identificateur.ident=0xF041E07;

/* Initialisation DU SJA1000 de la carte PC104 */
printf("init aton...\n");
Init_Aton_CAN();
Ecrire_Trame(e_gpddr);
Ecrire_Trame(feux_ad);
Ecrire_Trame(feux_ag);
Ecrire_Trame(feux_avd);
Ecrire_Trame(feux_avg);

//Initialisation de la carte web
printf("init WEB\n");
//Initialisation des temps d'accs pour la carte EID210
Init_pc104_eid003();
//Configuration + ouverture du port TPC/IP Internet Explorer
SetPort(80);
EID003_CONFIG=0x01;
//Initialisation des varaibles
Init();
//Initialisation de l'I.T.
Init_IRQ_HTML(0x01);

compteur=0;
codeHTML=0;

clsscr();
while(CRTL==1)
	{
	if (1==Lire_Trame(&message))
		{
		gotoxy(1,5);
		Affiche_Trame(message);
		if (message.trame_info.champ.extend==1&&
		    message.ident.extend.identificateur.ident==0x5041E07&&message.trame_info.champ.dlc==1)
			{
			commodo.valeur=~message.data[0];
			gotoxy(5,7);
			printf(" GP0: Veilleuse=%d \n",commodo.commande.veilleuse);
			printf(" GP1: Warning=%d \n",commodo.commande.warning);
			printf(" GP2: Phare=%d \n",commodo.commande.phare);
			printf(" GP3: Code=%d \n",commodo.commande.code);
			printf(" GP4: ClinGauche=%d \n",commodo.commande.clig_gauche);
			printf(" GP5: ClinDroit=%d \n",commodo.commande.clig_droit);
			printf(" GP6: Feux de stop=%d \n",commodo.commande.f_stop);
			printf(" GP7: Klaxon=%d \n\n\n",commodo.commande.klaxon);

			if (commodo.commande.veilleuse==1)
				{
				feux_ad.data[2]|=0x01;
				feux_ag.data[2]|=0x01;
				feux_avd.data[2]|=0x01;
				feux_avg.data[2]|=0x01;
				codeHTML=codeHTML|0x08;
				}
				else
				{
				feux_ad.data[2]&=0xFe;
				feux_ag.data[2]&=0xFe;
				feux_avd.data[2]&=0xFe;
				feux_avg.data[2]&=0xFe;
				codeHTML=codeHTML&0xF7;
				}
			if (commodo.commande.code==1)
				{
				feux_avd.data[2]|=0x02;
				feux_avg.data[2]|=0x02;
				codeHTML=codeHTML&0xF7;
				codeHTML=codeHTML|0x10;
				}
				else
				{
				feux_avd.data[2]&=0xFd;
				feux_avg.data[2]&=0xFd;
				codeHTML=codeHTML&0xEF;
				}
			if (commodo.commande.phare==1)
				{
				feux_avd.data[2]|=0x04;
				feux_avg.data[2]|=0x04;
				codeHTML=codeHTML&0xE7;
				codeHTML=codeHTML|0x20;
				}
				else
				{
				feux_avd.data[2]&=0xFB;
				feux_avg.data[2]&=0xFB;
				codeHTML=codeHTML&0xDF;
				}
			if (commodo.commande.f_stop==1)
				{
				feux_ad.data[2]|=0x02;
				feux_ag.data[2]|=0x02;
				}
				else
				{
				feux_ad.data[2]&=0xFD;
				feux_ag.data[2]&=0xFD;
				}
			if (commodo.commande.klaxon==1)
				{
				feux_ag.data[2]|=0x08;
				}
				else
				{
				feux_ag.data[2]&=0xF7;
				}
			if (commodo.commande.warning==1)
				{
				feux_ad.data[2]^=0x04;
				feux_avd.data[2]^=0x08;
				feux_ag.data[2]^=0x04;
				feux_avg.data[2]^=0x08;
				codeHTML=codeHTML|0x06;
				}
				else
				{
			if (commodo.commande.clig_droit==1)
				{
				feux_ad.data[2]^=0x04;
				feux_avd.data[2]^=0x08;
				codeHTML=codeHTML|0x02;
				}
				else
				{
				feux_ad.data[2]&=0xFB;
				feux_avd.data[2]&=0xF7;
				codeHTML=codeHTML&0xFD;
				}
			if (commodo.commande.clig_gauche==1)
				{
				feux_ag.data[2]^=0x04;
				feux_avg.data[2]^=0x08;
				codeHTML=codeHTML|0x04;
				}
				else
				{
				feux_ag.data[2]&=0xFB;
				feux_avg.data[2]&=0xF7;
				codeHTML=codeHTML&0xFB;
				}
				}

			gotoxy(1,15);
			printf("\n Arriere droit: \n");
			Affiche_Trame(feux_ad);	//feux arr
			printf("\n Arriere gauche: \n");
			Affiche_Trame(feux_ag);
			printf("\n\n\n\n");
			Ecrire_Trame(feux_ad);
			Ecrire_Trame(feux_ag);
			printf("\n Avant droit: \n");
			Affiche_Trame(feux_avd);	//feux av
			printf("\n Avant gauche: \n");
			Affiche_Trame(feux_avg);
			Ecrire_Trame(feux_avd);
			Ecrire_Trame(feux_avg);
			printf("\n");
			}	
		if (message.trame_info.champ.extend==1&&
		    message.ident.extend.identificateur.ident==0xF041E07&&message.trame_info.champ.dlc==1)
			{
			gotoxy(1,22);
			Affiche_Trame(message);
			printf("etat feux arriere gauche =%2.2X\n",message.data[0]);
			}
		}
	compteur++;
	

/*
Gestion des requetes HTML sans IRQ
	if (compteur==1000)
		{
		if(EID003_RX_COUNT!=0)
			{
			gotoxy(1,3);
			GestionHTML(codeHTML);
			codeHTML=0;
			}
		}
*/
	if (compteur==5000)
		{
		gotoxy(1,1);
		printf("demande etat commodo:\n");
		Affiche_Trame(com_lum);
		Ecrire_Trame(com_lum);
		compteur=0;
		}
	else if (compteur==20)
		{
		gotoxy(1,21);
		printf("demande etat feux arriere gauche\n");
//		Affiche_Trame(etat_feux_ag);
		Ecrire_Trame(etat_feux_ag);
		}
	}
feux_ad.data[2]=0;	/*quitter proprement*/
Ecrire_Trame(feux_ad);
for(compteur=0;compteur<20000;compteur++);
feux_ag.data[2]=0;
Ecrire_Trame(feux_ag);
for(compteur=0;compteur<20000;compteur++);
feux_avd.data[2]=0;
Ecrire_Trame(feux_avd);
for(compteur=0;compteur<20000;compteur++);
feux_avg.data[2]=0;
Ecrire_Trame(feux_avg);
for(compteur=0;compteur<20000;compteur++);
Stop_Aton_CAN();
Stop_IRQ_HTML();
clsscr();
}