/* module sur la carte reseau eid003 */

#include "eid003.h"
#include "eid210.h"

//Integration de toutes les images et des pages
#include "eid003_image.c"
#include "eid003_pageHTML.c"
#include "eid003_HTML.c"
#include "eid003_CGI.c"

#define	CSOR7	*(short*)	0xFFFA6A


void Init_pc104_eid003()
{
CSOR7=0x7F20;
printf("Version=%x\n",EID003_VERSION);
}



void SetPort(short port)
{
EID003_PORT_UP=(unsigned char) (port>>8);
EID003_PORT_DW=(unsigned char)(port);
}

short LitPort()
{
short port;
port=(short)(EID003_PORT_UP<<8);
port|=(short)EID003_PORT_DW;
return port;
}

/************************************/
/*	Initialisation des variables	*/
/************************************/
void InitWEB()
{
int i,j;
for(j=0;j<1000;j++) Buffer_reception.complet[j]='\0';
for(j=0;j<10;j++) Buffer_reception.methode[j]='\0';
for(j=0;j<150;j++) Buffer_reception.uri[j]='\0';
for(j=0;j<10;j++) Buffer_reception.version[j]='\0';
for(j=0;j<150;j++) Buffer_reception.body[j]='\0';
Buffer_reception.cpt=0;

for(j=0;j<8;j++) Buffer_emission.version[j]='\0';
Buffer_emission.space=' ';
for(j=0;j<50;j++) Buffer_emission.reason[j]='\0';
Buffer_emission.crlf[0]='\r';
Buffer_emission.crlf[1]='\n';
Buffer_emission.doublecrlf[0]='\r';
Buffer_emission.doublecrlf[1]='\n';
Buffer_emission.doublecrlf[2]='\r';
Buffer_emission.doublecrlf[3]='\n';
for(j=0;j<5000;j++) Buffer_emission.body[j]='\0';
}

/************************************/
/*	Programme principal		*/
/************************************/
GestionHTML(int choixVMD)
{
int tmp,i;
i=EID003_IRQ;
choixVMD=codeHTML;

//	while(EID003_RX_COUNT==0);	//Si le buffer est vide, on attend
//	clsscr(); 

	while(0==strstr(Buffer_reception.complet,standar[1])) //On receptionne tout le buffer 
	VideBufferRX();						//jusqu' \r\n\r\n

	code_erreur=0;
	//On identifie tout les elements provenant de IE
	IndentifieLigneRequete();		//On identifie la ligne de requete Methode, URI_PAGE, VERSION_HTTP
	//On affiche la page demande 
	AfficheBuffer(Buffer_reception.uri,4);

	if(0!=strstr(Buffer_reception.version,version[0])) 	//Identifie la version HTTP1.1
		{
		code_erreur=code_erreur|0x0002; //code HTTP1.1
		if(0!=strstr(Buffer_reception.methode,methode[0])) //Methode GET
			{
				code_erreur=code_erreur|0x0020; //code GET
				
				//Recherche la page qui a t deman
				if(0!=strstr(Buffer_reception.uri,pages[0]))	//Page index
					Reponse_Requete(Index_HTML,Reason_200);

				if(0!=strstr(Buffer_reception.uri,pages[1]))	//Page simes
					Reponse_Requete(Simes_HTML,Reason_200);

				//Lors d'une demande de modification avec la mthode GET,
				//la page apparait sous la forme nompage.html?
				//Il faut donc verifier en premier si on a demande la page pour une modification
				if(0!=strstr(Buffer_reception.uri,pages[9]))	//Page Actes pour une modification
					{
					CGI_PageActes();					//Modifier le code de la page
					Reponse_Requete(Actes_HTML,Reason_200);	//Repondre
					tmp=strlen(Buffer_reception.uri);		//Effacer la varible uri 
					for(i=0;i<tmp;i++) Buffer_reception.uri[i]='\0';
					}
				if(0!=strstr(Buffer_reception.uri,pages[2]))	//Page Actes
					Reponse_Requete(Actes_HTML,Reason_200);

				if(0!=strstr(Buffer_reception.uri,pages[10]))	//Page S_es2 pour une modification
					{
					CGI_PageS_es2();					//Modifier le code de la page
					Reponse_Requete(S_es2_HTML,Reason_200);	//Repondre
					tmp=strlen(Buffer_reception.uri);		//Effacer la varible uri 
					for(i=0;i<tmp;i++) Buffer_reception.uri[i]='\0';
					}
				if(0!=strstr(Buffer_reception.uri,pages[3]))	//Page S_es2
					Reponse_Requete(S_es2_HTML,Reason_200);
				
				//Frames, page principale
				if(0!=strstr(Buffer_reception.uri,pages[4]))	//Page S_es3
					Reponse_Requete(S_es3_HTML,Reason_200);
				//Frames, composant la page principale
				if(0!=strstr(Buffer_reception.uri,pages[5]))	//Page S_esS
					Reponse_Requete(S_esS_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[6]))	//Page S_esP
					Reponse_Requete(S_esP_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[7]))	//Page S_esL
					Reponse_Requete(S_esL_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[8]))	//Page S_es7
					Reponse_Requete(S_es7_HTML,Reason_200);

				//La page s'actualise toutes les 2 secondes
				if(0!=strstr(Buffer_reception.uri,pages[11]))	//Page Autoactu
					{
					CGI_PageAutoActu();
					Reponse_Requete(Auto_Actu_HTML,Reason_200);
					}
				//IMAGES
				if(0!=strstr(Buffer_reception.uri,imagesVMD[0]))	//Tableau de bord
					Reponse_Image(tableaubord_JPG,Reason_200,tableaubord_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[1]))	//Clin droit
					Reponse_Image(clindroit_JPG,Reason_200,clindroit_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[2]))	//Clin gauche
					Reponse_Image(clingauche_JPG,Reason_200,clingauche_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[3]))	//Code
					Reponse_Image(code_JPG,Reason_200,code_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[4]))	//Phare
					Reponse_Image(phare_JPG,Reason_200,phare_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[5]))	//Veuilleuse
					Reponse_Image(veuil_JPG,Reason_200,veuil_JPG_taille);

				//Favoris
				if(0!=strstr(Buffer_reception.uri,pages[12]))	//demande d'ajout dans les favoris
					Reponse_Requete(Erreur_HTML,Reason_200);

				//VMD
				if(0!=strstr(Buffer_reception.uri,pages2[0]))	//Page VMD presentation
					Reponse_Requete(VMD_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages2[1]))	//Page VMD version1
					{
					CGI_Vmd_10_HTML(choixVMD);
				//	Tempo(50);
					Reponse_Requete(Vmd_10_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages2[2]))	//Page VMD version2
					Reponse_Requete(Vmd_20_HTML,Reason_200);


			}
		if(0!=strstr(Buffer_reception.methode,methode[1])) //Methode POST
			{
			code_erreur=code_erreur|0x0040; //code POST
			if(0!=strstr(Buffer_reception.complet,"Content-Length: "))//Si le Content-Length est present
				{
				while(EID003_RX_COUNT!=0) VideBufferRX();		//=> il faut recuperer le body venant de IE
				IndentifieLigneBody(Buffer_reception.body);	//Indentifier le body et le mettre dans son buffer 
				//AfficheBuffer(Buffer_reception.body,8);
				}
				if(0!=strstr(Buffer_reception.uri,pages[5]))	//Page S_esS
					{
					CGI_PageS_esS();
					Reponse_Requete(S_esS_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[6]))	//Page S_esP
					{
					CGI_PageS_esP();
					Reponse_Requete(S_esP_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[7]))	//Page S_esL
					{
					CGI_PageS_esL();
					Reponse_Requete(S_esL_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[8]))	//Page S_es7
					{
					CGI_PageS_es7();
					Reponse_Requete(S_es7_HTML,Reason_200);
					}
			}	
		}
		else	//Ce n'est pas la version HTTP1.1 on en informe l'utilisateur 
		{	//et faire code_erreur=code_erreur|0x0004ou8.
			//Sinon on veut on peut traiter d'autres version ici
		printf("Il ne s'agit pas de la version HTTP1.1\n");
		}

	Analyse_code_erreur(code_erreur); //Analyse les erreurs 
	//Efface les variables de reception,d'identification et de reponses
	Init();
codeHTML=0;
}


/************************************/
/*		Irq du web			*/
/************************************/
void Init_IRQ_HTML(int it)
{
SetVect(28,&GestionHTML);	//ligne IRQ2
EID003_IRQ_ENABLE=it;	//Valid IRQ de la carte Web
VALID_IRQ.valeur=VALID_IRQ.valeur|0x10;	//Valid IRQ2 de la carte EID210
}

void Stop_IRQ_HTML()
{
EID003_IRQ_ENABLE=0x00; //restore IRQ de la carte Web
VALID_IRQ.valeur=VALID_IRQ.valeur&0xEF; //restore IRQ2 de la carte EID210
RestoreVect(28);
}
