#ifndef __EID003_H
#define __EID003_H

/* module de dfinition de la carte reseau eid003 */

#define CARTE_R	(char *) 0xB30000

#define TAILLE_BUFFER	32

typedef struct 
{
	unsigned char adr1;
	unsigned char adr2;
	unsigned char adr3;
	unsigned char adr4;
} adresse_ip;

struct config_ip
{
adresse_ip	tcp_adr;
adresse_ip	tcp_mask;
};

#define EID003_STATUS *(unsigned char *) CARTE_R
#define EID003_CONFIG *(unsigned char *) (CARTE_R+1)
#define EID003_TCP ((struct config_ip *)  (CARTE_R+2))

#define EID003_PORT_UP	*(unsigned char *) (CARTE_R+11)
#define EID003_PORT_DW	*(unsigned char *) (CARTE_R+12)

#define EID003_RX_COUNT	*(unsigned char *) (CARTE_R+13)
#define EID003_TX_COUNT	*(unsigned char *) (CARTE_R+14)
#define EID003_BUFFER	*(unsigned char *) (CARTE_R+15)

#define EID003_IRQ			*(unsigned char *) (CARTE_R+16)
#define EID003_IRQ_ENABLE 	*(unsigned char *) (CARTE_R+17)

#define EID003_VERSION	*(unsigned char *) (CARTE_R+31)

#define EID003_adr 		EID003_TCP->tcp_adr
#define EID003_mask 	EID003_TCP->tcp_mask

/************************************/
/*	Prototype de fonctions		*/
/************************************/

void Init_pc104_eid003();
void SetPort(short port);
void InitWEB();
void Init_IRQ_HTML(int it);
void Stop_IRQ_HTML();

/*Variable de Transmition*/
int codeHTML;

#endif