	/***********************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	************************************************************************************************
	*  	TP n 11:   Ensemble des commandes au volant (Feux + Essuie glace)
	*-----------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*  Raliser le TP9 en y incluant la carte web.
	*  Le fonctionnement de celle-ci se fera sous interruption (IRQ2).
	*  La carte WEB nous permettra une visualisation de l'etat du VMD via une page Internet Explorer.
 	*----------------------------------------------------------------------------------------------	
	*Dans le linker ajouter Aton_Can.o, Eid003.o
	*************************************************************************************************/
// Dclarations
// -> des fichiers  inclure
//***************************
#include <stdio.h>
#include "Structures_Donnees.h"
#include "cpu_reg.h"
#include "eid210_reg.h"
//			Suivant la version de la carte CAN ancienne    ou    nouvelle
//Biliotheque CAN			//Adresse de base      0xB30280    ou    0xB30100   (adresse par defaut)
#include "Can_vmd.h"
//Biliotheque EID003
#include "eid003.h"    		//Adresse de base      0xB30000     ou    0xB30000   (aucun swtich activ)

// -> des prototypes des fonctions 
void Envoi_IM_Et_Test(void); 
void Fonction_VMD(void);
// Dclarations des constantes
//-----------------------------
// Pour les temporisations
#define Tempo_Clignot 8	   	// En dixime de seconde -> 0,8 S
#define Tempo_Affichage 10	// Attente rponse en dixime de seconde -> 0,1 S
// Pour le codage des tats
#define Etat_Attente 0
#define Etat_Modif_Feux 1
#define Etat_Control_Stat 2

// Pour l'essuie Glace
#define Vitesse_Lente 80
#define Vitesse_Rapide 120
#define Tempo1 2	// en secondes
#define Tempo2 4 // Pour mode intermittent
#define Tempo3 6
#define Tempo4 8
#define Tempo5 10

// Dclaration des variables
//---------------------------
//Variable globale

// Pour affichage message alerte
char Texte[25];
//Pour Essuie Glace
unsigned char Valeur_Analogique,Cde_Vitesse,Tempo_Fin;
int Compteur_EG_Secondes,Compteur_EG_Passage_Irq;
// Pour les indicateurs divers (variables binaires)
union word_bits Indicateurs;
#define I_Fin_Tempo_Clignot Indicateurs.bit.b2
#define I_Fin_Tempo_Affichage Indicateurs.bit.b3
#define I_Warning Indicateurs.bit.b5
#define I_Clignot_Gauche Indicateurs.bit.b6
#define I_Clignot_Droit Indicateurs.bit.b7
#define I_Message_Pb_Affiche Indicateurs.bit.b8
#define I_Intermittent Indicateurs.bit.b9
#define I_Autorise_Cycle Indicateurs.bit.b10
// Pour le diagramme des tats Essuie Glace
union byte_bits Etat_EG;
#define Etat_EG_Arret Etat_EG.bit.b0
#define Etat_EG_Rot_Gauche Etat_EG.bit.b1
#define Etat_EG_Rot_Droite Etat_EG.bit.b2

// Pour les fins de courses Essuie Glace
union byte_bits FC;
#define Valeur_FC_EG FC.valeur // Pour l'ensemble des fins de course
#define fs FC.bit.b7	// Pour fin de sur course
#define fcg FC.bit.b6	// Pour fin de course gauche
#define fcd FC.bit.b5	// Pour fin de course droit
unsigned char Valeur_FC_EG_Mem;

// Dclaration des trames
Trame Trame_Recue;
Trame Trame_Envoyee;
Trame T_IM; 	// Trame de type "Input Message" pour commande module 4 Sorties de puissance
Trame T_AIM;	// Trame d'acquittement suite  une IM
Trame T_IRM;  	// Trame de type "Information Request Message" pour interroger "Status" lampes 
			// Ou commodo
	
// Pour la comparaison des identificateurs Trame envoye <-> Trame reue 
#define Ident_Trame_Envoyee Trame_Envoyee.ident.extend.identificateur.ident
#define Ident_Trame_Recue Trame_Recue.ident.extend.identificateur.ident
#define Ident_T_IM  T_IM.ident.extend.identificateur.ident
#define Ident_T_AIM  T_AIM.ident.extend.identificateur.ident
#define Ident_T_IRM  T_IRM.ident.extend.identificateur.ident

#define Valeur_T_IM T_IM.data[2]

// Pour les temporisations
WORD Compteur_Passage,Compteur_dS; // dS -> dixime de Seconde
WORD Valeur_Fin_Tempo_Clignot,Valeur_Fin_Tempo_Affichage,Rang_Affich;
// Pour le diagramme des tats
unsigned char Etat,Rang_Control_Stat,Rang_Modif_Feux;
// Pour la mmoire
unsigned char Valeur_Commodo_Feux_Mem,Valeur_Commodo_EG_Mem;
//  Fonction d'interruption "Base de Temps"
void irq_bt()
// Fonction excute toute les 10 mS
{// Pour les feux
 Compteur_Passage++;
 if(Compteur_Passage==10) // Une 1/10 Seconde s'est coule
	{Compteur_Passage=0;
	 Compteur_dS++;
	 if(Compteur_dS==Valeur_Fin_Tempo_Affichage)
		{I_Fin_Tempo_Affichage = 1;
		 Valeur_Fin_Tempo_Affichage = Compteur_dS + Tempo_Affichage;}
	 if(Compteur_dS==Valeur_Fin_Tempo_Clignot)
		{ if(I_Clignot_Gauche||I_Clignot_Droit||I_Warning)
			{I_Fin_Tempo_Clignot = 1;
		       Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;}
		}
	}
// Pour l'Essuie Glace
if(I_Intermittent) // Si mode intermittent actif
	{Compteur_EG_Passage_Irq++;
	 if(Compteur_EG_Passage_Irq==100)  // Une  Seconde s'est coule
		{Compteur_EG_Passage_Irq=0;
	 	 Compteur_EG_Secondes++;
	 	 if(Compteur_EG_Secondes>=Tempo_Fin)
			{Compteur_EG_Secondes=0;
			 I_Autorise_Cycle=1;}
		}}
} // Fin de la fonction d'interruption

//==========================
//  FONCTION PRINCIPALE
//==========================
main()
{
// Initialisations
//*****************
clsscr();

/* Initialisation DU SJA1000 de la carte ATON-Systemes" sur  */
printf("Init CAN\n");
Init_Aton_CAN();

/*Initialisation de la carte web*/
printf("init WEB\n");
//Initialisation des temps d'accs pour la carte EID210
Init_pc104_eid003();
//Configuration + ouverture du port TPC/IP Internet Explorer
SetPort(80);
EID003_CONFIG=0x01;
//Initialisation des varaibles
Init();
//Initialisation de l'I.T.
Init_IRQ_HTML(0x01);	//sur reception
//Variable de passage pour la gestion de la page web
codeHTML=0;

printf("init OK\n");

//  Dfinition des trames pour activer ou lire un bloc optique 
// D'aprs doc SJA1000 et  doc MCP25050 pages 22 (fonction "Write Register") et 37 (Adresse GPPIN)
// Pour les trames de commande  -> IM (Input Message) 
T_IM.trame_info.registre=0x00;
T_IM.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
// Pour la configuration des modules de 4 sorties et 4 Entres Status
T_IM.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne -> GPDDR
T_IM.data[1]=0x7F;	// deuxime donne -> "Masque" -> Voir Doc MCP25050 page 16
T_IM.data[2]=0xF0;	// troisime donne -> "Valeur" -> Les sorties sont les 4 bits de poids faibles

Ident_T_IM=Ident_T_IM_FRD;    // C'est l'identificateur du Feux aRrire Droit pour l'IM
Ident_T_AIM=Ident_T_AIM_FRD;  // C'est l'identificateur du Feux aRrire Droit pour l'Acquittement
strcpy(Texte,"Feux aRriere Droit    ");
Envoi_IM_Et_Test();
Ident_T_IM=Ident_T_IM_FRG;    // C'est l'identificateur du Feux arrire gauche pour l'IM
Ident_T_AIM=Ident_T_AIM_FRG;  // C'est l'identificateur du Feux arrire gauche pour l'Acquittement
strcpy(Texte,"Feux aRriere Gauche    ");
Envoi_IM_Et_Test();
Ident_T_IM=Ident_T_IM_FVG;    // C'est l'identificateur du Feux aVant Gauche pour l'IM
Ident_T_AIM=Ident_T_AIM_FVG;  // C'est l'identificateur du Feux aVant Gauche pour l'Acquittement
strcpy(Texte,"Feux aVant Gauche    ");
Envoi_IM_Et_Test();
Ident_T_IM=Ident_T_IM_FVD;    // C'est l'identificateur du Feux aVant Droit pour l'IM
Ident_T_AIM=Ident_T_AIM_FVD;  // C'est l'identificateur du Feux aVant Droit pour l'Acquittement
strcpy(Texte,"Feux aVant Droit    ");
Envoi_IM_Et_Test();
// Pour la configuration des modules 8 Entres 

T_IM.data[2]=0x7F; // troisime donne -> "Valeur" -> Pour les modules 8 entres GP7 non concern
Ident_T_IM=Ident_T_IM_Commodo_Feux;    // C'est l'identificateur du Commodo Feux pour l'IM
Ident_T_AIM=Ident_T_AIM_Commodo_Feux;  // C'est l'identificateur du Commodo Feux pour l'Acquittement
strcpy(Texte,"Commodo Feux       ");
Envoi_IM_Et_Test();
Ident_T_IM=Ident_T_IM_Commodo_EG;    // C'est l'identificateur du Commodo Essuie Glace pour l'IM
Ident_T_AIM=Ident_T_AIM_Commodo_EG;  // C'est l'identificateur du Commodo Essuie Glace pour l'Acquittement
strcpy(Texte,"Carte Asservissement");
Envoi_IM_Et_Test();
// Pour la configuration du modules "Asservissement" sur lequel est connect le moteur Essuie Glace
T_IM.data[2]=0xE3;	// Valeur ->  1 si Entre et 0 si Sortie
	// GP7=fs Entre; GP6=fcg Entree; GP5=fcd Entre;  GP4=ValidIP Sortie; 
	// GP3=PWM2 Sortie; GP2=PWM1 Sortie; GP1=AN1 Entre; GP0=AN0 Entre; 
Ident_T_IM=Ident_T_IM_Asservissement;    // C'est l'identificateur du module "Asservissement
Ident_T_AIM=Ident_T_AIM_Asservissement;  // C'est l'identificateur du Commodo Essuie Glace pour l'Acquittement
strcpy(Texte,"Commodo Essuie Glace  ");
Envoi_IM_Et_Test();

// Si on arrive jusque l, c'est que tous les 7 modules ont rpondu !
//--------------------------------------------------------------------
// Pour la configuration de l'entre analogique (Position molette sur le commodo Essuie Glace)
// Pour activer les conversions Ana -> Num
T_IM.data[0]=0x2A; 	// Adresse du registre ADCON0  
T_IM.data[1]=0xF0; 	// Masque -> bits 7..4 concerns
T_IM.data[2]=0x80;	// Valeur ->  ADON=1 et "prescaler rate"=1:32
Ident_T_IM=Ident_T_IM_Commodo_EG;    // C'est l'identificateur du Commodo Essuie Glace pour l'IM
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir le mode de conversion
T_IM.data[0]=0x2B; 	// Adresse du registre ADCON1  
T_IM.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM.data[2]=0x0E;	// Valeur ->  voir doc MCP25050 page 36 (GP0 -> Entre Analogique)
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour configurer les sortie PWM du module "Asservissement"
Ident_T_IM=Ident_T_IM_Asservissement;    // C'est l'identificateur du module "Asservissement"
// Pour dfinir sortie GP2 en PWM1  
T_IM.data[0]=0x21; 	// Adresse du registre T1CON
T_IM.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 concerns
T_IM.data[2]=0x80;	// Valeur ->  TMR1ON=1; Prescaler1=1
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM1  
T_IM.data[0]=0x23; 	// Adresse du registre PR1
T_IM.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM.data[2]=0xFF;	// Valeur ->  PR1=255
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir sortie GP3 en PWM2  
T_IM.data[0]=0x22; 	// Adresse du registre T2CON
T_IM.data[1]=0xB3; 	// Masque -> seuls bit 7;5;4;1;0 concerns
T_IM.data[2]=0x80;	// Valeur ->  TMR2ON=1; Prescaler2=1
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour dfinir frquence signal sortie PWM2  
T_IM.data[0]=0x24; 	// Adresse du registre PR2
T_IM.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM.data[2]=0xFF;	// Valeur ->  PR2=255
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser le rapport cyclique du signal PWM1 
T_IM.data[0]=0x25; 	// Adresse du registre PWM1DC
T_IM.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM.data[2]=0;	// Valeur ->  PWM1DC=0 
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour initialiser le rapport cyclique du signal PWM2  0
T_IM.data[0]=0x26; 	// Adresse du registre PWM2DC
T_IM.data[1]=0xFF; 	// Masque -> tous les bits sont concerns
T_IM.data[2]=0;	// Valeur ->  PWM2DC=0 
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
// Pour Valider le circuit de puissance
T_IM.data[0]=0x1E; 	// Adresse du registre GPLAT  (Registre I/O)
T_IM.data[1]=0x10; 	// Masque -> sortie GP4 (ValidIP) est concern
T_IM.data[2]=0x10;	// Valeur ->  ValidIP=1
Ecrire_Trame(T_IM);
do{}while(Lire_Trame(&Trame_Recue)==0); // Attendre rponse
T_IM.data[1]=0xFF; 	// Masque -> Pour les IM futures

clsscr(); // Pour effacer l'cran
// Pour les trames interrogatives ->  IRM  (Information Request Trame)
T_IRM.trame_info.registre=0x00;
T_IRM.trame_info.champ.extend=1;
T_IRM.trame_info.champ.dlc=0x01;
T_IRM.trame_info.champ.rtr=1;
// Pour Mettre le balai d'essuie glace en position initiale
Ident_T_IRM= Ident_T_IRM1_Asservissement; // Les fins de courses sont connects sur module "Asservissement"
Ecrire_Trame(T_IRM); 	// Envoi trame d'acquisition de l'tat des fins de course (1 octet en rponse)
do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
Valeur_FC_EG=~Trame_Recue.data[0]; 	// On rcupre l'tat des fin de course
if(fcd==0)	//SI le balai EG n'est pas en position droit, on commande une rotation  droite	
	{T_IM.data[0]=0x25; 	// Adresse du registre PWM1DC
	 T_IM.data[2]=Vitesse_Lente;	// Valeur ->  Pour vitesse lente
	 Ident_T_IM=Ident_T_IM_Asservissement;// Ce sera le module "Asservissement qui sera concern
	 Ecrire_Trame(T_IM); 	// Envoi trame de commande moteur
	 do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
	 do	{Ecrire_Trame(T_IRM); 	// Envoi trame d'acquisition tats fins de course
		 do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
		 Valeur_FC_EG=~Trame_Recue.data[0]; 	// On rcupre l'tat des fin de course
		 Valeur_FC_EG_Mem=Valeur_FC_EG;
	 	}while(fcd==0);
 	T_IM.data[2]=0;	// Valeur ->  Pour vitesse nulle
 	Ident_T_IM=Ident_T_IM_Asservissement;
 	Ecrire_Trame(T_IM); 	
 	do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
 	T_IM.data[0]=0x1E; 	// Pour plus tard Adresse du registre sortie GPLAT
	}
// Initialisation des variables d'tat Essuie Glace
Etat_EG_Arret=1,Etat_EG_Rot_Droite=0,Etat_EG_Rot_Gauche=0;
Compteur_EG_Secondes=0,Compteur_EG_Passage_Irq=0;
Valeur_FC_EG_Mem=0;
Valeur_Commodo_Feux_Mem=0;

// Init variable d'tat
Etat = Etat_Attente;	
// Pour l'tat "Control Status"
Rang_Control_Stat=1; 
// Pour l'tat "Modif Feux"
Rang_Modif_Feux=1;
// Pour l'ensemble des indicateurs
Indicateurs.valeur=0;
// Pour l'affichage
Rang_Affich=1;

// Pour base de temps et temporisations
//***************************************
SetVect(96,&irq_bt);	// mise en place de l'auto vecteur 
PITR = 0x0048;		// Une interruption toutes les 10 millisecondes 
PICR = 0x0760; 		//  96 = 60H
// Pour les temporisations
Compteur_Passage = 0,Compteur_dS = 0;
Valeur_Fin_Tempo_Clignot = Tempo_Clignot;
Valeur_Fin_Tempo_Affichage = Tempo_Affichage;
//   Afficher titre
gotoxy(1,1);
 printf("      TP  n: 11    Ensemble des commandes au volant \n");
 printf("      		    Integration d'un tableau de bord \n");
 printf("                   Integration de la carte web      \n");

// Boucle principale
//*******************

/*Demarrage immediat*/
Fonction_VMD();

}// FIN de la fonction principale

// Fonction "Envoi trame et test si module adress rpond
void Envoi_IM_Et_Test(void) 
{int Cptr_TimeOut,Temp;
I_Message_Pb_Affiche=0;
do {Ecrire_Trame(T_IM);// Envoyer trame sur rseau CAN 
	 Cptr_TimeOut=0;
	 do{Cptr_TimeOut++;}while((Lire_Trame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));
       if(Ident_Trame_Recue!=Ident_T_AIM)Cptr_TimeOut=200; // Test si identificateur correct
	 if(Cptr_TimeOut==200)
		{if(I_Message_Pb_Affiche==0)
			{I_Message_Pb_Affiche=1;
			 gotoxy(2,10);
		 	 printf(" Pas de reponse a la trame de commande sur %s \n",Texte);
		 	 printf("  Verifier si presence module et si alimentation 12 V  est OK \n");}
		for(Temp=0;Temp<100000;Temp++);} // Pour attendre un peu! 
    }while(Cptr_TimeOut==200);
} 

void Fonction_VMD()
{
//Lors d'un arret de la fonction VMD, il se peut que l'essuie glace soit rest en position intermediare,
Ident_T_IRM=Ident_T_IRM1_Asservissement; // On commence par l'tat lecture des Fins de Courses EG
Ecrire_Trame(T_IRM);
do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
Valeur_FC_EG=~Trame_Recue.data[0];
if(fcd==0 && fcg==0) //Si l'essuie Glace est bloqu en position mediane
	{
	I_Autorise_Cycle=1;
	Etat_EG_Arret=0,Etat_EG_Rot_Droite=1;	// on force une rotation  droite
	Ident_T_IM=Ident_T_IM_Asservissement;
	T_IM.data[2]=Cde_Vitesse; // On commande la rotation 
	T_IM.data[1]=0xFF; 	// Masque
	T_IM.data[0]=0x25; 	// Adresse du registre PWM2DC
	Ecrire_Trame(T_IM);
  	T_IM.data[0]=0x1E; 	// Adresse du registre sortie (ecritures futures)
	while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
	}

while(1) //n'importe quelle touche du clavier nous fera quitter
 {
// Acquisition tat des fins de courses Essuie Glace
 	Ident_T_IRM=Ident_T_IRM1_Asservissement; // On commence par l'tat lecture des Fins de Courses EG
 	Ecrire_Trame(T_IRM);
	do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
	if(Ident_Trame_Recue==Ident_T_IRM1_Asservissement) // On teste si identificateur correct
	 	{Valeur_FC_EG=~Trame_Recue.data[0];}// On rcupre les tats Fins de Courses
	if((Valeur_FC_EG!=Valeur_FC_EG_Mem)||(I_Autorise_Cycle==1))// Si modif tats fins de courses
		{ Valeur_FC_EG_Mem=Valeur_FC_EG;
		 // Traiter volution Etat Essuie Glace
		 if(Etat_EG_Arret) 	// Si le systme est dans l'tat "Arrt"
			{if(I_Autorise_Cycle) 		// Si on un cycle a t autoris
				{I_Autorise_Cycle=0;
		 	 	 Etat_EG_Arret=0,Etat_EG_Rot_Gauche=1;	// Evolution etat systme
			 	 Ident_T_IM=Ident_T_IM_Asservissement;
		  	 	 T_IM.data[2]=Cde_Vitesse; // On commande la rotation  gauche
				 T_IM.data[1]=0xFF; 	// Masque
		 	 	 T_IM.data[0]=0x26; 	// Adresse du registre PWM2DC
		 	 	 Ecrire_Trame(T_IM);
  				 T_IM.data[0]=0x1E; 	// Adresse du registre sortie (ecritures futures)
		 	 	 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
		 		}}// Fin si Etat_EG_Arret
		if(Etat_EG_Rot_Gauche) 	// Si le systme est dans l'tat "Rotation  Gauche"
			{if(fcg) 		// Si on est arriv en fin de course gauche
				{Etat_EG_Rot_Gauche=0,Etat_EG_Rot_Droite=1;	// Evolution etat systme
			 	 Ident_T_IM=Ident_T_IM_Asservissement;
				 T_IM.data[2]=0; 	// On arrte la rotation  gauche
				 T_IM.data[1]=0xFF; 	// Masque
				 T_IM.data[0]=0x26; 	// Adresse du registre PWM2DC
				 Ecrire_Trame(T_IM);
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				 T_IM.data[2]=Cde_Vitesse; // On commande la rotation gauche
				 T_IM.data[0]=0x25; 	// Adresse du registre PWM1DC
				 Ecrire_Trame(T_IM);
 				 T_IM.data[0]=0x1E; 	// Adresse du registre sortie (critures futures)
				 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
				}}// Fin si Etat_Rot Gauche
		if(Etat_EG_Rot_Droite) 	// Si le systme est dans l'tat "Rotation  droite"
			{if(fcd) 		// Si on est arriv en fin de course droit
			   {if(Cde_EG_Av_Pos1|Cde_EG_Av_Pos2)
			 	{Etat_EG_Rot_Droite=0,Etat_EG_Rot_Gauche=1;	// Evolution tat systme
			 	 Ident_T_IM=Ident_T_IM_Asservissement;
				 T_IM.data[2]=0; 	// On arrte la rotation  droite
				 T_IM.data[0]=0x25; 	// Adresse du registre PWM1DC
		 	  	 Ecrire_Trame(T_IM);
			  	 while(Lire_Trame(&Trame_Recue)==0){}; 	// On attend la rponse
			  	 T_IM.data[2]=Cde_Vitesse; // On commande la rotation  gauche
			  	 T_IM.data[0]=0x26; 	// Adresse du registre PWM2DC
		  	  	 Ecrire_Trame(T_IM);
 				 T_IM.data[0]=0x1E; 	// Adresse du registre sortie (critures futures)
			  	 while(Lire_Trame(&Trame_Recue)==0){}; }	// On attend la rponse
			   else {Etat_EG_Rot_Droite=0,Etat_EG_Arret=1;	// Evolution tat systme
				 Ident_T_IM=Ident_T_IM_Asservissement;
			 	 T_IM.data[2]=0; 	// On arrte la rotation  droite
			 	 T_IM.data[0]=0x25; 	// Adresse du registre PWM1DC
		 	 	 Ecrire_Trame(T_IM);
 				 T_IM.data[0]=0x1E; 	// Adresse du registre sortie (critures futures)
			 	 while(Lire_Trame(&Trame_Recue)==0){};}// On attend la rponse
				}} // Fin si Etat_EG_Rot_Droite
		}   // Fin traiter volution tat Essuie Glace
	// Traiter la modification des feux
	if(Etat==Etat_Modif_Feux)
		{  switch(Rang_Modif_Feux) // Module suivant dans la liste
				{// Le Feux aVant gauche a dj t command
				 case 1 : {Ident_T_IM=Ident_T_IM_FVD; //Feux aVant Droit
						Valeur_T_IM=Valeur_FVD;
						Rang_Modif_Feux++;
						Ecrire_Trame(T_IM); // Envoyer trame
			 	 		while(Lire_Trame(&Trame_Recue)==0){};} // On attend la rponse
			 	 break;	
				 case 2 : {Ident_T_IM=Ident_T_IM_FRD; //Feux aRrire Droit
						Valeur_T_IM=Valeur_FRD;
						Rang_Modif_Feux++;
						Ecrire_Trame(T_IM); // Envoyer trame
			 	 		while(Lire_Trame(&Trame_Recue)==0){};} // On attend la rponse
			 	 break;	
				 case 3 : {Ident_T_IM=Ident_T_IM_FRG; //Feux aRrire Gauche
						Valeur_T_IM=Valeur_FRG;
						Rang_Modif_Feux++;
						Ecrire_Trame(T_IM); // Envoyer trame
			 	 		while(Lire_Trame(&Trame_Recue)==0){};} // On attend la rponse
			 	 break;
				 case 4 : {Ident_T_IM=Ident_T_IM_FVG; //Feux aRrire Gauche
						Valeur_T_IM=Valeur_FVG;
						Ecrire_Trame(T_IM); // Envoyer trame
			 	 		while(Lire_Trame(&Trame_Recue)==0){};
						Etat=Etat_Control_Stat; // On a fini, on passe au controle
						Rang_Control_Stat=1;}	// de l'tat des lampes
			 	 break;
				}  // Fin "switch"
		} // FIN si "Etat modif feux" 
	else   // On n'est pas en tat modif feux
		{  // Acquisition tat Commodo Essuie Glace
		   //On prpare la trame pour interroger le module Commodo Essuie Glace
 		   T_IRM.trame_info.champ.dlc=0x08;	// 8 octets en rponse car voie ana
	 	   Ident_T_IRM=Ident_T_IRM8_Commodo_EG; // Commodo Essuie Glace
 		   Ecrire_Trame(T_IRM); // On envoie la trame interrogative sur le bus
		   T_IRM.trame_info.champ.dlc=0x01;	// 1 octets en rponse pour interrogations futures
		   do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
		   if(Ident_Trame_Recue==Ident_T_IRM8_Commodo_EG)
		   {Valeur_Commodo_EG=~Trame_Recue.data[1];  	// On rcupre l'tat commodo EG
		   Valeur_Analogique=Trame_Recue.data[2];} 	// On rcupre l'tat molette EG
		   // Traiter la modification de l'tat du Commodo Essuie Glace
			 if(Cde_EG_Av_Pos2)I_Autorise_Cycle=1,I_Intermittent=0,Cde_Vitesse=Vitesse_Rapide; 
		 // on autorise les cycles, avec une vitesse rapide, si on est en position 2 sur le commodo)
			else {if(Cde_EG_Av_Pos1||Cde_Lave_Glace_Av==0) I_Autorise_Cycle=1,I_Intermittent=0,Cde_Vitesse=Vitesse_Lente; 
		 // on autorise les cycles, avec une vitesse lente, si on est en position 1 sur le commodo)
			else	{if(Valeur_Analogique>=200)I_Intermittent=0; // Position "Arrt"
				 else {I_Intermittent=1,Cde_Vitesse=Vitesse_Lente; // Position "Intermittent"
				 if(Valeur_Analogique>=150)Tempo_Fin=Tempo5;// Selon la position de la molette
			 	 else {if(Valeur_Analogique>=140)Tempo_Fin=Tempo4;// la tempo plus ou moins longue
			 	 else {if(Valeur_Analogique>=120)Tempo_Fin=Tempo3;	
			 	 else {if(Valeur_Analogique>=90)Tempo_Fin=Tempo2;
			 	 else {if(Valeur_Analogique==0)Tempo_Fin=Tempo1;}}}}}}}
		    // Fin Traiter la modification Commodo Essuie Glace
		    // Fin Acquisition tat Essuie Glace
		// Acquisition de l'tat "Lecture tat Commodo Feux"
		//On prpare la trame pour interroger le module Commodo Essuie Glace
 		Ident_T_IRM=Ident_T_IRM_Commodo_Feux; // Module "Commodo Feux"
 		Ecrire_Trame(T_IRM);// On envoie la trame interrogative sur le bus
		do{}while(Lire_Trame(&Trame_Recue)==0); 	//On attend la rponse
		if(Ident_Trame_Recue==Ident_T_IRM_Commodo_Feux)// On vrifie l'identificateur
			{Valeur_Commodo_Feux=~(Trame_Recue.data[0]);//On rcupre l'tat du commodo
			codeHTML=Valeur_Commodo_Feux;}		//on transfert l'etat du commodo vers la carte WEB
			 if(Valeur_Commodo_Feux!= Valeur_Commodo_Feux_Mem)
			 // Si on a dtect une modification de l'tat commodo
				{Valeur_Commodo_Feux_Mem = Valeur_Commodo_Feux; // On met en mmoire
				 // On prdfinit l'tat des diffrentes ampoules
				 // Combinaisons dfinies dans CAN_VMD.h
				 Valeur_FVG=Cde_Nulle,Valeur_FVD=Cde_Nulle; 
 				 Valeur_FRG=Cde_Nulle,Valeur_FRD=Cde_Nulle; 
				 I_Warning=0;
				 I_Clignot_Droit=0;
				 I_Clignot_Gauche=0;
				 if(Cde_Phare) // Si Commande Phare
					{Valeur_FVG=Cde_FV_P,Valeur_FVD=Cde_FV_P;  // Les feux aVant
 					 Valeur_FRG=Cde_FR_P,Valeur_FRD=Cde_FR_P;} // Les feux aRrire
				 else if(Cde_Code) // Si Commande Code
					{Valeur_FVG=Cde_FV_C,Valeur_FVD=Cde_FV_C;  // Les feux aVant
 					 Valeur_FRG=Cde_FR_C,Valeur_FRD=Cde_FR_C;} // Les feux aRrire
				 else if(Cde_Veilleuse) // Si commande Veilleuse
					{Valeur_FVG=Cde_FV_V,Valeur_FVD=Cde_FV_V;  // Les feux aVant
 					 Valeur_FRG=Cde_FR_V,Valeur_FRD=Cde_FR_V;} // Les feux aRrire
				 if(Cde_Warning)
					{Valeur_FVD|=Masque_Clign_AV;
					 Valeur_FRD|=Masque_Clign_AR;
					 Valeur_FVG|=Masque_Clign_AV;
					 Valeur_FRG|=Masque_Clign_AR;
					 I_Warning=1;
					 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
					 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
				 else{
				  if(Cde_Clign_Droit)
					{Valeur_FVD|=Masque_Clign_AV;
					 Valeur_FRD|=Masque_Clign_AR;
					 I_Clignot_Droit=1;
					 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
					 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
 				  if(Cde_Clign_Gauche)
					{Valeur_FVG|=Masque_Clign_AV;
					 Valeur_FRG|=Masque_Clign_AR;
					 I_Clignot_Gauche=1;
				 	 Valeur_Fin_Tempo_Clignot = Compteur_dS + Tempo_Clignot;
					 I_Fin_Tempo_Clignot = 0;}  // Pour Init tempo_clignot
				     }
 				 if(Cde_Klaxon)
					{Valeur_FRG|=Masque_Klaxon;
					 Valeur_FRD|=Masque_Klaxon;}
				 if(Cde_Stop)
					{Valeur_FRG|=Masque_Stop;
					 Valeur_FRD|=Masque_Stop;}
				 Etat=Etat_Modif_Feux;
				 Rang_Modif_Feux=1;

				}  // Fin si modif commodo feux dtect
			}  // FIN si NON (else) tat modif feux
	if(Etat==Etat_Control_Stat)// Controler les status des sorties Feux
		{// On controle le bon tat des ampoules
		 switch(Rang_Control_Stat) // Module suivant dans la liste
			{case 1 : 	{// C'est le controle du Feux aVant Droite 
					 Ident_T_IRM=Ident_T_IRM_FVD;
					 Ecrire_Trame(T_IRM); // Envoyer trame
	 	 			 while(Lire_Trame(&Trame_Recue)==0){}; // On attend la rponse
					 Valeur_Status_FVD=Trame_Recue.data[0]; // On rcupre tat FVD
					 Rang_Control_Stat++;}
	 		break;	
			case 2 : 	{// C'est le controle du Feux aRrire Droit
					 Ident_T_IRM=Ident_T_IRM_FRD;
					 Ecrire_Trame(T_IRM); // Envoyer trame
	 	 			 while(Lire_Trame(&Trame_Recue)==0){}; // On attend la rponse
					 Valeur_Status_FRD=Trame_Recue.data[0]; // On rcupre tat FRD
					 Rang_Control_Stat++;} 
			break;	
			case 3 : 	{// C'est le contrle du Feux aRrire Gauche
					 Ident_T_IRM=Ident_T_IRM_FRG;
					 Ecrire_Trame(T_IRM); // Envoyer trame
	 	 			 while(Lire_Trame(&Trame_Recue)==0){}; // On attend la rponse
					 Valeur_Status_FRG=Trame_Recue.data[0];
					 Rang_Control_Stat++;} 
	 		break;	
	 		case 4 : 	{// C'est le contrle du Feux aVant Gauche
					 Ident_T_IRM=Ident_T_IRM_FVG;
					 Ecrire_Trame(T_IRM); // Envoyer trame
	 	 			 while(Lire_Trame(&Trame_Recue)==0){}; // On attend la rponse
					 Valeur_Status_FVG=Trame_Recue.data[0];
					 Rang_Control_Stat=1;} // On recommence au dbut!
 		 	break;
			}  // Fin "switch"
		}// Fin si etat "control status"
	// Si clignotement actif et fin temporisation clignoteur
	if((I_Clignot_Gauche||I_Clignot_Droit||I_Warning)&&(I_Fin_Tempo_Clignot))
		{I_Fin_Tempo_Clignot=0;
		 if(I_Warning)
			{// Commuter ampoules clignotants gauche
		 	 Valeur_FVG^=Masque_Clign_AV;
		 	 Valeur_FRG^=Masque_Clign_AR;
			 Valeur_FVD^=Masque_Clign_AV;
			 Valeur_FRD^=Masque_Clign_AR;
			 Etat=Etat_Modif_Feux;
			 Rang_Modif_Feux=1;} 			
		 if(I_Clignot_Gauche)
			{// Commuter ampoules clignotants gauche
		 	 Valeur_FVG^=Masque_Clign_AV;
		 	 Valeur_FRG^=Masque_Clign_AR;
			 Etat=Etat_Modif_Feux;
			 Rang_Modif_Feux=1;} 
		 if(I_Clignot_Droit)
			{// Commuter ampoules clignotants gauche
			 Valeur_FVD^=Masque_Clign_AV;
			 Valeur_FRD^=Masque_Clign_AR;
			 Etat=Etat_Modif_Feux;
			 Rang_Modif_Feux=1;} 
		}  // Fin prise compte clignotant  
	if(I_Fin_Tempo_Affichage)
		{I_Fin_Tempo_Affichage=0;
		 switch(Rang_Affich)
		 {case 1:	// Rsultat diagnostic Feux aVant Gauche
			{
			gotoxy(1,4),printf(" Bloc optique avant gauche:     \n");
			if(Veilleuse_FVG==1 && S_Veilleuse_FVG==0)
				{gotoxy(1,5),printf("  !! Probleme sur Veilleuse avant gauche   \n");
				}
			if(Veilleuse_FVG==0 && S_Veilleuse_FVG==1)
				{gotoxy(1,5),printf("                                           \n");}
			if(Code_FVG==1 && S_Code_FVG==0)
				{gotoxy(1,6),printf("  !! Probleme sur Code avant gauche        \n");
				}
			if(Code_FVG==0 && S_Code_FVG==1)
				{gotoxy(1,6),printf("                                           \n");}
			if(Phare_FVG==1 && S_Phare_FVG==0)
				{gotoxy(1,7),printf("  !! Probleme sur Phare avant gauche        \n");
				}
			if(Phare_FVG==0 && S_Phare_FVG==1)
				{gotoxy(1,7),printf("                                          \n");}
			if(Clignot_FVG==1 && S_Clignot_FVG==0)
				{gotoxy(1,8),printf("  !! Probleme sur Clignotant avant gauche   \n");
				}
			if(Clignot_FVG==0 && S_Clignot_FVG==1)
				{gotoxy(1,8),printf("                                            \n");}
			Rang_Affich++;}
		 	break;
		case 2:	// Rsultat diagnostic Feux aVant Droit
			{
			gotoxy(1,9),printf(" Bloc optique avant Droit:\n");
			if(Veilleuse_FVD==1 && S_Veilleuse_FVD==0)
				{gotoxy(1,10),printf("  !! Probleme sur Veilleuse avant droit \n");
				}
		 	if(Veilleuse_FVD==0 && S_Veilleuse_FVD==1)
				{gotoxy(1,10),printf("                                      \n");}
		 	if(Code_FVD==1 && S_Code_FVD==0)
				{gotoxy(1,11),printf("  !! Probleme sur Code avant droit       \n");
				}
		 	if(Code_FVD==0 && S_Code_FVD==1)
				{gotoxy(1,11),printf("                                         \n");}
		 	if(Phare_FVD==1 && S_Phare_FVD==0)
				{gotoxy(1,12),printf("  !! Probleme sur Phare avant droit     \n");
				}
		 	if(Phare_FVD==0 && S_Phare_FVD==1)
				{gotoxy(1,12),printf("                                         \n");}
		 	if(Clignot_FVD==1 && S_Clignot_FVD==0)
				{gotoxy(1,13),printf("  !! Probleme sur Clignotant avant droit  \n");
				}
			Rang_Affich++;} 
			break;
		case 3:	// Rsultat diagnostic Feux aRierre Droit
			{
			gotoxy(1,20),printf(" Feux arriere droit:\n");
			if(Veilleuse_FRD==1 && S_Veilleuse_FRD==0)
				{gotoxy(1,21),printf("  !! Probleme sur Lampe Arriere droit     \n");
				}
			if(Veilleuse_FRD==0 && S_Veilleuse_FRD==1)
				{gotoxy(1,21),printf("                                          \n");}
			if(Clignot_FRD==1 && S_Clignot_FRD==0)
				{gotoxy(1,22),printf("  !! Probleme sur Clignotant Arriere droit \n");
				}
			if(Clignot_FRD==0 && S_Clignot_FRD==1)
				{gotoxy(1,22),printf("                                         \n");}
			if(Stop_FRD==1 && S_Stop_FRD==0)
				{gotoxy(1,23),printf("  !! Probleme sur Stop Arriere droit       \n");
				}
			if(Stop_FRD==0 && S_Stop_FRD==1)
				{gotoxy(1,23),printf("                                           \n");}
			Rang_Affich++;} 
			break;
		case 4:	// Rsultat diagnostic Feux aVant Gauche
			{
			gotoxy(1,16),printf(" Feux arriere gauche:\n");
			if(Veilleuse_FRG==1 && S_Veilleuse_FRG==0)
				{gotoxy(1,17),printf("  !! Probleme sur Lampe Arriere Gauche      \n");
				}
			if(Veilleuse_FRG==0 && S_Veilleuse_FRG==1)
				{gotoxy(1,17),printf("                                            \n");}
			if(Clignot_FRG==1 && S_Clignot_FRG==0)
				{gotoxy(1,18),printf("  !! Probleme sur Clignotant Arriere Gauche \n");
				}
			if(Clignot_FRG==0 && S_Clignot_FRG==1)
				{gotoxy(1,18),printf("                                           \n");}
			if(Stop_FRG==1 && S_Stop_FRG==0)
				{gotoxy(1,19),printf("  !! Probleme sur Stop Arriere Gauche        \n");
				}
			if(Stop_FRG==0 && S_Stop_FRG==1)
				{gotoxy(1,19),printf("                                          \n");}
		 	if(Klaxon_FRG==1 && S_Klaxon_FRG==0)
				{gotoxy(1,19),printf("!! Probleme sur Klaxon Arriere Gauche      \n");
				}
		 	if(Klaxon_FRG==0 && S_Klaxon_FRG==1)
				{gotoxy(1,19),printf("                                          \n");}
			Rang_Affich++;} 
			break;
		case 5:	// Pour l'tat commodo
			{gotoxy(4,24);
			printf(" Etat des differentes entrees imposees par le commodo:\n");
printf(" Veilleuse=%d , Code=%d , Phare=%d , clign. G.=%d  \n",Cde_Veilleuse,Cde_Code,Cde_Phare,Cde_Clign_Gauche);
printf(" Klaxon=%d ,    Feux de stop=%d ,    clign. D= %d\n",Cde_Klaxon,Cde_Stop,Cde_Clign_Droit);
printf(" Etat commodo Essuie Glace  Etat = %x ;   Mollette = %d \n",Valeur_Commodo_EG,Valeur_Analogique);
			Rang_Affich=1;}
		} // Fin "switch"
		}   // Fin if fin tempo affichage		

	}// FIN de la boucle principale
}
