/* module sur la carte reseau eid003 */

#include "eid003.h"
#include "eid210.h"

//Integration de toutes les images
#include "eid003_image.c"
//Integration de toutes les pages
#include "eid003_pageHTML.c"
//Integration des fonctions
#include "eid003_HTML.c"
//Integration des modifications de pages
#include "eid003_CGI.c"


#define	CSOR7	*(short*)	0xFFFA6A

void Init_pc104_eid003()
{
CSOR7=0x7F20;
printf("Version=%x\n",EID003_VERSION);
}

void SetPort(short port)
{
EID003_PORT_UP=(unsigned char) (port>>8);
EID003_PORT_DW=(unsigned char)(port);
}

short LitPort()
{
short port;
port=(short)(EID003_PORT_UP<<8);
port|=(short)EID003_PORT_DW;
return port;
}

/************************************/
/*	Programme principal		*/
/************************************/
GestionHTML(int choixVMD)
{
int tmp,i;
i=EID003_IRQ;
//Mettre en commentaire si on n'utilise pas l'IRQ
choixVMD=codeHTML;

	while(0==strstr(Buffer_reception.complet,standar[1])) //On receptionne tout le buffer 
	VideBufferRX();						//jusqu' \r\n\r\n

	code_erreur=0;
	//On identifie tout les elements provenant de IE
	IndentifieLigneRequete();		//On identifie la ligne de requete Methode, URI_PAGE, VERSION_HTTP
	//On affiche la page demande 
	AfficheBuffer("                                                  ",28);
	AfficheBuffer(Buffer_reception.uri,28);

	if(0!=strstr(Buffer_reception.version,version[0])) 	//Identifie la version HTTP1.1
		{
		code_erreur=code_erreur|0x0002; //code HTTP1.1
		if(0!=strstr(Buffer_reception.methode,methode[0])) //Methode GET
			{
				code_erreur=code_erreur|0x0020; //code GET
				
				//Recherche la page qui a t deman
				if(0!=strstr(Buffer_reception.uri,pages[0]))	//Page index
					Reponse_Requete(Index_HTML,Reason_200);
				//VMD
				if(0!=strstr(Buffer_reception.uri,pages2[1]))	//Page VMD version1
					{
					CGI_Vmd_10_HTML(choixVMD);
					Reponse_Requete(Vmd_10_HTML,Reason_200);
					}
				//IMAGES
				if(0!=strstr(Buffer_reception.uri,imagesVMD[0]))	//Tableau de bord
					Reponse_Image(tableaubord_JPG,Reason_200,tableaubord_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[1]))	//Clin droit
					Reponse_Image(clindroit_JPG,Reason_200,clindroit_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[2]))	//Clin gauche
					Reponse_Image(clingauche_JPG,Reason_200,clingauche_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[3]))	//Code
					Reponse_Image(code_JPG,Reason_200,code_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[4]))	//Phare
					Reponse_Image(phare_JPG,Reason_200,phare_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,imagesVMD[5]))	//Veuilleuse
					Reponse_Image(veuil_JPG,Reason_200,veuil_JPG_taille);

			}
		if(0!=strstr(Buffer_reception.methode,methode[1])) //Methode POST
			{
			code_erreur=code_erreur|0x0040; //code POST
			if(0!=strstr(Buffer_reception.complet,"Content-Length: "))//Si le Content-Length est present
				{
				while(EID003_RX_COUNT!=0) VideBufferRX();		//=> il faut recuperer le body venant de IE
				IndentifieLigneBody(Buffer_reception.body);	//Indentifier le body et le mettre dans son buffer 
				}
			}	
		}
		else	//Ce n'est pas la version HTTP1.1 on en informe l'utilisateur 
		{	//et faire code_erreur=code_erreur|0x0004ou8.
			//Sinon on veut on peut traiter d'autres version ici
		printf("Il ne s'agit pas de la version HTTP1.1\n");
		}

	Analyse_code_erreur(code_erreur); //Analyse les erreurs 
	//Efface les variables de reception,d'identification et de reponses
	Init();
choixVMD=codeHTML=0;
}


/************************************/
/*		Irq du web			*/
/************************************/
void Init_IRQ_HTML(int it)
{
SetVect(28,&GestionHTML);	//ligne IRQ2
EID003_IRQ_ENABLE=it;	//Valid IRQ de la carte Web
VALID_IRQ.valeur=VALID_IRQ.valeur|0x10;	//Valid IRQ2 de la carte EID210
}

void Stop_IRQ_HTML()
{
EID003_IRQ_ENABLE=0x00; //restore IRQ de la carte Web
VALID_IRQ.valeur=VALID_IRQ.valeur&0xEF; //restore IRQ2 de la carte EID210
RestoreVect(28);
}
