	/************************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	*************************************************************************************************
	*  	TP n 1: Faire commuter les feux d'un bloc optique							
	*----------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite qu' intervalles de temps rguliers on dactive la sortie prcdemment active  
	*   pour activer la suivante (fonction chenillard)   								
 	*----------------------------------------------------------------------------------------------	

	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "mtr86.h"
#include "Structures_donnees.h"
#include "vmd.h"
#include "eid210.h"

//Selection simple d'un bloc optique
#define Feux_Selec Ident_T_IM_FRD

//Prototype de staches
TACHE  init  (void);
TACHE  LectureTrame(void);
TACHE	 chenillard(void);
TACHE  EcrireFeux();

/************************************************************************/
/*				Tache d'initialisation					*/
/************************************************************************/
TACHE init(void)
{
OpenCAN(ATON_V2);	//ATON_V1 pour les anciennes cartes ATONCAN
			//ATON_V2 pour les nouvelles cartes ATONCAN

active(cree(chenillard,1,1024));	//La gestion du chenillard est la tache la plus importante
cree(EcrireFeux,2,1024);		//L'ecriture sur les blocs optiques est  gerer aprs le chenillard
active(cree(LectureTrame,3,1024));	//La tache d'affichage est la moins prioritaire
}

/************************************************************************/
/*				Tache gerant le chenillard				*/
/************************************************************************/
TACHE chenillard(void)
{
//Les variables que l'on passe en parametre sont obligatoirement definies en static
static p_s=0x00;		//Valeur  crire sur le bloc optique
while(1)			//La tache tourne en permanance
	{
	switch(p_s)
			{
			case 0 : p_s=0x01;
				 break;
			case 1 : p_s=0x02;
				break;
			case 2 : p_s=0x04;
				break;
			case 4 : p_s=0x08;
				break;
			case 8 : p_s=0;
				break;
		}	
	m_send(num_tache(EcrireFeux),&p_s);	//Activation de la tache d'ecriture sur le rseau CAN
							//Passage de l'adresse de la valeur
	dort(200);					//Endormissement de la tache pendant 2 seconde
	}
}

/************************************************************************/
/*		Tache gerant l'envoie des trames sur le Rseau CAN		*/
/*Elle sera appele par la tache chenillard					*/
/*Elle s'excute lorsque la tache chenillard sera endormie			*/
/************************************************************************/
TACHE  EcrireFeux(e_s)
char e_s;	//Rcupration du parametre envoy
{
Trame feux;
//Configuration de la trame
feux.trame_info.registre=0x00;
feux.trame_info.champ.extend=1;
feux.trame_info.champ.dlc=0x03;
feux.ident.extend.identificateur.ident=Feux_Selec;
feux.data[0]=0x1e;	
feux.data[1]=0x0f;
feux.data[2]=e_s;
//envoie de la trame sur le rseau CAN
EcrireTrame(&feux);
}

/************************************************************************/
/*			Tache gerant la reception et l'affichage des trames	*/
/*Cette tache est cre et active par la tache d'initialisation		*/
/*Elle s'excutera lorsque la tache chenillard sera endormie et 		*/
/*que la tache Ecrire feux sera termine						*/
/************************************************************************/
TACHE LectureTrame(void)
{
Trame tr_rx;	//definition d'une trame
while(1)		//Tache active en permanance
	{
	LireTrame(&tr_rx);	//Cette  fonction endorme la tache tant qu'il n'y a pas de trames reue
	MONITOR			//Reservation du moniteur pour l'affichage (ressource critique)
	AfficheTrame(&tr_rx);	//Afficher la trame recue
	ENDM				//Libere le moniteur pour une autre tache
	}
}
/************************************************************************/
/*				Programme principal					*/
/************************************************************************/

main()
{
clsscr();
printf("tp1_bus can avec mtr86\n");
//Lancement du noyau temps rel
start_mtr(init,512);
}