	/************************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	*************************************************************************************************
	*  	TP n 2: Acqurir l'tat du commodo de commande feux et afficher les tats des entres  		
	*------------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*   On souhaite qu' intervalles de temps rguliers on interroge le module 8 entres sur lequel 
	*   est reli le commodo de commande des phares 								
	*   -> Les trames reues et envoyes sur le bus CAN sont affiches					
	*   -> Les tats des entres sont affichs									
	*   -> La temporisation est de type "logiciel" 									
 	*----------------------------------------------------------------------------------------------	

	*************************************************************************************************/
// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_donnees.h"
#include "mtr86.h"
#include "vmd.h"

//Dclaration d'un smaphore
SEMAPHORE  s_lect;

//Prototype des taches
TACHE  init  (void);
TACHE  LectureTrame(void);
TACHE  init_commodo(void);
TACHE  lecture_commodo(void);
TACHE  aff();

/************************************************************************/
/*				Tache d'initialisation					*/
/************************************************************************/
TACHE init(void)
{
OpenCAN(ATON_V2);	//ATON_V1 pour les anciennes cartes ATONCAN
			//ATON_V2 pour les nouvelles cartes ATONCAN
s_lect=s_cree(0);	//Cration du Smaphore 
active(cree(init_commodo,1,512));	//priorit 1 pour executer la configuration des E/S ds le debut
active(cree(LectureTrame,2,1024));
active(cree(lecture_commodo,3,1024));
cree(aff,4,1024);
}

/************************************************************************/
/*			Tache d'initialisation du commodo Feux			*/
/************************************************************************/
TACHE init_commodo(void)
{
Trame t_gpdr;
t_gpdr.trame_info.registre=0x00;
t_gpdr.trame_info.champ.extend=1; // On travaille en mode tendu
t_gpdr.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
t_gpdr.ident.extend.identificateur.ident=Ident_T_IM_Commodo_Feux;
t_gpdr.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne 
				//(GPDDR donne la direction des I/O) adresse = 1Fh  page 16
t_gpdr.data[1]=0x7F; 	// deuxime donne -> "Masque" 
				//-> Tous les bits concerns sauf GP0 (voir doc page 16)
t_gpdr.data[2]=0x7F; 	// troisime donne -> "Valeur" -> Tous les bits en entre
// Envoi trame pour dfinir de la direction des entres sorties
EcrireTrame(&t_gpdr);
}

/************************************************************************/
/*			Tache d'interrogation du commodo Feux			*/
/************************************************************************/
TACHE lecture_commodo(void)
{
Trame T_IRM_Commodo_Feux;
//initialisation de la trame
T_IRM_Commodo_Feux.trame_info.registre=0x00;
T_IRM_Commodo_Feux.trame_info.champ.extend=1;
T_IRM_Commodo_Feux.trame_info.champ.dlc=0x01;
T_IRM_Commodo_Feux.trame_info.champ.rtr=1;
T_IRM_Commodo_Feux.ident.extend.identificateur.ident=Ident_T_IRM_Commodo_Feux;
while(1)							//La tache tourne en permanance
	{
	s_wait(s_lect,0);					//Attendre que le smaphore soit libr et  default endore la tache (parametre 0)
	EcrireTrame(&T_IRM_Commodo_Feux);		//pour envoyer une IRM au commodo feux
	}
}

/************************************************************************/
/*			Tache lisant les trames receptionnes			*/
/************************************************************************/
TACHE LectureTrame(void)
{
static Trame tr_rx;
int compteur=0;

while(1)
	{
	LireTrame(&tr_rx);	//endore la tache jusqu' reception d'une trame
	if (compteur++==10)
		{
		MONITOR
		printf("affichage\n");
		ENDM
		m_send(num_tache(aff),&tr_rx);	
		compteur=0;	
		}
	if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_Commodo_Feux)
		{
		dort(20);		//endore la tache 0,2sesconde
		s_signal(s_lect);	//Libere le semaphore pour autoriser l'envoie d'une IRM dans la tache Lecture_Commodo
		}
	}
}

/************************************************************************/
/*					Tache d'affichage					*/
/************************************************************************/
TACHE aff(p_t)
Trame p_t;
{
MONITOR
gotoxy(2,2);
AfficheTrame(&p_t);
if (p_t.ident.extend.identificateur.ident==Ident_T_IRM_Commodo_Feux)
	{ // On a reu l'tat du commodo donc on affiche les nouveaux tats
	Etat_Commodo_Feux.valeur=~p_t.data[0];
	gotoxy(4,16);
	printf("Etat des differentes entrees imposees par le commodo:\n");
	printf("    Octet recupere et complemente (en Hexa) =%2.2x\n",Etat_Commodo_Feux.valeur);
	printf("    Veilleuse= %d ,   Code= %d ,   Phare= %d\n",Cde_Veilleuse,Cde_Code,Cde_Phare);
	printf("    clignotant gauche= %d  ,   clignotant droit= %d\n",Cde_Clign_Gauche,Cde_Clign_Droit); 
	printf("    Klaxon= %d\n",Cde_Klaxon);
	printf("    Feux de stop= %d\n",Cde_Stop);
 	printf("    Commande Warning= %d\n",Cde_Warning);
	}	

ENDM
}

/************************************************************************/
/*					Programme Principal				*/
/************************************************************************/
main()
{
clsscr();
printf("tp1_bus can avec mtr86\n");
start_mtr(init,512);
}