	/***********************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	************************************************************************************************
	*  	TP n 4:   Commander les feux  partir du commodo feux 
	*-----------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	* A intervalles de temps rguliers, on interroge le module sur lequel est connect le commodo lumires 
	* afin de connatre son tat.
	* En fonction de l'tat du commodo lumire, on active les diffrentes lampes des blocs optiques 
	*  avant et arrire.
	* La temporisation ncessaire au fonctionnement des clignotants est ralise par une tache specifiquement
	*   dedi a cet effet
	* Les diffrentes commandes imposes par la position de la manette commodo seront affiches 
	* individuellement.
	* On ralisera en plus des fonctions de controle:								
	*	- On vrifiera (par fonction logicielle) que les lampes commandes sont effectivement 
	*		allumes 
	*	- On affichera quelles sont les lampes concernes ainsi que le rsultat du test.
	*	- Le clignotement (du clignotant) sera indpendant de la permutation des autres lampes 
	*	  ainsi que	de la priode de controle,	
	*	- On dtectera, lors de la phase d'initialisation, si un module ne rpond pas.
	* On impose les priodes suivantes, dans l'ordre de priorit dcroissante:
      *  	- priode de commutation du clignoteur 0,8 S,
      *  	- priode de lecture commodo 0.2 S,
 	*  Ces priodes devront pouvoir tre modifies facilement.
 	*----------------------------------------------------------------------------------------------	

	*************************************************************************************************/

// Fichiers  inclure
//********************
#include <stdio.h>
#include "Structures_donnees.h"
#include "mtr86.h"
#include "vmd.h"

//Pour la Tempo entre deux clignottement
#define Tempo_Clign 8	//en dizieme de seconde


//Prototype des taches
TACHE  Init_VMD  (void);
TACHE  init  (void);
TACHE	 Actualise_Etat_Feux();
TACHE  irq_Clign(void);
TACHE  LectureTrame(void);
TACHE  Lecture_Commodo(void);
TACHE  Verif_Etat_Feux(void);
TACHE  Affichage();

/************************************************************************/
/*				Tache d'initialisation du VMD				*/
/************************************************************************/
TACHE Init_VMD(void)
{
//Configuration des modules
Trame T_IM_CFG,Trame_Recue;
int Temp,Cptr_TimeOut; //Pour les delais d'attente

int cpt;//pour les boucles
//Definition des differnet modules  configurer sous forme de tableau
int identificateur[]={Ident_T_IM_FRG,Ident_T_IM_FRD,Ident_T_IM_FVG,Ident_T_IM_FVD,Ident_T_IM_Commodo_Feux};
int identificateurACK[]={Ident_T_AIM_FRG,Ident_T_AIM_FRD,Ident_T_AIM_FVG,Ident_T_AIM_FVD,Ident_T_AIM_Commodo_Feux};
int valeur_data2[]={0xF0,0xF0,0xF0,0xF0,0xFF};
char *msg[]={"Feux aRriere Gauche","Feux aRriere Droit ","Feux  aVant  Gauche","Feux  aVant  Droit "," Commodo  Lumiere  "};

OpenCAN(ATON_V2);	//ATON_V1 pour les anciennes cartes ATONCAN
			//ATON_V2 pour les nouvelles cartes ATONCAN

//Configuration de la trame pour configuration des E/S
T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
// Pour la configuration des modules de 4 sorties(GP0  GP3) et 4 Entres Status(GP4  GP8)
T_IM_CFG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne -> GPDDR
T_IM_CFG.data[1]=0xFF;	// deuxime donne -> "Masque" -> Voir Doc MCP25050 page 16

//Configuration des modules a adresser et du fonctionnement de leurs E/S
for(cpt=0;cpt<5;cpt++)
{
T_IM_CFG.ident.extend.identificateur.ident=identificateur[cpt]; //mise en place de l'identificateur
T_IM_CFG.data[2]=valeur_data2[cpt];	// troisime donne -> "Valeur" 

MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court d'initialisation
printf("Initialisation du %s\n",msg[cpt]);

do	{
	EcrireTrame(&T_IM_CFG);// Envoyer une premire trame sur rseau CAN 
	Cptr_TimeOut=0;	//La fonction LireTrame endore la tache tant qu'il n'y a pas de trames recues.
	do{Cptr_TimeOut++;}while((LireTrame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));  
     	if(Trame_Recue.ident.extend.identificateur.ident==identificateurACK[cpt])Cptr_TimeOut=200; // Test si identificateur correct
		else {printf("Probleme\n");
			Cptr_TimeOut=0;}
	for(Temp=0;Temp<100000;Temp++); // Pour attendre un peu! 
    	}while(Cptr_TimeOut!=200);
printf("OK\n");
ENDM
}

MONITOR
clsscr();
//L'affichage prend ennormement de temps, donc on anticipe
gotoxy(1,1);
printf("**************************tp4_bus can avec mtr86**************************\n");
printf(" Etat du Commodo Feux                                                     \n");
printf("  GP0: Veilleuse=      ,GP2: Phare=        ,GP3: Code=                    \n");
printf("  GP1: Warning=        ,GP4: ClinGauche=   ,GP5: ClinDroit=               \n");
printf("  GP6: Feux stop=      ,GP7: Klaxon=                                      \n");

printf(" Feux aRriere Gauche:   Action        EtatReel                            \n");
printf(" Veilleuse 										    \n");
printf(" Stop											    \n");
printf(" Clignottant										    \n");
printf(" Klaxon											    \n");
printf("												    \n");
printf(" Feux aRriere Droit:   Action        EtatReel                             \n");
printf(" Veilleuse										    \n");
printf(" Stop											    \n");
printf(" Clignottant										    \n");
printf("												    \n");
printf(" Feux aVant gauche:   Action        EtatReel                              \n");
printf(" Veilleuse  										    \n");
printf(" Code											    \n");
printf(" Phare											    \n");
printf(" Clignottant										    \n");
printf("												    \n");
printf(" Feux aVant Droit:   Action        EtatReel                               \n");
printf(" Veilleuse										    \n");
printf(" Code											    \n");
printf(" Phare											    \n");
printf(" Clignottant										    \n");
ENDM

active(cree(init,1,1024));
dort(0); //Endort la tache indefiniment
}

/************************************************************************/
/*				Tache d'initialisation					*/
/************************************************************************/
TACHE init(void)
{
cree(Actualise_Etat_Feux,1,1024);		//Priorit n1 car la mise en marche des feux est le plus important
active(cree(LectureTrame,2,1024));		//lire les trame sera endormie automatiquement
cree(irq_Clign,2,256);				//Gestion de l'IT prioritaire pour avoir une base de temps exacte
active(cree(Lecture_Commodo,3,1024));	//Lire l'etat du commodo lumiere
cree(Verif_Etat_Feux,5,1024);			//Verifier l'etat des feux est moins important
cree(Affichage,6,1024);				//L'affichage conserve la derniere priorite
}

/************************************************************************/
/*				Tache gerant l'irq					*/
/************************************************************************/
TACHE irq_Clign(void)
{
int actualise;
static char Flag_Fin_Tempo_Clign;

while((Cde_Clign_Gauche || Cde_Clign_Droit || Cde_Warning))
	{
	dort(10*Tempo_Clign);			//Attendre 0.8s
	Flag_Fin_Tempo_Clign^=0x01; 	//Activer ou iniber le flag
//Attention pour envoyer une commande, on verifie en 1er si il s'agit d'un clignottant afin de shinter le Warning
	if(((Cde_Clign_Gauche==0) && (Cde_Clign_Droit==0) && (Cde_Warning==0))) break; //Si commande laches->on quitte
	if(Flag_Fin_Tempo_Clign==0x01) //Fin de la Tempo Clignottant
		{ //pour extiction
		if(Cde_Clign_Droit) actualise=((Valeur_Commodo_Feux^0x20)&0xFD); //Etteind Clin Droit et Wanning
		else if(Cde_Clign_Gauche) actualise=((Valeur_Commodo_Feux^0x10)&0xFD); //Etteind Clin Gauche et Wanning
		else if (Cde_Warning ) actualise=Valeur_Commodo_Feux^0x02; //Warning
		m_send(num_tache(Actualise_Etat_Feux),&actualise); 
		}
	else if(Flag_Fin_Tempo_Clign==0x00) //Fin de la Tempo Clignottant
		{ //pour l'allumer
		if (Cde_Clign_Droit) actualise=Valeur_Commodo_Feux&0xFD; //allume clin Droit, etteind warning
		else if (Cde_Clign_Gauche) actualise=Valeur_Commodo_Feux&0xFD; //allume clin Gauche, etteind warning
		else if (Cde_Warning ) actualise=Valeur_Commodo_Feux; //allum Warning
		m_send(num_tache(Actualise_Etat_Feux),&actualise); 
		}
	}

}

/************************************************************************/
/*				Tache la reception de trame				*/
/*   Cette tache doit en plus grer la mise  jour des variables et 	*/
/* le reveille des taches apropries						*/
/************************************************************************/
TACHE LectureTrame(void)
{
static Trame tr_rx;
static Valeur_Commodo_Feux_Mem;	//variable en stattic car il s'agit d'une memorisation
static Actu_Aff;	//Actu_Aff est defini en static car il s'agit d'un paramattre  transmettre
while(1)				//Tache active en permaance
	{

	if(LireTrame(&tr_rx))  //LireTrame endore la tache tant qu'il n'y a pas de trame recue
	   {
	   if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_Commodo_Feux) //on a recu une reponse du commodo
		{
		Valeur_Commodo_Feux=~(tr_rx.data[0]);	//inversion bit a bit pour l'etat reel du commodo
		if(Valeur_Commodo_Feux_Mem!=Valeur_Commodo_Feux)
			{//et son  etat  chang
			Valeur_Commodo_Feux_Mem=Valeur_Commodo_Feux; //on actualise la valeur memorise
			//Si un clignottant est actif, on valide l'it qui activera Actualise_Etat_Feux
			if(Cde_Clign_Gauche || Cde_Clign_Droit || Cde_Warning) active(num_tache(irq_Clign));
			//sinon, on reveille la tache d'actualisation de l'etat des feux avec la valeur du commodo sans clign
				else m_send(num_tache(Actualise_Etat_Feux),&Valeur_Commodo_Feux_Mem); 
			//On active la tache d'affichage
			Actu_Aff=1;
			m_send(num_tache(Affichage),&Actu_Aff);
			}
		} //Fin traitement commodo

	  if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FRG)
		{
		Valeur_Status_FRG=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FRG=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=2;
		m_send(num_tache(Affichage),&Actu_Aff);
		} //Fin traitement Feux aRriere gauche

	  if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FRD)
		{
		Valeur_Status_FRD=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FRD=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=3;
		m_send(num_tache(Affichage),&Actu_Aff);
		} //Fin traitement Feux aRriere Droit

	  if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FVG)
		{
		Valeur_Status_FVG=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FVG=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=4;
		m_send(num_tache(Affichage),&Actu_Aff);
		}  //Fin traitement Feux aVant Gauche

	  if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FVD)
		{
		Valeur_Status_FVD=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FVD=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=5;
		m_send(num_tache(Affichage),&Actu_Aff);
		} //Fin traitement Feux aVant Droit
	   } //Fin Lire Trame Recue
	} //Fin du while
}

/************************************************************************/
/*				Tache Interrogeant le commmodo (IRM)		*/
/************************************************************************/
TACHE Lecture_Commodo(void)
{
Trame T_IRM_Commodo_Feux;
T_IRM_Commodo_Feux.trame_info.registre=0x00;
T_IRM_Commodo_Feux.trame_info.champ.extend=1;
T_IRM_Commodo_Feux.trame_info.champ.dlc=0x01;
T_IRM_Commodo_Feux.trame_info.champ.rtr=1;
T_IRM_Commodo_Feux.ident.extend.identificateur.ident=Ident_T_IRM_Commodo_Feux;
while(1)		//Tache active en permanace
	{
	EcrireTrame(&T_IRM_Commodo_Feux);
	dort(10); 
	}
}

/************************************************************************/
/*				Tache gerant les feux					*/
/*	En fonction du paramettre pass (image du commodo), on allume ou	*/
/*  on etteind les lampes								*/
/************************************************************************/
TACHE Actualise_Etat_Feux(Value_Commodo)		//tache appele par lecture trame
Port_8ES Value_Commodo; //la variable est sous forme d'une structure de type Port_8ES 
				//qui nous permet un acces directe au niveau du bit
{
Trame T_IM_Feux,T_recue; //Trame qui sera  configurer pour adresser les blocs optiques
Valeur_FRG=0x00;	//mise a zero des blocs optiques
Valeur_FRD=0x00;
Valeur_FVG=0x00;
Valeur_FVD=0x00;

if(Value_Commodo.bit.GP2) //phare
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_P;
	Valeur_FVD|=Cde_FV_P;
	}
else if(Value_Commodo.bit.GP3) //Code
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_C;
	Valeur_FVD|=Cde_FV_C;
	}
else if(Value_Commodo.bit.GP0) //Veilleuse
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_V;
	Valeur_FVD|=Cde_FV_V;
	}

if(Value_Commodo.bit.GP1)	//Warning
	{
	Valeur_FRG|=Masque_Clign_AR;
	Valeur_FRD|=Masque_Clign_AR;
	Valeur_FVG|=Masque_Clign_AV;
	Valeur_FVD|=Masque_Clign_AV;
	}
	else
	{
	if(Value_Commodo.bit.GP4) //Clin gauche
		{
		Valeur_FRG|=Masque_Clign_AR;
		Valeur_FVG|=Masque_Clign_AV;
		}	
	if(Value_Commodo.bit.GP5) //Clin droit
		{
		Valeur_FRD|=Masque_Clign_AR;
		Valeur_FVD|=Masque_Clign_AV;
		}
	}

if(Value_Commodo.bit.GP6)//Stop
	{
	Valeur_FRG|=Masque_Stop;
	Valeur_FRD|=Masque_Stop;
	}

if(Value_Commodo.bit.GP7) //Klaxon
	Valeur_FRG|=Masque_Klaxon;

//printf("FRG=%x\nFRD=%x\nFVG=%x\nFVD=%x\n",Valeur_FRG,Valeur_FRD,Valeur_FVG,Valeur_FVD);

//initialisation de  la trame de commande sur le Feux 
T_IM_Feux.trame_info.registre=0x00;
T_IM_Feux.trame_info.champ.extend=1;
T_IM_Feux.trame_info.champ.dlc=0x03;
T_IM_Feux.data[0]=0x1e;	
T_IM_Feux.data[1]=0x0f;

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FRG;
T_IM_Feux.data[2]=Valeur_FRG;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FRD;
T_IM_Feux.data[2]=Valeur_FRD;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FVG;
T_IM_Feux.data[2]=Valeur_FVG;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FVD;
T_IM_Feux.data[2]=Valeur_FVD;
EcrireTrame(&T_IM_Feux);

//on vient de faire une demande de mofification des feux.
active(num_tache(Verif_Etat_Feux)); // On verifie leur etat
}


/************************************************************************/
/*		Tache Vrifiant l'tat rel des blocs optiques			*/
/*	Envoie d'IRM  destination des 4 blocs optiques				*/
/************************************************************************/
TACHE  Verif_Etat_Feux(void)
{
//initialisation de  la trame de verification d'etat du Feux aVant Gauche
Trame T_IRM_Feux;
T_IRM_Feux.trame_info.registre=0x00;
T_IRM_Feux.trame_info.champ.extend=1;
T_IRM_Feux.trame_info.champ.dlc=0x01;
T_IRM_Feux.trame_info.champ.rtr=1;
T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FRG;
//Envoie sur le Bus Can la trame interrogative
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FRD;
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FVG;
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FVD;
EcrireTrame(&T_IRM_Feux);

//endormissement infinie de la tache (activation sur reveille ou m_send)
}

/************************************************************************/
/*					Tache D'affichage					*/
/************************************************************************/
TACHE Affichage(actu)
char actu;
{
if(actu==1)
	{
	MONITOR		//on actualise les valeurs du Moniteur
	gotoxy(18,3);
	printf("%d\n",Cde_Veilleuse);
	gotoxy(36,3);
	printf("%d\n",Cde_Phare);
	gotoxy(55,3);
	printf("%d\n",Cde_Code);
	gotoxy(16,4);
	printf("%d\n",Cde_Warning);
	gotoxy(41,4);
	printf("%d\n",Cde_Clign_Gauche);
	gotoxy(60,4);
	printf("%d\n",Cde_Clign_Droit);
	gotoxy(18,5);
	printf("%d\n",Cde_Stop);
	gotoxy(37,5);
	printf("%d\n",Cde_Klaxon);
	ENDM
	}
if(actu==2)
	{

		MONITOR
		if(Veilleuse_FRG)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,7);
			printf("1\n");
			gotoxy(40,7);
			if(S_Veilleuse_FRG) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,7);
			printf("0\n");
			gotoxy(40,7);
			printf("  \n");
			}
		if(Stop_FRG)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,8);
			printf("1\n");
			gotoxy(40,8);
			if(S_Stop_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,8);
			printf("0\n");
			gotoxy(40,8);
			printf("  \n");
			}
		if(Clignot_FRG)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,9);
			printf("1\n");
			gotoxy(40,9);
			if(S_Clignot_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,9);
			printf("0\n");
			gotoxy(40,9);
			printf("  \n");
			}
		if(Klaxon_FRG)	//on a demander d'allumer le clignotant
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,10);
			printf("1\n");
			gotoxy(40,10);
			if(S_Klaxon_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,10);
			printf("0\n");
			gotoxy(40,10);
			printf("  \n");
			}
		ENDM
	}

if(actu==3)
{
		MONITOR
		if(Veilleuse_FRD)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,13);
			printf("1\n");
			gotoxy(40,13);
			if(S_Veilleuse_FRD) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,13);
			printf("0\n");
			gotoxy(40,13);
			printf("  \n");
			}
		if(Stop_FRD)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,14);
			printf("1\n");
			gotoxy(40,14);
			if(S_Stop_FRD) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,14);
			printf("0\n");
			gotoxy(40,14);
			printf("  \n");
			}
		if(Clignot_FRD)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,15);
			printf("1\n");
			gotoxy(40,15);
			if(S_Clignot_FRD) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,15);
			printf("0\n");
			gotoxy(40,15);
			printf("  \n");
			}
		ENDM

}

if(actu==4)
{
		MONITOR
		if(Veilleuse_FVG)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,18);
			printf("1\n");
			gotoxy(40,18);
			if(S_Veilleuse_FVG) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,18);
			printf("0\n");
			gotoxy(40,18);
			printf("  \n");
			}
		if(Code_FVG)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,19);
			printf("1\n");
			gotoxy(40,19);
			if(S_Code_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,19);
			printf("0\n");
			gotoxy(40,19);
			printf("  \n");
			}
		if(Phare_FVG)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,20);
			printf("1\n");
			gotoxy(40,20);
			if(S_Phare_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,20);
			printf("0\n");
			gotoxy(40,20);
			printf("  \n");
			}
		if(Clignot_FVG)	//on a demander d'allumer le clignotant
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,21);
			printf("1\n");
			gotoxy(40,21);
			if(S_Clignot_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,21);
			printf("0\n");
			gotoxy(40,21);
			printf("  \n");
			}
		ENDM

}

if(actu==5)
	{
	MONITOR
	if(Veilleuse_FVD)	//on a demander d'allumer la veilleuse
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,24);
		printf("1\n");
		gotoxy(40,24);
		if(S_Veilleuse_FVD) printf("OK\n");	//Status est  1, c'est bon
			else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
		}
	else
		{
		gotoxy(26,24);
		printf("0\n");
		gotoxy(40,24);
		printf("  \n");
		}
	if(Code_FVD)	//on a demander d'allumer le stop
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,25);
		printf("1\n");
		gotoxy(40,25);
		if(S_Code_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,25);
		printf("0\n");
		gotoxy(40,25);
		printf("  \n");
		}
	if(Phare_FVD)	//on a demander d'allumer le Clignot
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,26);
		printf("1\n");
		gotoxy(40,26);
		if(S_Phare_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,26);
		printf("0\n");
		gotoxy(40,26);
		printf("  \n");
		}
	if(Clignot_FVD)	//on a demander d'allumer le clignotant
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,27);
		printf("1\n");
		gotoxy(40,27);
		if(S_Clignot_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,27);
		printf("0\n");
		gotoxy(40,27);
		printf("  \n");
		}
	ENDM
	}

}

/************************************************************************/
/*				Programme Principal					*/
/************************************************************************/
main()
{
clsscr();
start_mtr(Init_VMD,1024);
}