	/************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)			
	*************************************************************************************
	*   TP n5:  Commande essuie glace avant
	*-------------------------------------------------------------------------------------  		
	*   CAHIER DES CHARGES :					      				
	*  *********************						      			
	*  On souhaite une commande normale de l'essuie glace  partir du commodo destin 
	*   cet effet:
	*	- position 'arrt'
	*	- position 'intermittant' -> le balai fait des "aller-retours" spars par des arrets
	*	  dont la dure est rgle par la molette intgre au commodo   
	*	- position 'un' -> le balai fait des "aller-retours"  vitesse lente
	*	- position 'deux' -> le balai fait des "aller-retours"  vitesse rapide
	*	- position 'lave glace' -> le balai fait des "aller-retours"  vitesse lente
 	*  Dans le mode 'intermittent', l'intervalle de temps entre deux battements est gnre 	
	*   par la tache specifiquement ddie a cet effet
	*  On affichera  l'cran, les tats des diverses entres commodo.
	*---------------------------------------------------------------------------------------

	*****************************************************************************************/
// Dclaration des fichiers d'inclusion
#include <stdio.h>
#include "Structures_donnees.h"
#include "mtr86.h"
#include "vmd.h"

//Variables golbales
//Pour la tempo EG
#define Tempo1 2	// en secondes
#define Tempo2 4 // Pour mode intermittent
#define Tempo3 6
#define Tempo4 8
#define Tempo5 10
//Pour les vitesse de battement
#define Vitesse_Rapide 0x80
#define Vitesse_Lente 0x50
#define Vitesse_Lave_Glace 0x60
//Fin de la tempo EG
char Flag_Fin_Tempo_EG;

//Prototype des taches
TACHE  Init_VMD  (void);
TACHE  init  (void);
TACHE	 Actualise_ASV();
TACHE  Lecture_FDC(void);
TACHE  LectureTrame(void);
TACHE  irq_eg();
TACHE  Lecture_Commodo_EG(void);
TACHE  Affichage(void);

TACHE Init_VMD(void)
{
//Configuration des modules
Trame T_IM_CFG,Trame_Recue,T_IRM_Etat_FC;
int Temp,Cptr_TimeOut; //Pour les delais d'attente

int cpt;
//Tableau comprenant les identifiants des modules concerns
int identificateur[]={Ident_T_IM_Commodo_EG,Ident_T_IM_Asservissement};
int identificateurACK[]={Ident_T_AIM_Commodo_EG,Ident_T_AIM_Asservissement};
//Tableau comprennant les donnes permettant la configuration des E/S
int valeur_data2[]={0xFF,0xE3};
//Chaines de caracteres
char *msg[]={" Commodo Essuie Glace "," Module Asservissement"};

//Tableau comprennant toutes les donnes.
//Les 2 premieres valeurs sont pour le Convertisseur Analogique Numeique de la molette du commodo EG.
//Les suivantes sont pour l'Asservissemnt (cfg PWM, frequence, Validation puissance,...)
int datazero[]={0x2A,0x2B,0x21,0x23,0x22,0x24,0x25,0x26,0x1E};
int dataun[]={0xF0,0xFF,0xB3,0xFF,0xB3,0xFF,0xFF,0xFF,0x10};
int datadeux[]={0x80,0x0E,0x80,0xFF,0x80,0xFF,0x00,0x00,0x10};


OpenCAN(ATON_V2);	//ATON_V1 pour les anciennes cartes ATONCAN
			//ATON_V2 pour les nouvelles cartes ATONCAN

T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
// Pour la configuration des modules de 4 sorties(GP0  GP3) et 4 Entres Status(GP4  GP8)
T_IM_CFG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne -> GPDDR
T_IM_CFG.data[1]=0xFF;	// deuxime donne -> "Masque" -> Voir Doc MCP25050 page 16


//Configuration des modules a adresser et du fonctionnement de leurs E/S
for(cpt=0;cpt<2;cpt++)
{
T_IM_CFG.ident.extend.identificateur.ident=identificateur[cpt]; //mise en place de l'identificateur
if(cpt==0) T_IM_CFG.data[2]=valeur_data2[0];	// troisime donne -> "Valeur" 
if(cpt==1) T_IM_CFG.data[2]=valeur_data2[1];	// troisime donne -> "Valeur" 

MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court d'initialisation
printf("Initialisation du %s\n",msg[cpt]);

do	{
	EcrireTrame(&T_IM_CFG);// Envoyer une premire trame sur rseau CAN 
	Cptr_TimeOut=0;	//La fonction LireTrame endore la tache tant qu'il n'y a pas de trames recues.
	do{Cptr_TimeOut++;}while((LireTrame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));  
     	if(Trame_Recue.ident.extend.identificateur.ident==identificateurACK[cpt])Cptr_TimeOut=200; // Test si identificateur correct
		else {printf("Probleme\n");
			Cptr_TimeOut=0;}
	for(Temp=0;Temp<100000;Temp++); // Pour attendre un peu! 
    	}while(Cptr_TimeOut!=200);
printf("OK\n");
ENDM
}

//Configuration specifique du commodo EG et du module Asservissement
for(cpt=0;cpt<9;cpt++)
{
if(cpt==0) T_IM_CFG.ident.extend.identificateur.ident=identificateur[0]; 
if(cpt==2) T_IM_CFG.ident.extend.identificateur.ident=identificateur[1]; 

T_IM_CFG.data[0]=datazero[cpt]; 	// Adresse du registre
T_IM_CFG.data[1]=dataun[cpt]; 	// Masque -> bits concerns
T_IM_CFG.data[2]=datadeux[cpt];	// Valeur 
MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court de configuartion
if(cpt<2) printf("Configuration du %s ...\n",msg[0]);
if(cpt>=2) printf("Configuration du %s ...\n",msg[1]);
ENDM
EcrireTrame(&T_IM_CFG);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
}

//Prise en position origine
MONITOR
printf("Prise de POM de l'essuie glace\n");
ENDM
//Configuration de l'interrogation des fin de course
T_IRM_Etat_FC.trame_info.registre=0x00;
T_IRM_Etat_FC.trame_info.champ.extend=1; // On travaille en mode tendu
T_IRM_Etat_FC.trame_info.champ.dlc=0x01; // Il y aura 1 donnes de 8 bits
T_IRM_Etat_FC.trame_info.champ.rtr=1;	//en rtour
T_IRM_Etat_FC.ident.extend.identificateur.ident=Ident_T_IRM1_Asservissement;
EcrireTrame(&T_IRM_Etat_FC);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
Valeur_FC_EG=~(Trame_Recue.data[0]);

if(!(fcd==0 && fcg==1))
	{
	//Configuration de la trame de pilotage du moteur
	T_IM_CFG.trame_info.registre=0x00;
	T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
	T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
	// Pour la configuration des modules de 4 sorties(GP0  GP3) et 4 Entres Status(GP4  GP8)
	T_IM_CFG.data[0]=0x26;
	T_IM_CFG.data[1]=0xFF;
	T_IM_CFG.data[2]=0x40;
	EcrireTrame(&T_IM_CFG);//active la vitesse negative
	while(!(fcd==0 && fcg==1))
		{
		EcrireTrame(&T_IRM_Etat_FC);
		while(LireTrame(&Trame_Recue)==0){}; //On attend la rponse
		Valeur_FC_EG=~(Trame_Recue.data[0]); // On rcupre l'tat des fin de course
		}
	T_IM_CFG.data[2]=0; //annule la vitesse negative
	EcrireTrame(&T_IM_CFG); //desactiver la commande negative
	} //Fin init module Asservissement
EcrireTrame(&T_IRM_Etat_FC);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
Valeur_FC_EG=~(Trame_Recue.data[0]); 

MONITOR
clsscr();
//L'affichage prend ennormement de temps, donc on anticipe
gotoxy(1,1);
printf("**************************tp5_bus can avec mtr86**************************\n");
printf("  				        							    \n");
printf(" Etat du Commodo Essuie Glace                                             \n");
printf("  GP0: Cde_EG_Av_Int=      	  , Valeur Potar=					    \n");
printf("  GP3: Cde_EG_Av_Pos1=        , GP4: Cde_EG_Av_Pos2=                      \n");
printf("  GP7: Cde_Lave_Glace_Av=   							    \n");
printf("  GP1: Entree1=      		  , GP2: Entree2=       			    \n");
printf("  GP5: Cde_EG_Ar=      		                                        \n");
printf("  GP6: Cde_Lave_Glace_Ar=        							    \n");
printf("  				        							    \n");
printf("  Etat des fins de course sur la carte Asservissemnt			    \n");
printf("  : Fin de Course Gauche =       							    \n");
printf("  : Fin de Sur-Course    =       							    \n");
printf("  : Fin de Course Droit  =       							    \n");

ENDM

active(cree(init,1,1024));
dort(0); //Endort la tache indefiniment
}

TACHE init(void)
{
cree(Actualise_ASV,1,1024);		//Priorit n1 car la gestion de l'essuie glace 
active(cree(Lecture_FDC,1,1024));	//et de l'etat des fin de course sont les plus importants
active(cree(LectureTrame,2,1024));		//lire les trame sera endormie automatiquement
cree(irq_eg,2,1024);				//Tempo entre 2 battement
active(cree(Lecture_Commodo_EG,3,1024));	//Lire l'etat du commodo EG
cree(Affichage,4,1024);				//L'affichage conserve la derniere priorite
}

/******************************************************************************************************************/
/*				Lecture des fins de courses et gerer le sens de rotation du moteur				*/
/******************************************************************************************************************/
TACHE Actualise_ASV(Vitesse_EG)		//tache appele par lecture trame
char Vitesse_EG; 
{
Trame T_IM_Cmde_Negative,T_IM_Cmde_Positive;
//Configuration de la trame Commande Negative
T_IM_Cmde_Negative.trame_info.registre=0x00;
T_IM_Cmde_Negative.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Cmde_Negative.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Cmde_Negative.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
T_IM_Cmde_Negative.data[0]=0x26; 	// Adresse du registre PWM2DC
T_IM_Cmde_Negative.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
//Configuration de la trame Commande Positive
T_IM_Cmde_Positive.trame_info.registre=0x00;
T_IM_Cmde_Positive.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Cmde_Positive.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Cmde_Positive.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
T_IM_Cmde_Positive.data[0]=0x25; 	// Adresse du registre PWM2DC
T_IM_Cmde_Positive.data[1]=0xFF; 	// Masque -> tous les bits sont conserns

//Les commandes lave glace sont inverse sur le commodo (Actif=0 , Inactif=1)
if((Cde_EG_Av_Pos2 || Cde_EG_Av_Pos1 || (Cde_Lave_Glace_Av==0))) //une commande "clasique" est valide
	{
	if(fcd)				//Si on est  droite, retour a gauche
		{
		T_IM_Cmde_Negative.data[2]=Vitesse_EG;
		T_IM_Cmde_Positive.data[2]=0x00;
		}
	else if(fcg)			//Si on est a gauche
		{
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=Vitesse_EG;
		}
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(Valeur_Analogique<200) //la commande intermitante est active, il faut gerer en fonction de la tempo
	{
	if(fcd) //on est  droite, on repart  gauche
		{
		T_IM_Cmde_Negative.data[2]=Vitesse_EG;
		T_IM_Cmde_Positive.data[2]=0x00;
		Flag_Fin_Tempo_EG=0;				//on annule le flag de fin de tempo
		}
	else if ((Flag_Fin_Tempo_EG)) //la tempo est finie
		{
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=Vitesse_EG;	//on lance le moteur
		}
	else if ((fcg) && (Flag_Fin_Tempo_EG==0))
		{ // gauche, en position intermitante, mais la tempo n'est pas finie
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=0x00;	//on arrete le moteur
		}
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(fcd) //on est  droite sans aucune commande, retour  gauche
	{
	T_IM_Cmde_Negative.data[2]=0x40;
	T_IM_Cmde_Positive.data[2]=0x00;
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(fcg) //on est a gauche sans aucune commande
	{
	T_IM_Cmde_Negative.data[2]=0x00;
	T_IM_Cmde_Positive.data[2]=0x00;
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
}

/******************************************************************************************************************/
/*					Envoie d'une trame  la carte Asservissement							*/
/******************************************************************************************************************/
TACHE Lecture_FDC(void)
{
Trame T_IRM_ASV;
T_IRM_ASV.trame_info.registre=0x00;
T_IRM_ASV.trame_info.champ.extend=1;
T_IRM_ASV.trame_info.champ.dlc=0x08;
T_IRM_ASV.trame_info.champ.rtr=1;
T_IRM_ASV.ident.extend.identificateur.ident=Ident_T_IRM1_Asservissement;
while(1)		//Tache active en permanace
	{
	EcrireTrame(&T_IRM_ASV);
	dort(3);
	}
}

/******************************************************************************************************************/
/*						Lecture des trames recue									*/
/******************************************************************************************************************/
TACHE LectureTrame(void)
{
static Trame tr_rx;
static Valeur_Commodo_EG_Mem;	//variable en static car il s'agit d'une memorisation
static Valeur_FC_EG_Mem;
static Valeur_Analogique_Mem;
static Actu_Aff,Vitesse_EG;//definis en static car il s'agit de paramattres  transmettre
static Tempo_EG;
while(1)				//Tache active en permaance
	{
	if(LireTrame(&tr_rx))  //LireTrame endore la tache tant qu'il n'y a pas de trame recue
	   {
	   Actu_Aff=0;
	   if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM8_Commodo_EG) //on a recu une reponse du commodo
		{
		Valeur_Commodo_EG=~(tr_rx.data[1]);	//Recup l'etat du commodo_EG
		Valeur_Analogique=tr_rx.data[2];	//Recup valeur du Potar

		//on determine la position du potar,pour activer la tempo
		if(Valeur_Analogique!=Valeur_Analogique_Mem)
			{
			Actu_Aff=1;
			Valeur_Analogique_Mem=Valeur_Analogique;
			if(Valeur_Analogique>=200) 
				{
				detruit(num_tache(irq_eg));
				Tempo_EG=0;
				}
			else 
				{
				detruit(num_tache(irq_eg));
				Vitesse_EG=Vitesse_Lente; // Position "Intermittent"
				if(Valeur_Analogique>=150)Tempo_EG=Tempo5;// Selon la position de la molette
					else if(Valeur_Analogique>=140)Tempo_EG=Tempo4;// la tempo plus ou moins longue
						else if(Valeur_Analogique>=120)Tempo_EG=Tempo3;	
					 		else if(Valeur_Analogique>=90)Tempo_EG=Tempo2;
					 	 		else if(Valeur_Analogique==0)Tempo_EG=Tempo1;
				m_send(num_tache(irq_eg),&Tempo_EG);
				}
			}

		if(Valeur_Commodo_EG_Mem!=Valeur_Commodo_EG)
			{
			Actu_Aff=1;
			Valeur_Commodo_EG_Mem=Valeur_Commodo_EG;
			Vitesse_EG=0;
			//Desactiver la position intermittente si elle tait selectionne
			if(Valeur_Analogique<200) detruit(num_tache(irq_eg));
			//...Traiter la position selectionne...
			if(Cde_EG_Av_Pos2) Vitesse_EG=Vitesse_Rapide;
			else if(Cde_EG_Av_Pos1) Vitesse_EG=Vitesse_Lente;
			else if(Cde_Lave_Glace_Av==0) Vitesse_EG=Vitesse_Lave_Glace; //inversion commodo
			//...et la reactiver si elle est toujours d'actualit
			else if(Cde_EG_Av_Int && (Valeur_Analogique<200)) 
				{
				Vitesse_EG=Vitesse_Lente;
				m_send(num_tache(irq_eg),&Tempo_EG);
				}
			m_send(num_tache(Actualise_ASV),&Vitesse_EG); 
			}
		} //Fin traitement commodo

	   if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM1_Asservissement) //on a recu une reponse de l'asv
		{
		Valeur_FC_EG=~(tr_rx.data[0]);
		
		if(Valeur_FC_EG_Mem!=Valeur_FC_EG)
			{
			Actu_Aff=2;
			Valeur_FC_EG_Mem=Valeur_FC_EG;
			m_send(num_tache(Actualise_ASV),&Vitesse_EG); 
			}
		}//Fin traitement Fin de Course

	  if(Actu_Aff!=0)
		active(num_tache(Affichage));
	  } //Fin Lire Trame Recue
	} //Fin du while
}

/******************************************************************************************************************/
/*								Interruption									*/
/******************************************************************************************************************/
TACHE irq_eg(Tempo)		//tache appele par lecture trame
char Tempo;
{
static Vitesse;
static Valeur_Ana;
Flag_Fin_Tempo_EG=0;
Vitesse=Vitesse_Lente;
while((Valeur_Analogique<200) && (Cde_EG_Av_Pos2==0) && (Cde_EG_Av_Pos1==0) && (Cde_Lave_Glace_Av==1))
	{
	if(Flag_Fin_Tempo_EG==0)
		{
		dort(100*Tempo); 
		Flag_Fin_Tempo_EG=1;
		m_send(num_tache(Actualise_ASV),&Vitesse); 
		}
	}
}

/******************************************************************************************************************/
/*				Envoie d'une trame  la carte Commodo Essuie Glace							*/
/******************************************************************************************************************/
TACHE Lecture_Commodo_EG(void)
{
Trame T_IRM_Commodo_EG;
T_IRM_Commodo_EG.trame_info.registre=0x00;
T_IRM_Commodo_EG.trame_info.champ.extend=1;
T_IRM_Commodo_EG.trame_info.champ.dlc=0x08;
T_IRM_Commodo_EG.trame_info.champ.rtr=1;
T_IRM_Commodo_EG.ident.extend.identificateur.ident=Ident_T_IRM8_Commodo_EG;
while(1)		//Tache active en permanace
	{
	EcrireTrame(&T_IRM_Commodo_EG);
	dort(10); 
	}
}

/******************************************************************************************************************/
/*						Tache d'affichage											*/
/******************************************************************************************************************/
TACHE Affichage(void)
{
static Valeur_Commodo_EG_Aff;	
static Valeur_Analogique_Aff;
static Valeur_FC_EG_Aff;

if(Valeur_Analogique_Aff!=Valeur_Analogique)
	{	
	Valeur_Analogique_Aff=Valeur_Analogique;
	MONITOR		//on actualise les valeurs du commodo sur le Moniteur
	gotoxy(45,4);
	printf("%d   \n",Valeur_Analogique);
	ENDM
	}

if(Valeur_Commodo_EG_Aff!=Valeur_Commodo_EG)
	{	
	Valeur_Commodo_EG_Aff=Valeur_Commodo_EG;
	MONITOR		//on actualise les valeurs du commodo sur le Moniteur
	gotoxy(22,4);
	printf("%d\n",Cde_EG_Av_Int);
	gotoxy(16,7);
	printf("%d\n",Entree1);
	gotoxy(39,7);
	printf("%d\n",Entree2);
	gotoxy(23,5);
	printf("%d\n",Cde_EG_Av_Pos1);
	gotoxy(53,5);
	printf("%d\n",Cde_EG_Av_Pos2);
	gotoxy(18,8);
	printf("%d\n",Cde_EG_Ar);
	//Les commandes lave glace sont inverse sur le commodo (Actif=0 , Inactif=1)
	gotoxy(27,9);
	printf("%d\n",(Cde_Lave_Glace_Ar^0x01));
	gotoxy(27,6);
	printf("%d\n",(Cde_Lave_Glace_Av^0x01));
	ENDM
	}
if(Valeur_FC_EG_Aff!=Valeur_FC_EG)
	{		//on actualise les valeurs des fin de course sur le Moniteur
	Valeur_FC_EG_Aff=Valeur_FC_EG;
	MONITOR
	if(fcg)	//Fin de course gauche actif
		{
		gotoxy(27,12);
		printf("1\n");
		}
	else
		{
		gotoxy(27,12);
		printf("0\n");
		}
	if(fcd)	//Fin de course droit actif
		{
		gotoxy(27,14);
		printf("1\n");
		}
	else
		{
		gotoxy(27,14);
		printf("0\n");
		}
	if(fs)	//Fin de surcouse
		{
		gotoxy(27,13);
		printf("1\n");
		}
	else
		{
		gotoxy(27,13);
		printf("0\n");
		}
		ENDM
	}

}


/******************************************************************************************************************/
/*							Programme Principal									*/
/******************************************************************************************************************/
main()
{
clsscr();
start_mtr(Init_VMD,1024);
}