	/***********************************************************************************************
	*       TP sur  EID210 / Rseau CAN - VMD  (Vhicule Multiplex Didactique)					
	************************************************************************************************
	*  	TP n 9:   Ensemble des commandes au volant (Feux + Essuie glace)
	*-----------------------------------------------------------------------------------------------		
	*   CAHIER DES CHARGES :					      						
	*  *********************						      						
	*  Raliser le TP6, sans interroger les commodos ni la carte asservissement.
	*  Ces 3 modules devront envoyer d'eux mme l'etat de leurs entres.
	*  On impose une base de temps de:
	*	-1 seconde pour les Commodos Feux et Essuie Glace
	*	-25ms pour la carte Asservissement
 	*----------------------------------------------------------------------------------------------	

	*************************************************************************************************/
// Dclarations
// -> des fichiers  inclure
//***************************
#include <stdio.h>
#include "Structures_donnees.h"
#include "mtr86.h"
#include "vmd.h"
#include "eid210.h"

#define Ident_T_OB_Commodo_Feux 0x05100000 // "Commodo Feux" en On Bus (par scduleur)

//Pour la tempo EG
#define Tempo1 2	// en secondes
#define Tempo2 4 // Pour mode intermittent
#define Tempo3 6
#define Tempo4 8
#define Tempo5 10
//Fin de la tempo EG
char Flag_Fin_Tempo_EG;
//Pour les vitesse de battement
#define Vitesse_Rapide 0x90
#define Vitesse_Lente 0x40
#define Vitesse_Lave_Glace 0x60
//Pour la Tempo entre deux clignottement
#define TempoClign 6	//en dizieme de seconde


//Prototype des taches
TACHE  Init_VMD(void);
TACHE  init  (void);
TACHE	 Actualise_ASV();
TACHE	 Actualise_Etat_Feux();
TACHE  LectureTrame(void);
TACHE  irq_Clign(void);
TACHE  irq_eg();
TACHE  Verif_Etat_Feux(void);
TACHE  Affichage(void);
TACHE  Quit(void);

/******************************************************************************************************************/
/*					Tache d'initialisation du VMD (configuration des modules)					*/
/******************************************************************************************************************/
TACHE Init_VMD(void)
{
//Configuration des modules
Trame T_IM_CFG,T_IRM_Etat_FC,Trame_Recue;
//Pour les delais d'attente entre 2envoie
int Temp,Cptr_TimeOut; 
//placer les identificateurs,valeur,...
int cpt;
//Identificateurs,valeurs,donnes:
//Identificateur
int identificateur[]={Ident_T_IM_Commodo_Feux,Ident_T_IM_Commodo_EG,Ident_T_IM_Asservissement,Ident_T_IM_FRG,Ident_T_IM_FRD,Ident_T_IM_FVG,Ident_T_IM_FVD};
//Acknolege
int identificateurACK[]={Ident_T_AIM_Commodo_Feux,Ident_T_AIM_Commodo_EG,Ident_T_AIM_Asservissement,Ident_T_AIM_FRG,Ident_T_AIM_FRD,Ident_T_AIM_FVG,Ident_T_AIM_FVD};
//Tableau comprennant les donnes permettant la configuration des E/S
int Config_E_S[]={0xFF,0xFF,0xE3,0xF0,0xF0,0xF0,0xF0};

//Chaines de caracteres permeetant de signaler le module en initialisation
char *msg[]={" Commodo  Lumiere  "," Commodo E-G       "," Module ASV        ","Feux aRriere Gauche","Feux aRriere Droit ","Feux  aVant  Gauche","Feux  aVant  Droit "};

//Tableau comprennant toutes les donnes.
//Les 2 premieres valeurs sont pour le Convertisseur Analogique Numeique de la molette du commodo EG.
//Les suivantes sont pour l'Asservissemnt (cfg PWM, frequence, Validation puissance,...)
int datazero[]={0x2A,0x2B,0x21,0x23,0x22,0x24,0x25,0x26,0x1E};
int dataun[]={0xF0,0xFF,0xB3,0xFF,0xB3,0xFF,0xFF,0xFF,0x10};
int datadeux[]={0x80,0x0E,0x80,0xFF,0x80,0xFF,0x00,0x00,0x10};

//Configuration du CAN et du mtr
dsp_stk(); //Connaitre l'etat des taches lorsque l'on quitte par le biais de mtr86exit(0);
OpenCAN(ATON_V2);	//ATON_V1 pour les anciennes cartes ATONCAN
			//ATON_V2 pour les nouvelles cartes ATONCAN

T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
// Pour la configuration des modules de 4 sorties(GP0  GP3) et 4 Entres Status(GP4  GP8)
T_IM_CFG.data[0]=0x1F;	// premire donne -> "Adresse" du registre concerne -> GPDDR
T_IM_CFG.data[1]=0xFF;	// deuxime donne -> "Masque" -> Voir Doc MCP25050 page 16


//Configuration des modules a adresser et du fonctionnement de leurs E/S
for(cpt=0;cpt<7;cpt++)
{
T_IM_CFG.ident.extend.identificateur.ident=identificateur[cpt]; //mise en place de l'identificateur
T_IM_CFG.data[2]=Config_E_S[cpt];	// troisime donne -> "Valeur" 

MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court d'initialisation
printf("Initialisation du %s\n",msg[cpt]);

do	{
	EcrireTrame(&T_IM_CFG);// Envoyer une premire trame sur rseau CAN 
	Cptr_TimeOut=0;	//La fonction LireTrame endore la tache tant qu'il n'y a pas de trames recues.
	do{Cptr_TimeOut++;}while((LireTrame(&Trame_Recue)==0)&&(Cptr_TimeOut<200));  
     	if(Trame_Recue.ident.extend.identificateur.ident==identificateurACK[cpt])Cptr_TimeOut=200; // Test si identificateur correct
		else 
		{
		printf("Probleme\n");
		Cptr_TimeOut=0;
		}
	for(Temp=0;Temp<100000;Temp++); // Pour attendre un peu! 
    	}while(Cptr_TimeOut!=200);
printf("OK\n");
ENDM
}

//cfg de la trame
T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; 
T_IM_CFG.trame_info.champ.dlc=0x03; 

//configuration du convertiseur Ana->Num du commodo EG
MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court de configuartion
printf("Configuration de la conversion A/N du %s ...\n",msg[1]);
ENDM
T_IM_CFG.ident.extend.identificateur.ident=identificateur[1]; 
for(cpt=0;cpt<2;cpt++)
{
T_IM_CFG.data[0]=datazero[cpt]; 	// Adresse du registre
T_IM_CFG.data[1]=dataun[cpt]; 	// Masque -> bits concerns
T_IM_CFG.data[2]=datadeux[cpt];	// Valeur 
EcrireTrame(&T_IM_CFG);
while((LireTrame(&Trame_Recue)==0));
}

//Configuration specifique du module Asservissement
MONITOR
gotoxy(2,9);	//on affiche donc un message pour dire quel module est en court de configuartion
printf("Configuration specifique du %s ...           \n",msg[2]);
ENDM
T_IM_CFG.ident.extend.identificateur.ident=identificateur[2]; 
for(cpt=0;cpt<9;cpt++)
{
T_IM_CFG.data[0]=datazero[cpt]; 	// Adresse du registre
T_IM_CFG.data[1]=dataun[cpt]; 	// Masque -> bits concerns
T_IM_CFG.data[2]=datadeux[cpt];	// Valeur 
EcrireTrame(&T_IM_CFG);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
}

//Prise en position origine
MONITOR
printf("Prise de POM de l'essuie glace\n");
ENDM
//Configuration de l'interrogation des fin de course
T_IRM_Etat_FC.trame_info.registre=0x00;
T_IRM_Etat_FC.trame_info.champ.extend=1; // On travaille en mode tendu
T_IRM_Etat_FC.trame_info.champ.dlc=0x01; // Il y aura 1 donnes de 8 bits
T_IRM_Etat_FC.trame_info.champ.rtr=1;	//en rtour
T_IRM_Etat_FC.ident.extend.identificateur.ident=Ident_T_IRM1_Asservissement;
EcrireTrame(&T_IRM_Etat_FC);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
Valeur_FC_EG=~(Trame_Recue.data[0]);

if(!(fcd==0 && fcg==1))
	{
	//Configuration de la trame de pilotage du moteur
	T_IM_CFG.trame_info.registre=0x00;
	T_IM_CFG.trame_info.champ.extend=1; // On travaille en mode tendu
	T_IM_CFG.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
	// Pour la configuration des modules de 4 sorties(GP0  GP3) et 4 Entres Status(GP4  GP8)
	T_IM_CFG.data[0]=0x26;
	T_IM_CFG.data[1]=0xFF;
	T_IM_CFG.data[2]=0x40;
	EcrireTrame(&T_IM_CFG);//active la vitesse negative
	while(!(fcd==0 && fcg==1))
		{
		EcrireTrame(&T_IRM_Etat_FC);
		while(LireTrame(&Trame_Recue)==0){}; //On attend la rponse
		Valeur_FC_EG=~(Trame_Recue.data[0]); // On rcupre l'tat des fin de course
		}
	T_IM_CFG.data[2]=0; //annule la vitesse negative
	EcrireTrame(&T_IM_CFG); //desactiver la commande negative
	} //Fin init module Asservissement
EcrireTrame(&T_IRM_Etat_FC);
do{}while(LireTrame(&Trame_Recue)==0); // Attendre rponse
Valeur_FC_EG=~(Trame_Recue.data[0]); 

MONITOR
clsscr();
//L'affichage prend ennormement de temps, donc on anticipe
gotoxy(1,1);
printf("**************************tp4_bus can avec mtr86**************************\n");
printf(" Etat du Commodo Essuie Glace                                             \n");
printf("  GP0: Cde_EG_Av_Int=         , Valeur Potar=					    \n");
printf("  GP3: Cde_EG_Av_Pos1=        , GP4: Cde_EG_Av_Pos2=                      \n");
printf("  GP7: Cde_Lave_Glace_Av=   							    \n");
printf("  GP1: Entree1=               , GP2: Entree2=       			    \n");
printf("  GP5: Cde_EG_Ar=             , GP6: Cde_Lave_Glace_Ar=   		    \n");
printf("  				        							    \n");
printf(" Etat du Commodo Feux                                                     \n");
printf("  GP0: Veilleuse=      ,GP2: Phare=        ,GP3: Code=                    \n");
printf("  GP1: Warning=        ,GP4: ClinGauche=   ,GP5: ClinDroit=               \n");
printf("  GP6: Feux stop=      ,GP7: Klaxon=                                      \n");
printf("  				        							    \n");
printf(" Etat des fins de course sur la carte Asservissemnt			    	    \n");
printf("  Fin de Course : Gauche=       	  Sur-course=          Droit=		    \n");
printf("  				        							    \n");
printf(" Feux aRriere Gauche:   Action        EtatReel                            \n");
printf("  Veilleuse 										    \n");
printf("  Stop											    \n");
printf("  Clignottant										    \n");
printf("  Klaxon											    \n");
printf(" Feux aRriere Droit:   Action        EtatReel                             \n");
printf("  Veilleuse										    \n");
printf("  Stop											    \n");
printf("  Clignottant										    \n");
printf(" Feux aVant gauche:   Action        EtatReel                              \n");
printf("  Veilleuse  										    \n");
printf("  Code											    \n");
printf("  Phare											    \n");
printf("  Clignottant										    \n");
printf(" Feux aVant Droit:   Action        EtatReel                               \n");
printf("  Veilleuse										    \n");
printf("  Code											    \n");
printf("  Phare											    \n");
printf("  Clignottant										    \n");
ENDM

//Configuration des modules Commodo feux, Commodo EG, et de la carte ASV pour un envoie automatique des trames  interval de temps reguli
T_IM_CFG.trame_info.registre=0x00;
T_IM_CFG.trame_info.champ.extend=1; 
T_IM_CFG.trame_info.champ.dlc=0x03; 
T_IM_CFG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_Feux; //commodo feux
//Calcul de la base de temps:(1/160000)*4096*(STBF1:STBF0)*(STM3STM0) (cf datasheet p24)
T_IM_CFG.data[0]=0x2C;	//Adresse du registre STCON=0x10 + Offset=0x1C==>0x2C
T_IM_CFG.data[1]=0xFF; //Tous les bits sont concerns 
T_IM_CFG.data[2]=0xeF; //STEN=1=>Valider envoie trame automatique/SMTS=1=>DLC=8
					//STBF1=1,STBF0=0,STM3=STM2=STM1=STM0=1 =>Base de temps=1seconde
					//==>on autorise donc un envoie automatique toutes les seconde
EcrireTrame(&T_IM_CFG);

T_IM_CFG.ident.extend.identificateur.ident=Ident_T_IM_Commodo_EG; //Commodo_EG
EcrireTrame(&T_IM_CFG);

T_IM_CFG.ident.extend.identificateur.ident=Ident_T_IM_Asservissement; //Carte Asservissement
T_IM_CFG.data[2]=0xd5; //a interval de temps plus rapide(0xCF=4 ms) (0xD2=12ms) (0xD5=25ms)
EcrireTrame(&T_IM_CFG);

active(cree(init,1,1024)); //Initalisation des taches
}

TACHE init(void)
{
cree(Actualise_ASV,1,512);		//Priorit n1 car la gestion de l'essuie glace 
cree(Actualise_Etat_Feux,1,512);
active(cree(LectureTrame,2,512));	//lire les trame sera endormie automatiquement
cree(irq_Clign,2,256);			//Gestion de l'IT pour les clignottant
cree(irq_eg,2,256);			//Gestion de l'IT pour L'essuie Glace
cree(Verif_Etat_Feux,4,512);		//Verifier l'etat des feux est moins important
cree(Affichage,5,1024);			//L'affichage conserve la derniere priorite
cree(Quit,6,256);			//La tache permettera de desactiver les autres taches et de quitter proproment
}
/******************************************************************************************************************/
/*							Gerer le sens de rotation du moteur							*/
/******************************************************************************************************************/

TACHE Actualise_ASV(Vitesse_EG)		//tache appele par lecture trame
char Vitesse_EG; 
{
//Etat des fin de course( t-1) pour retablir l'essuie glace lorsque le fin de sur-course  t activ
static Valeur_FC_EG_Verif_fs;
//Trames pour piloter le sene de rotation du moteur
Trame T_IM_Cmde_Negative,T_IM_Cmde_Positive;
//Configuration de la trame Commande Negative
T_IM_Cmde_Negative.trame_info.registre=0x00;
T_IM_Cmde_Negative.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Cmde_Negative.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Cmde_Negative.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
T_IM_Cmde_Negative.data[0]=0x26; 	// Adresse du registre PWM2DC
T_IM_Cmde_Negative.data[1]=0xFF; 	// Masque -> tous les bits sont conserns
//Configuration de la trame Commande Positive
T_IM_Cmde_Positive.trame_info.registre=0x00;
T_IM_Cmde_Positive.trame_info.champ.extend=1; // On travaille en mode tendu
T_IM_Cmde_Positive.trame_info.champ.dlc=0x03; // Il y aura 3 donnes de 8 bits (3 octets envoys)
T_IM_Cmde_Positive.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
T_IM_Cmde_Positive.data[0]=0x25; 	// Adresse du registre PWM2DC
T_IM_Cmde_Positive.data[1]=0xFF; 	// Masque -> tous les bits sont conserns

//Les commandes lave glace sont inverse sur le commodo (Actif=0 , Inactif=1)
if((Cde_EG_Av_Pos2 || Cde_EG_Av_Pos1 || (Cde_Lave_Glace_Av==0))) //une commande "clasique" est active
	{
	if(fcd)				//Si on est  droite, retour a gauche
		{
		T_IM_Cmde_Negative.data[2]=Vitesse_EG;
		T_IM_Cmde_Positive.data[2]=0x00;
		}
	else if(fcg)			//Si on est a gauche, on repart  droite
		{
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=Vitesse_EG;
		}
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(Valeur_Analogique<200) //la commande intermitante est active, il faut gerer en fonction de la tempo
	{
	if(fcd) //on est  droite, on repart  gauche
		{
		T_IM_Cmde_Negative.data[2]=Vitesse_EG;
		T_IM_Cmde_Positive.data[2]=0x00;
		Flag_Fin_Tempo_EG=0;				//on annule le flag de fin de tempo
		}
	else if ((Flag_Fin_Tempo_EG)) //la tempo est finie
		{
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=Vitesse_EG;	//on lance le moteur
		}
	else if (fcg && Flag_Fin_Tempo_EG==0)
		{ // gauche, en position intermitante, mais la tempo n'est pas finie
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=0x00;	//on arrete le moteur
		}
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(fcd) //on est  droite sans aucune commande, retour  gauche
	{
	T_IM_Cmde_Negative.data[2]=0x40;
	T_IM_Cmde_Positive.data[2]=0x00;
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(fcg) //on est a gauche sans aucune commande
	{
	T_IM_Cmde_Negative.data[2]=0x00;
	T_IM_Cmde_Positive.data[2]=0x00;
	EcrireTrame(&T_IM_Cmde_Positive);
	EcrireTrame(&T_IM_Cmde_Negative);
	}
else if(fs)//erreur, on est en surcouse 
	{
	if((Valeur_FC_EG_Verif_fs&0x40)==0x40) //du cot gauche, retour en fin de course Gauche
		{
		T_IM_Cmde_Negative.data[2]=0x00;
		T_IM_Cmde_Positive.data[2]=0x40;
		EcrireTrame(&T_IM_Cmde_Negative);
		EcrireTrame(&T_IM_Cmde_Positive);
		}
	if((Valeur_FC_EG_Verif_fs&0x20)==0x20)  //du cot droit, retour en fin de course droit
		{
		T_IM_Cmde_Negative.data[2]=0x40;
		T_IM_Cmde_Positive.data[2]=0x00;
		EcrireTrame(&T_IM_Cmde_Negative);
		EcrireTrame(&T_IM_Cmde_Positive);
		}
	}
Valeur_FC_EG_Verif_fs=Valeur_FC_EG;
}
/******************************************************************************************************************/
/*							Allumer les feux										*/
/******************************************************************************************************************/
TACHE Actualise_Etat_Feux(Value_Commodo)		//tache appele par lecture trame
Port_8ES Value_Commodo; //la variable est sous forme d'une structure de type Port_8ES 
				//qui nous permet un acces directe au niveau du bit
{
Trame T_IM_Feux,T_recue; //Trame qui sera  configurer pour adresser les blocs optiques
Valeur_FRG=0x00;	//mise a zero des blocs optiques
Valeur_FRD=0x00;
Valeur_FVG=0x00;
Valeur_FVD=0x00;

if(Value_Commodo.bit.GP2) //phare
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_P;
	Valeur_FVD|=Cde_FV_P;
	}
else if(Value_Commodo.bit.GP3) //Code
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_C;
	Valeur_FVD|=Cde_FV_C;
	}
else if(Value_Commodo.bit.GP0) //Veilleuse
	{
	Valeur_FRG|=Cde_FR_V;
	Valeur_FRD|=Cde_FR_V;
	Valeur_FVG|=Cde_FV_V;
	Valeur_FVD|=Cde_FV_V;
	}

if(Value_Commodo.bit.GP1)	//Warning
	{
	Valeur_FRG|=Masque_Clign_AR;
	Valeur_FRD|=Masque_Clign_AR;
	Valeur_FVG|=Masque_Clign_AV;
	Valeur_FVD|=Masque_Clign_AV;
	}
	else
	{
	if(Value_Commodo.bit.GP4) //Clin gauche
		{
		Valeur_FRG|=Masque_Clign_AR;
		Valeur_FVG|=Masque_Clign_AV;
		}	
	if(Value_Commodo.bit.GP5) //Clin droit
		{
		Valeur_FRD|=Masque_Clign_AR;
		Valeur_FVD|=Masque_Clign_AV;
		}
	}

if(Value_Commodo.bit.GP6)//Stop
	{
	Valeur_FRG|=Masque_Stop;
	Valeur_FRD|=Masque_Stop;
	}

if(Value_Commodo.bit.GP7) //Klaxon
	Valeur_FRG|=Masque_Klaxon;

//initialisation de  la trame de commande sur le Feux 
T_IM_Feux.trame_info.registre=0x00;
T_IM_Feux.trame_info.champ.extend=1;
T_IM_Feux.trame_info.champ.dlc=0x03;
T_IM_Feux.data[0]=0x1e;	
T_IM_Feux.data[1]=0x0f;

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FRG;
T_IM_Feux.data[2]=Valeur_FRG;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FRD;
T_IM_Feux.data[2]=Valeur_FRD;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FVG;
T_IM_Feux.data[2]=Valeur_FVG;
EcrireTrame(&T_IM_Feux);

T_IM_Feux.ident.extend.identificateur.ident=Ident_T_IM_FVD;
T_IM_Feux.data[2]=Valeur_FVD;
EcrireTrame(&T_IM_Feux);

//on vient de faire une demande de mofification des feux.
active(num_tache(Verif_Etat_Feux)); // On verifie leur etat
}
/******************************************************************************************************************/
/*						Lecture des trames recue									*/
/******************************************************************************************************************/
TACHE LectureTrame(void)
{
static Trame tr_rx;
static Valeur_Commodo_Feux_Mem;	//variable en stattic car il s'agit d'une memorisation
static Valeur_Commodo_EG_Mem;
static Valeur_FC_EG_Mem;
static Actu_Aff;
static Valeur_Analogique_Mem; //definis en static car il s'agit de paramattres  transmettre
static Vitesse_EG;
static Tempo_EG;
while(1)				//Tache active en permaance
	{
	if(LireTrame(&tr_rx))  //LireTrame endore la tache tant qu'il n'y a pas de trame recue
	   {
         if(CRTL==0) active(num_tache(Quit)); //Si Touche CRTL Appuye, on quitte
	   Actu_Aff=0;

	   if (tr_rx.ident.extend.identificateur.ident==Ident_T_OB_Asservissement) //on a recu une reponse de l'asv
		{
		Valeur_FC_EG=~(tr_rx.data[1]);
			if(Valeur_FC_EG_Mem!=Valeur_FC_EG)
			{
			m_send(num_tache(Actualise_ASV),&Vitesse_EG); 
			Actu_Aff=2;
			}
			else if(fs==1) m_send(num_tache(Actualise_ASV),&Vitesse_EG); 
		}//Fin traitement Fin de Course

	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_OB_Commodo_EG) //on a recu une reponse du commodo EG
		{
		Valeur_Commodo_EG=~(tr_rx.data[1]);	//Recup l'etat du commodo_EG
		Valeur_Analogique=tr_rx.data[2];	//Recup valeur du Potar
		//on determine la position du potar,pour activer la tempo
		if(Valeur_Analogique!=Valeur_Analogique_Mem)
			{
			Actu_Aff=1;
			Valeur_Analogique_Mem=Valeur_Analogique;
			if(Valeur_Analogique>=200)
				{
				detruit(num_tache(irq_eg));
				Tempo_EG=0;
				}
			else 
				{
				detruit(num_tache(irq_eg));
				Vitesse_EG=Vitesse_Lente; // Position "Intermittent"
				if(Valeur_Analogique>=150)Tempo_EG=Tempo5;// Selon la position de la molette
					else if(Valeur_Analogique>=140)Tempo_EG=Tempo4;// la tempo plus ou moins longue
						else if(Valeur_Analogique>=120)Tempo_EG=Tempo3;	
					 		else if(Valeur_Analogique>=90)Tempo_EG=Tempo2;
					 	 		else if(20<=Valeur_Analogique==0)Tempo_EG=Tempo1;
				m_send(num_tache(irq_eg),&Tempo_EG);
				}
			}

		if(Valeur_Commodo_EG_Mem!=Valeur_Commodo_EG)
			{
			Actu_Aff=1;
			Valeur_Commodo_EG_Mem=Valeur_Commodo_EG;
			Vitesse_EG=0;
			//Desactiver la position intermittente si elle tait selectionne
			if(Valeur_Analogique<200) detruit(num_tache(irq_eg));
			//...Traiter la position selectionne...
			if(Cde_EG_Av_Pos2) Vitesse_EG=Vitesse_Rapide;
			else if(Cde_EG_Av_Pos1) Vitesse_EG=Vitesse_Lente;
			else if(Cde_Lave_Glace_Av==0) Vitesse_EG=Vitesse_Lave_Glace; //inversion commodo
			//...et la reactiver si elle est toujours d'actualit
			else if(Cde_EG_Av_Int && (Valeur_Analogique<200)) 
				{
				Vitesse_EG=Vitesse_Lente;
				m_send(num_tache(irq_eg),&Tempo_EG);
				}
			m_send(num_tache(Actualise_ASV),&Vitesse_EG); 
			}
		} //Fin traitement commodo

	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_OB_Commodo_Feux) //on a recu une reponse du commodo
		{
		Valeur_Commodo_Feux=~(tr_rx.data[1]);	//inversion bit a bit pour l'etat reel du commodo
		if(Valeur_Commodo_Feux_Mem!=Valeur_Commodo_Feux)
			{//et son  etat  chang
			Valeur_Commodo_Feux_Mem=Valeur_Commodo_Feux; //on actualise la valeur memorise
			//Si un clignottant est actif, on valide l'it qui activera Actualise_Etat_Feux
			if(Cde_Clign_Gauche || Cde_Clign_Droit || Cde_Warning) active(num_tache(irq_Clign));
			//sinon, on reveille la tache d'actualisation de l'etat des feux avec la valeur du commodo sans clign
				else m_send(num_tache(Actualise_Etat_Feux),&Valeur_Commodo_Feux_Mem); 
			//On active la tache d'affichage
			Actu_Aff=3;
			}
		} //Fin traitement commodo Feux
	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FRG)
		{
		Valeur_Status_FRG=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FRG=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=4;
		} //Fin traitement Feux aRriere gauche

	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FRD)
		{
		Valeur_Status_FRD=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FRD=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=5;
		} //Fin traitement Feux aRriere Droit

	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FVG)
		{
		Valeur_Status_FVG=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FVG=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=6;
		}  //Fin traitement Feux aVant Gauche

	   else if (tr_rx.ident.extend.identificateur.ident==Ident_T_IRM_FVD)
		{
		Valeur_Status_FVD=tr_rx.data[0];	//Recupere l'etat du status qui est dans le poid fort de data[0]
		Valeur_FVD=tr_rx.data[0];		//Recupere l'etat demand qui est dans le poid faible de data[0]
		//On active la tache d'affichage
		Actu_Aff=7;
		} //Fin traitement Feux aVant Droit
	   if(Actu_Aff!=0) active(num_tache(Affichage));
	   } //Fin Lire Trame Recue
	} //Fin du while
}
/******************************************************************************************************************/
/*							Interruption										*/
/******************************************************************************************************************/
TACHE irq_Clign(void)
{
int actualise;
static char Flag_Fin_Tempo_Clign;

while((Cde_Clign_Gauche || Cde_Clign_Droit || Cde_Warning))
	{
	dort(10*TempoClign);			//Attendre 0.8s
	Flag_Fin_Tempo_Clign^=0x01; 	//Activer ou iniber le flag
//Attention pour envoyer une commande, on verifie en 1er si il s'agit d'un clignottant afin de shinter le Warning
	if(((Cde_Clign_Gauche==0) && (Cde_Clign_Droit==0) && (Cde_Warning==0))) break; //Si commande laches->on quitte
	if(Flag_Fin_Tempo_Clign==0x01) //Fin de la Tempo Clignottant
		{ //pour extiction
		if(Cde_Clign_Droit) actualise=((Valeur_Commodo_Feux^0x20)&0xFD); //Etteind Clin Droit et Wanning
		else if(Cde_Clign_Gauche) actualise=((Valeur_Commodo_Feux^0x10)&0xFD); //Etteind Clin Gauche et Wanning
		else if (Cde_Warning ) actualise=Valeur_Commodo_Feux^0x02; //Warning
		m_send(num_tache(Actualise_Etat_Feux),&actualise); 
		}
	else if(Flag_Fin_Tempo_Clign==0x00) //Fin de la Tempo Clignottant
		{ //pour l'allumer
		if (Cde_Clign_Droit) actualise=Valeur_Commodo_Feux&0xFD; //allume clin Droit, etteind warning
		else if (Cde_Clign_Gauche) actualise=Valeur_Commodo_Feux&0xFD; //allume clin Gauche, etteind warning
		else if (Cde_Warning ) actualise=Valeur_Commodo_Feux; //allum Warning
		m_send(num_tache(Actualise_Etat_Feux),&actualise); 
		}
	}

}

TACHE irq_eg(Tempo)		//tache appele par lecture trame
char Tempo;
{
static Vitesse;
static Valeur_Ana;
Vitesse=Vitesse_Lente;
Flag_Fin_Tempo_EG=0;
while((Valeur_Analogique<200) && (Cde_EG_Av_Pos2==0) && (Cde_EG_Av_Pos1==0) && (Cde_Lave_Glace_Av==1))
	{
	if(Flag_Fin_Tempo_EG==0)
		{
		dort(100*Tempo); 
		Flag_Fin_Tempo_EG=1;
		m_send(num_tache(Actualise_ASV),&Vitesse); 
		}
	}
}
/******************************************************************************************************************/
/*						Verifier l'etat reel des Feux									*/
/******************************************************************************************************************/
TACHE  Verif_Etat_Feux(void)
{
//initialisation de  la trame de verification d'etat du Feux aVant Gauche
Trame T_IRM_Feux;
T_IRM_Feux.trame_info.registre=0x00;
T_IRM_Feux.trame_info.champ.extend=1;
T_IRM_Feux.trame_info.champ.dlc=0x01;
T_IRM_Feux.trame_info.champ.rtr=1;
T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FRG;
//Envoie sur le Bus Can la trame interrogative
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FRD;
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FVG;
EcrireTrame(&T_IRM_Feux);

T_IRM_Feux.ident.extend.identificateur.ident=Ident_T_IRM_FVD;
EcrireTrame(&T_IRM_Feux);

//endormissement infinie de la tache (activation sur reveille ou m_send)
}
/******************************************************************************************************************/
/*						Tache d'affichage											*/
/******************************************************************************************************************/
TACHE Affichage(void)
{
static Valeur_FRG_Aff,Valeur_FRD_Aff,Valeur_FVG_Aff,Valeur_FVD_Aff;
static Valeur_Commodo_Feux_Aff;
static Valeur_Commodo_EG_Aff;	
static Valeur_Analogique_Aff;
static Valeur_FC_EG_Aff;

if(Valeur_Analogique_Aff!=Valeur_Analogique)
	{
	Valeur_Analogique_Aff=Valeur_Analogique;
	gotoxy(45,3);
	printf("%d   \n",Valeur_Analogique);
	}

if(Valeur_Commodo_EG_Aff!=Valeur_Commodo_EG)
//on actualise les valeurs du commodo EG sur le Moniteur
	{	
	Valeur_Commodo_EG_Aff=Valeur_Commodo_EG;
	MONITOR		
	gotoxy(22,3);
	printf("%d\n",Cde_EG_Av_Int);
	gotoxy(16,6);
	printf("%d\n",Entree1);
	gotoxy(46,6);
	printf("%d\n",Entree2);
	gotoxy(23,4);
	printf("%d\n",Cde_EG_Av_Pos1);
	gotoxy(53,4);
	printf("%d\n",Cde_EG_Av_Pos2);
	gotoxy(18,7);
	printf("%d\n",Cde_EG_Ar);
	//Les commandes lave glace sont inverse sur le commodo (Actif=0 , Inactif=1)
	gotoxy(56,7);
	printf("%d\n",(Cde_Lave_Glace_Ar^0x01));
	gotoxy(27,5);
	printf("%d\n",(Cde_Lave_Glace_Av^0x01));
	ENDM
	}

if(Valeur_FC_EG_Aff!=Valeur_FC_EG)
//on actualise les valeurs des fin de course sur le Moniteur
	{
	Valeur_FC_EG_Aff=Valeur_FC_EG;
	MONITOR
	gotoxy(26,15);
	if(fcg)	//Fin de course gauche actif
		printf("1\n");
	else
		printf("0\n");

	gotoxy(62,15);
	if(fcd)	//Fin de course droit actif
		printf("1\n");
	else
		printf("0\n");

	gotoxy(46,15);
	if(fs)	//Fin de surcouse
		printf("1\n");
	else
		printf("0\n");
		ENDM
	}

if(Valeur_Commodo_Feux_Aff!=Valeur_Commodo_Feux)
//on actualise les valeurs du commodo Feux sur le Moniteur
	{
	Valeur_Commodo_Feux_Aff=Valeur_Commodo_Feux;
	MONITOR
	gotoxy(18,10);
	printf("%d\n",Cde_Veilleuse);
	gotoxy(36,10);
	printf("%d\n",Cde_Phare);
	gotoxy(55,10);
	printf("%d\n",Cde_Code);
	gotoxy(16,11);
	printf("%d\n",Cde_Warning);
	gotoxy(41,11);
	printf("%d\n",Cde_Clign_Gauche);
	gotoxy(60,11);
	printf("%d\n",Cde_Clign_Droit);
	gotoxy(18,12);
	printf("%d\n",Cde_Stop);
	gotoxy(37,12);
	printf("%d\n",Cde_Klaxon);
	ENDM
	}

if(Valeur_FRG_Aff!=Valeur_Status_FRG)
//Etat du Bloc optique Arriere Gauche
	{
	Valeur_FRG_Aff=Valeur_FRG;
	MONITOR
		if(Veilleuse_FRG)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,18);
			printf("1\n");
			gotoxy(40,18);
			if(S_Veilleuse_FRG) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,18);
			printf("0\n");
			gotoxy(40,18);
			printf("  \n");
			}
		if(Stop_FRG)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,19);
			printf("1\n");
			gotoxy(40,19);
			if(S_Stop_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,19);
			printf("0\n");
			gotoxy(40,19);
			printf("  \n");
			}
		if(Clignot_FRG)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,20);
			printf("1\n");
			gotoxy(40,20);
			if(S_Clignot_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,20);
			printf("0\n");
			gotoxy(40,20);
			printf("  \n");
			}
		if(Klaxon_FRG)	//on a demander d'allumer le clignotant
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,21);
			printf("1\n");
			gotoxy(40,21);
			if(S_Klaxon_FRG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,21);
			printf("0\n");
			gotoxy(40,21);
			printf("  \n");
			}
	ENDM
	}

if(Valeur_FRD_Aff!=Valeur_Status_FRD)
//Etat du Bloc optique Arriere Droit
	{
	Valeur_FRD_Aff=Valeur_FRD;
	MONITOR
		if(Veilleuse_FRD)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,23);
			printf("1\n");
			gotoxy(40,23);
			if(S_Veilleuse_FRD) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,23);
			printf("0\n");
			gotoxy(40,23);
			printf("  \n");
			}
		if(Stop_FRD)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,24);
			printf("1\n");
			gotoxy(40,24);
			if(S_Stop_FRD) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,24);
			printf("0\n");
			gotoxy(40,24);
			printf("  \n");
			}
		if(Clignot_FRD)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,25);
			printf("1\n");
			gotoxy(40,25);
			if(S_Clignot_FRD) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,25);
			printf("0\n");
			gotoxy(40,25);
			printf("  \n");
			}
	ENDM
	}

if(Valeur_FVG_Aff!=Valeur_Status_FVG)
//Etat du Bloc optique Avant Gauche
	{
	Valeur_FVG_Aff=Valeur_FVG;
	MONITOR
		if(Veilleuse_FVG)	//on a demander d'allumer la veilleuse
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,27);
			printf("1\n");
			gotoxy(40,27);
			if(S_Veilleuse_FVG) printf("OK\n");	//Status est  1, c'est bon
				else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
			}
		else
			{
			gotoxy(26,27);
			printf("0\n");
			gotoxy(40,27);
			printf("  \n");
			}
		if(Code_FVG)	//on a demander d'allumer le stop
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,28);
			printf("1\n");
			gotoxy(40,28);
			if(S_Code_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,28);
			printf("0\n");
			gotoxy(40,28);
			printf("  \n");
			}
		if(Phare_FVG)	//on a demander d'allumer le Clignot
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,29);
			printf("1\n");
			gotoxy(40,29);
			if(S_Phare_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,29);
			printf("0\n");
			gotoxy(40,29);
			printf("  \n");
			}
		if(Clignot_FVG)	//on a demander d'allumer le clignotant
			{		//on verifie que le status soit conforme  la demande
			gotoxy(26,30);
			printf("1\n");
			gotoxy(40,30);
			if(S_Clignot_FVG) printf("OK\n");
				else printf("HS\n");
			}
		else
			{
			gotoxy(26,30);
			printf("0\n");
			gotoxy(40,30);
			printf("  \n");
			}
	ENDM
	}

if(Valeur_FVD_Aff!=Valeur_Status_FVD)
//Etat du Bloc optique Avant Droit
	{
	Valeur_FVD_Aff=Valeur_FVD;
	MONITOR
	if(Veilleuse_FVD)	//on a demander d'allumer la veilleuse
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,32);
		printf("1\n");
		gotoxy(40,32);
		if(S_Veilleuse_FVD) printf("OK\n");	//Status est  1, c'est bon
			else printf("HS\n");		//Status est  0, l'etat n'est pas conforme  la demmande
		}
	else
		{
		gotoxy(26,32);
		printf("0\n");
		gotoxy(40,32);
		printf("  \n");
		}
	if(Code_FVD)	//on a demander d'allumer le stop
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,33);
		printf("1\n");
		gotoxy(40,33);
		if(S_Code_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,33);
		printf("0\n");
		gotoxy(40,33);
		printf("  \n");
		}
	if(Phare_FVD)	//on a demander d'allumer le Clignot
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,34);
		printf("1\n");
		gotoxy(40,34);
		if(S_Phare_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,34);
		printf("0\n");
		gotoxy(40,34);
		printf("  \n");
		}
	if(Clignot_FVD)	//on a demander d'allumer le clignotant
		{		//on verifie que le status soit conforme  la demande
		gotoxy(26,35);
		printf("1\n");
		gotoxy(40,35);
		if(S_Clignot_FVD) printf("OK\n");
			else printf("HS\n");
		}
	else
		{
		gotoxy(26,35);
		printf("0\n");
		gotoxy(40,35);
		printf("  \n");
		}
	ENDM
	}
}
/******************************************************************************************************************/
/*							Quitter Proprement									*/
/******************************************************************************************************************/
TACHE Quit(void)
{
//Arret des modules
Trame T_IM_Arret;
int Tempo;
//Detruire toutes les taches
detruit(num_tache(Actualise_ASV));
detruit(num_tache(Actualise_Etat_Feux));
detruit(num_tache(LectureTrame));
detruit(num_tache(irq_Clign));
detruit(num_tache(irq_eg));
detruit(num_tache(Verif_Etat_Feux));
detruit(num_tache(Affichage));

//Configuration generale de la trame
T_IM_Arret.trame_info.registre=0x00;
T_IM_Arret.trame_info.champ.extend=1;
T_IM_Arret.trame_info.champ.dlc=0x03;

//Pour la carte Asservissement
 //En positif
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_Asservissement;
T_IM_Arret.data[0]=0x25;	
T_IM_Arret.data[1]=0xFF;
T_IM_Arret.data[2]=0x00;
EcrireTrame(&T_IM_Arret);
 //en negatif
T_IM_Arret.data[0]=0x26;	
EcrireTrame(&T_IM_Arret);

//Pour le Feux aRriere Gauche
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_FRG;
T_IM_Arret.data[0]=0x1e;	
T_IM_Arret.data[1]=0x0f;
T_IM_Arret.data[2]=0x00;
EcrireTrame(&T_IM_Arret);

//Pour le Feux aRriere Droit
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_FRD;
EcrireTrame(&T_IM_Arret);

//Pour le Feux aVant Gauche
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_FVG;
EcrireTrame(&T_IM_Arret);

//Pour le Feux aVant Droit
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_FVD;
EcrireTrame(&T_IM_Arret);

//Arret des envoie automatique
//Configuration des modules Commodo feux, Commodo EG, et de la carte ASV pour un envoie automatique des trames  interval de temps reguli
T_IM_Arret.trame_info.registre=0x00;
T_IM_Arret.trame_info.champ.extend=1; 
T_IM_Arret.trame_info.champ.dlc=0x03; 
T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_Commodo_Feux; //commodo feux
T_IM_Arret.data[0]=0x2C;
T_IM_Arret.data[1]=0xFF; 
T_IM_Arret.data[2]=0x00; 
EcrireTrame(&T_IM_Arret);

T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_Commodo_EG; //Commodo_EG
EcrireTrame(&T_IM_Arret);

T_IM_Arret.ident.extend.identificateur.ident=Ident_T_IM_Asservissement; //Carte Asservissement
EcrireTrame(&T_IM_Arret);


mtr86exit(0);
}

/******************************************************************************************************************/
/*							Programme Principal									*/
/******************************************************************************************************************/
main()
{
clsscr();
start_mtr(Init_VMD,2000);
}