#ifndef __BUSCAN_H
#define __BUSCAN_H

#define ATON_V1	0xB30280	// adresse carte Aton version 1
#define ATON_V2   0xB30100	// adresse Carte Aton version 2

typedef union 
{
struct 
	{
	unsigned short ident:11;
	unsigned short rtr:1;
	unsigned short nul:4;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	} registre;
unsigned short valeur;
} ident_standard;

typedef union
{
struct
	{
	unsigned long ident:29;
	unsigned long rtr:1;
	unsigned long x:2;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	unsigned char ident3;
	unsigned char ident4;
	} registre;
unsigned long valeur;
} ident_extend;

typedef union
	{
	struct
		{
		unsigned char extend:1;
		unsigned char rtr:1;
		unsigned char nul:2;
		unsigned char dlc:4;
		} champ;
	unsigned char registre;
	} tr_info;

typedef struct
{
tr_info trame_info;
union
	{
	ident_standard standard;
	ident_extend   extend;
	} ident;	
unsigned char data[8];
} Trame;


#endif