
#include <stdio.h>
#include "eid210.h"
#include "mtr86.h"
#include "mtr_can.h"


void ETrame(Trame trame)
{
unsigned char i;
TX_FRAME_INFO=trame.trame_info.registre;
if (trame.trame_info.champ.extend==1)
	{ // trame tendue
	TX_ID_1_E=trame.ident.extend.registre.ident1;
	TX_ID_2_E=trame.ident.extend.registre.ident2;
	TX_ID_3_E=trame.ident.extend.registre.ident3;
	TX_ID_4_E=trame.ident.extend.registre.ident4;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			*(TX_DATA_E+i)=trame.data[i];	
		}
	}
	else
	{ // trame standard
	TX_ID_1_S=trame.ident.standard.registre.ident1;
	TX_ID_2_S=trame.ident.standard.registre.ident2;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			*(TX_DATA_S+i)=trame.data[i];	
		}
	}
}


//fonction it

void irq_can()
{
int i;
unsigned char etat_int;
etat_int=INTERRUPT;
if (etat_int&0x01)
	{
	p_dcan->rx_mes[p_dcan->rang_recept].trame_info.registre=RX_FRAME_INFO;
	if (p_dcan->rx_mes[p_dcan->rang_recept].trame_info.champ.extend==1)
		{ // trame tendue
		p_dcan->rx_mes[p_dcan->rang_recept].ident.extend.registre.ident1=RX_ID_1_E;
		p_dcan->rx_mes[p_dcan->rang_recept].ident.extend.registre.ident2=RX_ID_2_E;
		p_dcan->rx_mes[p_dcan->rang_recept].ident.extend.registre.ident3=RX_ID_3_E;
		p_dcan->rx_mes[p_dcan->rang_recept].ident.extend.registre.ident4=RX_ID_4_E;
		if (p_dcan->rx_mes[p_dcan->rang_recept].trame_info.champ.rtr==0)
			{
			for(i=0;i<p_dcan->rx_mes[p_dcan->rang_recept].trame_info.champ.dlc;i++)
				p_dcan->rx_mes[p_dcan->rang_recept].data[i]=*(RX_DATA_E+i);	
			}
		}
		else
		{ // trame standart
		p_dcan->rx_mes[p_dcan->rang_recept].ident.standard.registre.ident1=RX_ID_1_S;
		p_dcan->rx_mes[p_dcan->rang_recept].ident.standard.registre.ident2=RX_ID_2_S;
		if (p_dcan->rx_mes[p_dcan->rang_recept].trame_info.champ.rtr==0)
			{
			for(i=0;i<p_dcan->rx_mes[p_dcan->rang_recept].trame_info.champ.dlc;i++)
				p_dcan->rx_mes[p_dcan->rang_recept].data[i]=*(RX_DATA_S+i);	
			}
		}   

    	/* Release receive buffer */
	COMMAND=0x04;
	p_dcan->rang_recept++;
	if (p_dcan->rang_recept==NB_MAX_MESSAGE)
		p_dcan->rang_recept=0;
	}
if (etat_int&0x02)	// gestion de l'emission en it
	{
	p_dcan->nb_tx--;
	if (p_dcan->nb_tx>0) //rang_write!=rang_emet)
		{
		disable();
		ETrame(p_dcan->tx_mes[p_dcan->rang_emet]);
		COMMAND=0x01 ;
		p_dcan->rang_emet++;
		if (p_dcan->rang_emet==NB_MAX_MESSAGE)
			p_dcan->rang_emet=0;
		enable();
		}
		else
		{
		INTERRUPT_ENABLE=0x01;  // irq reception
		}
	}
}

/** 
 * Initialisation du SJA1000 en mode PeliCAN.
 */
void init_sja1000_peli_acc (char acc_code0, char acc_code1, char acc_code2, char acc_code3,
                            char acc_mask0, char acc_mask1, char acc_mask2, char acc_mask3) {

    // On passe en RESET MODE (bit 0)
    while (!(MODE & 0x01)) 
		MODE=0x01;

    // Mode PeliCAN (bit 7)
    CLOCK_DIVIDER=0xC0;

    // et on desactive les interruptions
    INTERRUPT_ENABLE=0x00;
    ACCEPT_CODE0=acc_code0;  
    ACCEPT_CODE1=acc_code1;  
    ACCEPT_CODE2=acc_code2;  
    ACCEPT_CODE3=acc_code3;  
    ACCEPT_MASK0=acc_mask0; 
    ACCEPT_MASK1=acc_mask1;  
    ACCEPT_MASK2=acc_mask2;  
    ACCEPT_MASK3=acc_mask3;  
    BUS_TIMING_0=0x44; //0x03	/ 0xc4 /0x04 ou 0x44 /			0xc4; //0x07;
    BUS_TIMING_1=0x58; //0x7a / 0x58 /   0x58      /			0x3a;100 kbts/s //0xa3; 125
    // 11011011 (Push-pulls, "polarite zero", clock-output mode)
    OUTPUT_CONTROL=0x1A;
    /* Bit 0 = 0: Sortie du mode RESET
       Bit 1 = 0: Pas le mode Listen Only (donne des ACK)
       Bit 2 = 0: Pas le mode Self Test
       Bit 3 = 1: Acceptance filter mode = single */
    while (MODE & 0x01) 
			MODE=0x08;

}


void _open_can(int a)
{
if (p_dcan)
	mtr86fatal("Bus CAN deja ouvert");
disable();
p_dcan=(DCAN *)malloc(sizeof(DCAN));
p_dcan->adr_sja=a;
p_dcan->rang_recept=0;
p_dcan->rang_lect=0;
p_dcan->rang_emet=0;
p_dcan->rang_write=0;
p_dcan->nb_tx=0;
/* Initialisation DU SJA1000 de la carte PC104 */
init_sja1000_peli_acc (0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);
SetVect(29,&irq_can);
INTERRUPT_ENABLE=0x01;
VALID_IRQ.valeur=0x20;
enable();
}


void _close_can()
{
if (p_dcan!=NULL)
	{
	disable();
	INTERRUPT_ENABLE=0x00;
	VALID_IRQ.valeur=0x00;
	RestoreVect(29);
	free(p_dcan);
	enable();
	}
p_dcan=NULL;
}

// emmision d"une trame
int _Write_CAN(Trame *message)
{
if (p_dcan==NULL)
	mtr86fatal("Bus CAN n'est pas ouvert!");
disable();
if (p_dcan->nb_tx==0)
	{
	p_dcan->nb_tx++;
	ETrame(*message);
	// On envoie (bit 0)
	COMMAND=0x01 ;
	INTERRUPT_ENABLE|=0x02;		//activer les ITs en emission	
	}
	else
	{
	p_dcan->nb_tx++;
	p_dcan->tx_mes[p_dcan->rang_write]=*message;
	p_dcan->rang_write++;
	if (p_dcan->rang_write==NB_MAX_MESSAGE)
		p_dcan->rang_write=0;
	}
enable();
return 1;
}

int _Read_CAN(Trame *message_recu)
{
if (p_dcan==NULL)
	mtr86fatal("Bus CAN n'est pas ouvert!");
while(p_dcan->rang_lect==p_dcan->rang_recept)
	dort(1);
disable();
*message_recu=p_dcan->rx_mes[p_dcan->rang_lect];
p_dcan->rang_lect++;
if (p_dcan->rang_lect==NB_MAX_MESSAGE)
	p_dcan->rang_lect=0;
enable();
return 1;
}

void _Affiche_CAN(Trame *trame)
{
unsigned char i;
printf("Ext=%d, RTR=%d, dlc=%d, ",trame->trame_info.champ.extend,
					trame->trame_info.champ.rtr,
					trame->trame_info.champ.dlc);
if (trame->trame_info.champ.extend)
	printf("IDENTIFICATEUR=%8.8x, ",trame->ident.extend.identificateur.ident);
	else
	printf("IDENTIFICATEUR=%4.4x, ",trame->ident.standard.identificateur.ident);
if (trame->trame_info.champ.rtr==0)
	{
	printf("DATA= ");
	for(i=0;i<trame->trame_info.champ.dlc;i++)
		printf("%2.2x, ",trame->data[i]);
	}
	else
	printf("                                                      ");
printf("\n");
}
