/***********************************************************************
 * Module:  CBlocOptique.cpp
 * Author:  Equipe Projet DMS/UTEC
 * created: vendredi 21 janvier 2005 14:50:45
 * modified: mercredi 26 janvier 2005 14:21:15
 * Purpose: Implementation of the class CBlocOptique
 ***********************************************************************/

#include "CBlocOptique.h"


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie1()
// Purpose:    Implementation of CBlocOptique::AllumerSortie1()
// allume la sortie d'un bloc Optique
// Return:     void
////////////////////////////////////////////////////////////////////////
void CBlocOptique::AllumerSortie1(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x01;
Data[2]=0x0F;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie2()
// Purpose:    Implementation of CBlocOptique::AllumerSortie2()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::AllumerSortie2(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x02;
Data[2]=0x0F;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie3()
// Purpose:    Implementation of CBlocOptique::AllumerSortie3()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::AllumerSortie3(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x04;
Data[2]=0x0F;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie4()
// Purpose:    Implementation of CBlocOptique::AllumerSortie4()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::AllumerSortie4(void)
{
   int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x08;
Data[2]=0x0F;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreVeilleuse()
// Purpose:    Implementation of CBlocOptique::EteindreVeilleuse()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie1(void)
{
  int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x01;
Data[2]=0x00;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
//return tr;
}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie2()
// Purpose:    Implementation of CBlocOptique::EteindreSortie2()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie2(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x02;
Data[2]=0x00;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie3()
// Purpose:    Implementation of CBlocOptique::EteindreSortie3()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie3(void)
{
  int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x04;
Data[2]=0x00;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}



////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie4()
// Purpose:    Implementation of CBlocOptique::EteindreSortie4()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie4(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
Data[1]=0x08;
Data[2]=0x00;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::CBlocOptique()
// Purpose:    Implementation of CBlocOptique::CBlocOptique()
// parametre : 	addr adresse RXF1 du blocOPtique
//			ctrlcan adresse du controleur can grant
// Return:     void
////////////////////////////////////////////////////////////////////////
CBlocOptique::CBlocOptique(int Addr , CControleurCan* ctrlcan):PeripheriqueCAN_Sortie(Addr ,ctrlcan)
{
CTrame tr;
tr.SetAdresse(Adresse);
Data[0]=0x1E;
Data[1]=0x0F;
Data[2]=0x00;
tr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr);
}


