


//*****************************************************
//  Structures de donnes pour application  CAN VMD
//*****************************************************

#ifndef _VMD_H
#define _VMD_H


// Format de message 
typedef struct {
    /* nombre d'octets  envoyer, -1 si c'est une Remote Frame */
    int dlc;   
    unsigned char id1;  /* 8 bits de poids forts de l'ID. */
    unsigned char id2;  /* 3 bits de poids faible de l'ID. */
    unsigned char data[8];
} Message;


//  Pour l'identificateur en mode standard
typedef union 
{
struct 
	{
	unsigned short ident:11;
	unsigned short rtr:1;
	unsigned short nul:4;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	} registre;
unsigned short valeur;
} ident_standard;

//  Pour l'identificateur en mode tendu
typedef union
{
struct
	{
	unsigned long ident:29;
	unsigned long rtr:1;
	unsigned long x:2;
	} identificateur;
struct
	{
	unsigned char ident1;
	unsigned char ident2;
	unsigned char ident3;
	unsigned char ident4;
	} registre;
unsigned long valeur;
} ident_extend;

// Pour registre d'information Trame SJA1000
typedef union
	{
	struct
		{
		unsigned char extend:1;
		unsigned char rtr:1;
		unsigned char nul:2;
		unsigned char dlc:4;
		} champ;
	unsigned char registre;
	} tr_info;

// Pour Trame circulant sur rseau CAN
typedef struct
{
tr_info trame_info;
union
	{
	ident_standard standard;
	ident_extend   extend;
	} ident;	
unsigned char data[8];
} Trame;

typedef union
{
struct
	{
	unsigned char GP7:1;
	unsigned char GP6:1;
	unsigned char GP5:1;
	unsigned char GP4:1;
	unsigned char GP3:1;	
	unsigned char GP2:1;
	unsigned char GP1:1;
	unsigned char GP0:1;
	}bit;
unsigned char valeur;
}Port_8ES;
/*Port_8ES Etat_Commodo;
#define Cde_Veilleuse Etat_Commodo.bit.GP0
#define Cde_Code Etat_Commodo.bit.GP3
#define Cde_Phare Etat_Commodo.bit.GP2
#define Cde_Clign_Gauche Etat_Commodo.bit.GP4
#define Cde_Clign_Droit Etat_Commodo.bit.GP5
#define Cde_Klaxon Etat_Commodo.bit.GP6
#define Cde_Stop Etat_Commodo.bit.GP6
#define Entree7 Etat_Commodo.bit.GP7
*/

// Pour la Commande des feux
#define Cde_Nulle 0x00
#define Cde_FV_V 0x01 // Feux aVant en Veilleuse
#define Cde_FR_V 0x01 // Feux aRrire en Veilleuse
#define Cde_FV_C 0x03 // Feux aVant en Code
#define Cde_FR_C 0x01 // Feux aRrire en Code
#define Cde_FV_P 0x05 // Feux aVant en Phare
#define Cde_FR_P 0x01 // Feux aRrire en Phare
#define Masque_Clign_AV 0x04 // Pour Clignotant AVant
#define Masque_Clign_AR 0x04 // Pour Clignotant ARrire
#define Masque_Klaxon 0x08 // Pour Claxon
#define Masque_Stop 0x02 // Pour Stop
/*
//  Variables pour la commande et le control des feux
//----------------------------------------------------
//  Pour variables images de la commande effectue des diffrents feux
union byte_bits Image_FVG,Image_FVD,Image_FRD,Image_FRG;
// Pour Feux aVant Gauche
#define Valeur_FVG Image_FVG.valeur	// Pour un accs port complet
#define Veilleuse_FVG Image_FVG.bit.b0 
#define Code_FVG Image_FVG.bit.b1
#define Phare_FVG Image_FVG.bit.b2
#define Clignot_FVG Image_FVG.bit.b3
// Pour Feux aVant Droit
#define Valeur_FVD Image_FVD.valeur	// Pour un accs port complet
#define Veilleuse_FVD Image_FVD.bit.b0 
#define Code_FVD Image_FVD.bit.b1
#define Phare_FVD Image_FVD.bit.b2
#define Clignot_FVD Image_FVD.bit.b3
// Pour Feux aRrire Droit
#define Valeur_FRD Image_FRD.valeur	// Pour un accs port complet
#define Veilleuse_FRD Image_FRD.bit.b0 
#define Stop_FRD Image_FRD.bit.b1
#define Clignot_FRD Image_FRD.bit.b2
#define Klaxon_FRD Image_FRD.bit.b3
// Pour Feux aRrire Gauche
#define Valeur_FRG Image_FRG.valeur	// Pour un accs port complet
#define Veilleuse_FRG Image_FRG.bit.b0 
#define Stop_FRG Image_FRG.bit.b1
#define Clignot_FRG Image_FRG.bit.b2
#define Klaxon_FRG Image_FRG.bit.b3

// Pour les variables images des "Status" des sorties de puissance
union byte_bits Image_Stat_FVG,Image_Stat_FVD,Image_Stat_FRD,Image_Stat_FRG;
// Pour image "Status" Feux aVant Gauche

#define Valeur_Status_FVG Image_Stat_FVG.valeur // Pour un accs port complet
#define S_Veilleuse_FVG Image_Stat_FVG.bit.b4 	
#define S_Code_FVG Image_Stat_FVG.bit.b5
#define S_Phare_FVG Image_Stat_FVG.bit.b6
#define S_Clignot_FVG Image_Stat_FVG.bit.b7
// Pour image "Status" Feux aVant Droit
#define Valeur_Status_FVD Image_Stat_FVD.valeur // Pour un accs port complet
#define S_Veilleuse_FVD Image_Stat_FVD.bit.b4 	
#define S_Code_FVD Image_Stat_FVD.bit.b5
#define S_Phare_FVD Image_Stat_FVD.bit.b6
#define S_Clignot_FVD Image_Stat_FVD.bit.b7
// Pour image "Status" Feux aRrire Droit
#define Valeur_Status_FRD Image_Stat_FRD.valeur // Pour un accs port complet
#define S_Veilleuse_FRD Image_Stat_FRD.bit.b4 	
#define S_Stop_FRD Image_Stat_FRD.bit.b5
#define S_Clignot_FRD Image_Stat_FRD.bit.b6
#define S_Klaxon_FRD Image_Stat_FRD.bit.b7
// Pour image "Status" Feux aRrire Gauche
#define Valeur_Status_FRG Image_Stat_FRG.valeur // Pour un accs port complet
#define S_Veilleuse_FRG Image_Stat_FRG.bit.b4 	
#define S_Stop_FRG Image_Stat_FRG.bit.b5
#define S_Clignot_FRG Image_Stat_FRG.bit.b6
#define S_Klaxon_FRG Image_Stat_FRG.bit.b7*/

//  Dclaration des identificateurs, pour les diffrents modules sur le bus  VMD
//--------------------------------------------------------------------------------
#define Ident_T_IRM_FVG 0x0E041E07	// Feux aVant Gauche en interrogation (Information Request Message)
#define Ident_T_IM_FVG 0x0E080000	// Feux aVant Gauche en commande (Input Message)
#define Ident_AIM_FVG 0x0E200000		// Feux aVant Gauche en Acquittement commande

#define Ident_T_IRM_FVD 0x0E841E07	// Feux aVant Droit en interrogation (Information Request Message)
#define Ident_T_IM_FVD 0x0E880000	// Feux aVant Droit en commande (Input Message)
#define Ident_T_AIM_FVD 0x0EA0000	// Feux aVant Droit en Acquittement commande

#define Ident_T_IRM_FRG 0x0F041E07	// Feux aRrire Gauche en interrogation (Information Request Message)
#define Ident_T_IM_FRG 0x0F080000	// Feux aRrire Gauche en commande (Input Message)
#define Ident_T_AIM_FRG 0x0F200000	// Feux aRrire Gauche en Acquittement commande

#define Ident_T_IRM_FRD 0x0F841E07	// Feux aRrire Droit en interrogation (Information Request Message)
#define Ident_T_IM_FRD 0x0F880000	// Feux aRrire Droit en commande (Input Message)
#define Ident_T_AIM_FRD 0x0FA0000	// Feux aRrire Droit en Acquittement commande

#define Ident_T_IRM_Commodo 0x05041E07 // Commodo en interrogation (Information Request Message)




/*

Port_8ES Etat_Commodo_Essui_Glace;
#define Cde_Ess_Av_Int Etat_Commodo_Essui_Glace.bit.GP0
#define Entree1 Etat_Commodo_Essui_Glace.bit.GP1
#define Entree2 Etat_Commodo_Essui_Glace.bit.GP2
#define Cde_Ess_Av_Pos1 Etat_Commodo_Essui_Glace.bit.GP3
#define Cde_Ess_Av_Pos2 Etat_Commodo_Essui_Glace.bit.GP4
#define Cde_Ess_Ar Etat_Commodo_Essui_Glace.bit.GP5
#define Cde_Lave_Glace_Ar Etat_Commodo_Essui_Glace.bit.GP6
#define Cde_Lave_Glace_Av Etat_Commodo_Essui_Glace.bit.GP7

*/










#endif