/***********************************************************************
 * Module:  CBlocOptique.cpp
 * Author:  Equipe Projet DMS/UTEC
 * created: vendredi 21 janvier 2005 14:50:45
 * modified: mercredi 26 janvier 2005 14:21:15
 * Purpose: Implementation of the class CBlocOptique
 ***********************************************************************/

#include "CBlocOptique.h"
#include <stdio.h>

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie1()
// Purpose:    Implementation of CBlocOptique::AllumerSortie1()
// allume la sortie d'un bloc Optique
// Return:     void
////////////////////////////////////////////////////////////////////////
bool CBlocOptique::AllumerSortie1(void)
{
Data[2]=Data[2]|0x01;//donnee
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie2()
// Purpose:    Implementation of CBlocOptique::AllumerSortie2()
// Return:     void
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::AllumerSortie2(void)
{
Data[2]=Data[2]|0x02;//donnee
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie3()
// Purpose:    Implementation of CBlocOptique::AllumerSortie3()
// Return:     void
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::AllumerSortie3(void)
{
Data[2]=Data[2]|0x04;//donnee
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerSortie4()
// Purpose:    Implementation of CBlocOptique::AllumerSortie4()
// Return:     void
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::AllumerSortie4(void)
{
Data[2]=Data[2]|0x08;//donnee
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreVeilleuse()
// Purpose:    Implementation of CBlocOptique::EteindreVeilleuse()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie1(void)
{
Data[2]=Data[2]&0x0E;//donnee
}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie2()
// Purpose:    Implementation of CBlocOptique::EteindreSortie2()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie2(void)
{
Data[2]=Data[2]&0x0D;//donnee
}


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie3()
// Purpose:    Implementation of CBlocOptique::EteindreSortie3()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie3(void)
{
Data[2]=Data[2]&0x0B;//donnee
}



////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreSortie4()
// Purpose:    Implementation of CBlocOptique::EteindreSortie4()
// Return:     void
////////////////////////////////////////////////////////////////////////

void CBlocOptique::EteindreSortie4(void)
{
Data[2]=Data[2]&0x07;//donnee
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::CBlocOptique()
// Purpose:    Implementation of CBlocOptique::CBlocOptique()
// parametre : 	addr adresse RXF1 du blocOPtique
//			ctrlcan adresse du controleur can grant
// Return:     void
////////////////////////////////////////////////////////////////////////
CBlocOptique::CBlocOptique(int Addr , CControleurCan* ctrlcan):PeripheriqueCAN_Sortie(Addr ,ctrlcan)
{
CTrame tr_gpddr;//trame pour configrer le registre de direction
Data[0]=0x1F;
Data[1]=0x7F;//mask
Data[2]=0xF0;//4poid Fort Entre 4 poid Faible Sortie
tr_gpddr.SetAdresse(Adresse);
tr_gpddr.SetDonnee(Data,3);
ctrl_can->EcrireTrame(tr_gpddr);//envoie la trame sur le controleur CAN
while(ctrl_can->LireTrame(tr_gpddr)!=true);



tr_IM.SetAdresse(Adresse);
Data[0]=0x1E;
Data[1]=0x0F;//mask
Data[2]=0x00;//4poid Fort Entre 4 poid Faible Sortie

tr_IM.SetDonnee(Data,3);
PeripheriqueCAN_Sortie::EnvoyerEtat();
}



////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EtatSortie1(void)
// Purpose:    Implementation of CBlocOptique::EtatSortie1()
// Test l'etat de la sortie 1 d'un bloc Optique
// Return:     bool
////////////////////////////////////////////////////////////////////////
bool CBlocOptique::EtatSortie1(void)
{
if(( etat & 0x10 ) == 0x10 )
return true;
else 
return false;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EtatSortie2()
// Purpose:    Implementation of CBlocOptique::EtatSortie2()
// Return:     bool
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::EtatSortie2(void)
{
if(( etat & 0x20 ) == 0x20 )
return true;
else 
return false;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EtatSortie3()
// Purpose:    Implementation of CBlocOptique::EtatSortie3()
// Return:     boll
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::EtatSortie3(void)
{
if(( etat & 0x40 ) == 0x40 )
return true;
else 
return false;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EtatSortie4()
// Purpose:    Implementation of CBlocOptique::EtatSortie4()
// Return:     bool
////////////////////////////////////////////////////////////////////////

bool CBlocOptique::EtatSortie4(void)
{
if(( etat & 0x80 ) == 0x80 )
return true;
else 
return false;
}



