
#include <stdio.h>
#include "eid210.h"
#include "aton_can2.h"

#define NB_MAX_MESSAGE 20

void ETrame(Trame trame);

// variable global pour la gestion de la carte aton can

Trame rx_mes[NB_MAX_MESSAGE];
int rang_recept;
int rang_lect;
Trame tx_mes[NB_MAX_MESSAGE];
int rang_emet;
int rang_write;
int nb_tx;

// fonction interruption

void irq_can()
{
int i;
unsigned char etat_int;
etat_int=INTERRUPT;
if (etat_int&0x01)
	{
	rx_mes[rang_recept].trame_info.registre=RX_FRAME_INFO;
	if (rx_mes[rang_recept].trame_info.champ.extend==1)
		{ // trame tendue
		rx_mes[rang_recept].ident.extend.registre.ident1=RX_ID_1_E;
		rx_mes[rang_recept].ident.extend.registre.ident2=RX_ID_2_E;
		rx_mes[rang_recept].ident.extend.registre.ident3=RX_ID_3_E;
		rx_mes[rang_recept].ident.extend.registre.ident4=RX_ID_4_E;
		if (rx_mes[rang_recept].trame_info.champ.rtr==0)
			{
			for(i=0;i<rx_mes[rang_recept].trame_info.champ.dlc;i++)
				rx_mes[rang_recept].data[i]=*(RX_DATA_E+i);	
			}
		}
		else
		{ // trame standart
		rx_mes[rang_recept].ident.standard.registre.ident1=RX_ID_1_S;
		rx_mes[rang_recept].ident.standard.registre.ident2=RX_ID_2_S;
		if (rx_mes[rang_recept].trame_info.champ.rtr==0)
			{
			for(i=0;i<rx_mes[rang_recept].trame_info.champ.dlc;i++)
				rx_mes[rang_recept].data[i]=*(RX_DATA_S+i);	
			}
		}   

    	/* Release receive buffer */
	COMMAND=0x04;
	rang_recept++;
	if (rang_recept==NB_MAX_MESSAGE)
		rang_recept=0;
	}
if (etat_int&0x02)	// gestion de l'emission en it
	{
	nb_tx--;
	if (nb_tx>0) //rang_write!=rang_emet)
		{
		disable();
		ETrame(tx_mes[rang_emet]);
		COMMAND=0x01 ;
		rang_emet++;
		if (rang_emet==NB_MAX_MESSAGE)
			rang_emet=0;
		enable();
		}
		else
		{
		INTERRUPT_ENABLE=0x01;  // irq reception
		}
	}
}

/** 
 * Initialisation du SJA1000 en mode PeliCAN.
 */
void init_sja1000_peli_acc (char acc_code0, char acc_code1, char acc_code2, char acc_code3,
                            char acc_mask0, char acc_mask1, char acc_mask2, char acc_mask3) {

    // On passe en RESET MODE (bit 0)
    while (!(MODE & 0x01)) 
		MODE=0x01;

    // Mode PeliCAN (bit 7)
    CLOCK_DIVIDER=0xC0;

    // et on desactive les interruptions
    INTERRUPT_ENABLE=0x00;
    ACCEPT_CODE0=acc_code0;  
    ACCEPT_CODE1=acc_code1;  
    ACCEPT_CODE2=acc_code2;  
    ACCEPT_CODE3=acc_code3;  
    ACCEPT_MASK0=acc_mask0; 
    ACCEPT_MASK1=acc_mask1;  
    ACCEPT_MASK2=acc_mask2;  
    ACCEPT_MASK3=acc_mask3;  
    BUS_TIMING_0=0x03; //0xc4; //0x07;
    BUS_TIMING_1=0x7a; //0x3a;100 kbts/s //0xa3; 125
    // 11011011 (Push-pulls, "polarite zero", clock-output mode)
    OUTPUT_CONTROL=0x1A;
    /* Bit 0 = 0: Sortie du mode RESET
       Bit 1 = 0: Pas le mode Listen Only (donne des ACK)
       Bit 2 = 0: Pas le mode Self Test
       Bit 3 = 1: Acceptance filter mode = single */
    while (MODE & 0x01) 
			MODE=0x08;

}

/** 
 * Initialisation du SJA1000 en mode PeliCAN.
 */
void init_sja1000_peli () {
    init_sja1000_peli_acc(0, 0, 0, 0, 0xFF, 0xFF, 0xFF, 0xFF);
}

// init carte CAN ATON

void Init_Aton_CAN()
{
rang_recept=0;
rang_lect=0;
rang_emet=0;
rang_write=0;
nb_tx=0;

/* Initialisation DU SJA1000 de la carte PC104 */
init_sja1000_peli_acc (0x00,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF);
SetVect(29,&irq_can);
INTERRUPT_ENABLE=0x01;
VALID_IRQ.valeur=0x20;
}

void Stop_Aton_CAN()
{
INTERRUPT_ENABLE=0x00;
VALID_IRQ.valeur=0x00;
RestoreVect(29);
}

/* Ecrit une trame dans le SJA1000 */

void ETrame(Trame trame)
{
unsigned char i;
TX_FRAME_INFO=trame.trame_info.registre;
if (trame.trame_info.champ.extend==1)
	{ // trame tendue
	TX_ID_1_E=trame.ident.extend.registre.ident1;
	TX_ID_2_E=trame.ident.extend.registre.ident2;
	TX_ID_3_E=trame.ident.extend.registre.ident3;
	TX_ID_4_E=trame.ident.extend.registre.ident4;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			*(TX_DATA_E+i)=trame.data[i];	
		}
	}
	else
	{ // trame standard
	TX_ID_1_S=trame.ident.standard.registre.ident1;
	TX_ID_2_S=trame.ident.standard.registre.ident2;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			*(TX_DATA_S+i)=trame.data[i];	
		}
	}
}

// emmision d"une trame
char Ecrire_Trame(Trame message)
{
disable();
if (nb_tx==0)
	{
	nb_tx++;
	ETrame(message);
	// On envoie (bit 0)
	COMMAND=0x01 ;
	INTERRUPT_ENABLE|=0x02;		//activer les ITs en emission	
	}
	else
	{
	nb_tx++;
	tx_mes[rang_write]=message;
	rang_write++;
	if (rang_write==NB_MAX_MESSAGE)
		rang_write=0;
	}
enable();
return 1;
}

char Lire_Trame(Trame *message_recu)
{
disable();
if (rang_lect!=rang_recept)
	{
	*message_recu=rx_mes[rang_lect];
	rang_lect++;
	if (rang_lect==NB_MAX_MESSAGE)
		rang_lect=0;
	return 1;
	}
enable();
return 0;
}

Trame Lit_Trame()
{
Trame trame;
unsigned char i;
trame.trame_info.registre=RX_FRAME_INFO;
if (trame.trame_info.champ.extend==1)
	{ // trame tendue
	trame.ident.extend.registre.ident1=RX_ID_1_E;
	trame.ident.extend.registre.ident2=RX_ID_2_E;
	trame.ident.extend.registre.ident3=RX_ID_3_E;
	trame.ident.extend.registre.ident4=RX_ID_4_E;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			trame.data[i]=*(RX_DATA_E+i);	
		}
	}
	else
	{ // trame standard
	trame.ident.standard.registre.ident1=RX_ID_1_S;
	trame.ident.standard.registre.ident2=RX_ID_2_S;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			trame.data[i]=*(RX_DATA_S+i);	
		}
	}
return trame;
}

void Affiche_Trame(Trame trame)
{
unsigned char i;
printf("Ext=%d, RTR=%d, dlc=%d, ",trame.trame_info.champ.extend,
					trame.trame_info.champ.rtr,
					trame.trame_info.champ.dlc);
if (trame.trame_info.champ.extend)
	printf("IDENTIFICATEUR=%8.8x, ",trame.ident.extend.identificateur.ident);
	else
	printf("IDENTIFICATEUR=%4.4x, ",trame.ident.standard.identificateur.ident);
if (trame.trame_info.champ.rtr==0)
	{
	printf("DATA= ");
	for(i=0;i<trame.trame_info.champ.dlc;i++)
		printf("%2.2x, ",trame.data[i]);
	}
	else
	printf("                                                      ");
printf("\n");
}


Trame Receive_Trame()
{
Trame trame;
unsigned char i;
    /* Tant que l'on a pas de message, on attend */
    while ((STATUS & 0x10) == 0);

 
trame.trame_info.registre=RX_FRAME_INFO;

if (trame.trame_info.champ.extend==1)
	{ // trame tendue
	trame.ident.extend.registre.ident1=RX_ID_1_E;
	trame.ident.extend.registre.ident2=RX_ID_2_E;
	trame.ident.extend.registre.ident3=RX_ID_3_E;
	trame.ident.extend.registre.ident4=RX_ID_4_E;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			trame.data[i]=*(RX_DATA_E+i);	
		}
	}
	else
	{ // trame standart
	trame.ident.standard.registre.ident1=RX_ID_1_S;
	trame.ident.standard.registre.ident2=RX_ID_2_S;
	if (trame.trame_info.champ.rtr==0)
		{
		for(i=0;i<trame.trame_info.champ.dlc;i++)
			trame.data[i]=*(RX_DATA_S+i);	
		}
	}   


    /* Release receive buffer */
    COMMAND=0x04;

return trame;
}

/** 
 * Envoi d'une trame
 * La procedure attend que le message soit envoye (completement, cf TRANSMIT COMPLETE)
 * avant de rendre la main.
 *
 * @param   mes     Message a envoyer.
 */
void send_trame_peli (Message mes) {
    int i;

    /* Attend que le TRANSMIT BUFFER STATUS ne soit pas a l'etat "locked" */
    while ((STATUS & TRANSMIT_BUFFER_STATUS) == 0);

    /* Preparation du TRANSMIT BUFFER */
    // ID
    TX_ID_1_S=mes.id1;           /* 8 bits de poids forts de l'ID */
    TX_ID_2_S=mes.id2 << 5;      /* 3 bits de poids faible de l'ID, xxxxx */
    if (mes.dlc == -1) {
        // Frame Simple (bit 7), Remote (bit 6)
        TX_FRAME_INFO=0x40;
    } else {
        // Frame Simple (bit 7), pas Remote (bit 6), DLC (bits 3-0)
        TX_FRAME_INFO=mes.dlc;
        for (i = 0; i < mes.dlc; i++) {
            *(TX_DATA_S + i)=mes.data[i];
        }
    }

    // On envoie (bit 0)
    COMMAND=0x01 ;

    /* On attend que la transmission ait commence */
    while ((STATUS & TRANSMIT_STATUS) == 0);   // Tant que idle, on attend

    /* On attend que la precedente transmission soit complete (auto) */
    while ((STATUS& TRANSMISSION_COMPLETE) == 0);   // tant que incomplete, on attend
}


void reveille()
{
TX_ID_1_S=0x00;           /* 8 bits de poids forts de l'ID */
TX_ID_2_S=0x00;      /* 3 bits de poids faible de l'ID, xxxxx */
TX_FRAME_INFO=0x45;
COMMAND=0x01 ;

    /* On attend que la transmission ait commence */
    while ((STATUS & TRANSMIT_STATUS) == 0);   // Tant que idle, on attend

    /* On attend que la precedente transmission soit complete (auto) */
    while ((STATUS& TRANSMISSION_COMPLETE) == 0);   // tant que incomplete, on attend
}

/* lire entres sur MCP250x0 */

void lire_etat(short adr)
{
TX_ID_1_S=(char)(adr>>8);
TX_ID_2_S=(char)(adr&0x00E0);
TX_FRAME_INFO=0x48;
COMMAND=0x01 ;

    /* On attend que la transmission ait commence */
    while ((STATUS & TRANSMIT_STATUS) == 0);   // Tant que idle, on attend

    /* On attend que la precedente transmission soit complete (auto) */
    while ((STATUS& TRANSMISSION_COMPLETE) == 0);   // tant que incomplete, on attend

}

/**
 * Reception d'un message.
 * La procedure ne rend la main qu'apres avoir recu un message.
 * Le RECEIVE BUFFER est "release".
 *
 * @return  Le message recu.
 */
Message receive_trame_peli () {
    Message mes;
    int i;
    unsigned char fi;
    
    /* Tant que l'on a pas de message, on attend */
    while ((STATUS & 0x10) == 0);
/*	{
	gotoxy(6,10);
	printf("STATUS=%x\n",STATUS);
	}*/

    fi = RX_FRAME_INFO;
    if (fi & 0x40) mes.dlc = -1;    /* Remote */
    else mes.dlc = fi & 0x0F;       /* Data */
    
    mes.id1 = RX_ID_1_S;
    mes.id2 = RX_ID_2_S;
    
    for (i = 0; i < mes.dlc; i++) {
        mes.data[i] = *(RX_DATA_S + i);
    }

    /* Release receive buffer */
    COMMAND=0x04;

    return mes;
}

/** Affichage des regsitres en PeliCAN */ 
void print_reg_peli () {
    printf("REGISTRE en pelican");
    printf("MODE				0x00 = %x\n", MODE);
    printf("STATUS				0x02 = %x\n", STATUS);
    printf("INTERRUPT			0x03 = %x\n", INTERRUPT);
    printf("INTERRUPT_ENABLE	0x04 = %x\n", INTERRUPT_ENABLE);
    
    printf("BUS_TIMING_0		0x06 = %x\n", BUS_TIMING_0);
    printf("BUS_TIMING_1		0x07 = %x\n", BUS_TIMING_1);
    printf("OUTPUT_CONTROL		0x08 = %x\n", OUTPUT_CONTROL);
    
    printf("ARBIT_LOST_CAPTURE  0x0B = %x\n", ARBITRATION_LOST_CAPTURE);
    printf("ERROR_CODE_CAPTURE	0x0C = %x\n", ERROR_CODE_CAPTURE);
    printf("ERROR_WARNING_LIM   0x0D = %x\n", ERROR_WARNING_LIMIT);
    
    printf("RX_ERROR_COUNTER	0x0E = %x\n", RX_ERROR_COUNTER);
    printf("TX_ERROR_COUNTER	0x0F = %x\n", TX_ERROR_COUNTER);
    printf("RX_FRAME_INFO   	0x10 = %x\n", RX_FRAME_INFO);
    printf("TX_FRAME_INFO   	0x10 = %x\n", TX_FRAME_INFO);
    
    /* Mode SIMPLE FRAME */
    printf("RX_ID_1_S           0x11 = %x\n", RX_ID_1_S);
    printf("RX_ID_2_S           0x12 = %x\n", RX_ID_2_S);
    printf("RX_DATA_S           0x13 = %x\n", *(RX_DATA_S));
    printf("RX_DATA_S+1         0x14 = %x\n", *RX_DATA_S+1);
  
    printf("TX_ID_1_S           0x11 = %x\n", TX_ID_1_S);
    printf("TX_ID_2_S           0x12 = %x\n", TX_ID_2_S);
    printf("TX_DATA_S           0x13 = %x\n", *(TX_DATA_S));
    
    /* Les 2 modes */
    printf("RX_MESSAGE_COUNTER  0x1D = %x\n", RX_MESSAGE_COUNTER);
    printf("RX_BUF_START_AD     0x1E = %x\n", RX_BUFFER_START_ADDRESS);
    printf("CLOCK_DIVIDER       0x1F = %x\n", CLOCK_DIVIDER);
}

/* Affiche l'etat du STATUS REGISTER */
void show_status () 
{
    unsigned char stat = STATUS;

    printf("\n** STATUS REGISTER: %x\n", stat);

    if (stat & 0x80)    printf("BUS STATUS             = Bus off\n");
    else                printf("BUS STATUS             = Bus on\n");
    if (stat & 0x40)    printf("ERROR STATUS           = error\n");
    else                printf("ERROR STATUS           = ok\n");
    if (stat & 0x20)    printf("TRANSMIT STATUS        = Transmitting\n");
    else                printf("TRANSMIT STATUS        = idle\n");
    if (stat & 0x10)    printf("RECEIVE STATUS         = Receiving\n");
    else                printf("RECEIVE STATUS         = idle\n");
    if (stat & 0x08)    printf("TRANSMISSION COMPLETE  = Complete\n");
    else                printf("TRANSMISSION COMPLETE  = Incomplete\n");
    if (stat & 0x04)    printf("TRANSMIT BUFFER STATUS = Released\n");
    else                printf("TRANSMIT BUFFER STATUS = Locked\n");
    if (stat & 0x02)    printf("DATA OVERRUN STATUS    = Overrun\n");
    else                printf("DATA OVERRUN STATUS    = Absent\n");
    if (stat & 0x01)    printf("RECEIVE BUFFER STATUS  = Full\n");
    else                printf("RECEIVE BUFFER STATUS  = Empty\n");
}

/* Affiche le message passe en parametres sur une ligne */
void print_little (Message mes) {
    int dlc;
    int rtr;
    unsigned char id[12];
    int i;

    rtr = mes.id2 & 0x10;
    id[0]  = (mes.id1 & 0x80) ? '1' : '0';
    id[1]  = (mes.id1 & 0x40) ? '1' : '0';
    id[2]  = (mes.id1 & 0x20) ? '1' : '0';
    id[3]  = (mes.id1 & 0x10) ? '1' : '0';
    id[4]  = (mes.id1 & 0x08) ? '1' : '0';
    id[5]  = (mes.id1 & 0x04) ? '1' : '0';
    id[6]  = (mes.id1 & 0x02) ? '1' : '0';
    id[7]  = (mes.id1 & 0x01) ? '1' : '0';
    id[8]  = (mes.id2 & 0x80) ? '1' : '0';
    id[9]  = (mes.id2 & 0x40) ? '1' : '0';
    id[10] = (mes.id2 & 0x20) ? '1' : '0';
    id[11] = '\0';

    printf("ID: %s (%x %x), ", id, mes.id1, mes.id2 & 0xE0);
    printf("RTR: %d, ", rtr);
    printf("DLC: %d, ", mes.dlc);
    printf("Data: ");
    for (i = 0; i < mes.dlc; i++) {
        printf(" %x, ", mes.data[i]);
    }

}
