/***********************************************************************
 * Module:  CBlocOptique.cpp
 * Author:  clems
 * Modified: vendredi 21 janvier 2005 14:50:45
 * Purpose: Implementation of the class CBlocOptique
 ***********************************************************************/

#include "CBlocOptique.h"


////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerVeilleuse()
// Purpose:    Implementation of CBlocOptique::AllumerVeilleuse()
// Return:     void
////////////////////////////////////////////////////////////////////////
char tab[] ={0x1E,0x0F,0x01};

CTrame CBlocOptique::AllumerVeilleuse(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x01;
tab[2]=0x0F;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerCode()
// Purpose:    Implementation of CBlocOptique::AllumerCode()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::AllumerCode(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x02;
tab[2]=0x0F;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerPhare()
// Purpose:    Implementation of CBlocOptique::AllumerPhare()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::AllumerPhare(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x04;
tab[2]=0x0F;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreCode()
// Purpose:    Implementation of CBlocOptique::EteindreCode()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::EteindreCode(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x02;
tab[2]=0x00;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreVeilleuse()
// Purpose:    Implementation of CBlocOptique::EteindreVeilleuse()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::EteindreVeilleuse(void)
{
  int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x01;
tab[2]=0x00;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindrePhare()
// Purpose:    Implementation of CBlocOptique::EteindrePhare()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::EteindrePhare(void)
{
  int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x04;
tab[2]=0x00;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerStop()
// Purpose:    Implementation of CBlocOptique::AllumerStop()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::AllumerStop(void)
{
   int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x04;
tab[2]=0x0F;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreStop()
// Purpose:    Implementation of CBlocOptique::EteindreStop()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::EteindreStop(void)
{
     int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x04;
tab[2]=0x00;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::AllumerClignotant()
// Purpose:    Implementation of CBlocOptique::AllumerClignotant()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::AllumerClignotant(void)
{
      int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x08;
tab[2]=0x0F;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}

////////////////////////////////////////////////////////////////////////
// Name:       CBlocOptique::EteindreClignotant()
// Purpose:    Implementation of CBlocOptique::EteindreClignotant()
// Return:     void
////////////////////////////////////////////////////////////////////////

CTrame CBlocOptique::EteindreClignotant(void)
{
int tmp,cpt;
CTrame tr;
tr.SetAdresse(Adresse);
tab[1]=0x08;
tab[2]=0x00;
tr.SetDonnee(tab,3);
ctrl_can->EcrireTrame(tr);
return tr;
}


CBlocOptique::CBlocOptique(int Addr , CControleurCan* ctrlcan):PeripheriqueCAN_Sortie(Addr ,ctrlcan)
{

}


