	/************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*  	Test du port C qui pilote l'afficheur 7 segments		* 
	*        	 pour afficher un nombre dcimal  ( 0  9)			*			
	*  CAHIER DES CHARGES  :					      	*
	******************************					      	*	
	*  L'afficheur affiche un nombre dcimal (entre 0 et 9)		*
	*  qui s'incrmente environ toutes les secondes 			*
	*  Ce temps sera gnr par Timer en interruption		      	*
	*---------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER:  Aff_7S_HI.C			       		*
	**********************							*
	*************************************************************************/
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "CPU_reg.h"
#include "Structures_Donnees.h"

//*********************
//  DECLARATIONS  
//*********************
// Les prototypes des fonctions
void AFFICHER(unsigned char);
/* Dclaration des variables pour la temporisation */
int CPTR_mS;						/* dclaration des variables et compteurs de millisecondes */	
unsigned char Fin_tempo,Tempo_en_cours;		/*  dclaration variables pour gestion temporisation 


/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void irq_bt()
{	 if (Tempo_en_cours==1)
		{ CPTR_mS++;
                           if (CPTR_mS ==1000) Fin_tempo=1,Tempo_en_cours=0,CPTR_mS=0;
		}
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


//============================
//   	FONCTION PRINCIPALE 
//============================
main()
{
//Varirables locales
//********************
unsigned char compteur;

//  Initialisations
//*****************
// Pour le port C
Dir_Port_C=0xFF;	// Tous les bits du port C sont en sortie
Port_C=0x00;		// On teint tous les segments	
// Pour base de temps
CPTR_mS=0;			// initialisation compteurs millisecondes
SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H
Tempo_en_cours=0;		// Temporisation inactive

//Dbut de la boucle principale
//*********************************
	do
	{	for (compteur=0;compteur<=15;compteur++)
		{
			// AFFICHER
			Port_C=Tab_Valeurs_7Seg[compteur];
			//Pour attendre 1S
			Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
			do{}while(Fin_tempo==0);		// Attendre fin tempo
		}
	  /*Remise  0 du compteur */
	  compteur=0;
	 }while (1);
}
//Fin de la fonction principale
//********************************

