
	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*	 Affichage sur 7 segments de l'entre analogique		*
	*  	 n 0 (celle du potentiomtre)					*
	*								      	*	
	*  Cahier des charges	:					      	*
	* **********************						      	*	
	*  On affiche un nombre hexadcimal (entre 0 et 15)			*
	*  qui correspond aux poids forts du rsultat de conversion		*
	*  de l'entre analogique E0  						*
	*  (impose par la position du potentiomtre)			*
	*  On affiche galement les 8 bit MSB sur le port A			*
	*  -> Tournez le potentiomtre pour voir s'afficher la valeur		*
	* ------------------------------------------------------------------------------------------------------- 	*
	*  NOM du FICHIER:  CAN_Port_C&PA.C		       		*
	* ********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"


//************************
//    DECLARATIONS     *
//************************

/* Declaration des prototypes des fonctions */
void Afficher_Sur_PA(unsigned char);

//****************************************
//	FONCTION PRINCIPALE 	
//****************************************

main()
{
/*Variable locale*/
unsigned short resultat_conv;
unsigned char val_aff;

//  Initialisations
//*****************
/* Initialisation du port A en sortie*/
CFSR3=0x8888;		/* CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;		/* CHA4  CHA7 en mode "DIO" 	*/
CPR1=0xFFFF;		/* Tous les bits en priorit haute 	*/

/*Initialisation de l'afficheur*/
DirPortC=0xFF;		/* Le port C en sortie			*/

//Dbut de la boucle principale
//********************************
 do
    {	// Lancer la conversion de la voie 0
	CAN=0x0040;
	/*Attendre la fin de la conversion*/
	do{}while(Fin_Conv_AN==1);
	//Lire le rsultat de conversion
	resultat_conv=CAN;
	//masque des bits de poids faibles pour afficher les 4 bits de poids fort sur 7 Segments
	val_aff=(unsigned char) ((resultat_conv&0x0FFF)>>8);
	Port_C=Tab_Valeurs_7Seg[val_aff] ;  
	val_aff=(unsigned char) ((resultat_conv&0x0FFF)>>4);
	Afficher_Sur_PA(val_aff);
     }while(1);
}
//Fin de la boucle principale


void Afficher_Sur_PA(unsigned char etatPA)
{	if(etatPA&0x01)PA0=un;
	  else PA0=zero;
	if(etatPA&0x02)PA1=un;
	  else PA1=zero;
	if(etatPA&0x04)PA2=un;
	  else PA2=zero;
	if(etatPA&0x08)PA3=un; 
	  else PA3=zero;
	if(etatPA&0x10)PA4=un; 
	  else PA4=zero;
	if(etatPA&0x20)PA5=un;
	  else PA5=zero;
	if(etatPA&0x40)PA6=un;
	  else PA6=zero;
	if(etatPA&0x80)PA7=un;
	  else PA7=zero;
	HSRR1=Image_PA;
}




