	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*  Faire un chenillard avec les 8 leds du Simulateur  d'E/S	    	*
	*  Rem: Ces LEDs sont connectes sur le port A			*
	*            Lignes TPU du 68332: TPU0  TPU7  (CHA0   CHA7)	* 
 	* CAHIER DES CHARGES:					      	*
	***************************					      	*	
	*  Les leds s'allument suivant le cycle 			      	*
	*              D8 -> D7 -> .... -> D1  puis  -> D8 -> D7  ... etc                   	*
	* Une led s'allume par un 0						*
	*	PA0=0 -> PA1=0  .... etc					*
	*  Le temps pendant lequel une led s'allume est d'environ 1S   	*
	*  Ce temps sera gnr par une boucle "logiciel"		      	*
	*--------------------------------------------------------------------------------------------------------	*		
	*  NOM du FICHIER:  CHENILLARD_1_PA.C			       	*
	**********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
//  DECLARATIONS 
//********************
void ATTendre(int);

//=============================
//	FONCTION PINCIPALE 	
//=============================
main()
{
//Initialisations 
//****************

/* Initialisation du port A en sortie*/
CFSR3=0x8888;		/* CHA0  CHA3 en mode "DIO" */
CFSR2=0x8888;		/* CHA4  CHA7 en mode "DIO" */
CPR1=0xFFFF;		/* Tous les bits en priorit haute */

	//Dbut de la fonction principale
	//***********************************
        do
	{
	//Allumage succssif des LED
	HSRR1=0x5556;		/* D8*/
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x5559;		/* D7 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x5565;		/* D6 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x5595;		/* D5 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x5655;		/* D4 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x5955;		/* D3 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x6555;		/* D2 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	HSRR1=0x9555;		/* D1 */
	//Appeler le sous-programme TEMPORISATION
	ATTendre(1);

	}while(1);  // Fin de la boucle principale
}		
//    Fin de la fonction principale
//**********************************


//==================================
//  	FONCTION de temporisation 	
//==================================

void ATTendre(int nb)	   // Le paramtre pass (nb) donne le nombre de secondes
{
int i;
for (i=(400000*nb);i>0;i--);	/*Dcrmentation de la variable de temporisation*/
}

