	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*  Faire un chenillard avec les 8 leds du Simulateur  d'E/S	    	*
	*  Rem: Ces LEDs sont connectes sur le port A			*
	*            Lignes TPU du 68332: TPU0  TPU7  (CHA0   CHA7)	* 
 	* Cahier des charges:						      	*
	***********************						      	*	
	*  Les leds s'allument suivant le cycle 			      	*
	*              D8 -> D7 -> .... -> D1  puis  -> D8 -> D7  ... etc                   	*
	* Une led s'allume par un 0						*
	*	PA0=0 -> PA1=0  .... etc					*
	*  Le temps pendant lequel une led s'allume est d'environ 1S   	*
	*  Ce temps sera gnr par le Timer du 68332		      	*
	*  --------------------------------------------------------------------------------------------------	*		
	*  NOM du FICHIER:  CHENILLARD_2_PA.C  (solution 2)	       	*
	**********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"

//  DECLARATIONS 
//********************
/* Dclaration des variables*/
int CPTR_mS;			/* dclaration des variables et compteurs de millisecondes */	
unsigned char Fin_tempo,Tempo_en_cours;	/*  dclaration variables pour gestion temporisation 

/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void irq_bt()
{	 if (Tempo_en_cours==1)
		{ CPTR_mS++;
                           if (CPTR_mS ==1000) Fin_tempo=1,Tempo_en_cours=0,CPTR_mS=0;
		}
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


//=============================
//	FONCTION PINCIPALE 	
//=============================
main()
{
//Initialisations 
//****************
// Pour base de temps
//***********************
CPTR_mS=0;			// initialisation compteurs millisecondes
SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H
Tempo_en_cours=0;		// Temporisation inactive
/* Initialisation du port A en sortie*/
CFSR3=0x8888;		/* CHA0  CHA3 en mode "DIO" */
CFSR2=0x8888;		/* CHA4  CHA7 en mode "DIO" */
CPR1=0xFFFF;		/* Tous les bits en priorit haute */

	//Dbut de la fonction principale
	//***********************************
        do
	{
	//Allumage succssif des LED
	HSRR1=0x5556;		/* D8 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	 do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x5559;		/* D7 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x5565;		/* D6 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x5595;		/* D5 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x5655;		/* D4 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x5955;		/* D3 */
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x6555;		/* D2*/
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	do{}while(Fin_tempo==0);	// Attendre fin tempo

	HSRR1=0x9555;		/* D1*/
	Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	 do{}while(Fin_tempo==0);	// Attendre fin tempo

	}while(1);  // Fin de la boucle principale
}		
//    Fin de la fonction principale
//**********************************

