
	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*	Comptage du nombre de commutation sur l'entre 		*
	*	 repre IRQ sur la carte de simulation.			*
	*	 La commutation gnrera une interruption.			*
	* 	Ce nombre est affich sur l'afficheur 7 Segments 		*
	*            (les 4 bits LSB) et sur les 8 leds du portA.			*
	*									*
	*  Cahier des charges:						*
	*  **********************						*
	*  A chaque commutation un compteur s'incrmente	dans un	*
	*   programme d'interruption associ					*
	*  La rsultat de comptage est actualis dans la fonction 		*
	*   principale 								*
	*  ------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER:  Compt_IRQ.SRC		       		*
	* ********************							*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

//************************
//    DECLARATIONS     *
//************************
// Du prototype de la fonction d'affichage sur le portA
void Afficher_Sur_PA(unsigned char );
// Des variables globales
unsigned char compteur;
unsigned char Flag_Aff;
// De la fonction d'interruption
void irq_IRQ()
{ 	compteur++;
	Flag_Aff=1;
}

//****************************************
//	FONCTION PRINCIPALE 	
//****************************************
main()
{
//  Initialisations
//*****************
/* Pour port A en sortie */
CFSR3=0x8888;		/* CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;		/* CHA4  CHA7 en mode "DIO" 	*/
CPR1=0xFFFF;		/* Tous les bits en priorit haute 	*/
// Pour le comptage des commutations
compteur=0;
Flag_Aff=0;
// Mise en place du vecteur d'interruption
SetVect(30,&irq_IRQ);		// mise en place de l'autovecteur  avec la fonction irq_IRQ()
// Autoriser les interruption (Bouton IRQ connect sur  entre IRQ4 du microcontrleur)
Valid_Irq4=1;
/* Initialisation de l'afficheur*/
DirPortC=0xFF;		/* 	Le port C en sortie		*/

//Dbut de la boucle principale
//********************************
 do
    {
	/*Attendre ordre d'affichage ... donc d'une commutation de l'interrupteur "IRQ" */
	do{}while(Flag_Aff==1);
	// On affiche les 8 bits sur le port A
	Afficher_Sur_PA(compteur);
	// On affiche les 4 bits de poids faible sur 7 Segments
	Port_C=Tab_Valeurs_7Seg[compteur&0x0F] ; 
	// Pour attendre la prochaine commutation
	Flag_Aff=0;
     }while(1);
}
//Fin de la boucle principale

void Afficher_Sur_PA(unsigned char etatPA)
{	if(etatPA&0x01)PA0=un;
	  else PA0=zero;
	if(etatPA&0x02)PA1=un;
	  else PA1=zero;
	if(etatPA&0x04)PA2=un;
	  else PA2=zero;
	if(etatPA&0x08)PA3=un; 
	  else PA3=zero;
	if(etatPA&0x10)PA4=un; 
	  else PA4=zero;
	if(etatPA&0x20)PA5=un;
	  else PA5=zero;
	if(etatPA&0x40)PA6=un;
	  else PA6=zero;
	if(etatPA&0x80)PA7=un;
	  else PA7=zero;
	HSRR1=Image_PA;
}




