	/************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************	
	*  CAHIER DES CHARGES						*
	*  *************************						*
	*  Les tats des "SWITCHs" sont recopis sur les LEDs	    	*
	*  ainsi que sur l'afficheur 7 segments (4 bits de poids faibles)	*
	*  Description:								*
	*	Les LEDs sont connectes sur le Port A			*
	*             ->Lignes TPU du 68332: TPU0  TPU7  (CHA0   CHA7)	* 
	*         	Les  "SWITCHs" sont connects sur Port B			*
	*	  ->Lignes TPU du 68332: TPU0  TPU7  (CHA8   CHA15)	* 
	* 	Les LEDs de l'afficheur 7 segments sur le Port C		*
	*									*
	*  ----------------------------------------------------------------------------------------------------	* 		
	*  NOM du FICHIER:  RECOP_BsurA&C.SRC  		       	*
	* ********************							*
	*************************************************************************/
			
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

/* Dclarations
 ****************/
#define un 1
#define zero 2

/****************************************
*        FONCTION PRINCIPALE    	*
****************************************/
main()
{
/*  	INITIALISER
*************************/
/* Pour le port C (l ou il y a l'afficheur 7 segment*/
Dir_Port_C=0xFF;	// Les 8 bits MSB sont valides ; les 8 bits port C sont en sortie
PortC=0x00;

/*  Configurer le port A    en mode "Discet Input Output"   (DIO)-> code $8  */
CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/

/* Dfinir les priorits */
CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */
	
/* Les tats des entres sont mmoriss dans les registres d'tat
 * Lorsque l'on crira des 11 dans le registre de service 	*/
HSQR0=0xAAAA;	/* Les entres seront mmorises	*/					
/* Eteindre toutes les leds */
HSRR1=0x5555;	/* Tous les bits PA  1 */


/*  	 BOUCLE PRINCIPALE
************************************/
do
{	/* Acqurir les entres */
	HSRR0=0xFFFF;
	/*  tester l'tat de PB7  puis positionner l'image de PA7  */
	if(PB7==1)PA7=un,PC7=1;
	else PA7=zero,PC7=0;
	/*  tester l'tat de PB6  puis positionner l'image de PA6  */
	if(PB6==1)PA6=un,PC6=1;
	else PA6=zero,PC6=0;
	/*  tester l'tat de PB5  puis positionner l'image de PA5 */ 
	if(PB5==1)PA5=un,PC5=1;
	else PA5=zero,PC5=0;
	/* tester l'tat de PB4  puis positionner l'image de PA4  */
	if(PB4==1)PA4=un,PC4=1;
	else PA4=zero,PC4=0;
	/* tester l'tat de PB3  puis positionner l'image de PA3  */
	if(PB3==1)PA3=un,PC3=1;
	else PA3=zero,PC3=0;
	/* tester l'tat de PB2  puis positionner l'image de PA2  */
	if(PB2==1)PA2=un,PC2=1;
	else PA2=zero,PC2=0;
	/* tester l'tat de PB1  puis positionner l'image de PA1  */
	if(PB1==1)PA1=un,PC1=1;
	else PA1=zero,PC1=0;
	/* tester l'tat de PB0  puis positionner l'image de PA0  */
	if(PB0==1)PA0=un,PC0=1;
	else PA0=zero,PC0=0;
	// On actualise les 8 LEDs de sorties (Recopie de l'image du port A)
	HSRR1=Image_PA;	

} while(1);     /* Fin de la boucle principale */

}    /*	Fin de la fonction principale
     ************************************/	


