	/*************************************************************************
	*     TP sur  EID210 avec SIMULATEUR D'ENTREES SORTIES	*
	*************************************************************************
	*  Les tats des "SWITCHs" sont recopis sur les LEDs	    	*
	* 									*
	*  CAHIER DES CHARGES:						*
	*  **************************						*
	*	Les LEDs sont connectes sur le Port A			*
	*             ->Lignes TPU du 68332: TPU0  TPU7  (CHA0   CHA7)	* 
	*         	Les  "SWITCHs" sont connects sur Port B			*
	*	  ->Lignes TPU du 68332: TPU0  TPU7  (CHA8   CHA15)	* 
	*									*
	* -------------------------------------------------------------------------------------------------------	* 		
	*  NOM du FICHIER:  RECOP_BsurA.C  			       	*
	*  ********************							*
	*************************************************************************/
	
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Simulateur_ES.h"
#include "Structures_donnees.h"

/* Dclarations
 ****************/
/****************************************
*        FONCTION PRINCIPALE    	*
****************************************/
main()
{
/*  	INITIALISER
*************************/
/*  Configurer le port A    en mode "Discet Input Output"   (DIO)-> code $8  */
CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/
/* Dfinir les priorits */
CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */
	
/* Les tats des entres sont mmoriss dans les registres d'tat
 * Lorsque l'on crira des 11 dans le registre de service 	*/
HSQR0=0xAAAA;	/* Les entres seront mmorises	*/					
/* Eteindre toutes les leds */
HSRR1=0x5555;	/* Tous les bits PA  1 */


/*  	 BOUCLE PRINCIPALE
************************************/
do
{	/* Acqurir les entres */
	HSRR0=0xFFFF;
	/*  tester l'tat de PB7  puis positionner l'image de PA7  */
	if(PB7==1)PA7=un;
	else PA7=zero;
	/*  tester l'tat de PB6  puis positionner l'image de PA6  */
	if(PB6==1)PA6=un;
	else PA6=zero;
	/*  tester l'tat de PB5  puis positionner l'image de PA5 */ 
	if(PB5==1)PA5=un;
	else PA5=zero;
	/* tester l'tat de PB4  puis positionner l'image de PA4  */
	if(PB4==1)PA4=un;
	else PA4=zero;
	/* tester l'tat de PB3  puis positionner l'image de PA3  */
	if(PB3==1)PA3=un;
	else PA3=zero;
	/* tester l'tat de PB2  puis positionner l'image de PA2  */
	if(PB2==1)PA2=un;
	else PA2=zero;
	/* tester l'tat de PB1  puis positionner l'image de PA1  */
	if(PB1==1)PA1=un;
	else PA1=zero;
	/* tester l'tat de PB0  puis positionner l'image de PA0  */
	if(PB0==1)PA0=un;
	else PA0=zero;
	// On actualise les 8 sorties (Recopie de l'image du port A)
	HSRR1=Image_PA;	
} while(1);     /* Fin de la boucle principale */

}    /*	Fin de la fonction principale
     ************************************/	


