/*==============================================================
 *     DEFINITIONS  POUR LA CARTE DE SIMULATION D'ENTREES SORTIES  
 *==============================================================
 *  Le port A est connect sur les LEDs , ce sera des sorties
 *  Le port B est connect sur les 8 switchs , ce sera des entres
 *  Le port C est connect sur l'afficheur 7 segments, ce sera des sorties       
 *==============================================================*/

//  Pour le port A
union word_duos Etat_PA;
#define Image_PA Etat_PA.valeur;
#define PA0 Etat_PA.duo.duo0
#define PA1 Etat_PA.duo.duo1
#define PA2 Etat_PA.duo.duo2
#define PA3 Etat_PA.duo.duo3
#define PA4 Etat_PA.duo.duo4
#define PA5 Etat_PA.duo.duo5
#define PA6 Etat_PA.duo.duo6
#define PA7 Etat_PA.duo.duo7

#define un 1
#define zero 2


//   Dfinition des tats des bits du port B 
#define Etat_TPU8	(*(union word_bits*) (0xFFFF82))   	/* PB7 sur maquette */ 
#define Etat_TPU9	(*(union word_bits*) (0xFFFF92))   	/* PB6 sur maquette */ 
#define Etat_TPU10	(*(union word_bits*) (0xFFFFA2))   	/* PB5 sur maquette */ 
#define Etat_TPU11	(*(union word_bits*) (0xFFFFB2))   	/* PB4 sur maquette */ 
#define Etat_TPU12	(*(union word_bits*) (0xFFFFC2))   	/* PB3 sur maquette */ 
#define Etat_TPU13	(*(union word_bits*) (0xFFFFD2))   	/* PB2 sur maquette */ 
#define Etat_TPU14	(*(union word_bits*) (0xFFFFE2))   	/* PB1 sur maquette */ 
#define Etat_TPU15	(*(union word_bits*) (0xFFFFF2))   	/* PB0 sur maquette */ 

#define PB7 Etat_TPU8.bit.b15			/*  Dernier Etat	 de l'entre PB7 */
#define PB6 Etat_TPU9.bit.b15			/*  Dernier Etat	 de l'entre PB6 */
#define PB5 Etat_TPU10.bit.b15			/*  Dernier Etat	 de l'entre PB5 */
#define PB4 Etat_TPU11.bit.b15			/*  Dernier Etat	 de l'entre PB4 */
#define PB3 Etat_TPU12.bit.b15			/*  Dernier Etat	 de l'entre PB3 */
#define PB2 Etat_TPU13.bit.b15			/*  Dernier Etat	 de l'entre PB2 */
#define PB1 Etat_TPU14.bit.b15			/*  Dernier Etat	 de l'entre PB1 */
#define PB0 Etat_TPU15.bit.b15			/*  Dernier Etat	 de l'entre PB0 */



// Pour l'afficheur 7 segments
#define AFF_0	0xC0	// Pour afficher le chiffre 0
#define AFF_1	0xF9	// Pour afficher le chiffre 1
#define AFF_2	0xA4	// Pour afficher le chiffre 2
#define AFF_3	0xB0	// Pour afficher le chiffre 3
#define AFF_4	0x99	// Pour afficher le chiffre 4
#define AFF_5	0x92	// Pour afficher le chiffre 5
#define AFF_6	0x82	// Pour afficher le chiffre 6
#define AFF_7	0xF8	// Pour afficher le chiffre 7
#define AFF_8	0x80	// Pour afficher le chiffre 8
#define AFF_9	0x90	// Pour afficher le chiffre 9
#define AFF_10	0x88	// Pour afficher le caractre A
#define AFF_11	0x83	// Pour afficher le caractre B
#define AFF_12	0xC6	// Pour afficher le caractre C
#define AFF_13	0xA1	// Pour afficher le caractre D
#define AFF_14	0x86	// Pour afficher le caractre E
#define AFF_15	0x8E	// Pour afficher le caractre F

// les valeurs  charger sur port C pour allumer les bons segments de l'afficheur
unsigned char	Tab_Valeurs_7Seg[]={0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90,0x88,0x83,0xC6,0xA1,0x86,0x8E};




