	/************************************************************************************************
	* 		TP SUR EID210 avec FEU  DE  CARREFOUR		    	         		*
	*************************************************************************************************
	*      Cahier des charge TP N1:						       		*
	*    ******************************								*
	*    - Permutations rgulires:  voies principales - voies secondaires 			*
	*    - Les appels pitons et dtection de prsences voitures ne sont pas grs		*
	*    - Les temporisations sont ralises par des boucles d'attente de type logiciel		*
	*												*
	*												*
	*  NOM du FICHIER:  Feu_Carf_1.C  			  	    				*
	**********************										*
	*************************************************************************************************/
	
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_Donnees.h" 
#include "feux_carrefour.h"
void Active_Etat(int);
void Attendre(int);

/****************************************
*        FONCTION PRINCIPALE    	*
****************************************/
main()
{
/*  	INITIALISER
*************************/
/* Dfinition des "directions" du port C "   */

PortC_Dir=0x07;
PortC=0x00;

/*  Configurer le port A    en mode "Discet Input Output"   (DIO)-> code $8  */
CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/
/* Dfinir les priorits */
CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */

/*  	 BOUCLE PRINCIPALE
************************************/
do
{
	Active_Etat(1);		/*Autorisation des voies principales(feux 1 et 2 au vert)*/
	Attendre(12);		/*temporisation de 12 secondes*/
	Active_Etat(11);	/*les feux 1 et 2 passent  l'orange*/
	Attendre(3);		/*temporisation de 3 secondes*/
	Active_Etat(7);		/*Autorisation de la voie 5 (feux 5 au vert)*/
	Attendre(8);		/*temporisation de 8 secondes*/
	Active_Etat(8);		/*les feux 5 passent  l'orange*/
	Attendre(3);		/*temporisation de 3 secondes*/
} while(1);     /* Fin de la boucle principale */

}    /*	Fin de la fonction principale
     ************************************/


/*fonction d'affectation des sorties sur port C
****************************************************/	

void Active_Etat(int j)		/*Affectation des registres de sorties du port C
                          en fonction de l'tat	des tapes*/								
{
	switch(j)	/* numro de l'tat */ 
	{
	case 1 : {HSRR0=0x69A6;HSRR1=0x969A;PortC=0x04;break;} 	
	case 7 : 	{HSRR0=0x9AA6;HSRR1=0x9A69;PortC=0x03;break;}
	case 8 : 	{HSRR0=0x66A6;HSRR1=0x9A69;PortC=0x02;break;}
	case 11: 	{HSRR0=0x69A6;HSRR1=0x99A6;PortC=0x02;break;}
	default : 	{HSRR0=0xAAAA;HSRR1=0xAAAA;PortC=0x00;break;}  	// On teint tout 
	}
}

/*Boucle d'attente logicielle
*************************************/
void Attendre(int Duree) // Duree passe en paramtre
{	
int j,fin;
fin=Duree*250000;
for(j=0;j<=fin;j++); //boucle d'attente
}