	/************************************************************************************************
	* 		TP SUR EID210 avec FEU  DE  CARREFOUR		    	         		*
	*************************************************************************************************
	*      Cahier des charge TP N3:						       		*
	*    ******************************								*
	*	- prise en compte des appels pitons				 		*
	*	- si il n'y a pas d'appels pitons, permutation rgulire des feux :   		*
	*	  voies principales puis travers 4 puis voies secondaires puis     		*
	*	  voies principales puis traverse 3 puis voies secondaires... etc   		*
	*	- les prsences des vhicules ne sont pas geres                            		*
	*									            		*
	*  NOM du FICHIER:  Feu_Carf_3.C  				       	             		*
	*						                          	             		*
	*************************************************************************************************/
/* Liste des fichiers  inclure */
//*********************************
//#include <vector>

#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_Donnees.h"
#include "feux_carrefour.h" 

/* Declaration des variables
**************************************/

void TE0(void),TE1(void),TE2(void),TE3(void),TE4(void),TE5(void),TE6(void),TE7(void);
void TE8(void),TE9(void),TE10(void),TE11(void),TE12(void),TE13(void);
void Active_Etat(int);
void Init_Tempo(int);
int Etat,Duree,CPTR_mS,CPTR_S,Valeur_Tempo;
unsigned char Fin_Tempo,Tempo_en_Cours,Appel_Memorise;

/* fonction d'attente 
**************************************/

void Init_Tempo(int Duree)
{	
Tempo_en_Cours=1; 
Valeur_Tempo = Duree; 
Fin_Tempo=0;
CPTR_mS=0;
}

/* fonction d'interruption pour tempo  (Toutes les mS)
***********************************************************/

void irq_bt()
{
	if (Tempo_en_Cours==1)
		{ CPTR_mS++;
                  if (CPTR_mS ==1000) CPTR_S++,CPTR_mS=0;
		  if (CPTR_S>=Valeur_Tempo)Fin_Tempo=1,Tempo_en_Cours=0,CPTR_S=0;
		}
}

/****************************************
*        FONCTION PRINCIPALE    	*
****************************************/
main()
{

int essai;
/*  	INITIALISER
*************************/
/* Dfinition des "directions" du port C "   */

Dir_Port_C=0x07;
PortC=0x00;

/*  Configurer le port A    en mode "Discet Input Output"   (DIO)-> code $8  */

CFSR3=0x8888;	/*  CHA0  CHA3 en mode "DIO" 	*/
CFSR2=0x8888;	/*  CHA4  CHA7 en mode "DIO"	*/
CFSR1=0x8888;	/*  CHA8  CHA11 en mode "DIO"	*/
CFSR0=0x8888;	/*  CHA12  CHA15 en mode "DIO"	*/

/* Dfinir les priorits */

CPR1=0xFFFF;	/* Tous les bits de PA en priorit haute  */
CPR0=0xFFFF;	/* Tous les bits de PB en priorit haute  */

// Pour base de temps
//*******************
CPTR_mS=0;
CPTR_S=0;
//CPTR_prec=0;
essai=SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H

// Pour grafcet , activation de l'tape 0
//****************************************
Etat_grafcet=0x0001;		/*Initialisation du grafcet (Etape 0 active) */
Active_Etat(1);
Appel_Memorise=0;
Tempo_en_Cours=0;
Fin_Tempo=0;
// Activation tempo de 10 S
Init_Tempo(10);                       /* Dure tempo en Seconde passe comme paramtre */


/*  	 BOUCLE PRINCIPALE
************************************/
do
{
 if (AE0==1) TE0();
 if (AE1==1) TE1();
 if (AE2==1) TE2();
 if (AE3==1) TE3();
 if (AE4==1) TE4();
 if (AE5==1) TE5();
 if (AE6==1) TE6();
 if (AE7==1) TE7();
 if (AE8==1) TE8();
 if (AE9==1) TE9();
 if (AE10==1) TE10();
 if (AE11==1) TE11();
 if (AE12==1) TE12();
 if (AE13==1) TE13();
} while(1);     	/* Fin de la boucle principale */
}  //  Fin de la fonction principale
	
/*  	 SOUS PROGRAMMES DE TRAITEMENT DES ETAPES
*********************************************************************/

void TE0(void)  /*Autorisation des voies principales(feux 1 et 2 au vert)*/
{	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE0=0,AE12=1,Active_Etat(11),Init_Tempo(3),Appel_Memorise=0;
		  else AE1=1,AE0=0,Active_Etat(2),Init_Tempo(3);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;	
}
void TE1(void) /*le feu 1 passe  l'orange*/
{
	
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
	if (Appel_Memorise==1) AE1=0, AE12=1,Active_Etat(11),Init_Tempo(3), Appel_Memorise=0;
	else if (Fin_Tempo==1) AE1=0, AE2=1,Active_Etat(3),Init_Tempo(6);  	 	 

}	
void TE2(void)  /*Autorisation des voies 2 et 4 (feux 2 et 4 au vert)*/
{
	
	if(Fin_Tempo==1) AE2=0, AE3=1,Active_Etat(4), Init_Tempo(3);
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1; 		//  memorisation pieton pour tape suivante  
}
void TE3(void)  /*les feux 2 et 4 passent  l'orange*/
{
	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE3=0,AE13=1,Active_Etat(15),Init_Tempo(12),Appel_Memorise=0;
		  else AE4=1,AE3=0,Active_Etat(7),Init_Tempo(8);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
}
void TE4(void)  /*Autorisation de la voie 5 (feux 5 au vert)*/
{
	
	if(Fin_Tempo==1) AE4=0, AE5=1,Active_Etat(8), Init_Tempo(3);
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1;  		// memorisation pieton pour tape suivante
}
void TE5(void)  /*les feux 5 passent  l'orange*/
{
	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE5=0,AE13=1,Active_Etat(15),Init_Tempo(12),Appel_Memorise=0;
		  else AE6=1,AE5=0,Active_Etat(1),Init_Tempo(10);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
}
void TE6(void)  /*Autorisation des voies principales(feux 1 et 2 au vert)*/
{
	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE6=0,AE12=1,Active_Etat(11),Init_Tempo(3),Appel_Memorise=0;
		  else AE7=1,AE6=0,Active_Etat(9),Init_Tempo(3);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
}
void TE7(void) /*le feu 2 passe  l'orange*/
{
	
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
	if (Appel_Memorise==1) AE7=0, AE12=1,Active_Etat(11),Init_Tempo(3), Appel_Memorise=0;
	else if (Fin_Tempo==1) AE7=0, AE8=1,Active_Etat(5),Init_Tempo(8);  	 

}
void TE8(void)  /*Autorisation des voies 1 et 3 (feux 1 et 3 au vert)*/
{
	
	if(Fin_Tempo==1) AE8=0, AE9=1,Active_Etat(6), Init_Tempo(3); 
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1;		// memorisation pieton pour tape suivante
}
void TE9(void)  /*les feux 1 et 3 passent  l'orange*/
{
	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE9=0,AE13=1,Active_Etat(15),Init_Tempo(12),Appel_Memorise=0;
		  else AE10=1,AE9=0,Active_Etat(7),Init_Tempo(8);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
}
void TE10(void) /*Autorisation de la voie 5 (feux 5 au vert)*/
{
	
	if(Fin_Tempo==1) AE10=0, AE11=1,Active_Etat(8), Init_Tempo(3); 
	if ((AP1==0)||(AP2==0)) Appel_Memorise=1;		// memorisation piton pour tape suivante 
}
void TE11(void)  /*les feux 5 passent  l'orange*/
{
	
	if(Fin_Tempo==1)
		{ if(Appel_Memorise==1)AE11=0,AE13=1,Active_Etat(15),Init_Tempo(12),Appel_Memorise=0;
		  else AE0=1,AE11=0,Active_Etat(1),Init_Tempo(10);
		}

	else if ((AP1==0)||(AP2==0)) Appel_Memorise=1;
}
void TE12(void)  /*les feux 1 et 2 passent  l'orange*/
{
	
	if(Fin_Tempo==1) AE12=0, AE13=1,Active_Etat(15), Init_Tempo(12);  
}
void TE13(void) /*tous les feux pitons sont au vert*/
{
	
	if(Fin_Tempo==1) AE13=0, AE0=1,Active_Etat(1), Init_Tempo(10);  	
}

    /*	Fin de la dfinition des etapes 
     ************************************/	

/* fonction d'affectation des sorties 
**************************************/

void Active_Etat(int j)	/*Affectation des registres de sorties du port C
                          en fonction de l'tat	des tapes*/
{
	switch(j)    /* j:numro de l'tat */
	{
	case 1 : 	{HSRR0=0x69A6;HSRR1=0x969A;PortC=0x04;break;} 
	case 2 : 	{HSRR0=0x69A6;HSRR1=0x96A6;PortC=0x02;break;}
	case 3 : 	{HSRR0=0x696A;HSRR1=0x96A9;PortC=0x02;break;}
	case 4 : 	{HSRR0=0x699A;HSRR1=0x99A9;PortC=0x02;break;}	
	case 5 : 	{HSRR0=0x69A5;HSRR1=0xAA5A;PortC=0x02;break;}	
	case 6 : 	{HSRR0=0x69A6;HSRR1=0x6A66;PortC=0x02;break;}	
	case 7 : 	{HSRR0=0x9AA6;HSRR1=0x9A69;PortC=0x03;break;}
	case 8 : 	{HSRR0=0x66A6;HSRR1=0x9A69;PortC=0x02;break;}
	case 9 : 	{HSRR0=0x69A6;HSRR1=0x999A;PortC=0x02;break;}	
	case 11: 	{HSRR0=0x69A6;HSRR1=0x99A6;PortC=0x02;break;}
	case 15: 	{HSRR0=0xA9A6;HSRR1=0x9A69;PortC=0x05;break;}
	default : 	{HSRR0=0xAAAA;HSRR1=0xAAAA;PortC=0x00;break;}  	// On teint tout 
	}
}




