/******************************************************************************/
/*	Cration d'un serveur HTLM								*/
/*	But du Programme:										*/
/*		Realisation d'un serveur HTTP1.1						*/
/*		Analyse des trames provenant d'Internet Explorer (IE)			*/
/*		Reponse en respectant la norme HTTP1.1					*/
/*		Rendre les pages interactives							*/
/******************************************************************************/

#include <string.h>
#include <stdio.h> 

#include "eid210.h"
#include "eid003.h"

#include "eid003_pageHTML.c"

#include "eid003_HTML.c"
#include "eid003_CGI.c"

/************************************/
/*	Gestion des pages HTML		*/
/************************************/
void GestionHTML()
{
int tmp,i;
i=EID003_IRQ;
clsscr();
//printf("IT detect\n");
//InRs232();


	while(EID003_RX_COUNT==0);	//Si le buffer est vide, on attend
	clsscr(); 

	while(0==strstr(Buffer_reception.complet,standar[1])) //On receptionne tout le buffer 
	VideBufferRX();						//jusqu' \r\n\r\n

	code_erreur=0;
	//On identifie tout les elements provenant de IE
	IndentifieLigneRequete();		//On identifie la ligne de requete Methode, URI_PAGE, VERSION_HTTP
	//On les affiche 
	AfficheBuffer(Buffer_reception.methode,2);
	AfficheBuffer(Buffer_reception.uri,4);
	AfficheBuffer(Buffer_reception.version,6);
	AfficheBuffer(Buffer_reception.complet,10);

	if(0!=strstr(Buffer_reception.version,version[0])) 	//Identifie la version HTTP1.1
		{
		code_erreur=code_erreur|0x0002; //code HTTP1.1
		if(0!=strstr(Buffer_reception.methode,methode[0])) //Methode GET
			{
				code_erreur=code_erreur|0x0020; //code GET
				
				//Recherche la page qui a t deman
				if(0!=strstr(Buffer_reception.uri,pages[0]))	//Page index
					Reponse_Requete(Index_HTML,Reason_200);

				if(0!=strstr(Buffer_reception.uri,pages[1]))	//Page simes
					Reponse_Requete(Simes_HTML,Reason_200);

				//Lors d'une demande de modification avec la mthode GET,
				//la page apparait sous la forme nompage.html?
				//Il faut donc verifier en premier si on a demande la page pour une modification
				if(0!=strstr(Buffer_reception.uri,pages[9]))	//Page Actes pour une modification
					{
					CGI_PageActes();					//Modifier le code de la page
					Reponse_Requete(Actes_HTML,Reason_200);	//Repondre
					tmp=strlen(Buffer_reception.uri);		//Effacer la varible uri 
					for(i=0;i<tmp;i++) Buffer_reception.uri[i]='\0';
					}
				if(0!=strstr(Buffer_reception.uri,pages[2]))	//Page Actes
					Reponse_Requete(Actes_HTML,Reason_200);

				if(0!=strstr(Buffer_reception.uri,pages[10]))	//Page S_es2 pour une modification
					{
					CGI_PageS_es2();					//Modifier le code de la page
					Reponse_Requete(S_es2_HTML,Reason_200);	//Repondre
					tmp=strlen(Buffer_reception.uri);		//Effacer la varible uri 
					for(i=0;i<tmp;i++) Buffer_reception.uri[i]='\0';
					}
				if(0!=strstr(Buffer_reception.uri,pages[3]))	//Page S_es2
					Reponse_Requete(S_es2_HTML,Reason_200);
				
				//Frames, page principale
				if(0!=strstr(Buffer_reception.uri,pages[4]))	//Page S_es3
					Reponse_Requete(S_es3_HTML,Reason_200);
				//Frames, composant la page principale
				if(0!=strstr(Buffer_reception.uri,pages[5]))	//Page S_esS
					Reponse_Requete(S_esS_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[6]))	//Page S_esP
					Reponse_Requete(S_esP_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[7]))	//Page S_esL
					Reponse_Requete(S_esL_HTML,Reason_200);
				if(0!=strstr(Buffer_reception.uri,pages[8]))	//Page S_es7
					Reponse_Requete(S_es7_HTML,Reason_200);

				//La page s'actualise toutes les 2 secondes
				if(0!=strstr(Buffer_reception.uri,pages[11]))	//Page Autoactu
					{
					CGI_PageAutoActu();
					Reponse_Requete(Auto_Actu_HTML,Reason_200);
					}
				//IMAGES
				if(0!=strstr(Buffer_reception.uri,images[0]))	//image logo
					Reponse_Image(Logo_JPG,Reason_200,Logo_JPG_taille);
				if(0!=strstr(Buffer_reception.uri,images[1]))	//image batiment
					Reponse_Image(Batiment_JPG,Reason_200,Batiment_JPG_taille);

				//Son
				if(0!=strstr(Buffer_reception.uri,son[0]))	//son lors de l'arriv sur 
					Reponse_Image(demo_MP3,Reason_200,demo_MP3_taille); //la page 

				if(0!=strstr(Buffer_reception.uri,pages[12]))	//demande d'ajout dans les favoris
					Reponse_Requete(Erreur_HTML,Reason_200);

			}
		if(0!=strstr(Buffer_reception.methode,methode[1])) //Methode POST
			{
			code_erreur=code_erreur|0x0040; //code POST
			if(0!=strstr(Buffer_reception.complet,"Content-Length: "))//Si le Content-Length est present
				{
				while(EID003_RX_COUNT!=0) VideBufferRX();		//=> il faut recuperer le body venant de IE
				IndentifieLigneBody(Buffer_reception.body);	//Indentifier le body et le mettre dans son buffer 
				AfficheBuffer(Buffer_reception.body,8);
				}
				if(0!=strstr(Buffer_reception.uri,pages[5]))	//Page S_esS
					{
					CGI_PageS_esS();
					Reponse_Requete(S_esS_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[6]))	//Page S_esP
					{
					CGI_PageS_esP();
					Reponse_Requete(S_esP_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[7]))	//Page S_esL
					{
					CGI_PageS_esL();
					Reponse_Requete(S_esL_HTML,Reason_200);
					}
				if(0!=strstr(Buffer_reception.uri,pages[8]))	//Page S_es7
					{
					CGI_PageS_es7();
					Reponse_Requete(S_es7_HTML,Reason_200);
					}
			}	
		}
		else	//Ce n'est pas la version HTTP1.1 on en informe l'utilisateur 
		{	//et faire code_erreur=code_erreur|0x0004ou8.
			//Sinon on veut on peut traiter d'autres version ici
		printf("Il ne s'agit pas de la version HTTP1.1\n");
		}

	Analyse_code_erreur(code_erreur); //Analyse les erreurs 
	//Efface les variables de reception,d'identification et de reponses
	Init();

}

/************************************/
/*		Irq du web			*/
/************************************/
void Init_IRQ_HTML(int it)
{
SetVect(28,&GestionHTML);	//ligne IRQ2
//EID003_IRQ=it;
EID003_IRQ_ENABLE=it;	//Valid IRQ de la carte Web
VALID_IRQ.valeur=0x10;	//Valid IRQ2 de la carte EID210
}

void Stop_IRQ_HTML()
{
EID003_IRQ_ENABLE=0x00;
VALID_IRQ.valeur=0x00;
RestoreVect(28);
}

/************************************/
/*	Programme principal		*/
/************************************/
main()
{

//InitSimES
InitLED();
InitSwitch();
Init7Seg();
//Initialisation des temps d'accs pour la carte EID210
Init_pc104_eid003();
//Configuration + ouverture du port TPC/IP Internet Explorer
SetPort(80);
EID003_CONFIG=0x01;
//Initialisation des varaibles
Init();
//Initialisation de l'IT
Init_IRQ_HTML(0x01);
//principale
clsscr();

while(1)
	{
	gotoxy(1,5);
	printf("Attentent IT,EID003_IRQ_ENABLE=%d ,EID003_IRQ=%d\n",EID003_IRQ_ENABLE,EID003_IRQ);
	}
Stop_IRQ_HTML(0x01);
}