/************************/
/*				*/
/* Nom : Lib.c		*/
/*	   Librairie	*/				
/************************/

#include "eid005.h"
#include <stdio.h>
#include <string.h>
#include <math.h>

/******************************/
/*	Variables globales	*/	
/******************************/

double Cos[60], Sin[60];
unsigned int X, Y, np ;	//	X , Y : Position  d'un pixel dans le plan [ x y ] = [64 128] 
					// 	np : n du iexel sur la ligne X
double  pi = 3.14159265 ;
double  deuxpi = 6.28318530 ;
float K = 1.4872 ;		//	Facteur de correction entre les dimensions x et y du LCD

/******************************************/
/*	Fonctions utilise	 		*/	
/******************************************/

//	Fonction dlai ou temporisation

void delay (int t)
{
int i;
for(i=0;i<t;i++);
}

/******************************************/
/*	Fonction : Le LCD est-il prt ?	*/
/******************************************/
void BUSY()		// 
{
unsigned char data ;
unsigned char stat ;

do
 {					// Voir chronogrammes de lecture/criture du T6963C:
ctrl_aff.octet=0xEF;		// Tous les signaux de commandes  1 sauf fs
ctrl_aff.bit_ctrl.ce=0;		// Signal ce  0
ctrl_aff.bit_ctrl.rd=0;		// Signal rd  0
data=db_aff;			// Lecture du bus de Donnes
ctrl_aff.bit_ctrl.ce=1;		// Signal ce  1
ctrl_aff.bit_ctrl.rd=1;		// Signal rd  1
stat=data &(LCD_STATUS_BUSY1|LCD_STATUS_BUSY2);	// Isoler les bits Status 1 et 2
 } 
while (stat!=(LCD_STATUS_BUSY1|LCD_STATUS_BUSY2)); // Attendre que le LCD soit prt
}

/******************************************/
/*	Fonction : Ecriture d'une commande	*/
/******************************************/

//  Voir chron0grammes de lecture/criture du LCD

void lcd_write_command(unsigned char data)
{					
BUSY () ; 
ctrl_aff.bit_ctrl.cd=1;
db_aff=data;
ctrl_aff.bit_ctrl.ce=0;
ctrl_aff.bit_ctrl.wr=0;
//delay(5);
ctrl_aff.bit_ctrl.ce=1;
ctrl_aff.bit_ctrl.wr=1;
}

/******************************************/
/*	Fonction : Lecture d'une donne	*/
/******************************************/

unsigned char lcd_read_data()
{
unsigned char data;
BUSY () ;
ctrl_aff.bit_ctrl.cd=0;
ctrl_aff.bit_ctrl.ce=0;
ctrl_aff.bit_ctrl.rd=0;
//delay(5);
data=db_aff;
ctrl_aff.bit_ctrl.ce=1;
ctrl_aff.bit_ctrl.rd=1;
ctrl_aff.bit_ctrl.cd=1;
return data;
}

/******************************************/
/*	Fonction : Ecriture d'une donne	*/
/******************************************/

void lcd_write_data(unsigned char data)
{
BUSY () ;
ctrl_aff.bit_ctrl.cd=0;
db_aff=data;
ctrl_aff.bit_ctrl.ce=0;
ctrl_aff.bit_ctrl.wr=0;
delay(5);
ctrl_aff.bit_ctrl.ce=1;
ctrl_aff.bit_ctrl.wr=1;
ctrl_aff.bit_ctrl.cd=1;
}

/******************************************/
/*	Fonction initialisation du LCD	*/
/******************************************/

void init_aff()
{
ctrl_aff.octet=0xEf;
lcd_write_command(LCD_CG_ROM_MODE_OR);

//---------	Zone Texte		// Voir notice T6963C
lcd_write_data(0);		// TH LSByte = 00
lcd_write_data(0);		// TH MSByte = 00
lcd_write_command(0x40);	// Commande d'criture de TH 
lcd_write_data(0x10);		// TA = Nombre de charactres par ligne LSByte
lcd_write_data(0);		// TA MSByte = 0
lcd_write_command(0x41);	// Commande d'criture de TA 

//---------	Zone Graphique	// Voir notice T6963C
lcd_write_data(0);		// GH LSByte = 00
lcd_write_data(0x04);		// GH MSByte = 00
lcd_write_command(0x42);	// Commande d'criture de GH 
lcd_write_data(0x10);		// GA = Nombre de charactres par ligne LSByte
lcd_write_data(0);		// AA MSByte = 0
lcd_write_command(0x43);	// Commande d'criture de GA 

lcd_write_command(0x9c);
}

/************************************************/
/*	Fonction : Initialisation de l'afficheur	*/
/************************************************/

void lcd_gotoxy(unsigned char px, unsigned char py)
{
lcd_write_data(px);		//
lcd_write_data(py);
lcd_write_command(0x24);
}

/******************************************/
/*	Fonction Effacement de l'cran	*/
/******************************************/

void lcd_cls()
{
int i;
lcd_gotoxy(0,0);
for(i=0;i<2048;i++)
	{
	lcd_write_data(0);
	lcd_write_command(0xc0);
	}
}

/************************************************/
/*	Fonction Effacement de l'cran graphique	*/
/************************************************/

void lcd_clear_Graph()
{
int i;
lcd_gotoxy(0,04);
for(i=0;i<1024;i++)
	{
	lcd_write_data(0);
	lcd_write_command(0xc0);
	}
}

/******************************************************/
/*	Fonction Effacement de l'cran alphanumrique	*/
/******************************************************/

void lcd_clear_TXT()
{
int i;
lcd_gotoxy(0,00);
for(i=0;i<1024;i++)
	{
	lcd_write_data(0);
	lcd_write_command(0xc0);
	}
}


/******************************************/
/*	Fonction envoi chane de caractres	*/
/******************************************/
void lcd_out_str(char *texte)
{
int i;
for(i=0;i<strlen(texte);i++)
	{
	lcd_write_data((unsigned char)(texte[i]-0x20));
	lcd_write_command(0xc0);

	}
}

/************************************************/
/*	Fonction Ecriture d'une table de donnes	*/
/************************************************/

void lcd_out_Tab(unsigned char Tab[], int n)
{
int i;
i=0;
for(i=0; i < n ; i++)
	{
	lcd_write_data((unsigned char)(Tab[i]+0x10));
	lcd_write_command(0xc0);
	}
}

/***********************************************************/
/*			  FONCTIONS GRAPHIQUES			     */
/***********************************************************/
/* void test( int X1, int Y1,  int X2 , int  Y2, int Pen )
{float a,b,c,d,e;
printf("X1 = %d, Y1 = %d, X2 = %d, Y2 = %d, Pen = %d\n", X1, Y1, X2, Y2, Pen);
printf("a = %f; b = %f, c = %f, d = %f, e = %x \n", a=X1, b=Y1, c=X2, d=Y2, e=Pen);

}*/

//***********************************************************************/		
/*	 Conversion des corrdonnes Horizontale Verticale d'un point	*/  
/***********************************************************************/

//	Pen = Plume = pl
unsigned char Conversion_PosXY (unsigned int X1, unsigned int  Y1)

{
unsigned int  a;
a = 128*X1+Y1;	//	Dtermination du numro du pixel
X = (a/8)& 0xFF;	//	Calcule de 
Y = (a/8) >> 8;
np = 7-(a%8);
//printf("X = %2x  Y = %2x  np = %2x\n", X, Y,np);
return (X , Y , np ) ; 
}


/******************************/
/*	 Tracer d'un pixel	*/  
/******************************/
void Tracer_Pixel(int x, int y, unsigned char Pen)
{	
	Conversion_PosXY (x , y);
//printf(" X = %x,   Y = %x   np =%x\n", X,Y,np);
	lcd_gotoxy(X,Y+0x04);
	lcd_write_command(Pen + np);
}


/******************************************/
/*	 Tracer Ligne Horizontale : LH	*/  
/******************************************/

void Tracer_LH ( unsigned char M, unsigned char  N, unsigned char P, unsigned char Q, unsigned char Pen ) 
{ 
//unsigned char pl  = Pen ;
int r ;

for ( r = N ; r <= Q; r++)
	{	
		Conversion_PosXY (M , r);
		lcd_gotoxy (X, Y + 0x04);
		lcd_write_command(Pen + np);
	}
}

/******************************************/
/*	 Tracer Ligne Verticale : LV		*/  
/******************************************/

void Tracer_LV ( unsigned char M, unsigned char  N, unsigned char P, unsigned char Q, unsigned char Pen ) 
{
//unsigned char pl  = Pen ;
int r;
unsigned char Z;

if (M > P)		// Permuter X1 et X2 si X > X2
	{	Z = M;
		M = P;
		P = Z;
	}
for ( r = M ; r <= P; r++)
	{
		Conversion_PosXY (r , N);
		lcd_gotoxy (X, Y + 0x04);
		lcd_write_command(Pen + np);
	}
}

/******************************************/
/*	 Tracer d'une droite quelconque	*/ 
/******************************************/

void Droite ( int x1, int y1,  int x2, int y2, int  Pen )
{
float X1 = x1,  Y1 = y1, X2 = x2, Y2 = y2 ; 
//unsigned char Pen = Pen ;
float dx, dy, n, a, b, Z;
int i , m ;
dx = X2-X1 ;
dy = Y2-Y1 ;
if (Y2 != Y1)
{
	if (abs (dx) < abs (dy))
	
	{	a = dx/dy;
		b = X1-a*Y1;
		//printf ("a = %f ,  b = %f\n", a, b);

		if (Y1 > Y2)		// Permuter X1 et X2 si X > X2
			{	Z = Y1;
				Y1 = Y2;
				Y2 = Z;
			}

		for (i=Y1; i<=Y2 ; i++)
		{
			n = a*i + b ;
			m  = n ;
			if ((n-m)>0.5)
			m += 1;
			// m = x   i = y
			Conversion_PosXY (m , i);
			lcd_gotoxy (X, Y + 0x04); 
			lcd_write_command(Pen + np);
		}
	}
	else 
	{		
		a = dy/dx;
		b = Y1-a*X1;
		//printf ("a = %f ,  b = %f\n", a, b);

		if (X1 > X2)		// Permuter X1 et X2 si X > X2
			{	Z = X1;
				X1 = X2;
				X2 = Z;
			}

		for (i=X1; i<=X2 ; i++)
		{
			n = a*i + b ;
			m=n ;
			if ((n-m)>0.5)
			m += 1;
			// m = x   i = y
			Conversion_PosXY (i , m);
			lcd_gotoxy (X, Y + 0x04); 
			lcd_write_command(Pen + np);
		}
	}
}
else
Tracer_LV (X1,Y1,X2,Y2, Pen);
}

/************************/
/*	Tracer Rectangle	*/
/************************/

//	X1,Y1  -----------------  X1,Y4
// 		|			|
//		|			|
//		|			|
//	X4,Y1  ----------------- X4,Y4

void Rectangle (int X1, int Y1, int X4, int Y4, int Pen)
{
Tracer_LH (X1, Y1, X1, Y4, Pen );
Tracer_LV (X1, Y1, X4, Y1, Pen);
Tracer_LH (X4, Y1, X4, Y4, Pen);
Tracer_LV (X1, Y4, X4, Y4, Pen);
}

/************************/
/*	Tracer Triangle	*/
/************************/

//	    X1,Y1   *	
//   	 	     *  *
//		    *	   *
// 	         *      *
//	X2,Y2   *        *
//		      *     *
//		          *  *
//			        * 	X3,Y2
//				 

void Triangle (int X1, int Y1, int X2, int Y2, int X3, int Y3, int Pen) 

//Trois sommets 
{
Droite(X1, Y1, X2, Y2, Pen );
Droite(X2, Y2, X3, Y3, Pen );
Droite(X1, Y1, X3, Y3, Pen );
}
/************************************************/
/*	Clacul sinus cisinus 60 points : secondes	*/
/************************************************/

void Tab_Sin_Cos (void)
{
int i,j ;
double w ;
j = -1;
for ( i = 0 ; i < 360;  i += 6)
	{	
	j++;
	w = (90+i)*(pi/180);
	Cos [j] = cos(w);		// ==> p
	Sin [j] = sin(w);		// ==> q
	}
}

/************************************************/
//	Tracer d'un cercle Heures : 12 points	*/
/************************************************/
// R = Rayon   X0, Y0 coordonnes du centre
// Le point est enfait un car de cot 2d
// Coordonnes d'un point : m = x  n = y

double Cercle_H ( int x0, int y0,  int r, int Pen,  int h)

{
float X0=x0 , Y0=y0 , R =r, d ;		//	Dimension d'un point : "carr de cot 2d
double p, q ;
int  m, n ;
//unsigned char Pen = Pen ;
//	Calcul des corrdonnes x et y
d = 1 ;	

	p = R*Cos[h];
	q = R*Sin[h];
	m = q  ;
	n = p*K; 	
	if ((p-m)> 0.5)
		m += 1 ;
	if ((q-n) > 0.5)
		n += 1 ;
 		m = X0-m;
		n = Y0-n;

	//	printf("R = %f, sec = %d, q= %f, p = %f\n" , R ,sec, R*Cos[sec], R*Sin[sec]);

//	Tracer effectif du point 

	Tracer_LH (m-d, n-d, m-d, n+d, Pen);
	Tracer_LH (m+d, n-d, m+d, n+d, Pen);
	Tracer_LV (m-d, n-d, m+d, n-d, Pen);
	Tracer_LV (m-d, n+d, m+d, n+d, Pen);
}

/************************************/
/*	Tracer d'un cercle Secondes	*/
/************************************/

// Tracer du cercle des secondes (60 points)
// R = Rayon   X0, Y0 coordonnes du centre, a angle
// m = x  n = y
// sec : coordonne angulaire du point  afficher


void Cercle_S ( int x0, int y0,  int r, int Pen,  int sec)
{
float  X0=x0, Y0=y0,R =r,  d, d0 ;
double p, q ;
int  m, n ;
//unsigned char pl  = Pen ;
d0 = 3 ; d = 0.5 ;

//	Calcul des paramtres des points  afficher

	p = (R+d0)*Cos[sec];
	q = (R+d0)*Sin[sec] ;
	m = q  ;
	n = p*K; 	
	if ((p-m)> 0.5)
		m += 1 ;
	if ((q-n) > 0.5)
		n += 1 ;
 	m = X0-m;
	n = Y0-n;
//	Tracer effecti du point 
	Tracer_LH (m-d, n-d, m-d, n+d, Pen);
	Tracer_LH (m+d, n-d, m+d, n+d, Pen);
	Tracer_LV (m-d, n-d, m+d, n-d, Pen);
	Tracer_LV (m-d, n+d, m+d, n+d, Pen);
}

/************************************/
/*	Effacerd'un cercle Secondes	*/
/************************************/

// Effacement du cercle des secondes (60 points)
// R = Rayon   X0, Y0 coordonnes du centre
// m = x  n = y
void Effacer_Cercle_S ( int x0, int y0,  int r,   int Pen,  int sec)
{
float X0=x0, Y0=y0,R =r,  d ;
double p, q ;
int  m , n,  d0 ;	// Ecart des rayons Heures et Secondes
unsigned char g ;
//unsigned char pl  = Pen ;

d0 = 3; d= 0.5 ;
	p = (R+d0)*Cos[sec];
	q = (R+d0)*Sin[sec] ;
	m = q  ;
	n = p*K; 	
	if ((p-m)> 0.5)
		m += 1 ;
	if ((q-n) > 0.5)
		n += 1 ;
 	m = X0-m;
	n = Y0-n;

//	Calcul des paramtres des points  afficher

	Tracer_LH (m-d, n-d, m-d, n+d, Pen);
	Tracer_LH (m+d, n-d, m+d, n+d, Pen);
	Tracer_LV (m-d, n-d, m+d, n-d, Pen);
	Tracer_LV (m-d, n+d, m+d, n+d, Pen);
	
}

void Cercle_NPoints ( int x0, int y0,  int r,  unsigned int Pen,  unsigned int N)

// Tracer du cercle de N points
// R = Rayon   X0, Y0 coordonnes du centre
// m = x  n = y

{float X0=x0, Y0=y0,R =r;  
double  deuxpi = 6.28318530718 ;
double a, p, q, w  ;
int  m , n, v ;
//	unsigned char Pn = Pum ;
//	Calcul des corrdonnes X et Y
//	Calcul des paramtres des points  afficher
//	w = deuxpi/N ;
for ( v = 0 ; v <= N;   v++)	
	{ 
		a = v*(deuxpi/N);
		p = R*cos(a);
		q = R*sin(a);
		m = q  ;
		n = p*K; 	
		if ((p-m)> 0.5)
		m += 1 ;
		if ((q-n) > 0.5)
		n += 1 ;
 		m = X0-m;
		n = Y0-n;
//printf("a = %f\n", a);

//printf("m = %d, n = %d, np = %x\n", m, n, np);

//printf("X = %x, Y = %x, np = %x\n", X, Y, np);

		Conversion_PosXY (m , n);
		lcd_gotoxy (X, Y + 0x04); 
		lcd_write_command(Pen + np);
	}
}


/************************************/
/*	Arc de cercle 			*/
/************************************/
/*
void Arc_Cercle(float X0, float Y0, float R, float A0, float A1, int Pen)
{
int i;
double  deuxpi = 6.28318530718 ;
double a, p, q, w  ;
int  m , n, v ;


}
*/
/***********************************************************/
/*			  FONCTION RTC				     */
/***********************************************************/

void writebyte(unsigned char adr, unsigned char dat)
{
ctrl_rtc=0;
as_rtc=adr;
ds_rtc=dat;
ctrl_rtc=1;
}

unsigned char readbyte(unsigned char adr)
{
unsigned char dat;
ctrl_rtc=0;
as_rtc=adr;
dat=ds_rtc;
ctrl_rtc=1;
return dat;
}
