	/******************************************************************************
	*     TP sur  l'ensemble EID210 /  EID060		
	*******************************************************************************
	* Suivi de consigne donne par potentiomtre analogique pour courant moteur	
	*													
	*  CAHIER DES CHARGES :					      				
	*  *******************					      					
	*   On souhaite que l'image du courant moteur suive la tension     		
	*   impose par le potentiomtre analogique  -> Tension U_Potentiometre		
	*	-> Les 8bits MSB du resultat deviennent la consigne de I moteur		
 	*------------------------------------------------------------------------------	
	*  NOM du FICHIER :  TP1_Commande_Moteur.C		       					
	* *****************										
	*******************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "EID060.h"
#include <stdio.h>

/* Dclaration des variables globale */
WORD i,Resultat_Conversion,Consigne_Courant_Moteur,Compteur_passages;

/*==========================
 *    Fonction principale          
  ==========================*/
main(void)
{
/* Initialisation des variables */
/* Pour affichage valeur consigne */ 
Compteur_passages = 0;
// Init sortie analogique de commande moteur
SA0=128;    //Commander le moteur  0
// Pour les sorties logiques issues du TPU
CFSR0=0x0888; // Pour pouvoir piloter les sorties  Valid_IP;CAG;CRCG
CFSR0=0x8800; // Pour pouvoir piloter les sorties  Lect; RAZ
HSRR0=0x1960; // Valid_IP=1;CAG=0;CRG=1;Lect=1;RAZ=0
CPR0=0x1550;  // Pour dfinir une priorit faible
/*  Pour lancer la premire conversion A -> N   */
CAN=0x0043;    	// Lancer la conversion de la voie 3 (U_Potentiomtre)

/*   Boucle principale   */
/*************************/    
do	{  if (Fin_Conv_AN==0)
		{ Resultat_Conversion=CAN&0x0FFF;  // Le rsultat de conversion est sur 12 bits
		  Consigne_Courant_Moteur=(unsigned char)((Resultat_Conversion&0x0FFF)>>4); 
						// On ne prend que les 8 bits MSB  (de poids les plus forts)
		  SA0=Consigne_Courant_Moteur;	// Appliquer la Consigne Courant Moteur
  		  CAN=0x0043; 		// Lancer la conversion de la voie 3 (U_Pot)
		}
	Compteur_passages++;
	 if(Compteur_passages>60000)
		{Compteur_passages=0;
		 clsscr();
		 gotoxy(4,6);
	  	 printf("      AGIR SUR POTENTIOMETRE ANALOGIQUE  \n");
 	  	 printf("       -----------------------------------  \n");
		 gotoxy(4,10);
		 printf("  Resultat de conversion = %4x Hexa = %4D \n",Resultat_Conversion,Resultat_Conversion);
		 gotoxy(4,12);
		 printf("  Valeur commande moteur = %4x Hexa = %4D \n",Consigne_Courant_Moteur,Consigne_Courant_Moteur);
		}
	}while(1);  /* Fin de la boucle principale */
} /* Fin fonction principale */

