
	/************************************************************
	*     TP sur EID210 - EID060  							
	*************************************************************
	*  Cahier des charges:					      	
	*  *******************					      	
	*   Vrifier que la mesure de la position fonctionne			
	* -----------------------------------------------------------
	*  NOM du FICHIER:  TP2_1_Mesure_Position.C       		
	* ****************							
	*************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"			// Registre du processeur 68332
#include "EID210_reg.h"			// 
#include "Structures_donnees.h"
#include "EID060.h"


#define S_Mesure_Position  CPTR_Pos_Mot  // Rsultat de comptage des signaux en quadrature de phase
#define Cde_Moteur  SA0 //La commande moteur se fait par la Sortie Analogique 0 de la carte processeur EID210 
#define BP_CRTL REG_ETAT.bits_octet.b8   // Bouton poussoir repere "CRTL sur carte EID210
#define Sortie_Ana_Image_Position SA2   // La sortie analogique reperee Uz 
#define CDMP 2  // Coefficient de Dcalage pour Mesure Position  sortie analogique
//****************************************
//	FONCTION PRINCIPALE 	
//****************************************

main()
{short temp;
unsigned int i;

/* Les Initialiser les registres du TPU 		
 --------------------------------------- */
// Afin de pouvoir utiliser le compteur pour signaux en quadrature de phase
/* Effacer les bits de priorit		*/
   CPR0=0x0000;	
// Registre de Slection de la Fonction des canaux d'E/S  ch15(PB7) ch14(PB6) ch13(PB5) ch12(PB4)
   CFSR0=0x0888;	/* les bits (PB6=CH14=Valid_IP) (PB5=CH13=CAG) (PB4=CH12=CCRCG) en "DIO" 
             /* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 

   CFSR1=0x8866;	/* les bits (PB3=CH11=Lect) (PB2=CH10=RAZ) en "DIO" (Data Input Output)
	// les bit PB1 (CH8=TPU8) et PB0 (CH9=TPU9) en "QDEC" comptage de signaux en quadrature
/* Initialisation des paramtres RAM	 */
// Pour canal 8 sur lequel on a le CHa du codeur moteur
  Cor_PinS_CHA=0x0096;	 //  9 -> On compare par rapport au canal 9	
  Edge_T_CHA=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
// Pour canal 9 sur lequel on a le chb du codeur moteur
  Cor_PinS_CHB=0x0086;	// 8 -> On compare par rapport au canal 8
  Edge_T_CHB=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
/* Registre de squence de service	*/  
   HSQR0=0x0001;     	// Pour dfinir  PB1 primaire -> 00   PB0  secondaire ->  00
				// Pour dfinir lequel des signaux codeur est en avance sur l'autre
   HSRR0=0x296F; 	// Pour initialiser // Valid_IP=0; CAG=0; CRG=1; Lect=1;  RAZ=0
			//dmarrer le comptage: pour  PB1 -> 11   et pour PB0 -> 11  
 /* Positionner les bits de priorit	*/
   CPR0=0x155F;	// Priorits maxi pour les 2 canaux PB1-PB0 

/* Pour Initialiser la commande moteur
---------------------------------------*/ 
Cde_Moteur=0x80;  // Commande moteur gal 0 pour l'arreter



/* Pour Initialiser les capteurs de position et de vitesse
-----------------------------------------------------------*/ 
S_Mesure_Position=0;

/*  Pour lancer la premire conversion A -> N   */
CAN=0x0043;    	// Lancer la conversion de la voie 3 (U_Potentiomtre)



/*  DEBUT DE LA BOUCLE PRINCIPALE
----------------------------------*/
do
	{
	clsscr();
	gotoxy(4,6);
	printf("           FAIRE TOURNER AXE MOTEUR \n");
	printf("           -> LA MESURE POSITION DOIT EVOLUER\n");
	printf("           -> Le sens trogonometrique est le sens >0 \n");
	printf("           -> Pour remettre  0 le compteur (donc la mesure position \n");
	printf("              Appuyer sur bouton poussoir CRTL sur carte EID210 \n");

	gotoxy(4,12);
	printf("Mesure position moteur en 'inc': %8.8x Hexa=%9d Decimal %\n",S_Mesure_Position,S_Mesure_Position);

	 for(i=300000;i>0;i--);  // Attendre environ 1 seconde 
	 if(BP_CRTL==0)S_Mesure_Position=0; 
	 temp=S_Mesure_Position;
	 temp=temp>>CDMP;		// Application du coefficient de decalage
	 if(temp>127)temp=127;    // Saturations pour sortie analogique
	 if(temp<-128)temp=-128;  
	 temp=temp+128; 		// Symetrisation
       Sortie_Ana_Image_Position=(unsigned char)(temp);
	}while(1);	/* fin de la boucle principale */
//  Fin de la boucle principale

 
} // Fin de la fonction principale
