	/************************************************************
	*     TP sur l'ensemble EID210 + EID060  							
	*************************************************************
	*  Cahier des charges:					      	
	*  *******************					      	
	*   Effectuer la mesure de la vitesse de rotation			
	* -----------------------------------------------------------
	*  NOM du FICHIER:  TP2_2_Mesure_Vitesse.C       		
	* ****************							
	*************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"			// Registre du processeur 68332
#include "EID210_reg.h"			// 
#include "Structures_donnees.h"
#include "EID060.h"

// Dclarations des constantes
#define S_Mesure_Position  CPTR_Pos_Mot  // Rsultat de comptage des signaux en quadrature de phase
#define Cde_Moteur  SA0 //La commande moteur se fait par la Sortie Analogique 0 de la carte processeur EID210 
#define Valeur_Te  5   // La priode d'chantillonnage sera de 5 mS
#define Sortie_Ana_Image_Position SA2   // La sortie analogique reperee Uz 
#define CDMP	2	// Coefficient de Decalage de la mesure position pour sortie analogique
#define Sortie_Ana_Image_Vitesse SA3   // La sortie analogique reperee Ur 
/* Declaration des variables
==============================*/
short  S_Mesure_Vitesse,S_Mesure_Position_Precedente ;
unsigned char Cptr_Te;

/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
===============================================================================*/
void Irq_Base_De_Temps(void)
{ Cptr_Te--;
	if (Cptr_Te==0)
	{Cptr_Te=Valeur_Te;
	// Pour  Calcul de l'image numrique de la vitesse 
	// Derivation numrique de la position
	S_Mesure_Vitesse = S_Mesure_Position - S_Mesure_Position_Precedente;
	S_Mesure_Position_Precedente=S_Mesure_Position;  // Pour le coup d'apres
	}
}
//****************************************
//	FONCTION PRINCIPALE 	
//****************************************
 main()
{ 
int i;
unsigned char temp;
  // INIT TPU   (Voir TP n1  et n2-1 )
  CPR0=0x0000;
  CFSR0=0x0888,CFSR1=0x8866;	
  Cor_PinS_CHA=0x0096,Edge_T_CHA=0x0081;	
  Cor_PinS_CHB=0x0086,Edge_T_CHB=0x0081;	
  HSQR0=0x0001,HSRR0=0x196F,CPR0=0x155F;	
 // Pour Initialiser le timer programmable	
   SetVect(96,&Irq_Base_De_Temps);	// mise en place de l'autovecteur 
   PITR = 0x0008;		// Une interruption toutes les millisecondes 
   PICR = 0x0760; 		//  96 = 60H
  // Pour Initialiser la commande moteur
   Cde_Moteur=160;  // Commande moteur tourne en positif car suprieur  128
  // Pour Initialiser les capteurs de position et de vitesse
   S_Mesure_Position=0;
   S_Mesure_Position_Precedente=0;
   S_Mesure_Vitesse=0;
   Cptr_Te=Valeur_Te;
/*  DEBUT DE LA BOUCLE PRINCIPALE
----------------------------------*/
do  {	clsscr();
	gotoxy(4,6);
	printf("     -> LA MESURE POSITION DOIT EVOLUER\n");
	gotoxy(4,7);
	printf("     -> LA MESURE VITESSE DOIT ETRE CONSTANTE\n");
	printf("             SAUF SI ON FREINE MANUELLEMENT\n");
	gotoxy(4,10);
	printf("Mesure position moteur en 'inc': %4.4x Hexa=%6d Decimal %\n",S_Mesure_Position,S_Mesure_Position);
	gotoxy(4,12);
	printf("Mesure Vitesse moteur en 'inc': %2.2x Hexa=%3d Decimal %\n",S_Mesure_Vitesse,S_Mesure_Vitesse);
	gotoxy(4,15);
	printf("La sortie tension Uz est une image analogique de la position\n");
	gotoxy(4,16);
	printf("La sortie tension Ur est une image analogique de la vitesse\n");
 	for(i=600000;i>0;i--)
	{// Pour le suivi rapide des sorties analogiques des capteurs
	 //Pour capteur de position
	 temp=S_Mesure_Position;
	 temp=temp>>CDMP;		// Application du coefficient de decalage
	 if(temp>127)temp=127;    // Saturations pour sortie analogique
	 if(temp<-128)temp=-128;  
	 temp=temp+128; 		// Symetrisation
       Sortie_Ana_Image_Position=(unsigned char)(temp);
	 // Pour capteur de vitesse
	 temp=S_Mesure_Vitesse;
	 if(temp>127)temp=127;    // Saturations pour sortie analogique
	 if(temp<-128)temp=-128;  
	 temp=temp+128; 		// Symetrisation
       Sortie_Ana_Image_Vitesse=(unsigned char)(temp);
	};
    }while(1);	/* fin de la boucle principale */
} // Fin de la fonction principale


