	/******************************************************************
	*     TP sur EID210 et EID060  							
	********************************************************************
	*  Cahier des charges:					      	
	*  *******************					      	
	*   Affichage de la commande moteur et de la vitesse en boucle ouverte			
	*	-> La valeur de la commande est choisie par le potentiometre
	* -----------------------------------------------------------
	*  NOM du FICHIER:  TP3_1_Caractristique_En_BO.C	    		
	* ****************							
	*************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"			// Registre du processeur 68332
#include "EID210_reg.h"			// Definition pour Carte processeur EID210
#include "Structures_donnees.h"
#include "EID060.h"			// Definitions pour carte EID060

// Dclaration des constantes et dfinitions
#define S_Mesure_Position  CPTR_Pos_Mot  // Rsultat de comptage des signaux en quadrature de phase
#define Cde_Moteur  SA0 //La commande moteur se fait par la Sortie Analogique 0 de la carte processeur EID210 
#define Sortie_Ana_Uc SA1	// Sortie  analogique reperee Uc	
#define Valeur_Te  5   // La priode d'chantillonnage sera de 5 mS
#define Sortie_Ana_Image_Vitesse SA3   // La sortie analogique reperee Ur 

/* Declaration des variables
==============================*/
// Pour periode d'echantillonnage
unsigned char Cptr_Te;
// Pour la mesure de la vitesse
short  S_Mesure_Vitesse;
short S_Mesure_Position_Precedente;
short S_Valeur_Pot;
//  Pour affichage
unsigned short US_Compteur_Affichage=0;

/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
===============================================================================*/
void Irq_Base_De_Temps(void)
{
  Cptr_Te--;
	if (Cptr_Te==0)
	{Cptr_Te=Valeur_Te;
	// Pour  Calcul de l'image numrique de la vitesse 
	// Derivation numrique de la position
	S_Mesure_Vitesse = S_Mesure_Position - S_Mesure_Position_Precedente;
	S_Mesure_Position_Precedente=S_Mesure_Position;
	}
}
//****************************************
//	FONCTION PRINCIPALE 	
//****************************************
 main()
{short temp;
  // INIT TPU   (Voir TP n1  et n2-1 )
  CPR0=0x0000;
  CFSR0=0x0888,CFSR1=0x8866;	
  Cor_PinS_CHA=0x0096,Edge_T_CHA=0x0081;	
  Cor_PinS_CHB=0x0086,Edge_T_CHB=0x0081;	
  HSQR0=0x0001,HSRR0=0x196F,CPR0=0x155F;	

// Pour Initialiser le timer programmable	
 SetVect(96,&Irq_Base_De_Temps);	// mise en place de l'autovecteur 
 PITR = 0x0008;		// Une interruption toutes les millisecondes 
 PICR = 0x0760; 		//  96 = 60H
// Pour Initialiser la commande moteur
Cde_Moteur=128;  // Commande moteur gal 0
// Pour Initialiser les capteurs de position et de vitesse
S_Mesure_Position=0,S_Mesure_Position_Precedente=0,S_Mesure_Vitesse=0;
// Pour acquisition echantillons
Cptr_Te=Valeur_Te;
// Pour informer l'oprateur
	clsscr();
	gotoxy(4,6),printf("     Pour changer la vitesse \n");
	gotoxy(4,8),printf("     -> Modifier le potentiometre\n");

CAN=0x0043; // Pour lancer la premiere conversion
/*  DEBUT DE LA BOUCLE PRINCIPALE
----------------------------------*/
do
	{ 	if (Fin_Conv_AN==0)
			{S_Valeur_Pot=(short)(CAN&0x0FFC); // Sur 12bits et on masque les 2 bits LSB
		  	 CAN=0x0043; // Pour relancer la conversion de la voie 3 (Potentiometre)
			 Sortie_Ana_Uc=S_Valeur_Pot>>4; // La sortie analogique Uc sera une image de la commande
			}
		 US_Compteur_Affichage++;
		 if(US_Compteur_Affichage==50000)
			 	{US_Compteur_Affichage=0;
				 gotoxy(4,10),printf("  Valeur commande moteur  %3.3d\n",S_Valeur_Pot>>4);
				 gotoxy(4,12),printf("  Valeur Mesure vitesse   %3.3d\n",S_Mesure_Vitesse);
				 gotoxy(4,18),printf("La sortie tension Ur est une image analogique de la vitesse\n");

				 Cde_Moteur=(unsigned char)(S_Valeur_Pot>>4);
				}
	 // Pour capteur de vitesse
	 temp=S_Mesure_Vitesse;
	 if(temp>127)temp=127;    // Saturations pour sortie analogique
	 if(temp<-128)temp=-128;  
	 temp=temp+128; 		// Symetrisation
       Sortie_Ana_Image_Vitesse=(unsigned char)(temp);
	}while(1);	/* fin de la boucle principale */
} // Fin de la fonction principale


