
#include <string.h>
#include "mtr86.h"


/*
 ** T A C H E S   U T I L I S A T E U R S
 *  Tests des requtes de gestion des tubes:
 *  Utilise les flottants (configurer turboc: Option, Compiler, Code gnration, Floating point, Emulation)
 * short p_open(USHORT tache_w, USHORT tache_r, USHORT size, USHORT timeout);
 *   p_close(USHORT fn);
 * short p_write(USHORT fn,  *buf, USHORT size);
 * short p_read(USHORT  fn,  *buf, USHORT size);
 *
 */
#define USHORT unsigned short

TACHE  tacheA();                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheB();
TACHE  tacheC();
TACHE  tacheD();                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheE();
TACHE  tacheF();

TUBE   p1, p2, p3, p4;                   /*     Numeros des tubes          */
char t1[80];


_cputs(char *s)
{
   MONITOR
   printf(s);
   ENDM
}


TACHE tacheA()
{
   _cputs("------> EXEC tache A\n");
   cree(tacheC, 1 , 1024);
   cree(tacheB, 2 , 1024);
   cree(tacheD, 3 , 1024);
   cree(tacheE, 1 , 1024);
   cree(tacheF, 1 , 1024);
   p1 = p_open(num_tache(tacheB), num_tache(tacheC), 0);
   p2 = p_open(num_tache(tacheC), num_tache(tacheB), 0);
   p3 = p_open(num_tache(tacheD), num_tache(tacheE), cvrtic(1000L));
   p4 = p_open(num_tache(tacheE), num_tache(tacheD), cvrtic(1000L));
   strcpy(t1,"ABCDEFGHIJKLMNOPQRSTUVXYWZ");
   active(num_tache(tacheB));
   active(num_tache(tacheC));
   active(num_tache(tacheE));
   active(num_tache(tacheD));
   active(num_tache(tacheF));
   _cputs("Tubes ouverts\n");
}

TACHE  tacheB()
{
   char t2[80];
   _cputs("------> EXEC tache B\n");
   for (;;)  {
       dort(cvrtic(200L));
       if ( p_write(p1,t1, 27) == TIM )
           mtr86fatal("Delai depasse\n");
       if ( p_read(p2,t2,  27) == TIM )
           mtr86fatal("Delai depasse\n");
       strcpy(t1,t2);
   }
}

TACHE tacheC()
{
   char t[81];
   _cputs("------> EXEC tache C\n");
   for ( ;; ) {
       if ( p_read(p1,  t, 27 ) == TIM )
           mtr86fatal("Delai depasse\n");
       _cputs( t );
       if ( p_write(p2, t, 27 ) == TIM )
           mtr86fatal("Delai depasse\n");
   }
}

TACHE  tacheD()
{
   long d=0;
   _cputs("------> EXEC tache D\n");
   for (;;)  {
       if ( p_write(p3,&d, sizeof(d)) == TIM )
           mtr86fatal("Delai depasse\n");
       if ( p_read(p4,&d, sizeof(d)) == TIM )
           mtr86fatal("Delai depasse\n");
       d += 1;
   }
}

TACHE tacheE()
{
   long d;
   _cputs("------> EXEC tache E\n");
   for (;;) {
       dort(cvrtic(150L));
       if ( p_read(p3, &d, sizeof(d)) == TIM )
           mtr86fatal("Delai depasse\n");
       MONITOR
       printf("\n%u\n",d);
       ENDM
       if ( p_write(p4, &d, sizeof(d)) == TIM )
           mtr86fatal("Delai dpasse\n");
   }
}

TACHE tacheF()
{
   short d = 0;
   _cputs("TacheF dort pour 5 secondes\n");
   dort(cvrtic(5000L));
   _cputs("tacheF ecrit dans un tube non autorise\n");
   p_write(p3,&d, sizeof(d) );
}

 main()
{
   printf("    Test des communications inter-taches par tubes.\n");
   start_mtr(tacheA, 1024);
   p_close( p1 );                     /* facultatif */
   p_close( p2 );                     /* facultatif */
   p_close( p3 );                     /* facultatif */
   p_close( p4 );                     /* facultatif */
}