#include <ctype.h>
#include <stdlib.h>
#include "mtr86.h"

EVENEMENT ev1,ev2;

TACHE  init  (void);                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheB(void);                     /*     PROTOTYPES DES TACHES      */
TACHE  tacheC(void);
TACHE  tacheD(void);
TACHE  tacheE(void);
TACHE  tacheF(void);

char *itoa(int valeur,char *chaine,int base)
{
int reste;
int v_tmp=valeur;
int rang=0;
do
 {
 reste=v_tmp%base;
 v_tmp=v_tmp/base;
 rang++;
 }
 while(v_tmp!=0);
chaine[rang+1]=0;
v_tmp=valeur;
do
 {
 reste=v_tmp%base;
 v_tmp=v_tmp/base;
 chaine[rang]='0'+reste;
 rang--;
 }
 while(rang>=0);
return chaine;
}

void Cputs( char * s )
{
   MONITOR    /* exclusion mutuelle de cputs                         */
   printf(s);  /* cputs est appel simultanment par plusieurs taches */
   ENDM
}


TACHE init  (void)
{
   dsp_stk();
   ev1 = e_cree();
   ev2 = e_cree();
   printf("\nInit cree et active B, C, D, E, F de priorite respective 2, 3, 2, 1, 2\n");
   active(cree(tacheB, 2, 1024));
   active(cree(tacheC, 3, 1024));
   active(cree(tacheD, 2, 1024));
   active(cree(tacheE, 1, 1024));
   active(cree(tacheF, 2, 1024));
}

TACHE tacheB(void)
{
   Cputs("B en attente ev1 : 101b sans delai de garde.\n");
   e_wait( ev1,  0x5, 0xFFFF, EAND, 0);
   Cputs(" B: ev 101b present\n");
   Cputs(" B en attente ev1 : 10b avec delai de garde de 2 s.\n");
   if ( e_wait(ev1 ,0x2, 0xFFFF, EAND, cvrtic(2000)) == ETM )
       Cputs(" B: timeout\n");
   else
       Cputs(" B: ev 10b present\n");
}

TACHE tacheD(void)
{
   Cputs("D en attente ev1 : 10000b sans delai de garde.\n");
   e_wait( ev1, 0x10, 0xFFFF, EAND, 0);
   Cputs(" D: ev 10000b present\n");
   Cputs(" D en attente ev1 : xxxx xx10b avec delai de garde de 1s.\n");
   if ( e_wait(ev1 ,0x2, 0x3, EAND, cvrtic(1000)) == ETM )
       Cputs(" D: timeout\n");
   else
       Cputs(" D: ev xxxx xx10b present\n");
   Cputs(" D en attente ev1 : 001x 0000b sans delai de garde.\n");
   e_wait( ev1, 0x0010, 0xFFCF, EAND, 0);
   Cputs(" D: ev 001x 0000b present\n");
}

TACHE tacheC(void)
{
   short i, x, y;
   char t[10];
   Cputs("C signale continuellement i++ pour ev1 et ev2.\n");
   for (i = 0; ; i++) {
       e_signal(ev1, i);
       e_signal(ev2, i);
       MONITOR
       gotoxy(68,12);
       //printf("[i=%xb]\n",i);
       printf("[i=%sb]\n",itoa(i,t,2));
       ENDM;
       dort(cvrtic(100L));
   }
}

TACHE tacheE(void)
{
   Cputs("E en attente ev1 : 0x00110001b sans delai de garde.\n");
    e_wait(ev1, 0x0031, 0xFFFF, EAND, 0);
   if ( e_signal(ev1, 0) == PAE ) {
      Cputs("Plus de taches en attente\n"
             "Clos les evenements ce qui produira une erreur fatale dans C\n"
	     "(C signale alors des evenements non crees). \n");
      e_close( ev1 );
      e_close( ev2 );
      dort(150);
      mtr86exit(0);
   }
}

TACHE tacheF(void)
{
  Cputs("F en attente ev1 : 1000b ou 1010b sans delai de garde.\n");
  if ( e_wait(ev1, 0x18, 0x18, EOR, 0)==0x8)
      Cputs(" F: ev 1000b present\n");
   else
      Cputs(" F: ev 1010b present\n");
}

 main()
{
char travail[10]; 
 clsscr();
   printf("Utilisation des evenements dans la synchronisation des taches.\n"
         "-------------------------------------------------------------- \n");
   
   start_mtr(init, 1024);
}