// CEx1.c

#include "mtr86.h"

TACHE T1(void)
{
   long j, i;
  // Durant cette squence T2 et T3 sont arrts
   printf("T1: actif (priorite 1) et bloque T2 et T3 (priorite 2)\n");

   for (j=0; j < 1000000; j++);
   // remarque : cette squence alloue le processeur pour un travail inutile (pour peut
   // tre effectuer une temporisation). Cette faon de procder gaspille le temps CPU
   // et ne doit jamais tre utilise. La compilation avec l'option Release supprime cette ligne !

   // Durant la squence suivante T2, T3 sont actifs  chaque appel de dort durant 1 quantum.
   printf("T1: se suspend periodiquement et libere du temps processeur pour T2 et T3\n\n");
   for ( j=0; j < 250; j++) {
     for (i=0; i < 10000; i++); // simuler l'activit de la tche
     dort(1);  // T2 et T3 actifs durant 1 quantum
   }
   MONITOR    // accs exclusif de T1  la ressource cran ( voir par la suite )
   gotoxy(1,8);
   printf("T1 : fin -> acceleration de T2 et T3\n\n");
   ENDM      // fin accs
} // <- T1 est arrt, ce qui alloue le processeur  T2 et T3 : l'affichage est acclr

TACHE T2(void)
{
   // T2 est excut de faon concurrente avec T3
   unsigned j, i;
   for (j=0 ; j < 300 ; j++) {
     MONITOR  // accs exclusif de T2  la ressource cran ( voir par la suite )
     gotoxy(1,6);
     cprintf("T2 : j=%d\n",j);
     ENDM     // fin accs
     for (i=0; i < 1000; i++); // simuler l'activit de la tche
   }
} // <- T2 est arrt

TACHE T3(void)
{
   unsigned j,i;
   // T3 est excut de faon concurrente avec T2
   for (j=0 ; j < 500 ; j++) {
     MONITOR  // accs exclusif de T2  la ressource cran ( voir par la suite )
     gotoxy(1,7);
     cprintf("T3 : j=%d\n",j);
     ENDM    // fin accs
     for (i=0; i < 300; i++); // simuler l'activit de la tche
   }
   mtr86exit(0) ; // le noyau est stopp. Sortie aprs start()
  // jamais excut
}

// Tche d'initialisation. Possde la priorit maximale. Aucune autre tche ne peut
// s'excuter tant que celle ci n'est pas termine ou suspendue
// La tche init cre et active 3 tches. La tche T1 est la plus prioritaire et prempte
// le processeur au dtriment des tches T2 et T3.
TACHE init(void)
{
   printf("Init debut\n");
   active(cree(T1, 1, 1024));  // cre et active la tche T. priorit 1, 512 octets de pile.
   active(cree(T2, 2, 1024));  // cre et active la tche T. priorit 2, 512 octets de pile.
   active(cree(T3, 2, 1024));  // cre et active la tche T. priorit 2, 512 octets de pile.
   printf("Init fin\n");
} // -> A partir d'ici la tche T1 est lance

main()
{
  // Lance la tche init avec une taille de pile de 1024 octets
  clsscr();
  printf("----------------Exemple CEx1--------------------\n");
  start_mtr(init,1024);
}
