/* Diner des philosophes */
#include        <stdio.h>
#include        "mtr86.h"
#include        "eid210.h"

#define N       5  /* nombre de philosophes */

#define P(s)     s_wait(s, 0)
#define V(s)     s_signal(s)
#define gauche   ( (i+4) % N ) 
#define droite   ( (i+1) % N )
#define PENSER   0
#define AFFAMER  1
#define MANGER   2

char *p[3] = {"PENSE    \n","FIN      \n", "MANGE *\n"};
unsigned char status;
 
unsigned   etat[N];
RESSOURCE  mutex;
SEMAPHORE  s[N];

void etat_philo( void )
{
  int j, i=0;
  gotoxy(1,16);
  
  r_wait(mutex);          /* Section critique */
  for ( j = 0; j < N; j++ ) {
      gotoxy(45, 10 + j);
      cputs(p[etat[j]]);
  }
 
  EcritPortA(status);
  r_signal(mutex);        /* Liberer section critique */
}

void test( int i )
{
  if (etat[i]== AFFAMER && etat[gauche] != MANGER && etat[droite] != MANGER) {
    etat[i] = MANGER;
    V(s[i]);
  }
}

void pense( void ) { dort((rand() & 0x7F) + 10); }
void mange( void ) { dort((rand() & 0x7F) + 10); }

void prend_fourchette( int i )
{
  r_wait(mutex);       /* Section critique */
  etat[i] = AFFAMER;   /* PENSER -> AFFAME */
  test(i);             /* Voir si fourchette de gauche et de droite sont libre*/
  r_signal(mutex);     /* Liberer section critique */
  P(s[i]);             /* Bloquer le philosophe i si test n'a pas incrment le smaphore   */
}

void pose_fourchette( int i )
{
  r_wait(mutex);       /* Section critique */
  etat[i] = PENSER;
  test( gauche );
  test( droite  );
  r_signal(mutex);     /* Liberer section critique */
}

TACHE  philosophes(void)
{
   int i = tache_c()-2;
   while (1) {
     pense();
     prend_fourchette(i);
     status = (1 << i) | status;  // met le bit du philosophe i  1
     mange();
     pose_fourchette (i);         // met le bit du philosophe i  0
     status = ~(1 << i) & status; 
  }
}

TACHE init()
{
  int j;
  gotoxy(30,3);
  printf("Diner des philosophes\n");
  mutex = r_cree();
  for (j=0; j<N; j++) 
    s[j]  = s_cree(0);
  for (j=0; j<N; j++) 
    active(cree(philosophes,2,1024));
  gotoxy(1,10);
  printf( "                             philosophe 1 = \n\r"
          "                             philosophe 2 = \n\r"
          "                             philosophe 3 = \n\r"
          "                             philosophe 4 = \n\r"
          "                             philosophe 5 = \n");
  gotoxy(26,22);
  printf("Fin du repas par reset!!!\n");
  for ( ;; ) {
    etat_philo();
    dort(cvrtic(500L));
  }
}

main()
{
  int  j;
  clrscr();
  InitSimulateur();
  gotoxy(10,1);
  printf("RESOLUTION DU PROBLEME DU DINER DES PHILOSOPHES [Dijkstra 65]\n");
  start_mtr(init, 1024);
  for (j=0; j< 5; j++ ) s_close( s[j] );
}
