// ProdConsStock.c
#include <stdio.h>
#include "mtr86.h"

#define P(s) s_wait  (s,cvrtic(1000))
#define V(s) s_signal(s)
#define TAILLE_FIFO  10

/* 
 * Dclaration de la fifo
*/
typedef struct
{
   int stock[TAILLE_FIFO];
   unsigned ie, is;
} Fifo;

void fifo_init(Fifo* fifo)
{
   fifo->ie=fifo->is=0;
}

void Add(Fifo* fifo, int val)
{ 
   fifo->stock[fifo->ie++  % TAILLE_FIFO] = val; 
} 

int  Get(Fifo* fifo)
{ 
  return fifo->stock[fifo->is++ % TAILLE_FIFO]; 
}

SEMAPHORE sProd, sCons;
RESSOURCE r1;
Fifo q1;

TACHE Producteur(void)
{
  int j;
  for (j=0; j<TAILLE_FIFO; j++) 
  {
    P(sProd);
    Add(&q1, j);
    V(sCons);
  }
}

TACHE Consommateur(void)
{
  for (;;) {
    if ( P(sCons) == TIM ) 
      break;                // plus de donnes
    cprintf("%03d\n", Get(&q1));
    V(sProd);
  }
  s_close(sProd); s_close(sCons);
  mtr86exit(0);
}

TACHE init(void)
{
   fifo_init(&q1);
   sProd = s_cree(TAILLE_FIFO);
   sCons = s_cree(0);
   active(cree(Consommateur, 2, 1024));
   active(cree(Producteur,   2, 512));
}

main()
{
  clrscr();
  start_mtr(init, 512);
}
