// ProdConsStock.cpp
#include <stdio.h>
#include "mtr86.h"

#define P(s) s_wait  (s,cvrtic(1000))
#define V(s) s_signal(s)
#define TAILLE_FIFO  10

int test;

class Fifo
{
   int stock[TAILLE_FIFO];
   unsigned ie, is;

  public :
   Fifo()             { ie=0; is=0; }
   void Add(int val)  { stock[ie++  % TAILLE_FIFO] = val; }
   int  Get()         { return stock[is++ % TAILLE_FIFO]; }
};

SEMAPHORE sProd, sCons;

Fifo q1;

TACHE Producteur(void)
{
  int j;
  for (j=0; j<TAILLE_FIFO; j++)
  {
    P(sProd);
    q1.Add(j);
    V(sCons);
  }
}

TACHE Consommateur(void)
{
  for (;;) {
    if ( P(sCons) == TIM )
      break;                // plus de donnes
    cprintf("%03d\n", q1.Get());
    V(sProd);
  }
  s_close(sProd); s_close(sCons);
  mtr86exit(0);
}

TACHE init(void)
{
   sProd = s_cree(TAILLE_FIFO);
   sCons = s_cree(0);
   active(cree(Consommateur, 2, 1024));
   active(cree(Producteur,   2, 1024));
}

main()
{
  clrscr();
  cprintf("%3d\n", test);
  start_mtr(init, 512);
}
