// ProdConsStockSTL.cpp
#include <iostream>
#include <queue>
#include "mtr86.h"

using namespace std;

#define P(s) s_wait  (s,cvrtic(1000))
#define V(s) s_signal(s)
#define TAILLE_FIFO  10


SEMAPHORE sProd, sCons;
RESSOURCE r1;

typedef queue<int> Fifo;
Fifo    q1;

TACHE Producteur(void)
{
  int j;
  for (j=0; j<TAILLE_FIFO; j++)
  {
    P(sProd);
    r_wait(r1);
    q1.push(j);
    r_signal(r1);
    V(sCons);
  }
}

TACHE Consommateur(void)
{
  for (;;) {
    if ( P(sCons) == TIM )
      break;                // plus de donnes
    r_wait(r1);
    cout << q1.front() << endl;
    q1.pop();
    r_signal(r1);
    V(sProd);
  }
  s_close(sProd); s_close(sCons);
  mtr86exit(0);
}

TACHE init(void)
{
   sProd = s_cree(TAILLE_FIFO);
   sCons = s_cree(0);
   r1 = r_cree();   // utilis pour l'exclusion mutuelle des sections critiques dans la STL
   active(cree(Consommateur, 2, 1024));
   active(cree(Producteur,   2, 1024));
}

main()
{
  clrscr();
  start_mtr(init, 512);
}
