// babouins2.c
#include "mtr86.h"

#define P(s)  s_wait(s, 0)
#define V(s)  s_signal(s)
SEMAPHORE Sem;  

int bN, bS;      // compteurs de babouins actifs

void printBab(unsigned char image, int sens)
{
  int i;
  for(i=0; i<9; i++)
  {
    EcritPortA(image);
    if (sens==0)
      image <<=1;
    else
      image >>=1;
    dort(50);
  }
}

void Entrer_S(void)
{
  P(Sem);
  bS++;
  printf("->ES\n"); 
}

void Entrer_N(void)
{
  P(Sem);
  bN++;
  printf("->EN\n"); 
}          

void sortir_N(void)
{
  V(Sem);
  printf("SN->\n"); 
}

void sortir_S(void)
{
  V(Sem);
  printf("SS->\n"); 
}

TACHE babouinN(void)
{
  Entrer_N();
}

TACHE babouinS(void)
{
  Entrer_S();
}

TACHE traverse(void)
{
  for(;;)
  {
    if(bN)
    {
      printBab(1, 0);
      bN--;
      sortir_S();
    }
    if(bS)
    {
      printBab(0x80, 1);
      bS--;
      sortir_N();
    }
    dort(10);
  }
}

TACHE acquisition(void)
{
  unsigned char port=0;
  unsigned fn=0;
  unsigned fs=0;
  for (;;)
  {
     port = LirePortB();
     if(port&0x1 && fn==0)
       fn=1;
     if(port==0 && fn)
     {
       fn=0;
       active(num_tache(babouinN));
     }
     if(port&0x80 && fs==0)
        fs=1;
     if(port==0 && fs==1)
     {
       fs=0;
       active(num_tache(babouinS));
     }
     dort(10); 
   }
}
 

TACHE init(void)
{
  Sem = s_cree(1);
  bS=0; bN=0;
  cree(babouinN, 2, 512);
  cree(babouinS, 2, 512);
  active(cree(traverse, 1, 512));
  active(cree(acquisition,1, 512));
}

main()
{
  cputs("Resolution du probleme des baboins\n");
  InitSimulateur();
  start_mtr(init,512);
}
