	/*************************************************************************
	* 		TP SUR EID210 seul					*
	*************************************************************************
	*  Faire un chenillard avec les 3 leds sur le port QS                   	* 			
	*								      	*	
	*  Cahier des charges						      	*
	***********************						      	*	
	*  Les leds s'allument suivant le cycle 			      	*
	*              D10 -> D11 -> D12 -> D10 ... etc                                    	*
	*  Le temps pendant lequel une led s'allume est d'environ 1S   	*
	*  Ce temps sera gnr par le timer programmable		      	*
	*   gr en interruption						*
	*  NOM du FICHIER:  CHENI_2.C				       	*
	**********************							*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_Donnees.h"
#include <stdio.h>

/* Dclaration des variables*/
int CPTR_mS;			/* dclaration des variables et compteurs de millisecondes */	
unsigned char Fin_tempo,Tempo_en_cours;	/*  dclaration variables pour gestion temporisation 



/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void irq_bt()
{
	 if (Tempo_en_cours==1)
		{ CPTR_mS++;
                           if (CPTR_mS ==1000) Fin_tempo=1,Tempo_en_cours=0,CPTR_mS=0;
		}
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


/*=====================*/
/*      Fonction principale     */
/*=====================*/
main()
{
/* Dclarations *
*****************/
BYTE e_portqs=0x10;		/* Variable sur 8 bits donnant l'tat du port QS donc des LEDs */
unsigned int i;

/*   Initialisations *
*********************/
// Pour base de temps
//***********************
CPTR_mS=0;			// initialisation compteurs millisecondes
SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H
Tempo_en_cours=0;		// Temporisation inactive

// Pour PORT QS sur lequel sont connectes les LEDs
PQSCTR=0x0070;		/* Les 3 sorties sur lesquelles sont connectes les leds*/ 
				/* seront des sorties PQS(6..3) */

/* On crit un message sur le moniteur */
printf("Permutation des LEDs  D12 D11 D10\n");

/* Boucle principale *
**********************/    
	do
	{  	// ecriture Valeur sur le port QS 
	   PORTQS=e_portqs;  
		//  Attendre environ 1S  (Tempo logiciel)
	   Tempo_en_cours=1,Fin_tempo=0;	// Initialisation pour tempo
	   do{}while(Fin_tempo==0);	// Attendre fin tempo
		//  Prparation aux tats futurs				
	  e_portqs<<=1;		    	  
	  if (e_portqs==0x80)	e_portqs=0x10;
    	}while(1);  				/*  Fin de la boucle principale */

} /* Fin de la fonction principale */

 
