	/**************************************************************************************** 
	*  		TP SUR CARTE EID210 SEULE          	     	                              	*
	****************************************************************************************
	*      Tester les 3 LEDs connecte sur le port "QS" et l'entre "CTRL"                	*
	* 									    	       	*
	*                                             					  	                   	*
	*  Cahier des charges: 							       	*
	************************							       	*
	*  Le programme teste les 3 sorties utiles DIO du port QS        	                   	*
	*  A chaque appui sur le "switch" CTRL il y a permutation  de l'tat des leds     	*
	*                                                                                     "D12 D11 D10"                	*
	*  L'action sur le bouton CTRL se fait en interruption				      	*
	*                                                                                                                             	*
	*  Nom du fichier source en "c" : 	T_portQS_Int.C                                            	*
	* *********************************							*
	*****************************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include <stdio.h>

/*  Dclarations  
******************/
/* Des variables globales */
BYTE Flag_Int;
/* De la fonction d'interruption  */
void irq_CTRL()
{	
	Flag_Int=1;
}

 

/*=====================*/
/* Fonction principale */
/*=====================*/
main()
{
/* Dclarations *
*****************/
BYTE e_portqs;		/* Variable sur 8 bits donnant l'tat du port QS donc des LEDs */
e_portqs=0x10;
/*   Initialisations *
*********************/
e_portqs=0x10;
PQSCTR=0x0070;		/* Les 3 sorties sur lesquelles sont connectes les leds*/ 
				/* seront des sorties PQS(6..3) */
PORTQS=e_portqs;  		/* ecriture initiale */
/* On crit un message sur le moniteur */
printf("Test du port QS\n");
printf("Appuyer sur la touche CTRL pour faire une rotation\n");

// Mise en place du vecteur d'interruption
SetVect(25,&irq_CTRL);		// mise en place de l'autovecteur  avec la fonction irq_IRQ()
// Autoriser les interruptions (Bouton CTRL connect sur  entre IRQ1 du microcontrleur)
Valid_IrqCtrl=1;

/* Boucle principale *
**********************/    
	do
	{  while(Flag_Int==0);			/*  Attente appui sur touche CTRL 			*/
	  Flag_Int=0;
	  PORTQS=e_portqs;			/*  Chargement nouvelle valeur sur LEDS 		*/
	  e_portqs<<=1;		    	/*  Prparation etats futurs				*/
	  if (e_portqs==0x80)	e_portqs=0x10;
    	}while(1);  				/*  Fin de la boucle principale 			*/
} /* Fin de la fonction principale */

 
