/*=====================================================================================================
 *     DEFINITIONS  POUR LA CARTE d'INTERFACE POUR REGULATION DE PROCESSUS INDUSTRIELS  (I.R.P.I.)
 *=====================================================================================================
 * Auteurs: HANS T. et ROHOU J.L.
 * Nom de fichier: IRPI.h
 *====================================================================================================*/


/* Commande Sortie Logique n1*/
#define F_IRPI_Cde_SL1 PC4
/* Commande Sortie Logique n2*/
#define F_IRPI_Cde_SL2 PC5
/* Etat Entre logique (Contact Sec n1  */
#define F_IRPI_ECS1 PA0
/* Etat Entre logique (Contact Sec n2  */
#define F_IRPI_ECS2 PA1
/* Code application n1 */
#define F_Code_Appli1 PB6
/* Code application n2 */
#define F_Code_Appli2 PB7


						
//    Pour la conversion des entres analogiques
//-----------------------------------------------
BYTE B_Rang_Voie_Ana;				// N de la voie en cours de conversion
WORD TS_Result_CAN[6];	// Uniquement les voies de 0  3 sont utiliss
#define S_EA_BC1 TS_Result_CAN[0]	// Entre Analogique (Boucle de Courant) N1
#define S_EA_BC2 TS_Result_CAN[1]	// Entre Analogique (Boucle de Courant) N2
#define S_EA_BC3 TS_Result_CAN[2]	// Entre Analogique (Boucle de Courant) N3
#define S_Cde_Ana_Ext TS_Result_CAN[3] // Entre Commande Analogique Externe
#define S_Cde_Ana_Int TS_Result_CAN[4] // Entre Commande Analogique Interne




/* Dfinitions particulires */
/*  TPU PARAMETER RAM */

//   Dfinition des tats des bits du port A 
#define Etat_TPU0	(*(union word_bits*) (0xFFFF02))   	// ECS1 sur IRPI
#define Etat_TPU1	(*(union word_bits*) (0xFFFF12))   	// ECS2 sur IRPI

#define PA0 Etat_TPU0.bit.b15			/*  Dernier Etat	 de l'entre PA0 */
#define PA1 Etat_TPU1.bit.b15			/*  Dernier Etat	 de l'entre PA1 */
//   Dfinition des tats des bits du port B 
#define Etat_TPU14	(*(union word_bits*) (0xFFFFE2))   	// Code_Appli1
#define Etat_TPU15	(*(union word_bits*) (0xFFFFF2))   	// Code Appli2

#define PB6 Etat_TPU14.bit.b15			/*  Dernier Etat	 de l'entre PB6 */
#define PB7 Etat_TPU15.bit.b15			/*  Dernier Etat	 de l'entre PB7 */




// Pour les sorties analogiques
#define B_IRPI_SA_BC1 SA0	// Sortie Analogique Boucle de Courant n1
#define B_IRPI_SA_BC2 SA1	// Sortie Analogique Boucle de Courant n2
#define B_IRPI_SA_T SA2		// Sortie Analogique Tension