	/******************************************************************************
	*     Test de l'Interface pour Rgulation de Processus Industriel	(IRPI)	*
	*******************************************************************************
	*  													*
	*   CAHIER DES CHARGES :					      			*
	*  *********************					      			*
	*	- La sortie Boucle de courant n1 est commande par l'entre interne 	*
	*	 qui est le potentiomtre analogique(B_IRPI_SA_BC1=S_Cde_Ana_Int)		*
	*	- La sortie tension est elle aussi commande par l'entre interne 	*
	*	- La sortie Boucle de courant n2 est commande par l'entre externe 	*
	*	- Les sortie logiques recopies les entres logiques				*
 	*---------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Test_IRPI.C	       						*
	*  ****************
	*  Auteurs:   HANS T. ROHOU J.L.								*
	*  ********												*
	******************************************************************************/
/* Liste des fichiers  inclure */
#include "Structures_donnees.h"
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "IRPI.h"

/* Dclaration des variables globale */

WORD Compteur;

/*===========================
  *    Fonction principale          
  ===========================*/
main(void)
{
float i_m1;
float i_m2;
float i_m3;
float p_Ece,p_Eci;		// valeur en % des consignes externe et interne
float v_Ece,v_Eci;		// valeur en volt des consignes externe et interne
 CFSR0=0x8800;	  // Pour les 2 entres code cible (PPB6-> Code_Cible1 et PB7 -> Code_Cible)
 CFSR3=0x0088;	  // Pour les 2 entres logiques (PA0->EL1 et PA1 ->EL2)
 HSQR0=0xA000;	/* Les entres PB6 et PB7 seront mmorises	*/
 HSQR1=0x000A;	/* Les entres PA0 et PA1 seront mmorises	*/
 CPR0=0xF000;	/* Les bits de PB7 et PB6 en priorit haute  */					
 CPR1=0x000F;	/* Les bits de PA0 et PA2 en priorit haute  */
 HSRR0=0x0000; 		// Initialisation PortB  
 HSRR1=0x0000; 		// Initialisation PortA	  

/* De l'interface de puissance pour Charge Electrique  */
 Dir_PortC=0x30; 		
 

// Pour lancer la premire conversion
CAN=0x0050; 
B_Rang_Voie_Ana=0;

clsscr();

/*   Boucle principale   */
/*************************/    
do	{  
		if(Fin_Conv_AN==0);						// La conversion lance le coup d'avant est termine
		{ TS_Result_CAN[B_Rang_Voie_Ana]=CAN&0X0FFF; // Rcuprer le rsultat sur 12b de la voie en cours
		if(B_Rang_Voie_Ana==5)B_Rang_Voie_Ana=0;
		else B_Rang_Voie_Ana++;
		switch (B_Rang_Voie_Ana)
			{case 0 : {CAN=0x0050; // Lancer conversion voie 0  dans la plage 0/10V   
					break;}
			case 1 : 	{CAN=0x0051; // Lancer conversion voie 1  dans la plage 0/10V  
					break;}
			case 2 : 	{CAN=0x0052; // Lancer conversion voie 2  dans la plage 0/10V  
					break;}
			case 3 : 	{CAN=0x0053; // Lancer conversion voie 3  dans la plage 0/10V
					break;}
			case 4 : 	{CAN=0x0044; // Lancer conversion voie 3  dans la plage 0/5V
					break;}
			default:	{}}
		// Transfert des signaux analogiques
			B_IRPI_SA_BC1 =(unsigned char)(S_Cde_Ana_Int>>4);
			B_IRPI_SA_T = (unsigned char)(S_Cde_Ana_Int>>4);
			B_IRPI_SA_BC2 = (unsigned char)(S_Cde_Ana_Ext>>4);
		// Transfert des signaux d'entres logiques logiques (sur port A) sur les sorties logiques
		HSRR1=0xFFFF;	// Acqurir l'tat du port A
		F_IRPI_Cde_SL1=!F_IRPI_ECS1;
		F_IRPI_Cde_SL2=!F_IRPI_ECS2;
		// Lire le code application matrielle (sur port B)
		HSRR0=0xFFFF; 	// Acqurir l'tat du port B
		}
	Compteur++;
	if (Compteur==20000)
		{Compteur=0;
		i_m1=(float)S_EA_BC1;
		i_m1*=20;
		i_m1/=4095;
		i_m2=(float)S_EA_BC2;
		i_m2*=20;
		i_m2/=4095;
		i_m3=(float)S_EA_BC3;
		i_m3*=20;
		i_m3/=4095;
		p_Ece=(float)S_Cde_Ana_Ext;
		p_Ece*=100;
		p_Ece/=4095;
		v_Ece=(float)S_Cde_Ana_Ext;
		v_Ece*=10;
		v_Ece/=4095;
		p_Eci=(float)S_Cde_Ana_Int;
		p_Eci*=100;
		p_Eci/=4095;
		v_Eci=(float)S_Cde_Ana_Int;
		v_Eci*=5;
		v_Eci/=4095;
		gotoxy(1,10);
		printf("Actionner le potentiometre / appliquer une tension sur l'entre externe\n\n\n");
		printf("Valeur tension potentiometre = %3.3x = %.2f V = %.1f %%   \n",S_Cde_Ana_Int,v_Eci,p_Eci);
		printf("Valeur tension externe       = %3.3x = %.2f V = %.1f %%   \n",S_Cde_Ana_Ext,v_Ece,p_Ece);
		printf("Valeur boucle courant 1      = %3.3x = %2.2f mA \n",S_EA_BC1,i_m1);
		printf("Valeur boucle courant 2      = %3.3x = %2.2f mA \n",S_EA_BC2,i_m2);
		printf("Valeur boucle courant 3      = %3.3x = %2.2f mA \n",S_EA_BC3,i_m3);
		printf("EL1 =%d\n",F_IRPI_ECS1);
		printf("EL2 =%d\n",F_IRPI_ECS2);
		printf("Code Application n1 =%d\n",F_Code_Appli1);
		printf("Code Application n2 =%d\n",F_Code_Appli2);

		}
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

