	/************************************************************************************************
	*       TP sur  EID210 avec Interface pour Servo Mcanismes  (ISM)					*	
	*************************************************************************************************
	*  	Asservissement de la position moteur  la position potentiomtre numrique			*
	*	en mode Proportionnel												*
	*																*
	*   CAHIER DES CHARGES :					      						*
	*  *********************						      					*	
	*   On souhaite que la position de l'axe moteur suive la position du potentiomtre NUMERIQUE 	*
	*      															*
	*	-> La priode d'chantillonnage est impose parle timer programmable par interruptions	*
	*	-> L'action de correction sera de type P numrique							*
	*   	-> La sortie analogique de mesure Position et  activ							*
 	*---------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Asserv_Pos_P.C			       							*
	* ***************** 													*
	*************************************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie

/* Dclaration des constantes*/
#define Valeur_Te 50			// Priode d'chantillonnage = 50 mS
#define Valeur_Coef_Action_P 16	// Valeur du coefficient d'action proportionnel (en fait 12/256)	
/* Dclaration des variables globale */
int	i;
WORD  Kp,Cptr_Te,W_Temp;

signed short Cons_Pos,Pos_Mot_Prec,Ecart,Ecart_Prec,Var_Tempo,Im_Vit_W,S_Reg;	// Un short est cod sur 16 bits
signed int Result_Calcul;	// Un "int" est cod sur 32 bits 

/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
==============================================================================*/
void Irq_Base_Temps()
{signed short S_Temp;
 Cptr_Te--;
	if (Cptr_Te==0)
	{Cptr_Te=Valeur_Te;
	 Cons_Pos=S_Pot_Num;	// La consigne position suit la valeur mesure position Pot. Num.
	 Ecart = Cons_Pos - S_Pos_Mot ;		// Calcul de l'cart
	 Result_Calcul=Kp*Ecart;
	 Result_Calcul=Result_Calcul>>8;
	 S_Reg=Result_Calcul;//Result_Calcul;
	 // Gestion des saturations et application en sortie
		// Application de rsultat
		if (S_Reg>0)
			{Signe_Cde_Mot=0;		// Commande du moteur en positif
	  			if(S_Reg>255) 
					{Cons_TM=0x00FF;
	 	 			 S_Reg = 255;}
	    			else {Cons_TM=(WORD)(S_Reg);}}
		else if(S_Reg<0)
			{Signe_Cde_Mot=1;	// Commande du moteur en ngatif
	  			if(S_Reg<-255) 
					{Cons_TM=0x00FF;
	 	 			 S_Reg= -255;}
	    			else 	{S_Temp=~S_Reg;
					 S_Temp+=1;
					 Cons_TM=(WORD)(S_Temp);}}
		else Cons_TM=0x0000;
	  // Mise  l'chelle de la sortie analogique image Position et application
	  Var_Tempo = S_Pos_Mot>>4;
	  if(Var_Tempo>127) Mes_IP= 255;
	    else if(Var_Tempo<-128) Mes_IP= 0;
		  else Mes_IP=(signed char)(Var_Tempo+128);
	}
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


/*=========================
 *    Fonction principale          
  =========================*/
main(void)
{

/* Initialisations */

/* Des registres du TPU pour configurer le bit PA0 -> ch0  (TPU7) en sortir PWM */	 
 Per_Cde_Mot=0x0100;   	//  	Valeur de la PERiode du     
// Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
 Cons_TM=0x0000;   	// Dure du signal au niveau logique 
				// C'est la Consigne Tension Moteur	 	
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// Pendant init pas de spcification de priorit sur ch 0 7 
 CFSR3=0x0009;     	//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch 0 donc sur PA0)
 CTRL_TPU0=0x0091;  	// On utilise TCR1  
 HSRR1=0x0002; 		// Initialisation canal	  
 CPR1=0x0003;      	// Priorit haute pour ch0 -> PA0
// Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
				// C'est la Consigne Tension Moteur	 	
/* Des registres du TPU pour configurer le comptage sur signaux en quadrature de phase issu du codeur moteur
// bit PB0 -> ch8 (TPU8) en canal primaire et bit PB1 -> ch9 (TPU9) en canal secondaire */	 
/* Effacer les bits de priorit	*/
   CPR0=0x0000;	
/* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 
   CFSR1=0x8866;	// les bit PB1 et PB0  en QDEC en comptage de signaux en quadrature)  	
/* Initialisation des paramtres RAM	 */
  Cor_PinS_CHA=0x0096;	//  9 -> On compare par rapport au canal 9	
  Edge_T_CHA=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
  Cor_PinS_CHB=0x0086;	//  8 -> On compare par rapport au canal 8
  Edge_T_CHB=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
 
/* Registre de Slection de la Fonction des canaux d'E/S  15  14  13   12	*/ 
   CFSR0=0x0066;	/* les bit PB4 (CH12) et PB5(CH13)  en QDEC en comptage de signaux en quadrature)  	*/
/* Initialisation des paramtres RAM	 */
// Pour le CH12  qui sera le canal primaire
  Cor_PinS_PNA=0x00D6;	//  D -> on compare par rapport au canal 13 ($D)   (fonction 6 / canal 13)
  Edge_T_LSB_PNA=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)
// Pour CH13 qui sera le canal secondaire
  Cor_PinS_PNB=0x00C6;	//  C -> on compare par rapport au canal 12  ($C) (fonction 6 / canal 12)
  Edge_T_LSB_PNB=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)

/* Registre de squence de service	*/  
   HSQR0=0xA1A4;   
	// Pour dfinir  PB4 secondaire -> 01   PB5 primaire ->  00
   HSRR0=0x0F0F; 	// Pour initialiser et dmarrer le comptage pour  PB0-> 11  pour PB1-> 11  pour  PB5-> 11 et pour PB4-> 11   		
 /* Positionner les bits de priorit	*/
   CPR0=0x5F0F;	// Priorits maxi pour les 2 canaux PB1-PB0 

// Initialisation des compteurs pour signaux en quadrature
S_Pot_Num=0x0000;
S_Pos_Mot= 0x0000;
/* De l'interface de puissance de commande moteur */
  Dir_PortC = 0xCF; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
  Cons_CM = 0xFF;		// Le courant moteur sera limit  sa valeur maxi 
  Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
  Signe_Cde_Mot = 0;		// Commande Moteur en positif
  Val_Cod = 0;			// Pour Valider l'interface codeur
  Stb_Cod = 1 ;			// Pour valider le fonctionnement du codeur
/* Des variables diverses */
 Kp = Valeur_Coef_Action_P;	// Coefficient d'action Proportionnel
// On pilote en tension
Cons_CM=0x00FF;
// Pour la priode d'chantillonage
Cptr_Te=Valeur_Te;
// Pour base de temps
//***********************
SetVect(96,&Irq_Base_Temps);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H


/*   Boucle principale   */
/*************************/    
do	{  // Pour effacer l'cran
	// Tches rptitives
	i++;
	if(i>100000)
	  {
	  i=0;
	  clsscr(); // Effacer cran
	  // Rgulirement on envoie  l'cran:
	  gotoxy(4,6);
	  printf(" AGIR SUR POTENTIOMETRE NUMERIQUE  \n"); 
	  gotoxy(4,10);
	  printf("Consigne numerique de Position: %d\n",Cons_Pos);	// La consigne numrique de position
	  gotoxy(4,12);
	  printf("Mesure numerique de la Position: %d\n",S_Pos_Mot);	// La mesure numrique de la position
	  gotoxy(4,14);
 	  printf("Valeur de l'ecart: %d\n",Ecart);
 	  gotoxy(4,16);	
	  printf("Valeur sortie regulateur: %d\n",S_Reg);	// La mesure Sortie Rgulateur
	  }
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

