	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  Asservissement en vitesse  la position du potentiomtre numrique	*
	*  en mode Proportionnel + Intgral		  					*
	*												*
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*		
	*  On souhaite que la vitesse du moteur suive la valeur impose		*
	*     par le potentiomtre numrique  						*
	*	-> l'acquisition de la consigne est chantillonne  1 mS		*
	*	-> Cette priode d'chantillonnage Te est impose parle timer	*
	*	     programmable en mode d'interruption					*
	*    	-> On calcule une image numrique de la vitesse tous les Te		*
	*      Image_vit = (Image pos actuelle) - (Image pos prcdente)		*
	*   	-> L'action de correction sera de type PI numrique			*
	*	-> Une image analogique de la vitesse est fournie en Uiv		*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  Asserv_Vit_PI.C			       		*
	* *****************									*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie
/* Dclaration des constantes*/
#define Valeur_Te 50			// Priode d'chantillonnage = 50 mS
/* Dclaration des variables globale */
WORD i,Cptr_Te,Kp,Ka;
signed char Im_Vit_Num;
signed short S_Cons_Vit,S_Im_Vit;
signed short S_Temp,S_Reg,Ecart,Ecart_Prec,Sort_Reg_Prec,Var_Tempo,S_Pos_Mot_Prec;
// Un short est cod sur 16 bits
signed int Resultat1,Result_Calcul;	// Un "int" est cod sur 32 bits 
/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void Irq_Base_Temps()
{ Cptr_Te--;
	if (Cptr_Te==0)
	{Cptr_Te=Valeur_Te;
	S_Cons_Vit = S_Pot_Num;
	S_Im_Vit = S_Pos_Mot - S_Pos_Mot_Prec;	// Calcul de l'image numrique de la vitesse
	Ecart = S_Cons_Vit - S_Im_Vit;			// Calcul de l'cart
	Resultat1=(int)(Kp * Ecart - Ka * Ecart_Prec)>>4;
	Result_Calcul = (int)(Sort_Reg_Prec + Resultat1);	// Calcul de l'action de correction
	S_Reg=(short)Result_Calcul; 
	// Gestion des saturations et application en sortie
	// Application de rsultat
		if (S_Reg>0)
			{Signe_Cde_Mot=0;		// Commande du moteur en positif
	  			if(S_Reg>255) 
					{Cons_TM=0x00FF;
	 	 			 S_Reg = 255;}
	    			else {Cons_TM=(WORD)(S_Reg);}}
		else if(S_Reg<0)
			{Signe_Cde_Mot=1;	// Commande du moteur en ngatif
	  			if(S_Reg<-255) 
					{Cons_TM=0x00FF;
	 	 			 S_Reg= -255;}
	    			else 	{S_Temp=~S_Reg;
					 S_Temp+=1;
					 Cons_TM=(WORD)(S_Temp);}}
		else Cons_TM=0x0000;
	// Mise  jour des valeurs mmorises
	S_Pos_Mot_Prec = S_Pos_Mot;
	Sort_Reg_Prec = S_Reg;
	Ecart_Prec=Ecart;
	// Mise  l'chelle de la sortie analogique image vitesse et application en sortie analogique
	Var_Tempo = S_Im_Vit;
	Var_Tempo = Var_Tempo >> 7;
	if(Var_Tempo>127) Mes_IV = 255;
	 else if(Var_Tempo<-128) Mes_IV = 0;
		else Mes_IV =(signed char)(Var_Tempo+128);
   }
  
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


/*=====================
  *    Fonction principale          
  =====================*/
main(void)
{

/* Initialisations */

/* Des registres du TPU pour configurer le bit PA0 -> ch0  (TPU7) en sortir PWM */	 
 Per_Cde_Mot=0x0100;   	//  	Valeur de la PERiode du signal				
 // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
 Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
				// C'est la Consigne Tension Moteur	 	
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// Pendant init pas de spcification de priorit sur ch 0 7 
 CFSR3=0x0009;     	//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch 0 donc sur PA0)
 CTRL_TPU0=0x0091;  	// On utilise TCR1  
 HSRR1=0x0002; 		// Initialisation canal	  
 CPR1=0x0003;      	// Priorit haute pour ch0 -> PA0
/* Des registres du TPU pour configurer le comptage sur signaux en quadrature de phase issu du codeur moteur
// bit PB0 -> ch8 (TPU8) en canal primaire et bit PB1 -> ch9 (TPU9) en canal secondaire */	 
/* Effacer les bits de priorit	*/
   CPR0=0x0000;	
/* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 
   CFSR1=0x8866;	// les bit PB1 et PB0  en QDEC en comptage de signaux en quadrature)  	
/* Initialisation des paramtres RAM	 */
    Cor_PinS_CHA=0x0096;	//  9 -> On compare par rapport au canal 9	
  Edge_T_CHA=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
  Cor_PinS_CHB=0x0086;	//  8 -> On compare par rapport au canal 8
  Edge_T_CHB=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
  S_Pos_Mot=0x0000;	// On met  0 le compteur associ
/* Registre de Slection de la Fonction des canaux d'E/S  15  14  13   12	*/ 
   CFSR0=0x0066;	/* les bit PB4 (CH12) et PB5(CH13)  en QDEC en comptage de signaux en quadrature)  	*/
/* Initialisation des paramtres RAM	 */
// Pour le CH12  qui sera le canal primaire
  Cor_PinS_PNA=0x00D6;	//  D -> on compare par rapport au canal 13 ($D)   (fonction 6 / canal 13)
  Edge_T_LSB_PNA=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)
// Pour CH13 qui sera le canal secondaire
  Cor_PinS_PNB=0x00C6;	//  C -> on compare par rapport au canal 12  ($C) (fonction 6 / canal 12)
  Edge_T_LSB_PNB=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)
  S_Pot_Num=0;		// On met  0 le compteur associ	
/* Registre de squence de service	*/  
   HSQR0=0xA1A4;   
	// Pour dfinir  PB4 secondaire -> 01   PB5 primaire ->  00
   HSRR0=0x0F0F; 	// Pour initialiser et dmarrer le comptage pour  PB0-> 11  pour PB1-> 11  pour  PB5-> 11 et pour PB4-> 11   		
 /* Positionner les bits de priorit	*/
   CPR0=0x5F0F;	// Priorits maxi pour les 2 canaux PB1-PB0 

/* De l'interface de puissance de commande moteur */
 Dir_PortC=0xCF; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot=0;		// Commande Moteur en positif
 Val_Cod = 0;			// Pour Valider l'interface codeur
 Stb_Cod = 1 ;			// Pour valider le fonctionnement du codeur

/* Des variables diverses */
 S_Pos_Mot_Prec =0x0000;	// Pour la mesure vitesse	
 Ecart_Prec = 0x0000;	// Pour le correcteur Proportionnel + Intgral
 Sort_Reg_Prec = 0x0000;
 Kp = 2;	// Coefficient d'action Proportionnel
 Ka = 1;	// Ce qui donne un coefficient a = Kp/Ka = 0,5 
 i=0;
// On pilote en tension donc la consigne courant est  son maxi
Cons_CM=0x00FF;
// Pour la priode d'chantillonage
Cptr_Te=Valeur_Te;

// Pour base de temps
//***********************
SetVect(96,&Irq_Base_Temps);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H


/*   Boucle principale   */
/*************************/    
  do	{i++;
	 if(i>50000)
	  {
	  i=0;
	  clsscr(); // Effacer cran
	  // Rgulirement on envoie  l'cran:
	  gotoxy(4,6);
	  printf("      AGIR SUR POTENTIOMETRE NUMERIQUE  \n"); 
	  printf("        --------------------------------- \n");  
	  gotoxy(4,10);
	  printf("Consigne numerique de Vitesse: %d\n",S_Cons_Vit);	// La consigne numrique de vitesse
	  gotoxy(4,12);
	  printf("Mesure numerique de la position: %d\n",S_Pos_Mot);// La mesure numrique de la position
	  gotoxy(4,14);
	  printf("Mesure numerique de la Vitesse: %d\n",S_Im_Vit);	// La mesure numrique de la vitesse
	  gotoxy(4,16);
 	  printf("Valeur de l'ecart: %d\n",Ecart);
 	  gotoxy(4,18);	
	  printf("Valeur sortie regulateur: %d\n",S_Reg); // Rgulirement on envoie  l'cran:
	 }
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */