	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  	Compteur pour Signaux en Quadrature de phase (CSQ)			*
	*	issus du codeur incrmental accoupl au moteur				*
	*												*
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*	
	*  On souhaite que toutes les secondes, le moniteur renvoie le rsultat	*
	*   du compteur pour signaux en quadrature de phase 				*
	*  Signaux issus du codeur incrmental accoupl au moteurappliqus 	*
	*   sur Cod_A  -> PB0 -> TPU8 -> CH8						*
	*	  Cod_B  -> PB1 -> TPU9 -> CH9						*
	*  	  (Mode QDEC  -> code fonction $6)						*
	*  Le comptage ralis par le TPU interne au micro-controleur se fait	*
	*  sur 16 bits. Le programme ralise une extension sur 32 bits.		*
	*  -> Pour voir fonctionnement OK faire tourner le moteur  la main	*
 	*-----------------------------------------------------------------------*
	*  NOM du FICHIER :  CSQ_Cod_Mot.C		       				*
	* *****************									*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie

/* Dclaration de variables de travail */
WORD Resultat;
int i;

// definition de la structure pour mesur position sur 32 bits;
union position_32
{
struct
	{
	short depassement:16; 	// les 16 bits de poids forts
	short codeur:16;		// les 16 bits de poids faibles	
	} pos;
int position;
};
union position_32 position_0,position_1;
#define Position_32bits position_0.position 

// Dfinition prototype fonction 
// Pour le comptage sur 32 bits
void Calcul_Pos_32b(void);


/*==========================
 *     Fonction principale      
 *==========================*/
main()
{
/*  initialisations 
*******************/

position_0.position=0;
position_1.position=0;

/* Les registres du TPU 		
 ------------------------ */
/* Effacer les bits de priorit		*/
   CPR0=0x0000;	
/* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 
   CFSR1=0x0066;	/* les bit PB1 (CH8=TPU8) et PB0 (CH9=TPU9)  en QDEC en comptage de signaux en quadrature)  */
/* Initialisation des paramtres RAM	 */
// Pour canal 8 sur lequel on a le CHa du codeur moteur
  Cor_PinS_CHA=0x0096;	 //  9 -> On compare par rapport au canal 9	
  Edge_T_CHA=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
// Pour canal 9 sur lequel on a le chb du codeur moteur
  Cor_PinS_CHB=0x0086;	// 8 -> On compare par rapport au canal 8
  Edge_T_CHB=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
  Pos_Mot=0x0000;

/* Registre de squence de service	*/  
   HSQR0=0x0004;     	// Pour dfinir  PB1 secondaire -> 01   PB0 primaire ->  00
   HSRR0=0x000F; 	// Pour initialiser et dmarrer le comptage: pour  PB1 -> 11   et pour PB0 -> 11  
 /* Positionner les bits de priorit	*/
   CPR0=0x000F;	// Priorits maxi pour les 2 canaux PB1-PB0 
  
/* Pour le port C (Sur lequel est connect les interfaces codeur moteur)  */
  Dir_PortC = 0xFF;
  Stb_Cod=1;	// Autorisation fonctionnement codeur moteur
  Val_Cod =0;  	// Valisation interface codeur moteur
  Valid_IP_Mot=1; // On inhibe l'interface de puissance moteur

/* Boucle principale 
/********************/    
do
	{//Resultat=Pos_Mot;
 	Calcul_Pos_32b();
	clsscr();
	gotoxy(4,6);
	printf("           FAIRE TOURNER AXE MOTEUR \n");
	printf("           -> LA MESURE POSITION DOIT EVOLUER\n");
	gotoxy(4,10);
	printf("Mesure position moteur en 'inc': %8.8x Hexa=%9d Decimal %\n",Position_32bits,Position_32bits);
	 for(i=100000;i>0;i--);				// Attendre environ 1 seconde 
	}while(1);	/* fin de la boucle principale */
} /* fin fonction principale */



//  Fonction permettant d'obtenir un rsultat de comptage sur 32 bits
/**********************************************************************/ 
void Calcul_Pos_32b()
{
position_1=position_0;
position_0.pos.codeur=(short)Pos_Mot;
if ((position_0.pos.codeur&0xC000)==0xC000)
	{if((position_1.pos.codeur&0xC000)==0x0000)
	position_0.pos.depassement--;
	}
if ((position_0.pos.codeur&0xC000)==0x0000)
	{if((position_1.pos.codeur&0xC000)==0xC000)
	position_0.pos.depassement++;
	}
}
// Fin dfinition fonction









 