	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  	Compteur pour signaux en quadrature de phase				*
	*	issu du codeur incrmental accoupl au moteur				*
	*												*
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*	
	*  On souhaite que toutes les secondes, le moniteur renvoiele rsultat	*
	*   du compteur pour signaux en quadrature de phase 				*
	*  Signaux issus du codeur incrmental accoupl au moteur appliqus 	*
	*   sur Cod_A  -> PB0 -> TPU8 -> CH8						*
	*		   Cod_B -> PB1 -> TPU9 -> CH9					*
	*  	  (Mode QDEC  -> code fonction $6)						*
	*  -> Pour voir fonctionnement OK agir sur le potentionmtre		*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  CSQ_Cod_Mot.C		       				*
	* *****************									*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie

/* Dclaration de variables de travail */

WORD Resultat,Valeur_Cde,i;

// definition de la structure en position sur 32 bits;
union position_32
{
struct
	{
	short depassement:16;
	unsigned short codeur:16;
	} pos;
int position;
};

union position_32 position_0,position_1;
int vitesse;
// fonction base de temps pour convertir position sur 32 bits et calcul  vitesse.

void irq_bt()
{
int register tmp;
position_1=position_0;
position_0.pos.codeur=Pos_Mot;
if ((position_0.pos.codeur>=0xFF00) && (position_1.pos.codeur<=0x00FF))
	position_0.pos.depassement--;
if ((position_1.pos.codeur>=0xFF00) && (position_0.pos.codeur<=0x00FF))
	position_0.pos.depassement++;
vitesse=position_0.position-position_1.position;
tmp=vitesse*127;
tmp/=206;
tmp+=128;
Mes_IV=(char)(tmp&0xFF);
}


/*===========================
 *     Fonction principale      
 *===========================*/
main()
{
float vit;
float p_deg;
clsscr();

/*  initialisations 
*******************/

position_0.position=0;
position_1.position=0;

/* Les registres du TPU 		
 -----------------------------------------  */
// Pour la commande du moteur en tension (PWM) 
   Per_Cde_Mot=0x00FF;   	//  	Valeur de la PERiode du signal
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00FF	
   Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
   TPUMCR=0x0040; 	// tcr1 
   CPR1=0x0000;	
   CFSR3=0x0099;     	//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch0 donc sur PA0)
   CTRL_TPU0=0x0091;  	// On utilise TCR1
   CTRL_TPU1=0x0091;  
   HSRR1=0x000A; 		// Initialisation canal	  
   CPR1=0x000F;      	// Priorit haute pour ch0 -> PA0
   Cons_TM =0xFF;
   Per_Cde_CE=0xFF;
   Cons_TCE=0xFF;
   Cons_CCE=0xFF;   
//Cons_CM = 0xFF;	// Le courant moteur sera limit  sa valeur maxi 

/* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 
   CFSR1=0x0066;	/* les bit PB1 (CH8=TPU8) et PB0 (CH9=TPU9)  en QDEC en comptage de signaux en quadrature)  */
/* Initialisation des paramtres RAM	 */
// Pour canal 8 sur lequel on a le cha du codeur moteur
  Cor_PinS_CHA=0x0096;	//  9 -> On compare par rapport au canal 9	
  Edge_T_CHA=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
// Pour canal 9 sur lequel on a le chb du codeur moteur
  Cor_PinS_CHB=0x0086;	// 8 -> On compare par rapport au canal 8
  Edge_T_CHB=0x0081;	//  8 -> Le rsultat de comptage est en RAM canal 8
  Pos_Mot=0x0000;

/* Registre de squence de service	*/  
   HSQR0=0x0004;     	// Pour dfinir  PB1 secondaire -> 01   PB0 primaire ->  00
   HSRR0=0x000F; 		// Pour initialiser et dmarrer le comptage: pour  PB1 -> 11   et pour PB0 -> 11  
 /* Positionner les bits de priorit	*/
   CPR0=0x000F;		// Priorits maxi pour les 2 canaux PB1-PB0 

 Dir_PortC = 0x0F;
 Signe_Cde_Mot=0;		// Commande Moteur en positif
 Valid_IP_Mot = 0; 	// Validation de l'Interface de Puissance moteur
 Signe_Cde_CE=0;
 Valid_IP_CE=0;
/* Pour le port C (Sur lequel est connect les interfaces codeur moteur)  */
  Stb_Cod=1;		// Autorisation fonctionnement codeur moteur
  Val_Cod =0;  		// Valisation interface codeur moteur

// Pour base de temps
//***********************
SetVect(96,&irq_bt);   	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H

// Pour Dmarrer le cycle de conversion A->N
CAN=0x0043;


 /* Boucle principale 
/*************************/    
do
	{

	if (Fin_Conv_AN==0)
		{Resultat=CAN;
		Valeur_Cde=((Resultat&0x0FFF)>>4);
		Cons_CM=Valeur_Cde;
		if (Valeur_Cde==0)
			Cons_TM=0;
			else
			Cons_TM=255;
           }	// Appliquer consigne Tension Moteur
  		CAN=0x0043; 	// Lancer la conversion de la voie n3 du CAN -> EA3 -> U_Pot

	// Calcul de la position en Degr
	p_deg=(float)position_0.position*18;
	p_deg/=100;
	// Calcul de la vitesse en tr/min
	vit=(float)vitesse/2;
	vit*=60;
	// Affichage des rsultats
	gotoxy(4,2);
	printf("Pour voir fonctionnement -> agir sur le potentiometre \n");
	printf("    ou faire tourner l'axe moteur a la main \n");
	gotoxy(4,5);
	printf("Valeur commande moteur: %2.2x inc = %d \n",Valeur_Cde,Valeur_Cde);
	gotoxy(4,7);
	printf("Position moteur: 0x%8.8x en inc en Hexa =%.2f deg \n",position_0.position,p_deg);
	gotoxy(4,9);
	printf("Vitesse moteur: %8.8x inc en Hexa =%.3f tr/min\n",vitesse,vit);		
	 for(i=50000;i>0;i--);				// Attendre environ 1 seconde 
	}while(1);	/* fin de la boucle principale */
} /* fin fonction principale */















 