	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  	Compteur pour signaux en quadrature de phase				*
	*	issu du potentiomtre numrique						*
	*												*
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*	
	*  On souhaite que toutes les secondes, le moniteur renvoie			*
	*   le rsultat du compteur pour signaux en quadrature de phase 		*
	*  Signaux issus du potentiomtre numrique					*
	*  appliqus sur Pot_num_A  -> PB4 -> TPU12 -> CH12				*
	*		   Pot_Num_B -> PB5 -> TPU13 -> CH13				*
	*  	  (Mode QDEC  -> code fonction $6)						*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  CSQ_Pot_Num.C		       				*
	* *****************									*
	*************************************************************************/

/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie

/* Dclaration de variables de travail */

WORD Resultat;
signed short Resultat_D;
int i;


/*=====================*/
/* Fonction principale */
/*=====================*/
main()
{
/* initialisations */
/*******************/

/* Les registres du TPU 		
 -----------------------------------------  */
/* Effacer les bits de priorit		*/
   CPR0=0x0000;	
/* Registre de Slection de la Fonction des canaux d'E/S  15  14  13   12	*/ 
   CFSR0=0x0066;	/* les bit PB4 (CH12) et PB5(CH13)  en QDEC en comptage de signaux en quadrature)  	*/
/* Initialisation des paramtres RAM	 */
// Pour le CH12  qui sera le canal primaire
  Cor_PinS_PNA=0x00D6;	//  D -> on compare par rapport au canal 13 ($D)   (fonction 6 / canal 13)
  Edge_T_LSB_PNA=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)
// Pour CH13 qui sera le canal secondaire
  Cor_PinS_PNB=0x00C6;	//  C -> on compare par rapport au canal 12  ($C) (fonction 6 / canal 12)
  Edge_T_LSB_PNB=0x00D1; //  Le rsultat de comptage est dans RAM canal 12 ($C)
  S_Pot_Num=0x0000;

/* Registre de squence de service	*/  
   HSQR0=0x0100;     	// Pour dfinir  PB4 secondaire -> 01   PB5 primaire ->  00
   HSRR0=0x0F00; 	// Pour initialiser et dmarrer le comptage: pour  PB5 -> 11   et pour PB4 -> 11  		
 /* Positionner les bits de priorit	*/
   CPR0=0x0F00;	// Priorits maxi pour les 2 canaux PB1-PB0 
    
 /* Boucle principale 
/*************************/    
do
	{Resultat=S_Pot_Num;
 	Resultat_D=(short)Resultat;
	clsscr();
	gotoxy(4,6);
	printf("           FAIRE TOURNER BOUTON Potentiometre numerique \n");
	printf("           -> LA MESURE POSITION DOIT EVOLUER\n");
	gotoxy(4,10);
		printf("Mesure position potentiometre numerique en inc ): %4.4x Hexa %5d Decimal\n",Resultat,Resultat_D);
	 for(i=200000;i>0;i--);				
	}while(1);	/* fin de la boucle principale */
} /* fin fonction principale */















 