	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  	Commande Moteur en mode courant 						*
	*												*			
	*   CAHIER DES CHARGES :					      		*
	*  ***************************					      	*	
	*   On souhaite donner  la vitesse du moteur le cycle suivant    	*
	*    de 0  +Vmax puis de +Vmax  -Vmax puis de +Vmax  +Vmax etc		*
	*   L'interface de puissance sera de type commande en courant		*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  Cde_Mot_Courant.C		       			*
	* *****************									*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"

/* Dclaration des variables globale */
WORD Val_Cde_Mot,i;
unsigned char Signe_Variation;
/*=========================
  *    Fonction principale          
  ===========================*/
main(void)
{
/* Initialisations */

/* Des registres du TPU pour configurer le bit PA0 -> ch0  (TPU0) en sortir PWM */	 
// Rem: Pour une commande en courant on place la commande en tension  100%
TPUMCR=0x0040; 		// tcr1 
CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0 7 
CFSR3=0x0009;     		//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch 0 donc sur PA0)
CTRL_TPU7=0x0091;  	// On utilise TCR1 
HSRR1=0x0002; 		// Initialisation canal	  
CPR1=0x0003;      		// Priorit haute pour ch0 -> PA0
Per_Cde_Mot=0x00FF;   	//  	Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00FF	
Cons_TM=0x00FF;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  100 %

/* De l'interface de puissance de commande moteur */
 Dir_PortC = 0x03; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot = 0;		// On commence en positif
 Cons_CM=0x00;		// On commence avec une consigne de courant nulle

/* De variables diverses du programme */
 Signe_Variation = 1;		// On souhaite une augmentation de la commande
 Val_Cde_Mot = 0x00;		// On commence avec avec une consigne nulle

/*   Boucle principale   */
/*************************/    
do	{  	i=20000;
		do {i--;}while(i>0);				// Attendre un certain temps pour limiter la pente de la rampe
		clsscr();
		gotoxy(4,10);
		printf(" Valeur commande: %d\n",Val_Cde_Mot);
		if (Signe_Cde_Mot)printf("    Signe  commande: <0 \n");
		else printf("    Signe  commande: >0 \n");

	            if(Signe_Variation==1)Val_Cde_Mot++;	// Incrmenter puisque sens variation > 0
		  else Val_Cde_Mot--;				// Dcrmenter puisque sens variation <0
		  Cons_CM=Val_Cde_Mot;			// Charger la valeur en consigne de Courant Moteur 
		if ((Signe_Variation==1)&&Val_Cde_Mot==5) Signe_Variation=0; 
		// Rem:  255 est la valeur maxi possible pour la consigne courant moteur (sortie analogique sur 8 bits
		if ((Signe_Variation==0)&&Val_Cde_Mot==0) 
			{Signe_Variation=1;			// Changement de signe de variation
			 Signe_Cde_Mot=! Signe_Cde_Mot;	// Changement de la polarit de la commande	    
			}
	}while(1);  /* Fin de la boucle principale */
} /* Fin fonction principale */

