	/************************************************************************
	*       TP sur  EID210 avec Interface pour Servo Mcanismes (ISM)		*
	*************************************************************************
	*  	Commande Moteur en mode tension (PWM)					*
	*												*			
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*	
	*   On souhaite donner  la vitesse du moteur le cycle suivant   		*
	*   de 0  +Vmax puis de +Vmax  -Vmax puis de +Vmax  +Vmax etc		*
	*   L'interface de puissance sera de type commande en tension		*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  Cde_Mot_Tension.C		       			*
	* ********************									*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"

/* Dclaration des variables globale */
int Val_Cde_Mot,i;
unsigned char Signe_Variation;
/*=========================
  *    Fonction principale          
  =========================*/
main(void)
{
/*  Initialisations  */
/* Des registres du TPU pour configurer le bit PA0 -> ch0  (TPU0) en sortir PWM */	 
TPUMCR=0x0040; 		// tcr1 
CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0 7 
CFSR3=0x0009;     		//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch 0 donc sur PA0)
CTRL_TPU0=0x0091;  	// On utilise TCR1 
HSRR1=0x0002; 		// Initialisation canal	  
CPR1=0x0003;      		// Priorit haute pour ch0 -> PA0
Per_Cde_Mot=0x00FF;   	//  	Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %
 			// C'est la Consigne Tension Moteur
/* De l'interface de puissance de commande moteur */
 Dir_PortC=0x03; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot=0;		// Commande Moteur en positif
/* Pour l'application*/
 Signe_Variation=1;		// Le module de la vitesse augmentera
Val_Cde_Mot=0;

/*   Boucle principale   */
/*************************/    
do
	{  	i=10000;
		do {i--;}while(i>0);				// Attendre un ceratin temps pour limiter la pente de la rampe
		clsscr();
		gotoxy(4,10);
		printf(" Valeur commande: %d\n",Val_Cde_Mot);
		if (Signe_Cde_Mot)printf("    Signe  commande: <0 \n");
		else printf("    Signe  commande: >0 \n");
	             if(Signe_Variation==1)Val_Cde_Mot++;	// Incrmenter puisque sens de variation <0
		   	else Val_Cde_Mot--;				// Dcrmenter puisque sens de variation <0
		Cons_TM=Val_Cde_Mot;			// Charger la valeur dans le registre adquat (Consigne Tension Moteur)
		if ((Signe_Variation==1)&&Val_Cde_Mot>=255) Signe_Variation=0; 	// Changer le signe de variation
		// Rem:  256 est la valeur maxi possible pour la commande moteur en PWM
		if ((Signe_Variation==0)&&Val_Cde_Mot==0) 
			{Signe_Variation=1;			// Changer signe de variation		
			 Signe_Cde_Mot=! Signe_Cde_Mot;	// Changer polarit de la commande	    
			}
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

