	/******************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)			*
	*******************************************************************************
	*  	Commande tension moteur par entre externe					*
	*													*
	*   CAHIER DES CHARGES :					      			*
	*  *********************									*    
	*   On souhaite que l'image de la tension aux bornes du moteur 			*
	*   suive la tension impose par l'entre analogique externe.    			*
	*   La tension U_cde_Ana_Ext est sur l'entre analogique EA2 dans la 		*
	*   plage +-10V											*
	*	-> La conversion A->N de U_cde_Ana_Ext est demande toutes les  mS	*
	*	-> Cette priode d'chantillonnage est impose par				*
	*	    le timer programmable en mode d'interruption				*
	*	-> Les 8bits MSB du rsultat devienne la consigne de U moteur		*
 	*----------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Cde_TMot_E_Ext.C		       				*
	* *****************										*
	*******************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"

/* Dclaration des variables globale */
WORD Val_Cde_Mot,i,resultat_conv,Compteur_passages;
signed short Valeur,Valeur2;
float Tension_Externe;
/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
==============================================================================*/
void irq_bt()
{	 if (Fin_Conv_AN==0)
		{resultat_conv=CAN;
		 resultat_conv=resultat_conv&0x0FFF;
		  if(resultat_conv&0x0800)
		      	// La consigne est ngative
		     	{ Signe_Cde_Mot=1;
		        	Valeur=(signed short)(resultat_conv|0xF000);
				resultat_conv=(~resultat_conv);
			 	// Appliquer la Consigne Tension Moteur (Commande en PWM)
		       	resultat_conv=(resultat_conv&0x0FFF);
				Cons_TM=(WORD)(resultat_conv>>3); 
		     	}
	  	  else 	// La consigne est positive	   
		     	{ Signe_Cde_Mot=0;
				Valeur=(signed short)(resultat_conv&0x0FFF);
				// Appliquer la Consigne Tension Moteur (Commande en PWM) 
		       	resultat_conv=resultat_conv&0x0FFF;
				Cons_TM=(WORD)(resultat_conv>>3); 
			}
  		CAN=0x005A; // Lancer la conversion de la voie n2 du CAN -> EA3 -> U_cde_Ana_Ext  dans plage +-10V
		}
  	CAN=0x005A; 	// Lancer la conversion de la voie n2 du CAN -> EA3 -> U_cde_Ana_Ext  dans plage +-10V
} // Fin de la dfinition de la fonction d'interruption pour la temporisation


/*==========================
  *    Fonction principale          
  =========================*/
main(void)
{
/* Initialisation des variables */
 Per_Cde_Mot=0x0100;   	//  	Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
 Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
			// C'est la Consigne Tension Moteur	 	
/* Des registres du TPU pour configurer le bit PA0 -> TPU0 -> ch0  en sortir PWM */	 
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0 7 
 CFSR3=0x0009;     	//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch0 donc sur PA0)
 CTRL_TPU0=0x0091;  	// On utilise TCR1  
 HSRR1=0x0002; 		// Initialisation canal	  
 CPR1=0x0003;      		// Priorit haute pour ch0 -> PA0
/* De l'interface de puissance de commande moteur */
 Dir_PortC=0x03; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 	// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot=0;		// Commande Moteur en positif
 Cons_CM = 0xFF;		// Le courant moteur sera limit  sa valeur maxi 
// On lance une premire conversion  
CAN=0x005A; 	// Lancer la conversion de la voie n2 du CAN -> EA3 -> U_cde_Ana_Ext  dans plage +-10V
/* Pour le timer programmable	*/
 SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
 PITR = 0x0008;		// Une interruption toutes les millisecondes 
 PICR = 0x0760; 		//  96 = 60H

/*   Boucle principale   */
/*************************/    
do	{ Compteur_passages++;
	 if(Compteur_passages>50000)
		{Compteur_passages=0;
		 // Calcul de la valeur de la tension applique 
		 Tension_Externe=(float)(Valeur);
		 Tension_Externe=(Tension_Externe/2048)*10;
	 	// Afdfichage message et valeurs
		 clsscr();
		 gotoxy(4,10);
		 printf("LA TENSION A APPLIQUER SUR L'ENTREE EXTERNE DOIT ETRE ENTRE -10V et +10V  \n");
		 gotoxy(4,12);
		 printf("Tension Externe = %2.2f Volts \n",Tension_Externe);
		 gotoxy(4,14);
		 printf("Commande Tension Moteur = %2.2x H = %2D Decimal\n",Cons_TM,Cons_TM);
		}
 	  	// On ne fait rien!... Le suivi se fait en interruption
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

