/*****************************************************************************
 *	Fichier de dclarations pour le moniteur de pilotage de l'ISM
 *          (Interface pour Servo Mcanisme)
 *
 *	Nom du fichier: Moniteur_ISM.h
 ******************************************************************************/
/**********************
    Les variables
**********************/
//  Pour le dialogue avec l'ordinateur matre
//-------------------------------------------------------------------
#define B_Taille_Max_Mes_Recep 255
int Adresse;
BYTE B_Rang_Mes_Recep;
BYTE B_Nb_Carac_Mes_Recep;
BYTE B_Rang_Pile_Recep;
//BYTE B_Rang_Buff_Recep;
BYTE B_Code_Erreur_Recep;
BYTE B_Rang_Mes_Emis,B_Nb_Carac_Mes_Emis;
BYTE *Ptr_B,B_Donnee;				// Pointeur sur BYTE et donne sur 8 bits (un BYTE)
WORD	*Ptr_W,W_Donnee;				// Pointeur sur WORD et donne sur 16 bits (un WORD)
char C_ASCII1,	C_ASCII2,C_ASCII3,C_ASCII4;		// Pour rsultat de conversion de mots binaire en codes ASCII
char C_ASCII5,	C_ASCII6,C_ASCII7,C_ASCII8;
char TC_Pile_Recep[255];				// Tableau Pile de rception de caractres
char TC_Mes_Recep[255];				// Tableau de caractres pour la rception d'un message
char TC_Mes_Emis[150];				// Tableau de caractres pour la rception d'un message

char C_MSB_Nb_Carac_Mes,C_LSB_Nb_Carac_Mes,C_Tempo,C_Type_Mes;

//  Pour l'tat du dialogue via liaison srie
union word_bits Etat_Dialog;
#define F_Message_Recu 	Etat_Dialog.bit.b0							
#define F_Attente_Recep 	Etat_Dialog.bit.b1	
#define F_Erreur_Recep 	Etat_Dialog.bit.b2
#define F_Autoris_Emis_Mes Etat_Dialog.bit.b3
#define F_Emis_En_Cours 	Etat_Dialog.bit.b4
#define F_Acq_Mis 		Etat_Dialog.bit.b5	// Pour acquiter suite  une missive
#define F_Mes_Erreur_Emis  Etat_Dialog.bit.b6
#define F_Pile_Recep_Vide	Etat_Dialog.bit.b7	// Il y a au moins un caractre dans la pile de rception
#define F_Pile_Recep_Pleine Etat_Dialog.bit.b8

//  Pour la commande Processus
//-----------------------------------------------------
BYTE B_Cde_TM;		// Pour Commande Tension Moteur 
BYTE B_Cde_TCE;		// Pour Commande Tension Charge Electrique			
#define B_Cde_CM Cons_CM		// Pour Commande Courant Moteur 
#define B_Cde_CCE Cons_CCE	// Pour Commande Courant (Charge Electrique
			
//  Pour l'tat de la commande processus
union word_bits Etat_Cde_Process;
#define F_Type_CM 	Etat_Cde_Process.bit.b0	// Type Commande Moteur	0 -> en Tension    1 -> en courant					
#define F_Type_CCE Etat_Cde_Process.bit.b1	// Type Commande  Charge Electrique  0 -> en Tension   1 ->  en Courant 						
#define F_Signe_Cde_Mot 	Signe_Cde_Mot	// Signe Commande Moteur
#define F_Signe_Cde_CE 	Signe_Cde_CE	// Signe Commande Charge Electrique
#define F_Valid_IP_Mot 	Valid_IP_Mot		// Validation interface Puissance Moteur
#define F_Valid_IP_CE 	Valid_IP_CE		// Validation interface Puissance Charge Electrique
		
		
//  Pour le rgulateur
//----------------------------------
// Consignes diverses
short S_Cons_Vit;		// Consigne vitesse sur 16 bits en sign
short S_Cons_Pos;		// Consigne Position sur 16 bits en sign

int I_Cons_PT;			// Consigne Position en profil Trapzodal de vitesse sur 32 bits signs
short S_Pos_Num,S_Pos_Num1;	// Image numrique de la position sur 16 bit signs
int I_Pos_Num;		// Image numrique de la position sur 32 bit signs
short S_Pos_Num_CV1;		// Pour capteur de vitesse
short S_Vit_Num,S_Vit_Num1;
short S_Cde_BO;
BYTE 	B_Type_Reg;			// Pour dfinir le type du rgulateur (0 -> P, 1->PI, 2->PD, 3 ->PD etc ...)
//  Pour le profil Trapzodal
#define W_Taille_Max_TDCT  16384				// 256 blocs de 64 BYTEs
signed char TC_Delta_Cons_PT[W_Taille_Max_TDCT];	// Tableau des Delta de Consigne position pour mode Profil Trapzodal
int I_Delta_Cons_PT;
WORD	W_Rang_TDCT,W_Taille_TDCT=1023;		// Pour la recherche des consignes dans Tableau Consigne en mode PT
// Pour le profil Sinusodal
#define W_Taille_Max_TCS  8192				// 256 blocs de 32 SHORTs	
signed short TS_Cons_Sinus[W_Taille_Max_TCS];	// Tableau des Consignes sinusoidales
short S_Cons_Sinus;
WORD	W_Rang_TCS,W_Taille_TCS=1023;		// Pour la recherche des consignes dans Tableau Consigne en mode PT
// Pour la fonction de correction
WORD	W_Reg_KP1,W_Reg_KP2,W_Reg_KI,W_Reg_KD;	// Pour les coefficients d'action de correction 
short S_Reg_SI,S_Reg_SI1,S_Reg_SP,S_Reg_SD,S_Reg_SR,S_Reg_SR1;	// Pour la valeur des sorties d'action  de correction du PID en sign sur 16 bits
short S_Action_Deriv_Mes,S_Ecart,S_Ecart1;
// Pour les diffrentes priodes d'chantillonnage
WORD	W_TEM,W_TER,W_TES,W_TET,W_TEV;	// Pour T chantillonnage: capt. Vitesse, de Mmorisation chant., du rgulateur, profil T., Sinus
WORD	W_Cptr_TEM,W_Cptr_TER,W_Cptr_TES,W_Cptr_TET,W_Cptr_TEV;	// Compteur passage dans fonction base de temps  
//  Pour l'tat du rgulateur
union word_bits Etat_Regulateur;
#define F_Reg_Mode_Pos 	Etat_Regulateur.bit.b0	// Regulateur en Mode Position						
#define F_Reg_Mode_Vit 	Etat_Regulateur.bit.b1	// Regulateur en Mode Vitesse						
#define F_Reg_Mode_Trap 	Etat_Regulateur.bit.b2	// Regulateur en Mode Trapzoidal   -> Sinon en Boucle ouverte
#define F_Prof_T_En_Cours 	Etat_Regulateur.bit.b3	// Un Profil Trapzodal est En Cours d'excution
#define F_Reg_Mode_BO	Etat_Regulateur.bit.b4	// Mode en Boucle Ouverte
#define F_Suivi_Cons_Sinus	Etat_Regulateur.bit.b5	// Suivre Consigne Sinusodale issue d'un tableau reu
#define F_Autoris_Reg	Etat_Regulateur.bit.b6	// Pour autoriser le fonctionnement du rgulateur
#define F_Action_Deriv_Mes	Etat_Regulateur.bit.b7	// Pour Action Drive sur Mesure et non sur l'cart
#define F_Mem_Ech_Pleine	Etat_Regulateur.bit.b8	// Si Mmoire chantillons Pleine
						
//    Pour la conversion des entres analogiques
//------------------------------------------------------------------------------
BYTE B_Rang_Voie_Ana;				// N de la voie en cours de conversion
WORD TS_Result_CAN[4];	// Uniquement les voies de 0  3 sont utiliss
#define S_Mes_TM TS_Result_Conv_AN[0]
#define S_Mes_CM TS_Result_Conv_AN[1]
#define S_U_Cde_Ext TS_Result_Conv_AN[2]
#define S_U_Pot TS_Result_Conv_AN[3]

//  Pour les sorties analogiques de mesure position et vitesse
BYTE B_CMMAP,B_CMMAV;		// Coefficient de Multiplication pour Mesure Analogique 			

// Pour la mise en mmoire des chantillons
#define W_Taille_Mem_Ech 1023				// La valeur maximun tant 65534
short TS_Pos_Mem[W_Taille_Mem_Ech+1];			// Tableau de mmorisation des chantillons de Position 
short TS_SR_Mem[W_Taille_Mem_Ech+1];			// Tableau de mmorisation des chantillons de Sortie Rgulateur 
WORD W_Rang_Mem_Echant;					// Rang pour mmoriser l'chantillon  venir

/*********************
    Les messages
*********************/
char Mes_Erreur[]="!06E     "; 
char Mes_OK[]="!06OK   "; 	// Message d'acquittement si message reu est correct 

/************************************
  Les prototypes des fonctions 
*************************************/
//  Fonctions de conversion
BYTE Conv_2ASCII_to_B(char,char);				// Pour cnvertir un mot de 8 bits cod ASCII en binaire
WORD Conv_4ASCII_to_B(char,char,char,char);		// Pour cnvertir un mot de 16 bits cod ASCII en binaire 
int Conv_6ASCII_to_B(char,char,char,char,char,char);	// Pour cnvertir un mot de 24 bits cod ASCII en binaire
void Conv_B_to_ASCII(BYTE);				// Pour convertir un mot binaire de 8 bits (un BYTE) en 2 codes ASCII
void Conv_W_to_ASCII(WORD);				// Pour convertir un mot binaire de 16 bits (un WORD) en 4 codes ASCII
void Conv_I_to_ASCII(int);					// Pour convertir un mot binaire de 32 bits (Integer) en 8 codes ASCII

// Fonction de traitement des missives
void Traiter_Missive_E(void);			// Ecrire une donne spcifie  une adresse spcifie
void Traiter_Missive_C(void);			// Consignes ou Commandes
void Traiter_Missive_D(void);		// Dfinir paramtre
void Traiter_Missive_R(void);		// configurer la fonction Rgulation		
// Fonction de traitement des requte
void Traiter_Requete_A(void);		// Acqurir variables diverses (entres analogiques, Sorties Rgualteur etc...)
void Traiter_Requete_L(void);		// Lire  une adresse spcifie
void Traiter_Requete_P(void);		// On demande l'image numrique de la position
void Traiter_Requete_T(void);		// Transfrer donnes mmorises
void Traiter_Requete_V(void);		// On demande l'image numrique de la vitesse

// Fonctions d'interruption
void Irq_Recep_Serie(void);
void Irq_Base_Temps(void);