	/********************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*********************************************************************************
	*  	Commande de l'ISM par missives et requtes			*
	*										*
	*   CAHIER DES CHARGES :					      		*
	*  ***************************					      		*
	*  Grer la communication srie afin de pouvoir commander l' ISM par	*
	*    ->  des missives: rception d'une information ou d'un ordre		*
	*    ->  des requtes: rception d'une demande d'information		*
	*  afin de piloter un asservissement	  					*
 	*---------------------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Moniteur_ISM.C			       		*
	* ********************								*
	*********************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "ISM.h"
#include "Structures_donnees.h"
#include "Moniteur_ISM.h"
#include <stdio.h>	// Pour pouvoir utiliser les fonctions de communication srie

/* Dclaration des variables globale */
BYTE B_i,B_Temp;
WORD W_i,W_Temp;

/*===========================
      LA FONCTION PRINCIPALE          
  ===========================*/
main(void)
{
/* Dclaration variables locales  la fonction main */
/* Initialisations */

/* Des registres du TPU pour configurer le bit PA0 -> ch0  (TPU7) en sortir PWM */	 
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// Pendant init pas de spcification de priorit sur ch 0 7 
 CFSR3=0x0009;     		//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch 0 donc sur PA0)
 CTRL_TPU7=0x0091;  	// On utilise TCR1  
 HSRR1=0x0002; 		// Initialisation canal	  
 CPR1=0x0003;      		// Priorit haute pour ch0 -> PA0
 Per_Cde_Mot=0x0100;   	//  	Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
 Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
			// C'est la Consigne Tension Moteur	 	
/* Des registres du TPU pour configurer le comptage sur signaux en quadrature de phase issu du codeur moteur
// bit PB0 -> ch8 (TPU8) en canal primaire et bit PB1 -> ch9 (TPU9) en canal secondaire */	 
/* Effacer les bits de priorit	*/
   CPR0=0x0000;	
/* Registre de Slection de la Fonction des canaux d'E/S  11  10  9   8	*/ 
   CFSR1=0x0066;	/* les bit PB1 et PB0  en QDEC en comptage de signaux en quadrature)  	*/
/* Initialisation des paramtres RAM	 */
  Pos_Mot=0x0000;
  Cor_PinS_AD1_Mot=0x0026;
  Edge_T_LSB_AD1_Mot=0x0011;
  Cor_PinS_AD2_Mot=0x0016;
  Edge_T_LSB_AD2_Mot=0x0011;
/* Registre de squence de service	*/  
   HSQR0=0x0008;     	// Pour dfinir  PB1 secondaire -> 01   PB0 primaire ->  00
   HSRR0=0x000F; 	// Pour initialiser et dmarrer le comptage: pour  PB1 -> 11   et pour PB0 -> 11  
 /* Positionner les bits de priorit	*/
   CPR0=0x000F;	// Priorits maxi pour les 2 canaux PB1-PB0 
  
/* De l'interface de puissance de commande moteur */
 //Dir_PortC=0xC2; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 //Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 //Signe_Cde_Mot=0;		// Commande Moteur en positif
  //Val_Cod = 0;			// Pour Valider l'interface codeur
  //Stb_Cod = 1 ;			// Pour valider le fonctionnement du codeur


/* Pour le dialogue srie avec ordinateur matre */
// Pour la reception des messages
F_Pile_Recep_Vide=1;
F_Pile_Recep_Pleine=0;
F_Attente_Recep=1;
F_Message_Recu=0;
F_Erreur_Recep=0;
B_Code_Erreur_Recep=0x30;
B_Nb_Carac_Mes_Recep=0;
B_Rang_Pile_Recep=0;
B_Rang_Mes_Recep=0;

// Pour l'mission de messages
F_Emis_En_Cours=0;
F_Autoris_Emis_Mes=0;
F_Mes_Erreur_Emis =0;
C_MSB_Nb_Carac_Mes=0x00;
C_LSB_Nb_Carac_Mes=0x00;
// Pour la fonction de rgulation
B_Type_Reg=0;	// On initialise en correcteur Type P  (1 ->PI; 2->PID; 3->PD etc...)
F_Autoris_Reg=0;	// On inhibe la fonction de rgulation
F_Suivi_Cons_Sinus=0;
W_Reg_KP1=1;	// Le coefficient d'action proportionnelle avant sommateur
W_Reg_KP2=1;	// Le coefficient d'action proportionnelle aprs sommateur
W_Reg_KI=0 ;	// Le coefficient d'action Intgrale
W_Reg_KD=0;	// Le coefficient d'action intgrale
 // Pour Dmarrer le cycle de conversion A->N
CAN=0x0040;
B_Rang_Voie_En_Cours=0;
// Pour base de temps
//***********************
//SetVect(96,&Irq_Base_Temps);	     	// mise en place de l'autovecteur 
//PITR = 0x0008;		// Une interruption toutes les millisecondes 
//PICR = 0x0760; 		//  96 = 60H

//   Pour la reception srie
//***************************
SCCR0 = 9;			// Pour la vitesse de transmission de 57600 bauds
//QIVR=98;			// Pour Dfinir le vecteur d'interruption liaison srie (en rception)
				// !!!! Il doit tre paire pour la liaison SCI
//ILSCI=5;			// Niveau de priorit 5  (Min 0  Max 7)
SetVect(98,&Irq_Recep_Serie);	     	// mise en place du vecteur d'interruption 
QSMCR=0x0005;		// Positionner le IARB -> Priorit 
QILR=0x0562;		// 0x62=98         QILR=ILSCI/QIVR
SCCR1= 0x002C;		// Pour valider l'mission et la rceptionn srie et les interruptions en rception

// Pour Debug
S_Reg_SD=0x0101;
S_Reg_SI=0x0202;
S_Reg_SP=0x0303;
S_Reg_SR=0x0404;
for(W_i=0;W_i<1024;W_i++)TS_Pos_Mem[W_i]=W_i;
for(W_i=0;W_i<1024;W_i++)TS_SR_Mem[W_i]=W_i+0x10;
W_Rang_Mem_Echant=34;

/******************************/
/*   BOUCLE PRINCIPALE    */
/******************************/    
do
	{  //   Traiter la rception des messages
	   //****************************************
	
	if(F_Attente_Recep)
	{	if(F_Pile_Recep_Vide==0)
			{SCCR1=SCCR1 & 0xFFDF;				// Dbut de la section critique, on inhibe les interruptions en rception
			B_Rang_Pile_Recep--;
			C_Tempo=TC_Pile_Recep[B_Rang_Pile_Recep];	// On rcupre le caractre reu
				printf("%c",TC_Mes_Recep[0]);
			printf("%c",TC_Mes_Recep[1]);
			printf("%c",TC_Mes_Recep[2]);
			printf("%c",TC_Mes_Recep[3]);
			printf("%c",TC_Mes_Recep[4]);
			printf("%c",TC_Mes_Recep[5]);			
			printf("%c",TC_Mes_Recep[6]);
			printf("%c",TC_Mes_Recep[7]);
			printf("%c",TC_Mes_Recep[8]);
			printf("%c",TC_Mes_Recep[9]);
			printf("%c",TC_Mes_Recep[10]);
			printf("%c",TC_Mes_Recep[11]);
			printf("%c|\n",TC_Mes_Recep[12]);

			printf("C=  %c   rang = %d\n",C_Tempo,B_Rang_Mes_Recep);
			TC_Mes_Recep[B_Rang_Mes_Recep]=C_Tempo;
			
			printf("%c",TC_Mes_Recep[0]);
			printf("%c",TC_Mes_Recep[1]);
			printf("%c",TC_Mes_Recep[2]);
			printf("%c",TC_Mes_Recep[3]);
			printf("%c",TC_Mes_Recep[4]);
			printf("%c",TC_Mes_Recep[5]);			
			printf("%c",TC_Mes_Recep[6]);
			printf("%c",TC_Mes_Recep[7]);
			printf("%c",TC_Mes_Recep[8]);
			printf("%c",TC_Mes_Recep[9]);
			printf("%c",TC_Mes_Recep[10]);
			printf("%c",TC_Mes_Recep[11]);
			printf("%c|\n",TC_Mes_Recep[12]);

			F_Pile_Recep_Pleine=0;	
			if(B_Rang_Pile_Recep==0)F_Pile_Recep_Vide=1;	// Si le rang est nul c'est que la pile est vide
			SCCR1=SCCR1|0x0020;				// Fin de la section critique, on autorise  nouveau les interruptions en rception
			if(B_Rang_Mes_Recep==0)	 			// Si c'est Le premier caractre reu, ce doit tre soit ! soit ?
			  	{if((C_Tempo=='!')||(C_Tempo=='?')) 		// Ce sont les caractres de synchronisation
					{C_Type_Mes=C_Tempo;		// C'est le type du message
					 B_Rang_Mes_Recep++;
					 F_Mes_Erreur_Emis=0;
					 F_Erreur_Recep=0;
					 B_Code_Erreur_Recep=0x30;
					}		// En fait, aprs avoir envoy un message d'erreur, on attend de recevoir le bon type
				  else 	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x01;
				  	F_Autoris_Emis_Mes=1;		// On envoie un message erreur sur type
				 	F_Erreur_Recep=1;}
				}	
	  	  	else if(B_Rang_Mes_Recep==1)	
				{C_MSB_Nb_Carac_Mes=C_Tempo;		// C'est l'ASCII du MSB Nombre de Caractres constituant le message 
				 B_Rang_Mes_Recep++;}	
			else if(B_Rang_Mes_Recep==2)		
				{C_LSB_Nb_Carac_Mes=C_Tempo;		// C'est l'ASCII du LSB Nombre de Caractres constituant le message 
				   B_Rang_Mes_Recep++;
				   B_Nb_Carac_Mes_Recep=Conv_2ASCII_to_B(C_MSB_Nb_Carac_Mes,C_LSB_Nb_Carac_Mes);
				   if(B_Code_Erreur_Recep!=0x30) // Si erreur dans codes nombre, on rinitialise la rception message
				  		{ F_Autoris_Emis_Mes=1;	// On envoie un message erreur sur nombre
						  F_Erreur_Recep=1;}
				}
			else if(B_Rang_Mes_Recep==B_Nb_Carac_Mes_Recep)	// On a reu le nombre prvu de caractres
				{F_Message_Recu=1;
				 F_Attente_Recep=0;}	
			else if(B_Rang_Mes_Recep>B_Nb_Carac_Mes_Recep)	// C'est anormal de recevoir plus de caractres que prvu!
				{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x02;
				F_Autoris_Emis_Mes=1;
				F_Erreur_Recep=1;}			// On envoie un message erreur sur nombre
		 	else	{B_Rang_Mes_Recep++;
				}
			}
	} // Fin traiter rception

	if(F_Message_Recu) 		// Si message reu , alors on le traite
	
	//   Traiter le message reu
	//******************************
	{ 	if(TC_Mes_Recep[B_Rang_Mes_Recep]!=0x0D)			// On teste si le caractre de fin de message est un CR (Retour Chariot)
			{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x04;	// On positionne le bit d'erreur sur le caractre fin de chane
			 F_Erreur_Recep=1;
			}
		  else // Le message peut tre analys
			if(C_Type_Mes=='!')
			/*   C'est une missive
			*************************/
			{
			switch (TC_Mes_Recep[3])		// On teste le caractre code message
				{case 'C' :	{Traiter_Missive_C();		// Consignes ou Commandes processus
						break;}
				case 'D':	{ Traiter_Missive_D();		// Dfinir  un paramtre
 						break;	}
				case 'E':	{ Traiter_Missive_E();		// Ecrire une donne spcifie  une adresse spcifie 
 						break;	}
				case 'R':	{Traiter_Missive_R();		// configurer et commander la fonction de Rgulation
						break;	}
				default :	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
			 			F_Erreur_Recep=1;}		// On envoie un message "erreur code message"
				}
			F_Acq_Mis=1;		// Pour envoyer un message d'acquitement missive
			} // Fin traitement missive
			else if(C_Type_Mes=='?')
			 /*   C'est une requte
			***************************/
			{switch (TC_Mes_Recep[3])	// On teste le caractre code message
				{case 'A':	{ Traiter_Requete_A();  	// Acqurir la valeur d'une entre analogique
						break;}
				case 'L':	{ Traiter_Requete_L(); 	// Lecture  une adresse spcifie
						break;}				
				case 'P':	{ Traiter_Requete_P(); 	// On demande l'image numrique de la position soit sur16b soit sur 32b
						break;}			
				case 'T':	{Traiter_Requete_T(); 		// Transferer des donnes mmorises
						break;}	
				case 'V':	{ Traiter_Requete_V();  	// On demande l'image numrique de la vitesse  sur 16 bits
						break;	}
				default :	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
			 			F_Erreur_Recep=1;}	// On envoie un message erreur code message
				}
			} // Fin traitement requte
			else 	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
			 		F_Erreur_Recep=1;}
	F_Message_Recu=0;		// Le message a t trait
	F_Autoris_Emis_Mes=1;	// On autorise l'envoi d'un message en rponse
	
	} // Fin traitement message reu

//  Traiter l'emission des messages
	//**************************************
	if(F_Emis_En_Cours==0)
	{	if(F_Autoris_Emis_Mes)
		{	if(F_Erreur_Recep)
				{	/* Envoyer message d 'erreur en reception */
		 		  for(B_i=0;B_i<=B_Nb_Carac_Mes_Emis-2;B_i++)TC_Mes_Emis[B_i]=Mes_Erreur[B_i];
	 	 		  TC_Mes_Emis[4]=B_Code_Erreur_Recep;
	  			  TC_Mes_Emis[5]=0x0D;		// C'est le code du CR (retour chariot)
				  TC_Mes_Emis[6]=0x0A;		// C'est le code du LF (passage   ligne suivante) 
				  B_Nb_Carac_Mes_Emis=6;
				  B_Rang_Mes_Emis=0;
				  F_Erreur_Recep=0;
				  if(F_Mes_Erreur_Emis==0)
					{F_Mes_Erreur_Emis=1; 	// Pour indiquer qu'un message d'erreur a t mis
				  	F_Emis_En_Cours=1; }
				}		
			else if(F_Acq_Mis)
	 			{ 	/* Envoyer message de reception OK pour acquiter suite  une missive bien reue et excute */
		  		  for(B_i=0;B_i<=B_Nb_Carac_Mes_Emis-2;B_i++)TC_Mes_Emis[B_i]=Mes_OK[B_i];
	 			  TC_Mes_Emis[5]=0x0D;		// C'est le code du CR (retour chariot)
				  TC_Mes_Emis[6]=0x0A;
				  F_Acq_Mis=0;			// C'est le code du LF (passage   ligne suivante) 
				  B_Nb_Carac_Mes_Emis=6;
				  F_Emis_En_Cours=1;}
	 	 	/* C'est une rponse  une requte  -> il n'y a rien de spcial  faire car le message  envoyer est prt !*/
			else	{F_Emis_En_Cours=1;}
			/* Dans tous les cas */
			F_Autoris_Emis_Mes=0;
			B_Rang_Mes_Emis=0;			// On initialise le compteur de caractres mis
		}
	} // Fin initialisation pour envoi message
	else  // Si on est en cours d'mission message
	{	if(SCSR&TDRE)  // Si Emission libre
			{ SCDR=TC_Mes_Emis[B_Rang_Mes_Emis];	// Charger le caractre  mettre
			   if(B_Rang_Mes_Emis>=B_Nb_Carac_Mes_Emis) 
				{ F_Emis_En_Cours=0;		// On a fini d'mettre
				  F_Attente_Recep=1;			// On se prpare pour recevoir un nouveau message
				  B_Rang_Mes_Recep=0;
				  B_Code_Erreur_Recep=0x30;
				  F_Erreur_Recep=0;}
			  else B_Rang_Mes_Emis++;
			}
	}// Fin Emission en cours

//  Traiter la conversion des voies analogiques
	//**************************************************
	if(Fin_Conv_AN==0);						// La conversion lance le coup d'avant est termine
		{ TS_Result_Conv_AN[B_Rang_Voie_En_Cours]=CAN&0X0FFF;	// Rcuprer le rsultat de conversion sur 12b de la voie en cours
		if(B_Rang_Voie_En_Cours==5)B_Rang_Voie_En_Cours=0;
		else B_Rang_Voie_En_Cours++;
		switch (B_Rang_Voie_En_Cours)
			{case 0 : 	{CAN=0x0058; // Lancer conversion voie 0  dans la plage +-10V   -> Mes_TM  (Tension Moteur) 
					break;}
			case 1 : 	{CAN=0x0059; // Lancer conversion voie 1  dans la plage +-10V   -> Mes_CM  (Courant  Moteur)
					break;}
			case 2 : 	{CAN=0x005A; // Lancer conversion voie 2  dans la plage +-10V   -> U_Cde_Ext  (tension Commande Externe)
					break;}
			case 3 : 	{CAN=0x0043; // Lancer conversion voie 3  dans la plage  0 5V?	-> U_Pot_Int	(Tension potentiomtre interne)
					break;}
			default:	{}}
		}
	// Mise  jour des sorties analogiques image position et vitesse
	Mes_IP=((char)(S_Pos_Num<<B_CMMAP))+0x80;
	Mes_IV=((char)(S_Vit_Num<<B_CMMAV))+0x80;



	}while(1); /* fin de la boucle principale */
	




} /* fin fonction principale */


/*--------------------------------------------------------------
    LES FONCTIONS D'INTERRUPTIONS
------------------------------------------------------------------*/

/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void Irq_Base_Temps()
{
// Pour la mesure de la vitesse
W_Cptr_TEV--;
if(W_Cptr_TEV==0)		// le Temps d'Echantillonnage capteur Vitesse
	{S_Vit_Num=(S_Pos_Num-S_Pos_Num_CV1);
	 W_Cptr_TEV=W_TEV;
	S_Pos_Num_CV1=S_Pos_Num;}
// Pour la fonction de rgulation et de mmorisation des chantillons si active
if(F_Autoris_Reg)		// La fonction de rgulation est active ainsi que la mmorisation des chantillons
	{ // Pour l'application d'une consigne sinus si active ( partir d'un tableau communiqu)
	if(F_Suivi_Cons_Sinus)
		{W_Cptr_TES--;
		if(W_Cptr_TES==0)	// le Temps d'Echantillonnage de consigne Sinus est atteinte
			{W_Cptr_TES=W_TES;
			if(F_Reg_Mode_Pos)S_Cons_Pos=TS_Cons_Sinus[W_Rang_TCS];		// On cherche Consigne Position dans le tableau
			else if(F_Reg_Mode_Vit)S_Cons_Vit=TS_Cons_Sinus[W_Rang_TCS];	// On cherche Consigne Vitesse dans le tableau
			else if(F_Reg_Mode_BO)S_Cde_BO=TS_Cons_Sinus[W_Rang_TCS];	// On cherche Consigne Boucle Ouverte dans le tableau
			if(W_Rang_TCS<W_Taille_TCS)W_Rang_TCS++;				// Tableau Consigne Sinus
		        		else W_Rang_TCS=0;}					
		} // Fin application consigne Sinus
	// Pour l'application en profil Trapzodal
	if(F_Prof_T_En_Cours)
		{W_Cptr_TET--;
		if(W_Cptr_TET==0)	// le Temps d'Echantillonnage de profil Trapzodal
			{W_Cptr_TET=W_TET;
			I_Delta_Cons_PT=(int)(TC_Delta_Cons_PT[W_Rang_TDCT]); 
			I_Cons_PT=I_Cons_PT+I_Delta_Cons_PT;
			if(W_Rang_TDCT<W_Taille_TDCT)W_Rang_TDCT++;		// Tableau Delta Consigne Profil Trapzodal
				else F_Prof_T_En_Cours=0;}					// On a atteint la fin du tableau
		} // Fin application Profil Trapzodal
	// Pour la fonction de rgulation
	W_Cptr_TER--;
	if(W_Cptr_TER==0)	// le Temps d'Echantillonnage Rgulateur
		{ W_Cptr_TER=W_TER;
		if(F_Reg_Mode_BO==0)	// Si on n'est pas en boucle ouvert, on est donc en boucle ferme
		 	{if(F_Reg_Mode_Pos)	S_Ecart = (S_Cons_Pos - S_Pos_Num);	// Si Reg Position, calcul ecart en position 
	 		else if(F_Reg_Mode_Vit) S_Ecart = (S_Cons_Vit - S_Vit_Num);	// Si Reg Vitesse, calcul ecart en vitesse
			else if(F_Reg_Mode_Trap)						// Si Reg Profil Trapzoidal
				{ S_Ecart = (I_Cons_PT - I_Pos_Num);}			// Calcul Ecart  partir consigne dans tableau
			else S_Ecart =0;
			// Calcul des diverses action de correction
			S_Reg_SP=(short)(S_Ecart * W_Reg_KP1);				// Calcul de la sortie de l'action Proportionnel	
			S_Reg_SI=S_Reg_SI1+(short)(S_Ecart * W_Reg_KI);		// Calcul de la sortie de l'action Intgrale
			if(S_Reg_SI>+255)S_Reg_SI=255;					// Sturation de l'action Intgrale
			if(S_Reg_SI<-255)S_Reg_SI=-255;
			if(F_Action_Deriv_Mes==0)S_Reg_SD=(short)(W_Reg_KD*(S_Ecart -S_Ecart1));  	// Action Drive sur l'cart  
		 	else 	{ if(F_Reg_Mode_Vit) S_Action_Deriv_Mes=(S_Vit_Num - S_Vit_Num1); 	// Calcul drive de la mesure vitesse
				 else S_Action_Deriv_Mes=(short)(S_Pos_Num - S_Pos_Num1); 		// Calcul drive de la mesure position
			 	S_Reg_SD=(short)(W_Reg_KD*S_Action_Deriv_Mes);}			// Calcul de la sortie de l'action drive
	 		// Calcul de l'action de correction globale
			if(B_Type_Reg==0) S_Reg_SR=(short)(W_Reg_KP2*S_Reg_SP);	// C'est un type P	
	 		else if(B_Type_Reg==1) S_Reg_SR=(short)(W_Reg_KP2*(S_Reg_SP+S_Reg_SI));		// C'est un type PI	
	 		else if(B_Type_Reg==2) S_Reg_SR=(short)(W_Reg_KP2*(S_Reg_SP+S_Reg_SI+S_Reg_SD));	// C'est un type PID/Ecart
			else if(B_Type_Reg==3) S_Reg_SR=(short)(W_Reg_KP2*(S_Reg_SP+S_Reg_SD));		// C'est un type PD/Ecart	
	 		else if(B_Type_Reg==4) S_Reg_SR=(short)(W_Reg_KP2*(S_Reg_SP+S_Reg_SI+S_Reg_SD));	// C'est un type PID/Ecart
			else if(B_Type_Reg==5) S_Reg_SR=(short)(W_Reg_KP2*(S_Reg_SP+S_Reg_SD));		// C'est un type PD/Ecart
			else S_Reg_SR=0;
			// Mise  jour des valeurs mmorises
			S_Pos_Num1=S_Pos_Num;		
			S_Vit_Num1=S_Vit_Num;
			S_Reg_SI1=S_Reg_SI;
			S_Ecart1=S_Ecart;		// Fin fonction rgulation
			} // Fin de on n'est pas en boucle ouverte (donc on est en boucle ferme)
		else S_Reg_SR=S_Cde_BO;		// On est en Boucle Ouverte
		// Gestion des saturations et application en sortie
		if (S_Reg_SR>0)
			{Signe_Cde_Mot=0;		// Commande du moteur en positif
	  			if(S_Reg_SR>255) 
					{Cons_TM=0x00FF;
					Cons_CM=0x00FF;
	 	 			S_Reg_SR = 255;}
	    			else if(F_Type_CM)Cons_CM=(WORD)(S_Reg_SR); 
					else Cons_TM=(WORD)(S_Reg_SR); }
  		else 	{Signe_Cde_Mot=1;		// Commande du moteur en ngatif
	  			if(S_Reg_SR< -255) 
					{Cons_TM=0x00FF;
					Cons_CM=0x00FF;
	 	 			S_Reg_SR = -255;}
	    			else if(F_Type_CM)Cons_CM=(WORD)((~S_Reg_SR)+1);
					else Cons_TM=(WORD)((~S_Reg_SR)+1);}
		S_Reg_SR1=S_Reg_SR; 		// Actualisation de la valeur mmorise de SR
		}
	// Mmorisation des chantillons
	if(F_Mem_Ech_Pleine==0)	// La mmoire n'est pas pleine donc on continue de mmoriser
		{W_Cptr_TEM--;	
		if(W_Cptr_TEM==0)	// le Temps d'Echantillonnage de mmorisation
			{W_Cptr_TEM=W_TEM;
			TS_Pos_Mem[W_Rang_Mem_Echant]=S_Pos_Num;
			TS_SR_Mem[W_Rang_Mem_Echant]=S_Reg_SR;
			W_Rang_Mem_Echant++;
			if(W_Rang_Mem_Echant>W_Taille_Mem_Ech)F_Mem_Ech_Pleine==1;}
		} //  Fin mmorisation des chantillons
	} // Rgulation et mmorisation
} // Fin de la dfinition de la fonction d'interruption de base temps


/*  Fonction d'intruption associe  la Rception srie
*************************************************************/
void Irq_Recep_Serie(void)
{ 	if(SCSR&RDRF)							// Un caractre vient d'tre reu
		{TC_Pile_Recep[B_Rang_Pile_Recep]=(char)SCDR; 	// On mmorise le caractre dans la pile
		if(F_Pile_Recep_Pleine==0)	
		{B_Rang_Pile_Recep++;					// On pointe la case vide suivante
		F_Pile_Recep_Vide=0;}					// La pile n'est pas vide
		if(B_Rang_Pile_Recep==0xFF)F_Pile_Recep_Pleine=1;}	// Il y a saturation de la pile au del de 255 caractres dedans
} // Fin fonction d'interruption associe  la communication srie 


/*-------------------------------------------------------------
    LES  FONCTIONS DE CONVERSION
  -------------------------------------------------------------*/
/* Fonction de conversion de 2 codes Hexa en ASCII vers un octet sur 8bits 
***********************************************************************************/
BYTE Conv_2ASCII_to_B(char Code_ASCII1,char Code_ASCII0)
{		 
BYTE	B_Resultat_Conv=0;
  // Conversion du caractre de poids fort
  if((Code_ASCII1>=0x30)&&(Code_ASCII1<=0x39))				// Test si quartet MSB est un chiffre
	{ B_Resultat_Conv=(Code_ASCII1&0x0F)<<4;  }
     else if((Code_ASCII1>=0x41)&&(Code_ASCII1<=0x46)) 			 // Test si quartet MSB est une lettre HEXA (entre A et F)
	   { B_Resultat_Conv=((Code_ASCII1&0x0F)+9)<<4;}
 	  else	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x32;}	// Si c'est pas un caractre Hexa, on positionne bit erreur
  // Conversion du caractre de poids faible 
    if((Code_ASCII0>=0x30)&&(Code_ASCII0<=0x39))				// Test si quartet LSB est un chiffre
	{ B_Resultat_Conv=B_Resultat_Conv|(Code_ASCII0&0x0F);  }
     else if((Code_ASCII0>=0x41)&&(Code_ASCII0 <= 0x46))  			// Test si quartet LSB est une lettre HEXA (entre A et F)
	   { B_Resultat_Conv=B_Resultat_Conv|((Code_ASCII0&0x0F)+9); }
 	  else	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x32; } 	// Si c'est pas un caractre Hexa, on positionne bit erreur
return B_Resultat_Conv;
} // Fin de la fonction de conversion

/* Fonction de conversion de 4 codes Hexa en ASCII vers un mot binaire sur 16 bits 
*******************************************************************************************/
WORD Conv_4ASCII_to_B(char Code_ASCII3,char Code_ASCII2,char Code_ASCII1,char Code_ASCII0)
{  WORD W_Resultat_Conv;
  W_Resultat_Conv=(WORD)(Conv_2ASCII_to_B(Code_ASCII1,Code_ASCII0));
  W_Resultat_Conv=(WORD)(W_Resultat_Conv|(Conv_2ASCII_to_B(Code_ASCII3,Code_ASCII2)<<8));
  return W_Resultat_Conv;
 }// Fin de la fonction de conversion

/* Fonction de conversion de 6 codes Hexa en ASCII vers un mot binaire sur 24 bits (cas d'une adresse)
*****************************************************************************************************************/
int Conv_6ASCII_to_B(char Code_ASCII5,char Code_ASCII4,char Code_ASCII3,char Code_ASCII2,char Code_ASCII1,char Code_ASCII0)
 {int A_Resultat_Conv;
   A_Resultat_Conv=(int)(Conv_2ASCII_to_B(Code_ASCII1,Code_ASCII0));
   A_Resultat_Conv=(int)(A_Resultat_Conv|(Conv_2ASCII_to_B(Code_ASCII3,Code_ASCII2)<<8));
   A_Resultat_Conv=(int)(A_Resultat_Conv|(Conv_2ASCII_to_B(Code_ASCII5,Code_ASCII4)<<16));
   return A_Resultat_Conv;
  }// Fin de la fonction de conversion


/* Fonction de conversion d'un mot binaire sur 8 bits vers 2 codes  ASCII  (C_ASCII2 et C_ASCII1)
**********************************************************************************************************/
void Conv_B_to_ASCII(BYTE B_Code_8b)
{char B_Code_MSB;
 B_Code_MSB=(B_Code_8b&0xF0)>>4;
 B_Code_8b=B_Code_8b&0x0F;
	if(B_Code_8b<0x0A)C_ASCII1= B_Code_8b|0x30; 		// Les LSB donne un chiffre
	else C_ASCII1= (B_Code_8b-0x09)|0x40; 			// Les LSB donne une lettre (entre A et F)
	if(B_Code_MSB<0x0A)C_ASCII2= B_Code_MSB|0x30; 	// Les MSB donne un chiffre
	else C_ASCII2= (B_Code_MSB-0x09)|0x40; 			// Les MSB donne une lettre (entre A et F)
} // Fin de la fonction de conversion


/* Fonction de conversion d'un mot binaire sur 16 bits (un WORD) vers 4 codes  ASCII (C_ASCII4  C_ASCII1)
**********************************************************************************************************************/
void Conv_W_to_ASCII(WORD W_Code_16b)
{BYTE B_Code_Temp;
 B_Code_Temp=(BYTE)(W_Code_16b>>8);			// Pour isoler les 8 bits de poids fort
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids fort
 C_ASCII4=C_ASCII2;
 C_ASCII3=C_ASCII1;
 B_Code_Temp=(BYTE)(W_Code_16b&0x00FF);		// Pour isoler les 8 bits de poids faible
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids faible
} // Fin de la fonction de conversion


/* Fonction de conversion d'un mot binaire sur 32 bits (un Integer vers 8 codes  ASCII (C_ASCII8  C_ASCII1)
***********************************************************************************************************************/
void Conv_I_to_ASCII(int I_Code_32b)
{BYTE B_Code_Temp;
 B_Code_Temp=(BYTE)(I_Code_32b>>24);			// Pour isoler les 8 bits de poids fort
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids fort
 C_ASCII8=C_ASCII2;
 C_ASCII6=C_ASCII1;
 B_Code_Temp=(BYTE)(I_Code_32b>>16);			// Pour isoler les 8 bits de poids mdians
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids mdians
 C_ASCII5=C_ASCII2;
 C_ASCII4=C_ASCII1;
 B_Code_Temp=(BYTE)(I_Code_32b>>8);			// Pour isoler les 8 bits de poids mdians
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids mdians
 C_ASCII3=C_ASCII2;
 C_ASCII2=C_ASCII1;
 B_Code_Temp=(BYTE)(I_Code_32b&0x00FF);		// Pour isoler les 8 bits de poids faibles
 Conv_B_to_ASCII(B_Code_Temp);				// Pour convertir en ASCII l'octet de poids faibles
} // Fin de la fonction de conversion


/*--------------------------------------------------------------------------------
      FONCTION DE TRAITEMENT DES MISSIVES
  --------------------------------------------------------------------------------*/
/*  Fonction de traitement de la missive 'C'  (Consignes et commandes)
******************************************************************************/
void Traiter_Missive_C(void)
{if(TC_Mes_Recep[4]=='B')						// C'et la commande en BO
		{if(TC_Mes_Recep[5]=='O') 				// C'est une Commande Courant Moteur
			{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9]);
			if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else S_Cde_BO=W_Donnee;}		// On rcupre le module de la commande
		else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;// On positionne le bit d'erreur sur le code message
			 F_Erreur_Recep=1;}				// On envoie un message "erreur code message"
		}
else 	if(TC_Mes_Recep[4]=='V')					// C'est une consigne de Vitesse
	{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[5],TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8]);
 	if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
	else  S_Cons_Vit=(short)(W_Donnee);}			// On affecte la consigne rcupre sur 16 bits
else 	if(TC_Mes_Recep[4]=='P') 					// C'est une consigne de Position
	{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[5],TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8]);
 	if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
	else S_Cons_Pos=(W_Donnee);}				// On affecte la consigne rcupre sur 16 bits
else 	if(TC_Mes_Recep[4]=='R') 					// C'est le tableau de consigne d'asservissement
		{if(TC_Mes_Recep[5]=='T') 				// en mode profil Trapzodal
			{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7]);	// On rcupre le n du bloc (un bloc c'est 128 char)
			W_Donnee=(WORD)(B_Donnee*64);		// Donne le rang dans le tableau (c'est un tableau de char donc 128/2=64
		       	if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
			else	{for(B_i=8;B_i<=134;B_i=B_i+2)
					{W_Rang_TDCT=W_Donnee+(B_i -8);	
					B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[B_i],TC_Mes_Recep[B_i+1]);
					if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
					else TC_Delta_Cons_PT[W_Rang_TDCT]=B_Donnee;}}
			}

		else if(TC_Mes_Recep[5]=='S') 			// en mode profil Sinusodal
			{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7]);	// On rcupre le n du bloc (un bloc= 128 char)
			W_Donnee=(WORD)(B_Donnee*32);		// Donne le rang dans le tableau (c'est un tableau de short donc 128/4=32
		       	if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
			else	{for(B_i=8;B_i<=134;B_i=B_i+4)
					{W_Rang_TCS=W_Donnee+(B_i -8);	
					W_Temp=Conv_4ASCII_to_B(TC_Mes_Recep[B_i],TC_Mes_Recep[B_i+1],TC_Mes_Recep[B_i+2],TC_Mes_Recep[B_i+3]);
					if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
					else TS_Cons_Sinus[W_Rang_TCS]=W_Temp;}}
			}
		else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
		 F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
		}
else 	if(TC_Mes_Recep[4]=='C')					
		{if(TC_Mes_Recep[5]=='M') 				// C'est une Commande Courant Moteur
			{if(TC_Mes_Recep[6]=='+') 
				{F_Signe_Cde_Mot=0;			// C'est une Commande positive
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_CM=B_Donnee;}		// On rcupre le module de la commande
			else if(TC_Mes_Recep[6]=='-') 
				{F_Signe_Cde_Mot=1;			// C'est une Commande ngative
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_CM=B_Donnee;}		// On rcupre le module de la commande
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
				F_Erreur_Recep=1;}			// On envoie un message "erreur code message"
			}
		else if(TC_Mes_Recep[5]=='C') 			// C'est une Commande Courant Charge Electrique
			{if(TC_Mes_Recep[6]=='+') 
				{F_Signe_Cde_CE=0;			// C'est une Commande positive
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_CCE=B_Donnee;}	// On rcupre le module de la commande
		 	else if(TC_Mes_Recep[6]=='-') 
				{F_Signe_Cde_CE=1;			// C'est une Commande ngative
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_CCE=B_Donnee;}			// On rcupre le module de la commande
		 	else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
		          		F_Erreur_Recep=1;}			// On envoie un message "erreur code message"
			}
		else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;// On positionne le bit d'erreur sur le code message
			 F_Erreur_Recep=1;}				// On envoie un message "erreur code message"
		}
else if(TC_Mes_Recep[4]=='T')					
		{if(TC_Mes_Recep[5]=='M') 				// C'est une Commande Tension Moteur
			{if(TC_Mes_Recep[6]=='+') 
				{F_Signe_Cde_Mot=0;			// C'est une Commande positive
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_TM=B_Donnee;}		// On rcupre le module de la commande
		 	else if(TC_Mes_Recep[6]=='-') 
				{F_Signe_Cde_Mot=1;			// C'est une Commande ngative
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_TM=B_Donnee;}			// On rcupre le module de la commande
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
				F_Erreur_Recep=1;}				// On envoie un message "erreur code message"
			}
		else if(TC_Mes_Recep[5]=='C') 				// C'est une Commande Tension Charge Electrique
			{if(TC_Mes_Recep[6]=='+') 
				{F_Signe_Cde_CE=0;				// C'est une Commande positive de la Charge Electrique
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_TCE=B_Donnee;}		// On rcupre le module de la commande
		 	else if(TC_Mes_Recep[6]=='-') 
				{F_Signe_Cde_CE=1;				// C'est une Commande ngative de la Charge Electrique
				B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8]);
				if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;
				else B_Cde_TCE=B_Donnee;}		// On rcupre le module de la commande
			 else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
			 	F_Erreur_Recep=1;}				// On envoie un message "erreur code message"
			}
		else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;// On positionne le bit d'erreur sur le code message
			  F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
		}
else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;// On positionne le bit d'erreur sur le code message
          F_Erreur_Recep=1;}							// On envoie un message "erreur code message"	
} // Fin de la fonction de traitement de la missive 'C'

/*  Fonction de traitement de la missive 'D'  (Dfinir un paramtre)
******************************************************************************/
void Traiter_Missive_D(void)
{if(TC_Mes_Recep[4]=='C')	// pour dfinir Coefficient
	{if(TC_Mes_Recep[5]=='M') // Multiplication
		{if(TC_Mes_Recep[6]=='M') // Mesure
			{if(TC_Mes_Recep[7]=='P') // Position
				{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[8],TC_Mes_Recep[9]);
		    		if(B_Code_Erreur_Recep!=0x30) 
					F_Erreur_Recep=1;					// Si erreur on envoie un message "erreur sur nombre"
				else 	B_CMMAP=B_Donnee;}	// Coefficient de Multiplication pour Mesure analogique de Position
			else if(TC_Mes_Recep[7]=='V') // Vitesse   (Coefficient de Multiplication pour Mesure analogique de Vitesse)
				{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[8],TC_Mes_Recep[9]);
		    		if(B_Code_Erreur_Recep!=0x30) 
					F_Erreur_Recep=1;					// Si erreur on envoie un message "erreur sur nombre"
				else 	B_CMMAV=B_Donnee;}	// Coefficient de Multiplication pour Mesure analogique de Position
			else	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    		F_Erreur_Recep=1;}							// On envoie un message "erreur code message"
			}
		else	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    		F_Erreur_Recep=1;}							// On envoie un message "erreur code message"
		}
	else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
		    	F_Erreur_Recep=1;}						// On envoie un message "erreur code message"
	}
else if(TC_Mes_Recep[4]=='T')	// pour dfinir la Taille  (ou Type)
	{if(TC_Mes_Recep[5]=='T') // du Tableau
		{if(TC_Mes_Recep[6]=='T') // de consigne en profil Trapzodal
			{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9],TC_Mes_Recep[10]);
		    		if(B_Code_Erreur_Recep!=0x30) 
					F_Erreur_Recep=1;					// Si erreur on envoie un message "erreur sur nombre"
				else 	if(W_Donnee>16384)
						{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x02;	// On positionne le bit d'erreur sur le nombre
		    				F_Erreur_Recep=1;}					
					else	W_Taille_TDCT=W_Donnee;}
		else if(TC_Mes_Recep[6]=='S') // de consigne sinusodale
			{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9],TC_Mes_Recep[10]);
		    		if(B_Code_Erreur_Recep!=0x30) 
					F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
				else 	if(W_Donnee>8192)
						{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x02;	// On positionne le bit d'erreur sur le nombre
		    				F_Erreur_Recep=1;}					
					else	W_Taille_TCS=W_Donnee;}
		else	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    	F_Erreur_Recep=1;}							// On envoie un message "erreur code message"
		}
	else if(TC_Mes_Recep[5]=='C') // pour Dfinir Type Commande
		{if(TC_Mes_Recep[6]=='M') // du moteur
			{if(TC_Mes_Recep[7]=='T') F_Type_CM=0;			// Le moteur sera command en Tension
			else if(TC_Mes_Recep[7]=='C') F_Type_CM=1;		// Le moteur sera command en Courant
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur code
		    				F_Erreur_Recep=1;}}					
		else if(TC_Mes_Recep[6]=='C') // de la Charge Electrique 
			{if(TC_Mes_Recep[7]=='T') F_Type_CM=0;			// la Charge lectrique sera command en Tension
			else if(TC_Mes_Recep[7]=='C') F_Type_CM=1;		// la Charge lectriquesera command en Courant
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur code
		    				F_Erreur_Recep=1;}}					
		else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
		    	F_Erreur_Recep=1;}						// On envoie un message "erreur code message"
		}
else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
   		F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
	}
}  // Fin de la fonction de traitement de la missive D (Dfinir un paramtre)

/*  Fonction de traitement de la missive 'E' (Ecrire  une adresse spcifie de la donne spcifie 
************************************************************************************************************/
void Traiter_Missive_E(void)
{Adresse=Conv_6ASCII_to_B(TC_Mes_Recep[5],TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9],TC_Mes_Recep[10]);
 if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;			// Si erreur, on envoie un message "erreur sur nombre"
 else	if(TC_Mes_Recep[4]=='B')  	// C'est l'criture d'un mot de 8 bits (un BYTE)  l'adresse spcifie
		{ B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[11],TC_Mes_Recep[12]);
		     if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    else		{Ptr_B=(BYTE*)Adresse;			// Sinon on effectue l'criture de l'octet (BYTE)
		    	  	  *Ptr_B=B_Donnee;}
		}
	else if(TC_Mes_Recep[4]=='W')  	// C'est l'criture d'un mot de 16 bits (un WORD)  l'adresse spcifie
		 {W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[11],TC_Mes_Recep[12],TC_Mes_Recep[13],TC_Mes_Recep[14]);
		    if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    else   	{Ptr_W=(WORD*)Adresse;			// Sinon on effectue l'criture du mot de 16 bits (WORD)
		         	 	  *Ptr_W=W_Donnee;}
		}
	else 	  { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
		    F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
}

/*  Fonction de traitement de la missive 'R'  (configuer et actionner fonction de Rgulation 
***************************************************************************************************/
void Traiter_Missive_R(void)	// configurer et actionner la fonction de Rgulation
{switch (TC_Mes_Recep[4])		// On teste le caractre code message
	{case 'D': 	// On donne le Dpart de la mise en rgulation et de la mmorisation en RAM
			{F_Autoris_Reg=1;
			W_Rang_Mem_Echant=0;	// Init Rang dans la mmoire de sauvegarde des chantillons
			F_Mem_Ech_Pleine=0;
			S_Pos_Num1=0;		// Pour les donnes rgulateur		
			S_Vit_Num1=0;
			S_Reg_SI1=0;
			S_Ecart1=0;
			S_Reg_SR1=0;
			if(F_Reg_Mode_Trap){W_Rang_TDCT=0;
						F_Prof_T_En_Cours=0;} 
			break;}
	case 'E': 	// On dfinit les priodes d'Echantillonnage
			{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9]);
		     		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
				else if(TC_Mes_Recep[5]=='M') W_TEM=W_Donnee;	// Le paramtre d'chantillonnage pour mmorisation Echantillon
				else if(TC_Mes_Recep[5]=='R') W_TER=W_Donnee;	// Le paramtre d'chantillonnage du rgulateur
				else if(TC_Mes_Recep[5]=='S') W_TES=W_Donnee;		// Le paramtre d'chantillonnage pour rgime sinus
				else if(TC_Mes_Recep[5]=='T') W_TET=W_Donnee;		// Le paramtre d'chantillonnage pour <profil Trapzodal
				else if(TC_Mes_Recep[5]=='V') W_TEV=W_Donnee;		// Le paramtre d'chantillonnage du capteur de Vitesse
				else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    			F_Erreur_Recep=1;}
			break;}
	case 'K': 	// On donne le Type de la fonction de rgulation
			{if(TC_Mes_Recep[5]=='P')		// Pour coefficient d'action  "Proportionnelle"
				{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9]);
		    		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    		else  W_Reg_KP1=W_Donnee;				// On rcupre le coefficient d'action proportionnelle	n1
				W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[10],TC_Mes_Recep[11],TC_Mes_Recep[12],TC_Mes_Recep[13]);
		    		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    		else  W_Reg_KP2=W_Donnee;}				// On rcupre le coefficient d'action proportionnelle	n2
			else if(TC_Mes_Recep[5]=='I')	// Pour coefficient d'action  "Intgrale"
				{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9]);
		    		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    		else W_Reg_KI=W_Donnee;} 				// On rcupre le coefficient d'action Intgrale
			else if(TC_Mes_Recep[5]=='D')	// Pour coefficient d'action "Drive"
				{W_Donnee=Conv_4ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9]);
		    		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    		else W_Reg_KD=W_Donnee;} 				// On rcupre le coefficient d'action Intgrale
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    		F_Erreur_Recep=1;}
			break;}
	case 'M' :	// On donne le Mode de rgulation (Position, Vitesse, profil Trap., voir Boucle ouverte)
			{ if(TC_Mes_Recep[5]=='P')F_Reg_Mode_Pos=1,F_Reg_Mode_Vit=0,F_Reg_Mode_Trap=0,F_Reg_Mode_BO=0;
			else if(TC_Mes_Recep[5]=='V')F_Reg_Mode_Pos=0,F_Reg_Mode_Vit=1,F_Reg_Mode_Trap=0,F_Reg_Mode_BO=0;
			else if(TC_Mes_Recep[5]=='T')F_Reg_Mode_Pos=0,F_Reg_Mode_Vit=0,F_Reg_Mode_Trap=1,F_Reg_Mode_BO=0;	
			else if(TC_Mes_Recep[5]=='O')F_Reg_Mode_Pos=0,F_Reg_Mode_Vit=0,F_Reg_Mode_Trap=0,F_Reg_Mode_BO=1;
			else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    		F_Erreur_Recep=1;}
			break;}
	case 'S': 	// On arrte (Stop) la mise en rgulation
			{F_Autoris_Reg=0;
			 break;}
	case 'T':	// On dfinit le type de rgulation
			{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[11],TC_Mes_Recep[12]);
		     	if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;	// Si erreur on envoie un message "erreur sur nombre"
		    	else	B_Type_Reg=B_Donnee;			// Sinon on rcupre le type de rgulation
 			break;}
	default :	{B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;		// On positionne le bit d'erreur sur le code message
		    	F_Erreur_Recep=1;}
	
	}	
} // Fin fonction de traitement de la missive 'R' (configurer la fonction de rgulation)

/*----------------------------------------------------------------------------------
     FONCTIONS DE TRAITEMENT DES REQUETES
  -----------------------------------------------------------------------------------*/
/*  Fonction de traitement de la requte "A"  (Acqurir la valeur de grandeurs diverses )
*************************************************************************************************/
void Traiter_Requete_A(void)
{if(TC_Mes_Recep[4]=='E')
	{if (TC_Mes_Recep[5]=='A')			// C'est l'acquisition d'une entre analogique
		{B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[6],TC_Mes_Recep[7]);	// On rcupre le n de la voie concern
		if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;		// Si erreur, on envoie un message "erreur sur nombre"
		else 	if(B_Donnee<=3)	// Seules les voies de 0  3 sont utilises 
				{// Prparation de la missive de rponse
				Conv_W_to_ASCII(TS_Result_Conv_AN[B_Donnee]);	// On demande la valeur d'une voie analogique	 
				TC_Mes_Emis[0]='!';
				TC_Mes_Emis[1]='0';
				TC_Mes_Emis[2]='D';						// Le message rponse comporte 11 caractres
				for(B_i=3;B_i<=7;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et le numro de voie
				TC_Mes_Emis[8]=C_ASCII4;					// Rsultat de lecture en ASCII(MSB)
				TC_Mes_Emis[9]=C_ASCII3;					// Rsultat de lecture en ASCII
				TC_Mes_Emis[10]=C_ASCII2;					// Rsultat de lecture en ASCII
				TC_Mes_Emis[11]=C_ASCII1;					// Rsultat de lecture en ASCII(LSB)
				TC_Mes_Emis[12]=0x0D;					// C'est le code du CR (retour chariot)
				TC_Mes_Emis[13]=0x0A;					// C'est le code du LF (passage   ligne suivante) 
				B_Nb_Carac_Mes_Emis=13;}
			else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
    					F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
		}
	else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
	}	// Fin acquisition entre analogique
else if(TC_Mes_Recep[4]=='P')
	{if (TC_Mes_Recep[5]=='N')			// C'est l'acquisition du rsultat de comptage - Potentiomtre Numrique
	  	{Conv_W_to_ASCII(CPTR_Pot_Num);	// On demande le rsultat de comptage signaux Potentiomtre Numrique 			
		 // Prparation de la missive de rponse
		TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='0';
		TC_Mes_Emis[2]='B';						// Le message rponse comporte 11 caractres
		for(B_i=3;B_i<=5;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message
		TC_Mes_Emis[6]=C_ASCII4;					// Rsultat de lecture en ASCII(MSB)
		TC_Mes_Emis[7]=C_ASCII3;					// Rsultat de lecture en ASCII
		TC_Mes_Emis[8]=C_ASCII2;					// Rsultat de lecture en ASCII
		TC_Mes_Emis[9]=C_ASCII1;					// Rsultat de lecture en ASCII(LSB)
		TC_Mes_Emis[10]=0x0D;					// C'est le code du CR (retour chariot)
		TC_Mes_Emis[11]=0x0A;					// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=11;}
	else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
	}	// Fin acquisition Potentiomtre numrique
else if(TC_Mes_Recep[4]=='S')				// pour acquisition Signaux divers de taille 16 bits
	{if (TC_Mes_Recep[5]=='D')Conv_W_to_ASCII(S_Reg_SD);	   	// C'est l'acquisition de la Sortie de l'action de correction Drive du PID
	else if (TC_Mes_Recep[5]=='I')Conv_W_to_ASCII(S_Reg_SI);	// C'est l'acquisition de la Sortie de l'action de correction Intgrale du PID
	else if (TC_Mes_Recep[5]=='P')Conv_W_to_ASCII(S_Reg_SP);	// C'est l'acquisition de la Sortie de l'action de correction Proportionnelle du PID
	else if (TC_Mes_Recep[5]=='R')Conv_W_to_ASCII(S_Reg_SR);	// C'est l'acquisition de la Sortie Rgulateur du PID (aprs sommateur)
	else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
	 // Prparation de la missive de rponse
	TC_Mes_Emis[0]='!';
	TC_Mes_Emis[1]='0';
	TC_Mes_Emis[2]='B';						// Le message rponse comporte 11 caractres
	for(B_i=3;B_i<=5;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message
	TC_Mes_Emis[6]=C_ASCII4;					// Rsultat de lecture en ASCII(MSB)
	TC_Mes_Emis[7]=C_ASCII3;					// Rsultat de lecture en ASCII
	TC_Mes_Emis[8]=C_ASCII2;					// Rsultat de lecture en ASCII
	TC_Mes_Emis[9]=C_ASCII1;					// Rsultat de lecture en ASCII(LSB)
	TC_Mes_Emis[10]=0x0D;					// C'est le code du CR (retour chariot)
	TC_Mes_Emis[11]=0x0A;					// C'est le code du LF (passage   ligne suivante) 
	B_Nb_Carac_Mes_Emis=11;}
else { B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
}  // Fin de traitement de la requte "A"  


/*  Fonction de traitement de la requete "L"  (Lecture  une adresse spcifie)
***************************************************************************************/
void Traiter_Requete_L(void)
{Adresse=Conv_6ASCII_to_B(TC_Mes_Recep[5],TC_Mes_Recep[6],TC_Mes_Recep[7],TC_Mes_Recep[8],TC_Mes_Recep[9],TC_Mes_Recep[10]);
if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;		// Si erreur, on envoie un message "erreur sur nombre"
else	if(TC_Mes_Recep[4]=='B')  			// C'est une lecture d'un mot de 8 bits (un BYTE)  l'adresse spcifie
		{ Ptr_B=(BYTE*)Adresse;			// Sinon on effectue la lecture de l'octet (BYTE)
		 B_Donnee=*Ptr_B;
		 // Prparation de la missive de rponse
		Conv_B_to_ASCII(B_Donnee);		// On rcupre le rsultat de conversion dans C_ASCII2 et C_ASCII1	 
		TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='0';
		TC_Mes_Emis[2]='E';				// Le message rponse comporte 14 caractres
	 	for(B_i=3;B_i<=10;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et l'adresse
		TC_Mes_Emis[11]=C_ASCII2;			// Rsultat de lecture en ASCII(MSB)
		TC_Mes_Emis[12]=C_ASCII1;			// Rsultat de lecture en ASCII(LSB)
		TC_Mes_Emis[13]=0x0D;			// C'est le code du CR (retour chariot)
		TC_Mes_Emis[14]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=14;}
	else if(TC_Mes_Recep[4]=='W')  	// C'est une lecture d'un mot de 16 bits (un WORD)  l'adresse spcifie
		{ Ptr_W=(WORD*)Adresse;			// Sinon on effectue la lecture du mot de 16 bits (WORD)
		W_Donnee=*Ptr_W;
		// Prparation de la missive de rponse
		Conv_W_to_ASCII(W_Donnee);		// On rcupre le rsultat de conversion dans C_ASCII4,3,2,1
	 	TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='1';
		TC_Mes_Emis[2]='0';				// Le message rponse comporte 16 caractres
		for(B_i=3;B_i<=10;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et l'adresse
		TC_Mes_Emis[11]=C_ASCII4;			// Rsultat de lecture en ASCII(MSB)
		TC_Mes_Emis[12]=C_ASCII3;			// Rsultat de lecture en ASCII
		TC_Mes_Emis[13]=C_ASCII2;			// Rsultat de lecture en ASCII
		TC_Mes_Emis[14]=C_ASCII1;			// Rsultat de lecture en ASCII(LSB)
	 	TC_Mes_Emis[15]=0x0D;			// C'est le code du CR (retour chariot)
		TC_Mes_Emis[16]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=16;}
	else 	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
} // Fin de la fonction de traitement de la requte "L" (Lecture  une adresse spcifie)


/*  Fonction de traitement de la requete "P"  (acquisition Position)
***************************************************************************************/
void Traiter_Requete_P(void)
{if(TC_Mes_Recep[4]=='S')		// On demande la position sur 16 bits
	{ // Prparation message en rponse
	TC_Mes_Emis[0]='!';
	TC_Mes_Emis[1]='0';
	TC_Mes_Emis[2]='A';				// Le message rponse comporte 9 caractres
	TC_Mes_Emis[3]='P';
	TC_Mes_Emis[4]='S';
	Conv_W_to_ASCII(S_Pos_Num);	// On rcupre le rsultat de conversion dans C_ASCII4,3,2,1
	TC_Mes_Emis[5]=C_ASCII4;			// Rsultat  en ASCII(MSB)
	TC_Mes_Emis[6]=C_ASCII3;			// Rsultat  en ASCII
	TC_Mes_Emis[7]=C_ASCII2;			// Rsultat  en ASCII
	TC_Mes_Emis[8]=C_ASCII1;			// Rsultat en ASCII(LSB)
	TC_Mes_Emis[9]=0x0D;			// C'est le code du CR (retour chariot)
	TC_Mes_Emis[10]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
	B_Nb_Carac_Mes_Emis=10;}
else if(TC_Mes_Recep[4]=='I')	// On demande la position sur 32 bits
	{ // Prparation message en rponse
	TC_Mes_Emis[0]='!';
	TC_Mes_Emis[1]='0';
	TC_Mes_Emis[2]='A';				// Le message rponse comporte 9 caractres
	TC_Mes_Emis[3]='P';
	TC_Mes_Emis[4]='I';
	Conv_W_to_ASCII((short)I_Pos_Num);	// On rcupre le rsultat de conversion dans C_ASCII4,3,2,1
	TC_Mes_Emis[5]=C_ASCII8;			// Rsultat  en ASCII(MSB)
	TC_Mes_Emis[6]=C_ASCII7;			// Rsultat  en ASCII
	TC_Mes_Emis[7]=C_ASCII6;			// Rsultat  en ASCII
	TC_Mes_Emis[8]=C_ASCII5;			// Rsultat en ASCII(LSB)
	TC_Mes_Emis[9]=C_ASCII4;			// Rsultat  en ASCII(MSB)
	TC_Mes_Emis[10]=C_ASCII3;			// Rsultat  en ASCII
	TC_Mes_Emis[11]=C_ASCII2;			// Rsultat  en ASCII
	TC_Mes_Emis[12]=C_ASCII1;			// Rsultat en ASCII(LSB)
	TC_Mes_Emis[13]=0x0D;			// C'est le code du CR (retour chariot)
	TC_Mes_Emis[14]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
	B_Nb_Carac_Mes_Emis=14;}
else {B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
}

/*  Fonction de traitement de la requete "T"  (Transferer des donnes mmorises)
*******************************************************************************************/
void Traiter_Requete_T(void)
{ WORD W_Rang_Mem;
B_Donnee=Conv_2ASCII_to_B(TC_Mes_Recep[5],TC_Mes_Recep[6]);	// On rcupre le n du bloc  transferer
if(B_Code_Erreur_Recep!=0x30) F_Erreur_Recep=1;		// Si erreur, on envoie un message "erreur sur nombre"
else	if(TC_Mes_Recep[4]=='P')  		// C'est un transfert des chantillons mmoriss de position
		{  // Prparation de la missive de rponse
		TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='8';
		TC_Mes_Emis[2]='8';				// Le message rponse comporte 136 caractres
	 	for(B_i=3;B_i<=6;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et n bloc
		W_Rang_Mem=(WORD)(B_Donnee);		// Pour calculer la position de dpart dans la mmoire d'chantillons
		W_Rang_Mem=W_Rang_Mem*32;		//  = N bloc *32  (32 Words soit 128 caractres par bloc transfr)
		for(B_i=7;B_i<=135;B_i=B_i+4)
			{W_Rang_Mem++;
			Conv_W_to_ASCII(TS_Pos_Mem[W_Rang_Mem]);
			TC_Mes_Emis[B_i]=C_ASCII4;
			TC_Mes_Emis[B_i+1]=C_ASCII3;
			TC_Mes_Emis[B_i+2]=C_ASCII2;
			TC_Mes_Emis[B_i+3]=C_ASCII1;}
		TC_Mes_Emis[136]=0x0D;		 	// C'est le code du CR (retour chariot)
		TC_Mes_Emis[137]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=137;}
	else if(TC_Mes_Recep[4]=='S') 	// C'est un transfert des chantillons mmoriss de Sortie Rgulateur
		{// Prparation de la missive de rponse
		TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='8';
		TC_Mes_Emis[2]='8';				// Le message rponse comporte 136 caractres
	 	for(B_i=3;B_i<=6;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et n bloc
		W_Rang_Mem=(WORD)(B_Donnee);		// Pour calculer la position de dpart dans la mmoire d'chantillons
		W_Rang_Mem=W_Rang_Mem*32;		//  = N bloc*32  (32 Words soit 128 caractres par bloc transfr)
		for(B_i=7;B_i<=135;B_i=B_i+4)
			{W_Rang_Mem++;
			Conv_W_to_ASCII(TS_SR_Mem[W_Rang_Mem]);
			TC_Mes_Emis[B_i]=C_ASCII4;
			TC_Mes_Emis[B_i+1]=C_ASCII3;
			TC_Mes_Emis[B_i+2]=C_ASCII2;
			TC_Mes_Emis[B_i+3]=C_ASCII1;}
		TC_Mes_Emis[136]=0x0D;		 	// C'est le code du CR (retour chariot)
		TC_Mes_Emis[137]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=136;}	
	else if(TC_Mes_Recep[4]=='E') 		// C'est le test si un bloc est transfrable  (Etat du transfert)
		{TC_Mes_Emis[0]='!';
		TC_Mes_Emis[1]='0';
		TC_Mes_Emis[2]='9';				// Le message rponse comporte 10 caractres
	 	for(B_i=3;B_i<=6;B_i++)TC_Mes_Emis[B_i]=TC_Mes_Recep[B_i]; // Pour le code message et n bloc
		W_Rang_Mem=(WORD)(B_Donnee+1);	// Pour calculer la position finale dans la mmoire d'chantillons
		W_Rang_Mem=W_Rang_Mem*32;		//  = N bloc *32  (32 Words soit 128 caractres par bloc transfr)
		if(W_Rang_Mem_Echant>W_Rang_Mem)TC_Mes_Emis[7]='O';	// le bloc est transfrable donc c'est Oui
		else	TC_Mes_Emis[7]='N';						// Le bloc n'est pas tranfrable donc c'est Non
		TC_Mes_Emis[8]=0x0D;		 	// C'est le code du CR (retour chariot)
		TC_Mes_Emis[9]=0x0A;			// C'est le code du LF (passage   ligne suivante) 
		B_Nb_Carac_Mes_Emis=9;	
		}
	else 	{ B_Code_Erreur_Recep=B_Code_Erreur_Recep|0x08;	// On positionne le bit d'erreur sur le code message
	    	F_Erreur_Recep=1;}					// On envoie un message "erreur code message"
} // Fin de la fonction de traitement de la requte "T" (Transfert des chantillons mmorises)


/*  Fonction de traitement de la requete "V"  (Acqurir l'image de la vitesse)
*******************************************************************************************/
void Traiter_Requete_V(void)
{	TC_Mes_Emis[0]='!';
	TC_Mes_Emis[1]='0';
	TC_Mes_Emis[2]='9';				// Le message rponse comporte 9 caractres
	TC_Mes_Emis[3]='V';
	Conv_W_to_ASCII(S_Vit_Num);		// On rcupre le rsultat de conversion dans C_ASCII4,3,2,1
	TC_Mes_Emis[4]=C_ASCII4;			// Rsultat  en ASCII(MSB)
	TC_Mes_Emis[5]=C_ASCII3;			// Rsultat  en ASCII
	TC_Mes_Emis[6]=C_ASCII2;			// Rsultat  en ASCII
	TC_Mes_Emis[7]=C_ASCII1;			// Rsultat en ASCII(LSB)
	TC_Mes_Emis[8]=0x0D;			// C'est le code du CR (retour chariot)
	TC_Mes_Emis[9]=0x0A;			// C'est le code du LF (passage  ligne suivante) 
	B_Nb_Carac_Mes_Emis=9;
} // Fin traitement missive V



