	/********************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*********************************************************************************
	*  	Suivi de consigne pour courant moteur				*
	*										*
	*  CAHIER DES CHARGES :					      		*
	*  ***************************					      		*	
	*   On souhaite que l'image du courant moteur suive  la tension     		*
	*   impose par le potentiomtre analogique  -> Tension U_Pot 		*
	*	-> La conversion A->N de U_Pot est demande toutes les  mS	*
	*	-> Cette priode d'chantillonnage est impose par			*
	*	    le timer programmable en mode d'interruption			*
	*	-> Les 8bits MSB du rsultat devienne la consigne de I moteur	*
 	*---------------------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Suivi_Cons_C_Mot.C		       			*
	* ********************								*
	*********************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "ISM.h"
#include "Structures_donnees.h"


/* Dclaration des variables globale */
WORD i,resultat_conv;


/* FONCTION d'interruption pour temporisation  (base de temps: toutes les mS)
=================================================================*/
void irq_bt()
{	 if (Fin_Conv_AN==0)
		{ resultat_conv=CAN;
		  Cons_CM=(unsigned char) ((resultat_conv&0x0FFF)>>4);	// Appliquer la Consigne Courant Moteur
  		CAN=0x0043; 		// Lancer la conversion de la voie 3 (U_Pot)
		}
} // Fin de la dfinition de la fonction d'interruption pour la temporisation

/*=====================
  *    Fonction principale          
  =====================*/
main(void)
{
/* Initialisation des variables */

/* De l'interface de puissance de commande moteur */
 Dir_PortC = 0x03; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot = 0;		// On commande en positif
 Cons_CM = 0x00;		// On commence avec avec une consigne nulle

/* Pour le timer programmable	*/
 SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
 PITR = 0x0008;		// Une interruption toutes les millisecondes 
 PICR = 0x0760; 		//  96 = 60H

/*  Pour lancer la premire conversion A -> N   */
CAN=0x0043;    	// Lancer la conversion de la voie 3 (U_Pot)

/*   Boucle principale   */
/*************************/    
do	{  		// On ne fait rien!... Le suivi se fait en interruption
	}while(1);  /* Fin de la boucle principale */
} /* Fin fonction principale */

