	/************************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)				*
	*************************************************************************************
	*  	Suivi de consigne pour courant charge electrique  partir potentiomtre		*	
	*											analogique		*
	*														*
	*   CAHIER DES CHARGES :					      				*
	*  *********************					      				*	
	*  On souhaite que le courant dans la charge lectrique suive la tension impose	*
	*  par le potentiomtre analogique Tension U_Pot_Int sur entre analogique EA3	*
	*	-> La conversion A->N de U_Pot est demande 						*
	*	-> Les 8bits MSB du rsultat devienne la consigne de I Charge Elec		*
 	*----------------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Suivi_Cons_PA_C_CE.C	       						*
	* **************** 											*
	*************************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>

/* Dclaration des variables globale */
WORD Val_Cde_CE,i,resultat_conv, compteur;

/*==========================
  *    Fonction principale          
  ==========================*/
main(void)
{
/* Initialisation des variables */
// Rem:  Dans une commande en courant on place la commande en tension  100%
 Per_Cde_CE=0x00FF;   	//  Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00F00	
 Cons_TCE=0x00FF;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  100 %  
/* Des registres du TPU pour configurer le bit PA7 (TPU7) en sortir PWM */	 
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0  7 
 CFSR3=0x0090;     	//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch1 donc sur PA1)
 CTRL_TPU1=0x0091;  	// On utilise TCR1  
 HSRR1=0x0020; 		// Initialisation canal	  
 CPR1=0x0030;      	// Priorit haute pour ch0 -> PA0
/* De l'interface de puissance pour Charge Electrique  */
 Dir_PortC=0x0C; 		// Signe_Cde_CE et Valid_IP_CE seront actifs
 Valid_IP_CE = 0; 	// Validation de l'Interface de Puissance Charge Electrique
 Signe_Cde_CE=0;		// Commande Charge Electrique en positif (Mettre 1 pour commander en ngatif)

// Pour lancer la premire conversion
CAN=0x0043;

/*   Boucle principale   */
/*************************/    
do	{  
	  	 if (Fin_Conv_AN==0)
		{resultat_conv = CAN;
		 Val_Cde_CE=((resultat_conv&0x0FFF)>>4);	// Appliquer la Consigne Courant Charge Electrique 
		 Cons_CCE =Val_Cde_CE;
  		 CAN=0x0043; 	// Lancer la conversion de la voie n3 du CAN -> EA3 -> U_Pot
		}
	if (Val_Cde_CE==0)Valid_IP_CE = 1; // On inhibe la commande puissance
	else Valid_IP_CE = 0; //On valide la commande puissance

	compteur++;
	if (compteur==50000)
		{compteur=0;
		 clsscr();
		 gotoxy(4,6);
	  	 printf("      AGIR SUR POTENTIOMETRE ANALOGIQUE  \n");
 	  	 printf("         ---------------------------------  \n");
		 printf("   Commande Courant Charge Electrique = %2.2x H = %2D\n",Val_Cde_CE,Val_Cde_CE);
		}
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

