	/************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)		*
	*************************************************************************
	*  	Suivi de consigne pour tension moteur  partir Potentiomtre	*
	*										Analogique	*
	*												*
	*   CAHIER DES CHARGES :					      		*
	*  *********************					      		*	
	*   On souhaite que l'image de la tension aux bornes du moteur 		*
	*   suive  la tension impose par le potentiomtre analogique  		*
	*    		Tension U_Pot_Int sur entre analogique EA3			*
	*	-> La conversion A->N de U_Pot est demande 				*
	*	-> Les 8bits MSB du rsultat devienne la consigne de U moteur	*
 	*----------------------------------------------------------------------	*
	*  NOM du FICHIER :  Suivi_Consigne_T_Mot.C	       			*
	* ****************									*
	*************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "Structures_donnees.h"
#include "ISM.h"
#include <stdio.h>
/* Dclaration des variables globale */
WORD Val_Cde_Mot,i,resultat_conv,Valeur_Cde;

/*=========================
  *    Fonction principale          
  =========================*/
main(void)
{
WORD Compteur;
/* Initialisation des variables */
 Per_Cde_Mot=0x00FF;   	//  	Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x00FF	
 Cons_TM=0x0000;   	// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
			// C'est la Consigne Tension Moteur	 	
/* Des registres du TPU pour configurer le bit PA0 -> TPU0 -> ch0  en sortie PWM */	 
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0 7 
 CFSR3=0x0009;     		//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch0 donc sur PA0)
 CTRL_TPU0=0x0091;  	// On utilise TCR1  
 HSRR1=0x0002; 		// Initialisation canal	  
 CPR1=0x0003;      		// Priorit haute pour ch0 -> PA0
/* De l'interface de puissance de commande moteur */
 Dir_PortC=0x03; 		// Signe_Cde_Mot et Valid_IP_Mot  seront actifs
 Valid_IP_Mot = 0; 		// Validation de l'Interface de Puissance moteur
 Signe_Cde_Mot=0;		// Commande Moteur en positif (Mettre 1 pour commander en ngatif)
 Cons_CM = 0xFF;		// Le courant moteur sera limit  sa valeur maxi 

// Pour lancer la premire conversion
CAN=0x0043; 

/*   Boucle principale   */
/*************************/    
do	{   if (Fin_Conv_AN==0)
		{ resultat_conv=CAN;
		 Valeur_Cde=((resultat_conv&0x0FFF)>>3);
		 Valeur_Cde=0x0;
	       if (resultat_conv&0x0800)
			Signe_Cde_Mot=0;
			else
			Signe_Cde_Mot=1;
		Cons_TM=Valeur_Cde;	// Appliquer la Consigne Tension Moteur (Commande en PWM) 
		CAN=0x0043; 	// Relancer la conversion de la voie n3 du CAN -> EA3 -> U_Pot
		}

	Compteur++;
	if(Compteur==65000)
		{clsscr();
		 gotoxy(4,6);
	  	 printf("      AGIR SUR POTENTIOMETRE ANALOGIQUE  \n");
 	  	 printf("         ---------------------------------  \n");
		 printf("Valeur commande tension moteur: 0x%2.2X = %2d\n",Valeur_Cde,Valeur_Cde);
		 Compteur=0;
		}
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

