	/****************************************************************************************
	*     TP sur  EID210 avec Interface pour Servo Mcanismes	(ISM)			*
	*****************************************************************************************
	*  	Suivi de consigne pour tension charge electrique				*
	*											*
	*   CAHIER DES CHARGES :					      			*
	*  ***************************					      			*	
	*   On souhaite que l'image de la tension aux bornes de la charge lectrique 	*
	*   suive  la tension impose par le potentiomtre analogique  			*
	*    		Tension U_Pot_Int sur entre analogique EA3			*
	*	-> La conversion A->N de U_Pot est demande 				*
	*	-> Les 8bits MSB du rsultat devienne la consigne de U Charge Elec	*
 	*--------------------------------------------------------------------------------------------------------------------------------	*
	*  NOM du FICHIER :  Suivi_Cons_T_CE.C	       					*
	* ********************									*
	*****************************************************************************************/
/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "EID210_reg.h"
#include "ISM.h"
#include "Structures_donnees.h"
/* Dclaration des variables globale */
WORD Val_Cde_Mot,i,resultat_conv;


/*=====================
  *    Fonction principale          
  =====================*/
main(void)
{
WORD Compteur;
/* Initialisation des variables */
 Per_Cde_CE=0x00FF;   	//  Valeur de la PERiode du signal				
   // Remarque:  Le Rapport Cyclique  (RC_Cde_Mot)  ne pourra varier que de 0x0000  0x000FF	
 Cons_TCE=0x0000;   		// Dure du signal au niveau logique 1  Rapport cyclique initialis  0 %  
				// C'est la Consigne Tension Charge Electrique	 	
/* Des registres du TPU pour configurer le bit PA7 (TPU7) en sortir PWM */	 
 TPUMCR=0x0040; 		// tcr1 
 CPR1=0x0000;	  	// pendant init pas de spcification de priorit sur ch 0  7 
 CFSR3=0x0090;     		//  Rgistre de configuration pour Canaux 3..0  (PWM sur ch1 donc sur PA1)
 CTRL_TPU1=0x0091;  	// On utilise TCR1  
 HSRR1=0x0008; 		// Initialisation canal	  
 CPR1=0x000C;      		// Priorit haute pour ch1 -> PA1
/* De l'interface de puissance pour Charge Electrique  */
 Dir_PortC=0x0C; 		// Signe_Cde_CE et Valid_IP_CE seront actifs
 Valid_IP_CE = 0; 		// Validation de l'Interface de Puissance Charge Electrique
 Signe_Cde_CE=0;		// Commande Charge Electrique en positif
 Cons_CCE = 0xFF;		// Le courant dans Charge Electrique sera limit  sa valeur maxi 

// Pour lancer la premire conversion
CAN=0x0043; 


/*   Boucle principale   */
/*************************/    
do	{  
	if (Fin_Conv_AN==0)
		{ resultat_conv = CAN;
		  Cons_TCE=((resultat_conv&0x0FFF)>>4);	// Appliquer la Consigne Tension Charge Electrique (Commande en PWM) 
		CAN=0x0043; 	// Lancer la conversion de la voie n3 du CAN -> EA3 -> U_Pot
		}
  	Compteur++;
	if (Compteur==40000)
		{Compteur=0;
		printf("Consigne CE=%4.4x\n",Cons_TCE);
		}
	}while(1);
/* fin de la boucle principale */
} /* fin fonction principale */

