/*=======================================================================
 *     DEFINITIONS  POUR LA CARTE d'INTERFACE POUR SERVOMECANISME  (I.S.M.)
 *=======================================================================
 *  La ligne PA0  (TPU0) sera configur en PWM pour la commande en tension du moteur
 *  La ligne PA1  (TPU1) sera configur en PWM pour la commande de la charge lectrique
 *  Le port B est connect sur les 8 switchs , ce sera des entres
 *  Le port C est connect sur l'afficheur 7 segments, ce sera des sorties       
 *=========================================================================*/

//   Pour la commande en tension du moteur
/*   PARAMETER RAM pour ch1 (TPU0 -> PA0) en PWM	*/
#define RC_Cde_Mot	*(WORD*)	0xFFFF04	// Pour dfinir le Rapport Cyclique de la Commande Moteur
#define Cons_TM RC_Cde_Mot			// Comme Consigne Tension Moteur
#define Per_Cde_Mot	*(WORD*)	0xFFFF06	// Pour dfinir la Periode de la Commande Moteur

//  Pour la commande en tension de la charge lectrique
/*   PARAMETER RAM pour ch1 (TPU1 -> PA1) en PWM	*/
#define RC_Cde_CE	*(WORD*)	0xFFFF14	// Pour dfinir le Rapport Cyclique de la Commande Charge Electrique
#define Cons_TCE RC_Cde_CE			// Comme Consigne Tension Charge Electrique
#define Per_Cde_CE	*(WORD*)	0xFFFF16	// Pour dfinir la Periode de la Commande Charge Electrique

/* Signe de la commande moteur  */
#define Signe_Cde_Mot PC0
/*  Validation de l'Interface de Puissance  Moteur*/
#define Valid_IP_Mot PC1	// Active sur un niveau bas
/* Signe de la commande Charge Electrique  */
#define Signe_Cde_CE PC2
/*  Validation de l'Interface de Puissance Charge Electrique  */
#define Valid_IP_CE PC3	// Active sur un niveau bas
/*  Mise en "Standby" du codeur  */
#define Stb_Cod PC6	// Actif sur un niveau bas
/*  Validation de l'Interface Codeur  */
#define Val_Cod PC7		// Active sur un niveau bas
/* Consigne Courant Moteur  */
#define Cons_CM SA0		// Sur la sortie analogique 0
/* Consigne Courant Charge Electrique  */
#define Cons_CCE SA1	// Sur la sortie analogique 2

#define un 1
#define zero 2

/* Dfinitions particulires */
/*  TPU PARAMETER RAM */

//   Dfinition des tats des bits du port B 
#define Etat_TPU8	(*(union word_bits*) (0xFFFF82))   	/* PB7 sur maquette */ 
#define Etat_TPU9	(*(union word_bits*) (0xFFFF92))   	/* PB6 sur maquette */ 
#define Etat_TPU10	(*(union word_bits*) (0xFFFFA2))   	/* PB5 sur maquette */ 
#define Etat_TPU11	(*(union word_bits*) (0xFFFFB2))   	/* PB4 sur maquette */ 
#define Etat_TPU12	(*(union word_bits*) (0xFFFFC2))   	/* PB3 sur maquette */ 
#define Etat_TPU13	(*(union word_bits*) (0xFFFFD2))   	/* PB2 sur maquette */ 
#define Etat_TPU14	(*(union word_bits*) (0xFFFFE2))   	/* PB1 sur maquette */ 
#define Etat_TPU15	(*(union word_bits*) (0xFFFFF2))   	/* PB0 sur maquette */ 

#define PB0 Etat_TPU8.bit.b15			/*  Dernier Etat	 de l'entre PB7 */
#define PB1 Etat_TPU9.bit.b15			/*  Dernier Etat	 de l'entre PB6 */
#define PB2 Etat_TPU10.bit.b15			/*  Dernier Etat	 de l'entre PB5 */
#define PB3 Etat_TPU11.bit.b15			/*  Dernier Etat	 de l'entre PB4 */
#define PB4 Etat_TPU12.bit.b15			/*  Dernier Etat	 de l'entre PB3 */
#define PB5 Etat_TPU13.bit.b15			/*  Dernier Etat	 de l'entre PB2 */
#define PB6 Etat_TPU14.bit.b15			/*  Dernier Etat	 de l'entre PB1 */
#define PB7 Etat_TPU15.bit.b15			/*  Dernier Etat	 de l'entre PB0 */

//Pour le comptage des signaux en quadrature de phase issu du codeur accoupl  l'arbre moteur
 	/* PARAMETER RAM pour ch8 -> PB0 -> Cod_A  qui sera le canal primaire		*/
	#define CPTR_Pos_Mot			*(WORD*)	0xFFFF82
	#define S_Pos_Mot CPTR_Pos_Mot
	#define Cor_PinS_CHA			*(WORD*)	0xFFFF88
	#define Edge_T_CHA		*(WORD*)	0xFFFF8A
	/* PARAMETER RAM pour ch9 -> PB1 ->  Cod_B qui sera le canal secondaire	*/
   	#define Cor_PinS_CHB			*(WORD*)	0xFFFF98
	#define Edge_T_CHB		*(WORD*)	0xFFFF9A


//Pour le comptage des signaux en quadrature de phase issu du potentiomtre numrique
 	/* PARAMETER RAM pour ch12 -> PB4 -> Pot_Num_A  qui sera le canal primaire		*/
	#define CPTR_Pot_Num			*(WORD*)	0xFFFFC2
	#define S_Pot_Num CPTR_Pot_Num
	#define Cor_PinS_PNA			*(WORD*)	0xFFFFC8
	#define Edge_T_LSB_PNA		*(WORD*)	0xFFFFCA
	/* PARAMETER RAM pour ch13 -> PB5 ->  Pot_Num_B qui sera le canal secondaire	*/
   	#define Cor_PinS_PNB			*(WORD*)	0xFFFFD8
	#define Edge_T_LSB_PNB		*(WORD*)	0xFFFFDA



// Pour les sortie analogiques
#define Mes_IV SA3	// Mesure Image Vitesse sur la sortie analogique 3
#define Mes_IP SA2	// Mesure Image Position sur la sortie analogique 2
