

#include "d12ci.h"
#include "usb.h"
#include "isr_usb.h"
#include "eid210.h"
#include "qsm.h"


USBFLAGS bUSBFlags;

CONTROL_XFER ControlData;

unsigned char GenEpBuf[EP1_PACKET_SIZE];
//IO_REQUEST ioRequest;

extern char buf_tx[128];
extern int r_tx_ecr;
extern int nb_tx;
extern char tx_status;
extern int cpt_irq;

void ep0_rxdone(void)
{
	unsigned char ep_last, i;

	ep_last = D12_ReadLastTransactionStatus(0); // Clear interrupt flag
	//printf("ep_last=%x\n",ep_last);
	if (ep_last & D12_SETUPPACKET) {

		ControlData.wLength = 0;
		ControlData.wCount = 0;

		if( D12_ReadEndpoint(0, (unsigned char *)(&(ControlData.DeviceRequest)),
			sizeof(ControlData.DeviceRequest)) != sizeof(DEVICE_REQUEST) ) {

			D12_SetEndpointStatus(0, 1);
			D12_SetEndpointStatus(1, 1);
			bUSBFlags.bits.control_state = USB_IDLE;
			
			return;
		}

		// Acknowledge setup here to unlock in/out endp
		D12_AcknowledgeEndpoint(0);
		D12_AcknowledgeEndpoint(1);

		ControlData.wLength = LSB(ControlData.DeviceRequest.wLength)<<8;
		ControlData.wLength |= MSB(ControlData.DeviceRequest.wLength);
		ControlData.wCount = 0;
		ControlData.DeviceRequest.wLength=ControlData.wLength;
		//printf("l=%x",ControlData.wLength);
		if (ControlData.DeviceRequest.bmRequestType & (unsigned char)USB_ENDPOINT_DIRECTION_MASK) {
			bUSBFlags.bits.setup_packet = 1;
			OutRs232('p');
			bUSBFlags.bits.control_state = USB_IDLE;		/* get command */
		}
		else {
			if (ControlData.DeviceRequest.wLength == 0) {
				bUSBFlags.bits.setup_packet = 1;
				OutRs232('z');
				bUSBFlags.bits.control_state = USB_IDLE;		/* set command */
			}
			else {
				if(ControlData.DeviceRequest.wLength > MAX_CONTROLDATA_SIZE) {
					bUSBFlags.bits.control_state = USB_IDLE;
					OutRs232('f');
					D12_SetEndpointStatus(0, 1);
					D12_SetEndpointStatus(1, 1);
				}
				else {
					OutRs232('e');
					bUSBFlags.bits.setup_packet = 1;
					bUSBFlags.bits.control_state = USB_IDLE;	/* set command with OUT token */
				}
			} // set command with data
		} // else set command
	} // if setup packet

	else if (bUSBFlags.bits.control_state == USB_RECEIVE) {
		i =	D12_ReadEndpoint(0, ControlData.dataBuffer + ControlData.wCount,
			EP0_PACKET_SIZE);

		ControlData.wCount += i;
		//ControlData.wCount = i;
		if( i != EP0_PACKET_SIZE || ControlData.wCount >= ControlData.wLength) {
			bUSBFlags.bits.setup_packet = 1;
			bUSBFlags.bits.control_state = USB_IDLE;
		}
	}

	else {
		bUSBFlags.bits.control_state = USB_IDLE;
	}
//printf(" lf=%x\n",ControlData.wLength);
}

void ep0_txdone(void)
{
	short i = ControlData.wLength - ControlData.wCount;

	D12_ReadLastTransactionStatus(1); // Clear interrupt flag

	if (bUSBFlags.bits.control_state != USB_TRANSMIT) 
		return;

	if( i >= EP0_PACKET_SIZE) {
		D12_WriteEndpoint(1, ControlData.pData + ControlData.wCount, EP0_PACKET_SIZE);
		ControlData.wCount += EP0_PACKET_SIZE;

		bUSBFlags.bits.control_state = USB_TRANSMIT;
	}
	else if( i != 0) {
		D12_WriteEndpoint(1, ControlData.pData + ControlData.wCount, i);
		ControlData.wCount += i;

		bUSBFlags.bits.control_state = USB_IDLE;
	}
	else if (i == 0){
		D12_WriteEndpoint(1, 0, 0); // Send zero packet at the end ???

		bUSBFlags.bits.control_state = USB_IDLE;
	}
}

void ep1_txdone(void)
{
	D12_ReadLastTransactionStatus(3); /* Clear interrupt flag */
	tx_status=0;
	bUSBFlags.bits.control_state = USB_IDLE;		
			
//	printf("ep_tx1\n");
}

void ep1_rxdone(void)
{
	unsigned char len,i;

	D12_ReadLastTransactionStatus(2); /* Clear interrupt flag */

	len = D12_ReadEndpoint(2, GenEpBuf, sizeof(GenEpBuf));
//	printf("ep_rx1=%d\n",len);
	if(len != 0)
		{
		//D12_AcknowledgeEndpoint(2);
		//D12_AcknowledgeEndpoint(3);

		bUSBFlags.bits.ep1_rxdone = 1;
		nb_tx+=len;
		for(i=0;i<len;i++)
			{
			buf_tx[r_tx_ecr]=GenEpBuf[i];
			r_tx_ecr++;
			if (r_tx_ecr==128)
				r_tx_ecr=0;
			//D12_WRITE_CARACT(5,tampon[i]);
			}
		/*if (bUSBFlags.bits.control_state != USB_TRANSMIT)
			{
			bUSBFlags.bits.control_state = USB_TRANSMIT;
			D12_WriteBuffer();
			}*/		
		//D12_WriteEndpoint(3,GenEpBuf,len);
		bUSBFlags.bits.control_state = USB_IDLE;
		}
		else
		{
		//D12_AcknowledgeEndpoint(2);
		//D12_AcknowledgeEndpoint(3);
		//bUSBFlags.bits.control_state = USB_IDLE;
		}
//	if (nb_tx!=0)
//		D12_WriteBuffer();

}

void main_txdone(void)
{
char s;
s=D12_ReadLastTransactionStatus(5); /* Clear interrupt flag */
//tx_status=0;
//printf("trans ok=%x\n",s);
}

void main_rxdone(void)
{
unsigned char ep_last,len,i;
char tampon[65];
ep_last=D12_ReadLastTransactionStatus(4); 
//printf("main_rxd=%x\n",ep_last);
len=D12_ReadEndpoint(4,tampon,64);
nb_tx+=len;
printf("nb_tx%d len %d\n",nb_tx,len);
//printf("s=%x len=%d tampon=%s\n",ep_last,len,tampon);
for(i=0;i<len;i++)
	{
	buf_tx[r_tx_ecr]=tampon[i];
	r_tx_ecr++;
	if (r_tx_ecr==128)
		r_tx_ecr=0;
	//D12_WRITE_CARACT(5,tampon[i]);
	}
//D12_WriteEndpoint(5,tampon,len);
}

void fn_usb_isr()
{
	unsigned int i_st;
	PORTQS=0x0040;
	bUSBFlags.bits.in_isr = 1;
	i_st = D12_ReadInterruptRegister();
	cpt_irq++;
	//printf("isrD12(%d)=%x\n",cpt_irq,i_st);
	if (i_st!=0)
	{
		if(i_st & D12_INT_BUSRESET)
		{
		bUSBFlags.bits.bus_reset = 1;
		}
		else
		{
		if(i_st & D12_INT_SUSPENDCHANGE)
				bUSBFlags.bits.suspend = 1;
		if(i_st & D12_INT_ENDP0IN)
				ep0_txdone();
		if(i_st & D12_INT_ENDP0OUT)
				ep0_rxdone();
		if(i_st & D12_INT_ENDP1IN)
				ep1_txdone();
		if(i_st & D12_INT_ENDP1OUT)
				ep1_rxdone();
		if(i_st & D12_INT_ENDP2IN)
				main_txdone();
		if(i_st & D12_INT_ENDP2OUT)
				main_rxdone();
		}
	}
	bUSBFlags.bits.in_isr = 0;
	PORTQS=0x70;
}

__asm__("

.text
.even
.globl IsrUsb
IsrUsb:
		movem.l %d7/%d6/%d5/%d4/%d3/%d2/%d1/%d0/%a6/%a5/%a4/%a3/%a2/%a1/%a0,-(%a7)

		jsr		fn_usb_isr

		movem.l (%a7)+, %d7/%d6/%d5/%d4/%d3/%d2/%d1/%d0/%a6/%a5/%a4/%a3/%a2/%a1/%a0
		rte
");