/* test usb main */

#include "d12ci.h"
#include "usb.h"
#include "isr_usb.h"
#include "eid210.h"
//#include "68332.h"
#include "qsm.h"

extern void fn_usb_isr();

extern CONTROL_XFER ControlData;
extern USBFLAGS bUSBFlags;

char buf_tx[128];
int r_tx_ecr;
int r_tx_lect;
int nb_tx;
char tx_status;

int cpt_irq;

#define	CSBAR6	*(short*)	0xFFFA64	/* regitre de configuration de l'adresse de base du chip select CS6 */
#define	CSOR6	*(short*)	0xFFFA66		/* regitre de controle des options de configuration du chip select CS6 */
#define  CSPAR0	*(short *) 0xFFFA44
#define PORTC_68	*(char *)	0xFFFA41

void init_cs()
{
//CSBAR6=0xA000;
//CSOR6=0x7D20;
//CSPAR0=0x38FE;
//PORTC_68=0xFE;
r_tx_ecr=0;
r_tx_lect=0;
nb_tx=0;
tx_status=0;
}


void setvect(int num, int p_isr)
{
int *p_vect;
p_vect=(int *)(0x800000+4*num);
*p_vect=p_isr;
}

void reconnect_USB()
{
int i;
printf("Reconnect USB ...\n");
	disconnect_USB();
	PORTQS=0x50;
	for(i=0;i<200000;i++);
	PORTQS=0x70;
	connect_USB();

}

main()
{
int i;
int cpt_ecr;
int cpt_i;
unsigned char type, req;
unsigned char s,t;
PQSCTR=0x0070;
PORTQS=0x70;
cpt_irq=0;
	init_cs();	// validation des ligne chip select usb
//nb_tx=2;
	printf("Test de l'USB sur EID210\n");
	IrqUsb=0;
	SetVect(31,&fn_usb_isr); // autovecteur niveau 7 pour l'usb
//	setvect(31,(int)&IsrUsb);
//	reconnect_USB();
	//ENABLE;
bUSBFlags.value=0;
	IrqUsb=1;
	cdc_init();
cpt_ecr=0;
cpt_i=0;
while(1)
	{
	//for(i=0;i<500;i++);
//	if (IRQ_USB==0)
//		{
	//	PORTQS=0x0020;
//		fn_usb_isr();
	//	type = ControlData.DeviceRequest.bmRequestType & USB_REQUEST_TYPE_MASK;
	//req = ControlData.DeviceRequest.bRequest & USB_REQUEST_MASK;
		//cpt_ecr=0;
//		PORTQS=0x0070;
		//printf("USBFLAG=%x type=%d req=%d\n",bUSBFlags.value,type,req);
//		}
	cpt_ecr++;
	if (cpt_ecr==10)
		{
		PORTQS=0x0060;
		cpt_ecr=0;
	if (cpt_i!=cpt_irq)	
		{
		printf(" cpt_irq=%d\n",cpt_irq);
		cpt_i=cpt_irq;
		}
/*	if (bUSBFlags.value!=0)
		{
		type = ControlData.DeviceRequest.bmRequestType & USB_REQUEST_TYPE_MASK;
	req = ControlData.DeviceRequest.bRequest & USB_REQUEST_MASK;
		//printf("USBFLAG=%x type=%d req=%d\n",bUSBFlags.value,type,req);
		}*/
	if (bUSBFlags.bits.in_isr==0)
	{
	if (bUSBFlags.bits.suspend==1)
	{
		disable(); //IrqUsb=0;
		bUSBFlags.bits.suspend=0;
		enable(); //IrqUsb=1;
		//printf("suspend\n");
		OutRs232('s');
		nb_tx=0;
		//cpt_irq--;
	}
	if (bUSBFlags.bits.bus_reset)
		{
		disable(); //IrqUsb=0;
		bUSBFlags.bits.bus_reset=0;
		enable(); //IrqUsb=1;
		//printf("reset\n");
		OutRs232('R');
		nb_tx=0;
		
		//cpt_irq--;
		}
	if (bUSBFlags.bits.setup_packet&&bUSBFlags.bits.control_state == USB_IDLE)
		{
		disable(); //IrqUsb=0;
		bUSBFlags.bits.setup_packet=0;
		//type = ControlData.DeviceRequest.bmRequestType & USB_REQUEST_TYPE_MASK;
		req = ControlData.DeviceRequest.bRequest; // & USB_REQUEST_MASK;
		enable(); //IrqUsb=1;
		nb_tx=0;
		//cpt_irq--;
		//OutRs232('0'+req);
		//printf("Setup(%x)(%x)...\n",req,type);
		switch(req)
			{
			case 0 : if (ControlData.DeviceRequest.bmRequestType==0x21)
					{
					}
					else
					get_status();
				 break;
			case 1 : if (ControlData.DeviceRequest.bmRequestType==0xa1)
					{
					}
					else
					clear_feature();
				break;
			case 2 : 
				break;
			case 3 : set_feature();
				break;
			case 4 : 
				break;
			case 5 : set_address();
				break;
			case 6 : get_descriptor();
				break;
			case 7 : 
				break;
			case 8 : get_configuration();
				break;
			case 9 : set_configuration();
				break;
			case 10 : get_interface();
				break;
			case 11 : set_interface();
				break;
			case 0x20 : cdc_set_line_coding();
					//printf("\n");
				break;
			case 0x21 : cdc_get_line_coding();
				break;
			case 0x22 : 
					single_transmit(0, 0);
					//bUSBFlags.bits.control_state = USB_IDLE;
					nb_tx=0;
					OutRs232('\n');
					//printf("set ctrl line\n\n\n");
					
					//D12_ClearBuffer(2);
					//D12_ClearBuffer(3);
					//D12_AcknowledgeEndpoint(2);
					//D12_AcknowledgeEndpoint(3);

					//D12_WriteEndpoint(3,0,0);
					//affiche_status();
					//stall_ep0();
					//clsscr();
				break;
			case 0x23 : printf("send break\n");
					single_transmit(0, 0);
					bUSBFlags.bits.control_state = USB_TRANSMIT;
					//stall_ep0();
				break;
			default: printf("!Setup(%d)(%x)...\n",req,type);
					stall_ep0();
				break;
			}
	//	IrqUsb=1;
		}
		else
		{
		
		if (nb_tx!=0&&bUSBFlags.bits.control_state == USB_IDLE)
					{
						//printf("T\n");
						affiche_status();
						bUSBFlags.bits.control_state = USB_TRANSMIT;
						D12_WriteBuffer();
					}
		}
	}
	else
	OutRs232('i');
	PORTQS=0x0070;
	}
	
	}
	//RestoreVect(31);
}

