/* module permettant l'accs au pdi usb 12 sur EID210 */

#include "d12ci.h"
#include "eid210.h"


void fn_usb_isr();

extern USBFLAGS bUSBFlags;
extern char buf_tx[128];

extern int r_tx_lect;
extern int nb_tx;
extern char tx_status;

void D12_SetAddressEnable(unsigned char bAddress, unsigned char bEnable)
{
D12_COMMAND=0xD0;
if(bEnable)
	bAddress |= 0x80;
D12_DATA=bAddress;
}

void D12_SetEndpointEnable(unsigned char bEnable)
{
D12_COMMAND=0xD8;
if(bEnable)
	D12_DATA=1;
	else
	D12_DATA=0;
}

void D12_SetMode(unsigned char bConfig, unsigned char bClkDiv)
{
D12_COMMAND=0xF3;
D12_DATA=bConfig;
D12_DATA=bClkDiv;
}

void D12_SetDMA(unsigned char bMode)
{
D12_COMMAND=0xFB;
D12_DATA=bMode;
}
unsigned char D12_LitDma()
{
char d;
D12_COMMAND=0xFB;
d=D12_DATA;
return d;
}

unsigned short D12_ReadInterruptRegister(void)
{
	unsigned char b1,b2;
	unsigned short j;

D12_COMMAND=0xF4;
b1 =D12_DATA;
b2 =D12_DATA;
j = (unsigned short)b2;

	j <<= 8;
	j |= b1&0xFF;
//printf("d12=%x  %x %x\n",j,b1,b2);
	return j;
}

unsigned char D12_SelectEndpoint(unsigned char bEndp)
{
D12_COMMAND=bEndp;
return D12_DATA;
}

unsigned char D12_ReadLastTransactionStatus(unsigned char bEndp)
{
D12_COMMAND=0x40 + bEndp;
return D12_DATA;
}

unsigned char D12_ReadEndpointStatus(unsigned char bEndp)
{
D12_COMMAND=0x80 + bEndp;
return	D12_DATA;
}

void D12_SetEndpointStatus(unsigned char bEndp, unsigned char bStalled)
{
D12_COMMAND=0x40 + bEndp;
D12_DATA=bStalled;
}

void D12_SendResume(void)
{
D12_COMMAND=0xF6;
}

unsigned short D12_ReadCurrentFrameNumber(void)
{
	unsigned short i,j;
	D12_COMMAND=0xF5;
	i= D12_DATA;
	j = D12_DATA;

	i += (j<<8);

	return i;
}

unsigned short D12_ReadChipID(void)
{
	unsigned short i,j;
	D12_COMMAND=0xFD;
	i=D12_DATA;
	j=D12_DATA;
	i += (j<<8);
	return i;
}

unsigned char D12_ReadEndpoint(unsigned char endp, unsigned char * buf, unsigned char len)
{
	unsigned char i, j;
D12_COMMAND=endp;
	if((D12_DATA & D12_FULLEMPTY) == 0) 
	{
		return 0;
	}

	D12_COMMAND=0xF0;
	j = D12_DATA;
	j = D12_DATA;

	if(j > len)
		j = len;

	for(i=0; i<j; i++)
		{
		*(buf+i) = D12_DATA;
		//printf("%x ",*(buf+i));
		}
	D12_COMMAND=0xF2;
	//printf(" long=%d\n",j);
	return j;
}

// D12_ReadMainEndpoint() added by V2.2 to support double-buffering.
// Caller should assume maxium 128 bytes of returned data.
unsigned char D12_ReadMainEndpoint(unsigned char * buf)
{
	unsigned char i, j, k = 0, bDblBuf = 1;

	D12_COMMAND=0x84;
	if( (D12_DATA & 0x60) == 0x60)
		bDblBuf = 2;

	while(bDblBuf) {
		D12_COMMAND=4;
		if((D12_DATA & D12_FULLEMPTY) == 0)
			break;

		D12_COMMAND=0xF0;
		j = D12_DATA;
		j = D12_DATA;

		for(i=0; i<j; i++)
			*(buf+i+k) = D12_DATA;

		k += j;

		D12_COMMAND=0xF2;

		bDblBuf --;
	}

	return k;
}

unsigned char D12_WriteEndpoint(unsigned char endp, unsigned char * buf, unsigned char len)
{
	unsigned char i,t;
	
	D12_COMMAND=endp;
	i=D12_DATA;
	if (i&0x01)
		{
		D12_COMMAND=0xF2;		
		printf("eps=%x ",i);
		i=D12_ReadEndpointStatus(endp);
		t=D12_ReadLastTransactionStatus(endp);
		printf("s=%x, t=%x\n",i,t);
		return 0;
		}
	//printf("endpoint=%d ,len=%d, ", endp,len);
	D12_COMMAND=0xF0;
	D12_DATA=0;
	D12_DATA=len;

	for(i=0; i<len; i++)
		{
		D12_DATA=*(buf+i);
		//printf("%x ",*(buf+i));
		}
	D12_COMMAND=0xFA;
      //printf("\n");
	return len;
}

void D12_WriteBuffer()
{
unsigned char i,j;
unsigned char len;
D12_COMMAND=3;
i=D12_DATA;
if (i&0x01)
	{
	i=D12_ReadEndpointStatus(3);
	printf("full(%x)\n",i);
	//D12_COMMAND=0xFA;
	//D12_AcknowledgeEndpoint(2);
	//D12_AcknowledgeEndpoint(3);
	return;
	}

len=nb_tx;
if (len>16)
	{
	len=16;
	nb_tx-=16;
	}
	else
	nb_tx=0;
tx_status=1;
//printf("len=%d\n", len);
	D12_COMMAND=0xF0;
	D12_DATA=0;
	D12_DATA=16;

	for(i=0; i<16; i++)
		{
		if (i<len)
			{
			D12_DATA=buf_tx[r_tx_lect];
			r_tx_lect++;
			if (r_tx_lect==128)
				r_tx_lect=0;
			}
			else
			D12_DATA='0'+i;
		//printf("%x \n",i);
		}
	//if (len<16)
		D12_COMMAND=0xFA;
//while(IRQ_USB==1);
//do
//	{
	//for(j=0;j<100;j++);
//	i=D12_ReadLastTransactionStatus(3);
//	for(j=0;j<4000;j++);
//	printf("s=%x\n",i);
//	i&=0x01;
//	}
//	while (i==0);
}

void D12_WRITE_CARACT(unsigned char endp,unsigned char carac)
{
D12_WriteEndpoint(endp,&carac,1);

/*	unsigned char i;

	D12_COMMAND=endp;
	i=D12_DATA;
	printf("eps=%x\n",i);
//	if (i&0x01)
//		D12_COMMAND=0xF2;
	D12_COMMAND=0xF0;
	D12_DATA=0;
	D12_DATA=1;
	i=0;
	D12_DATA=carac;
	D12_COMMAND=0xFA;
	/*while(IRQ_USB==1)
		{
		i=D12_ReadLastTransactionStatus(5);
		printf("s=%x\n",i);
		}*/
}

void D12_AcknowledgeEndpoint(unsigned char endp)
{
	D12_COMMAND=endp;
	D12_COMMAND=0xF1;
	if(endp == 0)
		D12_COMMAND=0xF2;
}

void D12_ClearBuffer(unsigned char endp)
{
char i;
D12_COMMAND=endp;
i=D12_DATA;
D12_COMMAND=0xF2;
}

void disconnect_USB(void)
{
	// Initialize D12 configuration
	D12_SetMode(D12_NOLAZYCLOCK|D12_CLOCKRUNNING, D12_SETTOONE | D12_CLOCK_12M);
}

void connect_USB(void)
{
	// reset event flags
	bUSBFlags.value = 0;

	// V2.1 enable normal+sof interrupt
//	D12_SetDMA(D12_ENDP4INTENABLE | D12_ENDP5INTENABLE);
	D12_SetDMA(D12_ENDP4INTENABLE );
	// Initialize D12 configuration
	D12_SetMode(D12_NOLAZYCLOCK|
				D12_CLOCKRUNNING|
				D12_SOFTCONNECT,  D12_CLOCK_12M);
}

void affiche_status()
{
int i;
char s;
char t;
short f_n;
f_n=D12_ReadCurrentFrameNumber();
printf("dma=%x\n",f_n&0xFFFF);
for(i=0;i<6;i++)
	{
	s=D12_ReadEndpointStatus(i);
	t=D12_ReadLastTransactionStatus(i);
	printf("e(%d) s=%x t=%x\n",i,s,t);
	}
}