#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>

#include <at8xc5132.h>
#include "compiler.h"
#include "schneider.h"
#include "s_com.h"
#include "usb_drv.h"

#define OEN		P3_6
#define PS0		P3_3
#define PS1		P3_4
#define PS2		P3_5

#define EP0		P5_0
#define EP1		P5_1
#define EP2		P5_2
#define EP3		P5_3

/*timer 0 =1ms */

#define TH0_RELOAD	0xF5
#define TL0_RELOAD	0x95

/* UART */

#define TAILLE_BUFFER	16

idata char buf_rx[TAILLE_BUFFER];
idata char usb_buf_rx[TAILLE_BUFFER];
idata char commande[TAILLE_BUFFER];
idata char param[TAILLE_BUFFER];
idata char str_o[32];

unsigned char r_isr;
unsigned char r_usb_read;
unsigned char r_lect;
unsigned char r_lect_usb;
unsigned char nb_caract;
unsigned char nb_caract_usb;
unsigned char type_trame;
unsigned char etat_trame;
unsigned char rang_trame;
xdata long	time,time1;
xdata long  t_att;
char uart_data;
char etat_pom;

/* USB */
bit     usb_connected;
bit 	usb_cmd,usb_cmd0;

extern Uchar   usb_configuration_nb;


void isr_int0(void) interrupt 0;
void isr_timer0(void) interrupt 1;
void isr_serial(void) interrupt 4;

void main()
{
	init_robot();
	str_out("ESD020001\r\n");
	while(1)
		{
			
		}
}

void init_robot()
{
	AUXR=0x1D;
	P0=0x00;	/* sortie  0*/
	PS0=1;
	PS1=1;
	PS2=1;
	OEN=0;
	EP0=1;
	EP1=1;
	EP2=1;
	EP3=1;
	P2=0xFF;	/* port 2 en entre */
	
	/* initialisation uart */
	clk=0;
	r_isr=0;
	r_lect=0;
	nb_caract=0;
	etat_trame=0;
	rang_trame=0;
	commande[0]=0;
	param[0]=0;
	time=0;
	
	emission=0;
	PCON|=0x80;	/*SMOD1=1*/
	SCON=0x50;  /*SPD=1 TBCK=1 RBCK=1 */ 
	BDRCON&=0xEE;
	BDRCON|=0x0E;
	BRL=239;	/*57600 bauds */
	CKCON|=0x01; /* X2=1 */
	/* TIMER 0*/
	TMOD=0x01;	/* Timer 0 en mode 1 16 bits */
	TH0=TH0_RELOAD;
	TL0=TL0_RELOAD;
	TR0=1;	/* active timer 0 */
	ET0=1;  /* active isr timer 0*/
	ES=1;   /* active isr ls */
	EA=1;
	BDRCON|=0x10;
	etat_pom=0;
	usb_cmd=0;
}

/* fonctions interruptions */

void isr_int0(void) interrupt 0
{
	
}

void isr_timer0(void) interrupt 1
{
	if (clk==0)
		clk=1;
		else
		clk=0;
	time++;
	TH0=TH0_RELOAD;
	TL0=TL0_RELOAD;
}

void isr_serial(void) interrupt 4
{
	if (RI== 1)
	{
		RI=0;
		usb_cmd=0;
		buf_rx[r_isr]=SBUF;
		r_isr++;
		r_isr&=(TAILLE_BUFFER-1);
		nb_caract++;
		/*uart_data=SBUF;
		SBUF=uart_data;*/
	}
	if (TI==1)
		{
		TI=0;
		emission=0;
		}
}