#ifndef _SCHNEIDER_H
#define _SCHNEIDER_H

/* USB Configuration */
                                    /* DEVICE DESCRIPTOR */
#define USB_SPECIFICATION     0x0110
#define DEVICE_CLASS          0x02
#define DEVICE_SUB_CLASS      0
#define DEVICE_PROTOCOL       0
#define EP_CONTROL_LENGTH     32
#define VENDOR_ID             0x169c        /* DMS Vendor ID */
#define PRODUCT_ID            0x0120       /* Product ID: 2009h = CDC C5131 */
#define RELEASE_NUMBER        0x0000
#define MAN_INDEX             0x00
#define PROD_INDEX            0x00
#define SN_INDEX              0x00
#define NB_CONFIGURATION      1

                                    /* CONFIGURATION DESCRIPTOR */
#define CONF_LENGTH           0x43 //0x43  // 3E00
#define NB_INTERFACE          2
#define CONF_NB               1
#define CONF_INDEX            0
#define CONF_ATTRIBUTES        USB_CONFIG_SELFPOWERED
#define MAX_POWER             50          /* 100 mA */


                                    /* INTERFACE 0 DESCRIPTOR */
#define INTERFACE0_NB          0
#define ALTERNATE0             0
#define NB_ENDPOINT0           1
#define INTERFACE0_CLASS       0x02 /* CDC ACM Comm */
#define INTERFACE0_SUB_CLASS   0x02
#define INTERFACE0_PROTOCOL    0x01
#define INTERFACE0_INDEX       0

                                    /* INTERFACE 1 DESCRIPTOR */
#define INTERFACE1_NB          1
#define ALTERNATE1             0
#define NB_ENDPOINT1           2
#define INTERFACE1_CLASS       0x0A /* CDC ACM Data */
#define INTERFACE1_SUB_CLASS   0
#define INTERFACE1_PROTOCOL    0
#define INTERFACE1_INDEX       0

                                    /* ENDPOINT 3 DESCRIPTOR */
#define ENDPOINT_NB_3         0x83
#define EP_ATTRIBUTES_3       0x03  // interrupt
#define EP_SIZE_3             8
#define EP_INTERVAL_3         0x02

                                    /* ENDPOINT 1 DESCRIPTOR */
#define ENDPOINT_NB_1         0x01
#define EP_ATTRIBUTES_1       0x02  // bulk
#define EP_SIZE_1             64 
#define EP_INTERVAL_1         0x00

                                    /* ENDPOINT 2 DESCRIPTOR */
#define ENDPOINT_NB_2         0x82
#define EP_ATTRIBUTES_2       0x02  // bulk
#define EP_SIZE_2             64 
#define EP_INTERVAL_2         0x00


#define USB_MANUFACTURER_NAME {'D', 'M', 'S'}
#define USB_MN_LENGTH         3
#define USB_PRODUCT_NAME      {'E', 'S', 'D', '0', '2', '0', '0', \
                               '0', '1' }
#define USB_PN_LENGTH         9
#define USB_SERIAL_NUMBER     {'1', '.', '0', '.', '0'}
#define USB_SN_LENGTH         5

#define LANG_ID               0x00
#define LANGUAGE_ID           0x0904


#define EP_CONTROL            0x00
#define EP_IN                 0x01
#define ENDPOINT_0            0x00
#define ENDPOINT_1            0x81

#define RX_EP	1
#define TX_EP	2



#endif