/************************************************************************ 
*  Programme de test des fonctions lmentaires de la carte SMD_332    	*
*															           	*
*      		V1.0   du 07/01	 T. HANS   J.L. ROHOU 		               	*
* 	Nom du fichier: T_BT_INT.C									   	   	*
*                                             						   	*
*  Description: 													   	*
*  - on gnre une base de temps de 10ms avec interruption			   	*
*  - la sortie PA0 produit une impulsion  '1'  chaque interruption  	*
*************************************************************************/


/* Liste des fichiers  inclure */
#include "Cpu_reg.h"
#include "SMD_332.h"
#include "TPU_reg.h"

/* Dclaration de la fonction d'interruption */
void IT_PITMR() __attribute__((noreturn));
/* Dfinitions particulires */
/*  TPU PARAMETER RAM */

 	/* PWM PARAMETER RAM pour ch.7 	*/
	#define PWMHI7		*(WORD*)	0xFFFF74
	#define PWMPER7		*(WORD*)	0xFFFF76

/* Dclaraation de variables*/
WORD pwm_HI,pwm_PER,etat;


/*=====================*/
/* Fonction principale */
/*=====================*/
main()
{
/* initialisations */
/*******************/


/* Initialisation des variables*/
pwm_HI=0x0000;   	/* Dure du signal au niveau logique 1  (HIgh) 	*/
						/* Rapport cyclique initialis 0 %				*/
pwm_PER=0x0100;   	/* Valeur de la PERiode du signal				*/
etat=0;
   /* Remarque:
   pwnHI ne pourra varier que de 0x0000  0x00FF */	
	
/* Des registres du TPU pour configurer le bit PA0 (TPU0) en sortir TOR		*/
/* registre de slection de la fonction des canaaux d'E/S  3 2 1 0			*/ 
   CFSR3=0x0008;	/* le bit TPU0 est une DIO  (Entre sortie discrte) 	*/
  
   HSQR1=0x0000;
   CPR1=0x0003; 
/* Registre de contrle du canal 0  (Sortie non force -> obligatoire en DIO) */
   CTRL_TPU0=0x0003;

/* initialisation du vecteur */
/*	setvect(96,IT_PITMR); */

/* Initialisation du timer */	
  	Pitr=0x0008;	 /* Periode = 1ms ;	  	*/
   /*	Pitr=0x0101;	 /* F = 15  1600 khz ;	  	*/
	
	Picr=0x0760;	 /* IT level 7, vecteur IT=96 (0x60h)	*/

  
 /* Boucle principale */
/*********************/ 
   
do
	{ 
	/* On ne fait rien dans la boucle principale */ 	
	}while(1);
	
/* fin de la boucle principale */

} /* fin fonction principale */


 	
/* Fonction de Traitement IT periodique	*/
void IT_PITMR()
{ 	
if (etat==0)
	{
   /* Forage du canal 0  1 */
		HSRR1=0x0002;
		etat=1;
	}
	else
	{
   /* Forage du canal 0  0 */
		HSRR1=0x0001;
		etat=0;
	}
 }

















 