
#include "eid210.h"

#include "feux.h"

// Pour le temporisateur programmable
#define PITR	*(short *)(0xFFFA24)	//
#define PICR	*(short *)(0xFFFA22)


/*Retour capture du portB*/
#define ValPB4 *(short*)(0xFFFFC2)
#define ValPB5 *(short*)(0xFFFFD2)



int tick;

short etat_pb5,etat_pb5_1;
short etat_pb4,etat_pb4_1;

int compteur_simul_1,compteur_simul;
int compteur_vitesse_1,compteur_vitesse;

void irq_bt()
{
if (++tick==2500)
	{
	tick=0;
	compteur_simul_1=compteur_simul;
	compteur_simul=0;
	compteur_vitesse_1=compteur_vitesse;
	compteur_vitesse=0;
	}
HSRR0=0x0F00;	//Capture PB
etat_pb5_1=etat_pb5;
etat_pb5=ValPB5;
etat_pb4_1=etat_pb4;
etat_pb4=ValPB4;
if (!(etat_pb4_1&0x8000)&&(etat_pb4&0x8000))
	compteur_vitesse++;
if (!(etat_pb5_1&0x8000)&&(etat_pb5&0x8000))
	compteur_simul++;

}


void InitMeteo()
{
CFSR0=(short)0x8888;
CFSR1=(short)0x8888;
CFSR2=(short)0x8888;
CFSR3=(short)0x8888;

HSQR0=(short)0;
HSQR1=(short)0;
CPR0=(short)0xFFFF;
CPR1=(short)0xFFFF;
CTRL_TPU0=(short)0x0003;
CTRL_TPU1=(short)0x0003;
CTRL_TPU2=(short)0x0003;
CTRL_TPU3=(short)0x0003;
CTRL_TPU4=(short)0x0003;
CTRL_TPU5=(short)0x0003;
CTRL_TPU6=(short)0x0003;
CTRL_TPU7=(short)0x0003;

CTRL_TPU8=(short)0x0003;
CTRL_TPU9=(short)0x0003;
CTRL_TPU10=(short)0x0003;
CTRL_TPU11=(short)0x0003;
CTRL_TPU12=(short)0x0003;
CTRL_TPU13=(short)0x0003;
CTRL_TPU14=(short)0x0003;
CTRL_TPU15=(short)0x0003;

HSRR0=0xFFFF;
HSRR1=0xFFFF;

HSRR0=0xAAAA;
HSRR1=0x5555;

/* initialisation du port C*/

PortCDir=0xFF;
PortCPort=0x00;

}

short LitDirVentSimul()
{
short v_ana;
CAN=0x40;
while(IRQ_CAN==1);
v_ana=CAN&0xFFF;
return v_ana;
}

short LitDirVent()
{
short v_ana;
CAN=0x42;
while(IRQ_CAN==1);
v_ana=CAN&0xFFF;
return v_ana;
}

short LitTempSimul()
{
short v_ana;
CAN=0x43;
while(IRQ_CAN==1);
v_ana=CAN&0xFFF;
return v_ana;
}

void RoseVent(short direction)
{
short pb=0x0000;
switch(direction&0x0F)
	{
	case 0 : pb=0x00AA;
		 break;
	case 1: pb=0x00a9;
		break;
	case 2 : pb=0x00a6;
		break;
	case 3 : pb=0x00a5;
		break;
	case 4 : pb=0x009a;
		break;
	case 5 : pb=0x0099;
		break;
	case 6 : pb=0x0096;
		break;
	case 7 : pb=0x0095;
		break;
	case 8 : pb=0x006a;
		break;
	case 9 : pb=0x0069;
		break;
	case 10 : pb=0x0066;
		break;
	case 11 : pb=0x0065;
		break;
	case 12 : pb=0x005a;
		break;
	case 13 : pb=0x0059;
		break;
	case 14 : pb=0x0056;
		break;
	case 15 : pb=0x0055;
		break;
	}
HSRR0=pb;
}

void VitVent(short vit)
{
unsigned short v_vit=vit; //(vit*255)/35;
unsigned short pa=0;

if (v_vit>=1)
	pa|=0x0002;
	else
	pa|=0x0001;
if (v_vit>=2)
	pa|=0x0008;
	else
	pa|=0x0004;
if (v_vit>=3)
	pa|=0x0020;
	else
	pa|=0x0010;
if (v_vit>=4)
	pa|=0x0080;
	else
	pa|=0x0040;
if (v_vit>=5)
	pa|=0x0200;
	else
	pa|=0x0100;
if (v_vit>=6)
	pa|=0x0800;
	else
	pa|=0x0400;
if (v_vit>=7)
	pa|=0x2000;
	else
	pa|=0x1000;
if (v_vit>=8)
	pa|=0x8000;
	else
	pa|=0x4000;
HSRR1=pa;

}

void EcritAffMeteo(int valeur)
{
short unite,diz;
diz=valeur/10;
unite=valeur-diz*10;
HSRR0=0x1000;
EcritAff(unite);
HSRR0=0x2000;
HSRR0=0x4000;
EcritAff(diz);
HSRR0=0x8000;
}

main()
{
short v_dir,v_dir_sim;
short v_degre,v_degre_sim;
short v_tsimul;
short direction;
short compteur=0;
short vitesse_vent,vitesse_vent_sim;
int i;
short vitesse=0;
clsscr();
InitMeteo();
tick=0;
compteur_simul=0;
compteur_simul_1=0;
SetVect(96,&irq_bt);	     	// mise en place de l'autovecteur 
PITR = 0x0008;		// Une interruption toutes les millisecondes 
PICR = 0x0760; 		//  96 = 60H
while(1)
	{
	VitVent(vitesse);
	vitesse++;
	EcritAffMeteo(compteur);
	compteur++;
	if (compteur==100)
		compteur=0;
	if(vitesse==9)
		vitesse=0;
	v_dir=LitDirVent();
	v_dir_sim=LitDirVentSimul();
	direction=v_dir_sim&0xF00;
	direction>>=8;
	v_degre=(v_dir*360)/4095;
	v_degre_sim=(v_dir_sim*360)/4095;
	gotoxy(5,5);
	printf("v_dir=%3.3X  v_dir_sim=%3.3X\n",v_dir,v_dir_sim);
	gotoxy(5,6);
	printf("degre_dir=%d, degre_sim=%d                  \n",v_degre,v_degre_sim);
	gotoxy(5,7);
	printf("direction=%d\n",direction);
	RoseVent(direction);
	v_tsimul=LitTempSimul();
	gotoxy(5,10);
	printf("temp_simul=%3.3X\n",v_tsimul);

	gotoxy(1,15);
	vitesse_vent=compteur_vitesse_1*1.852;
	printf("vitesse du vent en noeud=%d          \nvitesse du vent=%d Km/h          \n",compteur_vitesse_1,vitesse_vent);
	gotoxy(1,18);
	vitesse_vent_sim=compteur_simul_1*1.852;
	printf("vitesse du vent simul en noeud=%d          \n vitesse du vent simule=%d Km/h          \n",compteur_simul_1,vitesse_vent_sim);
	for(i=0;i<100000;i++);

	}
}